                        
			README FOR CEA2 BATCH JOBS

CEA2 is slightly different that the NASA Glenn program described in NASA RP-1311, 
Parts I and II. (Manuals are available from this website). The program now uses an 
INCLUDE file named cea.inc which consolidates PARAMETER assignments and 
COMMON variable statements in one place.  Previously these statements were at 
the beginning of each subroutine.  The INCLUDE file is useful for revising maximum
dimensions and input/output unit assignments. See RP-1311, part II, p39.

The FORTRAN source and data are ASCII files in our anonymous FTP server available 
at the following internet URL:   ftp://ftp.grc.nasa.gov/users/xxminna/CEA+Fortran/ .
        
The files you should have downloaded are:
	readme.cea
	cea2.f	
	cea.inc
	thermo.inp
	trans.ing
	cea2.inp
	cea2.out

Since this program is identical to the one available with the CEAgui download, 
you may use that executable called FCEA2.exe if the platform is appropriate. 
Or you may compile cea2.f  with cea.inc available in the same directory.  
Note that compilers are freely available from the internet.

File names have an extension (suffix) defined as follows: 
	Fortran source programs - .f
	Input files - .inp
	Output files - .out
	Files of output parameters for plotting - .plt
	Include file - .inc
	Unformatted thermodynamic or transport property databases - .lib

The root names of these files are referred to as prefixes. To run CEA2, simply type 
in the name of the executable and CEA2 will interactively ask for the prefix of the input file.

The thermodynamic and transport data files must be preprocessed to form “.lib” files 
before input problem files can be run. The “.lib” files are obtained by running the 
thermo.inp and trans.inp as input files. The user types thermo or trans when CEA2 
asks for an input prefix and the required files are created.  These files do not need to be 
processed again unless the data are revised.  The thermo.out file lists each species name, 
the reference/date code, the heat of formation in Joules/mole at 298.15K , 
and some reference information.

You are now ready to run the sample problems cea2.inp and check with the sample output 
cea2.out

To get thermodynamic properties of individual species for the coefficients or to download subsets of 
the 
thermodynamic data, go to the following URL and see “About ThermoBuild”  for details.

	http://cea.grc.nasa.gov/

If you have any comments or questions, please contact Russell.W.Claus@nasa.gov

 

                      README FOR MAKELIB


The makelib.f code converts the formatted form of the thermodynamic and 
transport property databases to an unformatted form for use in programs like
SUBEQ and CEA or CEA2.


A complete description for using this program is given in the comments in the
FORTRAN source program (i.e. makelib.f).  Compilers are freely available on the
internet for any computer platform. 

If you have any questions, contact Russell.W.Claus@nasa.gov

         
     
                        README FOR OLDNEW
         
          
The code oldnew.f comverts the NASA Glenn thermodynamic coefficient 
data in the old format to the new format.  In the old format Cp was fitted 
to a fourth-order polynomial while the new format has an empirical form with 
two extra terms.  After conversion the coefficients for these extra terms 
will be zero.
         
Descriptions of input and output are given in the comments in the 
FORTRAN code.  
         
FORTRAN compilers are freely available on the internet for various 
Computer platforms.

If you have any questions, please contact Russell.W.Claus@nasa.gov

                                              README FOR PAC

We are currently using a version of PAC called PAC99.  Some input features will be 
a little different than those described in the manual, NASA RP-1271, 1992, available 
from the website http://www.grc.nasa.gov/WWW/CEAWeb/.  Also atomic weights, 
fundamental constants, and some of the examples have been updated.  
Please let us know if you have any difficulties.

The FORTRAN source and data are ASCII files in our anonymous FTP server available 
at the following URL:

         ftp://ftp.grc.nasa.gov/users/xxminna/CEA+Fortran/pac/
         
The files you should have downloaded are:

	readme.pac
	pac99.f
	new.groups
	EFdata.i97
	exp.i97
	exp.o97
	exp.c97
	exp.e97

The root names of these files are referred to as prefixes. File names have extensions 
(suffixes) defined as follows: 

	Fortran source programs - .f
	Input files - .i97
	General output listing with tables - .o97
	Coefficients in latest thermo data format - .c97
	Element data used in calculating the heat of Formation and LogK - .e97

The “.e97” file will be used only for elements and then only if the option is called for in 
the “i97” file. Coefficients output “.c97” is also an option.

General information to get started:

* Compile the fortran program pac99.f.  Note that compilers are freely 
      available from the internet.
* Type in the name of the executable.  PAC99 will ask for the name of the input prefix.
* The first input file should the EFdata.i97.  PAC99 will make a binary file unf.EFdata 
      to be used for the heat of Formation and LogK calculations in the tables.
* The file new.groups must be available for the group additivity option.  It is not a binary file.
* Run the sample problems exp.i97 and check the output files.

To get thermodynamic properties of individual species for the NASA Glenn coefficients database 
or to download subsets of this data, go to the following URL and see “About ThermoBuild”
 for details.      
         http://cea.grc.nasa.gov/

If you have any comments or questions, please contact Russell.W.Claus@nasa.gov
         

 		           README FOR CAP
        
The Coefficiients and Properties (CAP) computer code is described 
in NASA/TP--2001-210595 available from the CEA website. See "Codes
related to thermodynamic properties of individual species..." 
          
           http://www.grc.nasa.gov/WWW/CEAWeb/
          
The report provides a detailed description of input preparation and 
examples of input and output for many species.  
          
The program permits the generation of tabulated thermodynamic functions 
from NASA least-squares coefficients.  CAP provides considerable 
flexibility in the output format, the temperature schedule, and the 
energy units of the calculated properties. ThermoBuild at the following
website is similar except for the fact that it uses the NASA thermo
database and does not allow for as much flexibility in energy units.
          
           http://cea.grc.nasa.gov/
          
The Fortran source code and associated data are available at the 
following internet URL:
          
           ftp://ftp.grc.nasa.gov/users/xxminna/CEA+Fortran/cap/
          
GENERAL INFORMATION TO GET STARTED:
          
1)  Compile the fortran program cap.f.  Note that compilers 
    are freely available from the CEAWeb.
2)  When executing CAP, the file cap.elms must be available
    if heats of formation and log K values are desired.
3)  Input and output files as assumed to be standard input
    (I/O unit 5) and standard output (I/O/ unit 6).  OPEN
    statements may be added to the source code.
4)  Run the executable with the provided example "cap.in",e.g.:
          
            cap.x < cap.in > cap.out
          
Generally, the input consists of 2 records followed by any number of 
sets of coefficients in the format of 9 coefficients for Cp--see 
ThermoBuild (details given in "About ThermoBuild") or the CAP manual.
The first record contains options in the form of keywords.  The
second record indicates the desired T schedule.  These records are
also descrided in source code comments.
          
CAP will generate output tables for each species whoses coefficients
are provided.  An unlimited number of species may be run. For species 
with several phases, the phases must be supplied in increasing order 
by temperature.  If the temperature schedule in record 2 exceeds the
range of the coefficients, CAP will use the coefficients for up to 
20 percent beyond the endpoint.
          
The file "cap.elms" contains coefficients for the reference elements.
These data may be revised or expanded.

If you have any comments or questions, please contact Russell.W.Claus@nasa.gov.     

      PROGRAM OLDNEW
C   Program converts a file of multiple old form NASA coefficients
C   to new file of multiple new form NASA coefficients.  All gases
C   are converted to a two-range version of new form (numint=2)
C   with 1000 as the common temperature (Tcom).  Condensed species
C   in sequence produce a series (phase=1,2,3..) of new form
C   coefficients in order of increasing temperature.
C  
C   The output goes to a file organized as:
C         Rec 1
C             col 1-16        name
C             col 17-24       blank
C             col 25-80       comments (not available from old form)
C         Rec 2
C             col 1           blank
C             col 2           number of temperature intervals (numint)
C             col 3           blank
C             col 4-7         (code)
C             col 8-9         (date)
C             col 10          blank
C             col 11-50       formula ( 5(A2,F6.2)  )
C                              (el1,n1,el2,n2,el3,n3,el4,n4,el5,n5)
C             col 51          blank
C             col 52          (phase) See below for code.
C             col 53-65       molecular weight (molwgt).
C             col 66-80       heat of formation in J/mol (htform)
C         Rec 3
C             col 1           blank
C             col 2-11        low temp of first interval (Tlow)
C             col 12-21       high temp of first interval (Tcom)
C             col 22          blank
C             col 23          Number of Coefficients for Cp
C             col 24-63       T exponents  (ex = 0,1,2,3,4,5,0,0)
C             col 66-80       H-HO at 298.15 J/mole  (rh)
C                             (not available on old form)
C         Rec 4
C             col 1-80        first 5 coefficients 
C                             (alow, blow, clow, dlow, elow)
C         Rec 5
C             col 1-48        last 3 coefficients (xlow, ylow, zlow)
C                             (not available on old form)
C             col 49-80       Integration constants (flow, glow)
C         Rec 6
C             col 1           blank
C             col 2-11        low temp of second interval (Tcom)
C             col 12-21       high temp of second interval (Thi)
C             col 22          blank
C             col 23          Number of Coefficients for Cp
C             col 24-63       T exponents (ex = 0,1,2,3,4,5,0,0)
C             col 66-80       H-HO at 298.15 J/mole  (rh)
C                             (not available on old form)
C         Rec 7
C             col 1-80        first 5 coefficients 
C                             (ahi, bhi, chi, dhi, ehi)
C         Rec 8
C             col 1-48        last 3 coefficients (xhi, yhi, zhi)
C                             (not available on old form)
C             col 49-80       Integration constants (fhi, ghi)
C
C         Data from records beyond 8 are not used in the old form.
C
C   The input comes from a file organized as:
C         Rec 1
C             col 1-16        (name)
C             col 17-18       blank
C             col 19-22       (code)
C             col 23-24       (date)
C             col 25-44       formula  (  4(A2,F3.0)  )
C                                 (el1,n1,el2,n2,el3,n3,el4,n4)
C             col 45          (phase)  See code below.
C             col 46-55       low temp of low range (Tlow)
C             col 56-65       high temp of high range (Thi)
C             col 66-78       molecular weight (molwgt)
C             col 79          blank
C             col 80          blank (might hold integer '1')
C         Rec 2
C             col 1-15        coefficient  (ahi)
C             col 16-30       coefficient  (bhi)
C             col 31-45       coefficient  (chi)
C             col 45-60       coefficient  (dhi)
C             col 61-75       coefficient  (ehi)
C             col 76-79       blank
C             col 80          blank (might hold integer '2')
C         Rec 3
C             col 1-15        coefficient  (fhi)
C             col 16-30       coefficient  (ghi)
C             col 31-45       coefficient  (alow)
C             col 46-60       coefficient  (blow)
C             col 61-75       coefficient  (clow)
C             col 76-79       blank
C             col 80          blank (might hold integer '3')
C         Rec 4
C             col 1-15        coefficient  (dlow)
C             col 16-30       coefficient  (elow)
C             col 31-45       coefficient  (flow)
C             col 46-60       coefficient  (glow)
C             col 61-75       heat of formation/R in K (htform)
C             col 76-79       blank
C             col 80          blank (might hold integer '4')

       character*1 phase, phaseo
       character*2 date,el1,el2,el3,el4,el5
       character*2      el1sav,el2sav,el3sav,el4sav
       character*4 code
       character*18 name
       integer numint
       real    n1,n2,n3,n4,n5
       real    n1sav,n2sav,n3sav,n4sav,ex(8)
       real*8  molwgt,htform,Tlow,Tcom,Thi, Tprvhi
       real*8  alow,blow,clow,dlow,elow,flow,glow,xlow
       real*8  ahi,bhi,chi,dhi,ehi,fhi,ghi,xhi
       data ex/0,1,2,3,4,5,0,0/

C****************************************************************
C   Input data from four old form records.

5      read(5,50,end=100) name,code,date,el1,n1,el2,n2,el3,n3,el4,n4,
     +             phase,Tlow,Thi,molwgt 
50     format( A18,A4,A2,4(A2,F3.0),A1,2F10.3,F13.5,1X,1X)
C   Note: An isotope code might be in col 17-18 of old form.  
C         This item is not used in new form so it is overlooked.

       read(5,60) ahi,bhi,chi,dhi,ehi
60     format( 5(E15.8),4X,1X )

       read(5,60) fhi,ghi,alow,blow,clow
       read(5,60) dlow,elow,flow,glow,htform

C*****************************************************************
C   In the new form, the phase is coded  0 => gas  (G)
C                                        1 => lowest T condensed phase
C                                        2 => next T condensed phase
C                                        3 => next T condensed phase
C                                        etc.
C  In the old form, the phase is coded G => gas
C                                      C => condensed
C  The following transforms this code
       if (phase .eq. 'G') then
           phase = '0'
       else
           if (  el1 .EQ. el1sav    .AND.
     +           el2 .EQ. el2sav    .AND.
     +           el3 .EQ. el3sav    .AND.
     +           el4 .EQ. el4sav    .AND.
     +           n1  .EQ. n1sav     .AND.
     +           n2  .EQ. n2sav     .AND.
     +           n3  .EQ. n3sav     .AND.
     +           n4  .EQ. n4sav     .AND.
     +           Tlow .EQ. Tprvhi          )   then
              if (phaseo .EQ. '6')  stop       
              if (phaseo .EQ. '5')  phase = '6'
              if (phaseo .EQ. '4')  phase = '5'
              if (phaseo .EQ. '3')  phase = '4'
              if (phaseo .EQ. '2')  phase = '3'
              if (phaseo .EQ. '1')  phase = '2'
           else
              phase = '1'
           endif
C          Save formula, phase, and Thi for next cycle
           el1sav = el1
           el2sav = el2
           el3sav = el3
           el4sav = el4
           n1sav = n1
           n2sav = n2
           n3sav = n3
           n4sav = n4
           phaseo = phase
           Tprvhi = Thi
       endif
C*****  end of phase conversion **********************************

       if (Thi .LE. 1000) then
          numint = 1
          Tcom = Thi
       endif
       if (Tlow .GE. 1000) then
          numint = 1
          Tcom = Thi
          alow = ahi
          blow = bhi
          clow = chi
          dlow = dhi
          elow = ehi
          flow = fhi
          glow = ghi  
       endif
       if ((Tlow .LT. 1000) .AND. (Thi .GT. 1000)) then
          numint = 2
          Tcom = 1000
       endif         

C  The values of xlow and xhi never appear in the old form.
C  They are here set to zero for the new form.
       xlow = 0.0
       xhi = 0.0

C  The values of el5 and n5 do not appear in the old form.
C  They are set to blank and zero for the new form.
       el5 = '  '
       n5 = 0

C  Output data to eight (or five) new form records.

       write(6,10) name
10     format( A18)
       htform = htform * 8.31451d0

       write(6,20) numint,code,date,el1,n1,el2,n2,el3,n3,el4,n4,el5,n5,
     +            phase,molwgt,htform
20     format( 1X, I1,1X,A4,A2,1X,5(A2,F6.2 ),1X,A1,F13.5,f15.3 )

       write(6,30) Tlow,Tcom,ex,alow,blow,clow,dlow,elow,flow,glow
30     format( 1X,2F10.3,' 5',8f5.1,1p/5d16.8/48x,2d16.8)

       if (numint .EQ. 2) then
          write(6,30) Tcom,Thi,ex,ahi,bhi,chi,dhi,ehi,fhi,ghi
       endif

       goto 5

100    stop
       end

      PROGRAM MAKELIB
C***********************************************************************
C READ THERMO DATA FROM I/O UNIT 5 IN ASCII FORMAT AND WRITE
C UNFORMATTED ON I/O UNIT 6.  DATA ARE REORDERED GASES FIRST. A
C LIST OF NAMES AS PROCESSED WILL BE LISTED ON I/O UNIT 8 (names.lst).
C INPUT DATA FORMAT IS DESCRIBED ON PAGE 43 OF NASA/TP-2002-211556.
c These data may be obtained interactively from NASA Thermobuild at
c   the CEA website: http://www.grc.nasa.gov/WWW/CEAWeb/
c
c Makelib makes an unformatted library of data requires by NASA
c computer programs CEA, CEA2, and CECALL.  2/14/2003 (B.McBride)
c Added CHARACTER*10 Thdate, replaced lerc.nasa by grc.nasa 11/17/2005
C
c Input in order:
c   1) Optional initial comment records ('!' or '#' in column 1).
c   2) Record should contain the word 'thermo' starting in column 1.
c   3) Record with 4 temperatures indicating standard intervals for
c      gases followed by date of last update.
c   4) Coefficient data sets as described in NASA/TP-2002-211556
c      by McBride, Zehe, and Gordon.
c   ...
c These data may be obtained interactively from NASA Thermobuild at
c   the CEA website: http://www.grc.nasa.gov/WWW/CEAWeb/
C
C I/O UNITS:
C UNIT 13 - scratch
C UNIT 8 - list of names, date codes, Hf298, and notes from input.
C
C GASEOUS SPECIES:
C THE STANDARD TEMPERATURE RANGES TGL ARE GIVEN ON THE FIRST
C RECORD, FOLLOWED BY THE DATE OF THE LAST DATA CHANGE THDATE.
C
C WHEN COEFFICIENTS ARE NOT GIVEN FOR THE THIRD TEMPERATURE
C INTERVAL, A STRAIGHT LINE FOR CP/R IS USED.  FOR HIGH TEMPS,
C THE EXTRAPOLATION GOES BETWEEN THE LAST POINT GIVEN AND THE
C FOLLOWING VALUES AA AT TINF=1.D06 K:
C      MONATOMICS  2.5
C      DIATOMICS   4.5
C      POLYATOMICS 3*N-1.75  (AVERAGE 1.5 AND 2)
C
C THE FOLLOWING EXTRAPOLATION IS NOT CURRENTLY PROGRAMED (12/9/98):
C   FOR LOW TEMPS, THE EXTRAPOLATION GOES BETWEEN THE FIRST VALUE
C   DOWN TO THE FOLLOWING VALUES AA AT 0 K:
C      MONATOMICS  2.5
C      DIATOMICS   3.5
C      POLYATOMICS 3.75 (AVERAGE 3.5 AND 4.0)
C
C IF DATA ARE AVAILABLE FOR THE THIRD T INTERVAL, IFAZ (SEE
C DEFINITION) IS SET TO -1 AND THE NAME IS ALTERED TO START WITH *.
C
C CONDENSED SPECIES:
C NO EXTRAPOLATIONS ARE DONE.  TEMP INTERVALS VARY.
C
C SOME DEFINITIONS:
C TGL(I)  - TEMPERATURE INTERVALS FOR GASES (I.E. 200,1000,6000,20000).
C FILL(I) - IF TRUE, DATA MISSING FOR INTERVAL.  CURRENTLY ONLY 3RD
C           INTERVAL CHECKED.
C NGL     - NUMBER OF GASEOUS PRODUCTS.
C NS      - NGL + NUMBER OF CONDENSED PRODUCT PHASES.
C NALL    - NS + NUMBER OF REACTANT SPECIES.
C IFAZ    - PHASE INDICATOR. GASES ARE 0, CONDENSED PHASES ARE NUMBERED
C           STARTING WITH 1 FOR THE LOWEST T RANGE, 2 FOR THE NEXT
C           CONTIGUOUS PHASE, ETC.
C NTL     - NUMBER OF T INTERVALS FOR A SPECIES SET.
C***********************************************************************
      CHARACTER*15 name
      CHARACTER*16 namee,record*80,ans*1
      CHARACTER*65 notes
      CHARACTER*2 sym(5)
      CHARACTER*6 date
	CHARACTER*10 Thdate
      INTEGER i,ifaz,ifzm1,inew,int,j,k,kk,l,nall,ncoef,ngl,ns,ntl
      INTEGER INDEX
      LOGICAL fill(3)
      REAL*8 aa,atms,cpfix,dlt,expn(8),fno(5),hform,hh,mwt,templ(9),tex,
     &       tgl(4),thermo(9,3),tinf,tl(2),ttl,tx
      REAL*8 DBLE,DLOG
C
      OPEN (13,STATUS='scratch',FORM='unformatted')
      OPEN (8,FILE='names.lst',STATUS='unknown',FORM='formatted')
C
c  Read and skip comments and 'thermo' records
c
 10   READ (5,15,err=400) record
 15   FORMAT (a80)
      IF ( record(:6).NE.'thermo' ) GOTO 10
C
      ngl = 0
      ns = 0
      nall = 0
      ifzm1 = 0
      inew = 0
      tinf = 1.D06
      READ (5,99001) tgl,Thdate
 100  DO i = 1,3
        fill(i) = .TRUE.
        DO j = 1,9
          thermo(j,i) = 0.
        ENDDO
      ENDDO
      hform = 0.
      tl(1) = 0.
      tl(2) = 0.
      READ (5,99002,END=300,ERR=400) name,notes
      IF ( name(:3).EQ.'END'.OR.name(:3).EQ.'end' ) THEN
        IF ( INDEX(name,'ROD').EQ.0.AND.INDEX(name,'rod').EQ.0 )
     &       GOTO 300
        ns = nall
        GOTO 100
      ENDIF
      READ (5,99003,ERR=400) ntl,date,(sym(j),fno(j),j=1,5),ifaz,mwt,
     &                       hform
      WRITE (8,99004) name,date,hform,notes
C IF NTL=0, REACTANT WITHOUT COEFFICIENTS
      IF ( ntl.EQ.0 ) THEN
        IF ( ns.EQ.0 ) GOTO 300
        nall = nall + 1
        READ (5,99005,ERR=400) tl,ncoef,expn,hh
        thermo(1,1) = hform
        WRITE (13) name,ntl,date,(sym(j),fno(j),j=1,5),ifaz,tl,mwt,
     &                thermo
        GOTO 100
      ELSEIF ( name.EQ.'Air' ) THEN
        sym(1) = 'N'
        fno(1) = 1.56168D0
        sym(2) = 'O'
        fno(2) = .419590D0
        sym(3) = 'AR'
        fno(3) = .009365D0
        sym(4) = 'C'
        fno(4) = .000319D0
      ELSEIF ( name.EQ.'e-' ) THEN
        mwt = 5.48579903D-04
      ENDIF
      DO i = 1,ntl
        READ (5,99005,ERR=400) tl,ncoef,expn,hh
        READ (5,99006,ERR=400) templ
        IF ( ifaz.EQ.0.AND.i.GT.3 ) GOTO 400
        IF ( ifaz.LE.0 ) THEN
          IF ( tl(2).GT.tgl(4)-.01D0 ) THEN
            ifaz = -1
            namee = '*'//name
            name = namee(:15)
          ENDIF
          IF ( tl(1).GE.tgl(i+1) ) GOTO 200
          int = i
          fill(i) = .FALSE.
        ELSE
          int = 1
          IF ( i.GT.1 ) THEN
            DO k = 1,7
              thermo(k,1) = 0.D0
            ENDDO
          ENDIF
        ENDIF
        DO l = 1,ncoef
          DO k = 1,7
            IF ( expn(l).EQ.DBLE(k-3) ) THEN
              thermo(k,int) = templ(l)
              GOTO 150
            ENDIF
          ENDDO
 150    ENDDO
        thermo(8,int) = templ(8)
        thermo(9,int) = templ(9)
        IF ( ifaz.GT.0 ) THEN
          nall = nall + 1
          IF ( ifaz.GT.ifzm1 ) THEN
            inew = inew + 1
          ELSE
            inew = i
          ENDIF
          WRITE (13) name,ntl,date,(sym(j),fno(j),j=1,5),inew,tl,mwt,
     &                  thermo
        ENDIF
 200  ENDDO
      ifzm1 = ifaz
      IF ( ifaz.LE.0 ) THEN
        inew = 0
        nall = nall + 1
        IF ( ifaz.LE.0.AND.ns.EQ.0 ) THEN
          ngl = ngl + 1
          IF ( fill(3) ) THEN
            atms = 0.
            DO i = 1,5
              IF ( sym(i).EQ.' '.OR.sym(i).EQ.'E' ) GOTO 210
              atms = atms + fno(i)
            ENDDO
C FOR GASES WITH NO COEFFICIENTS FOR TGL(3)-TGL(4) INTERVAL,
C CALCULATE ESTIMATED COEFFICIENTS. (STRAIGHT LINE FOR CP/R)
 210        aa = 2.5D0
            IF ( atms.GT.1.9 ) aa = 4.5D0
            IF ( atms.GT.2.1 ) aa = 3.*atms - 1.75D0
            ttl = tl(2)
            tx = ttl - tinf
            cpfix = 0
            templ(8) = 0.
            templ(9) = 0.
            dlt = DLOG(ttl)
            DO k = 7,1, - 1
              kk = k - 3
              IF ( kk.EQ.0 ) THEN
                cpfix = cpfix + thermo(k,2)
                templ(8) = templ(8) + thermo(k,2)
                templ(9) = templ(9) + thermo(k,2)*dlt
              ELSE
                tex = ttl**kk
                cpfix = cpfix + thermo(k,2)*tex
                templ(9) = templ(9) + thermo(k,2)*tex/kk
                IF ( kk.EQ.-1 ) THEN
                  templ(8) = templ(8) + thermo(k,2)*dlt/ttl
                ELSE
                  templ(8) = templ(8) + thermo(k,2)*tex/(kk+1)
                ENDIF
              ENDIF
            ENDDO
            templ(2) = (cpfix-aa)/tx
            thermo(4,3) = templ(2)
            templ(1) = cpfix - ttl*templ(2)
            thermo(3,3) = templ(1)
            thermo(8,3) = thermo(8,2)
     &                    + ttl*(templ(8)-templ(1)-.5*templ(2)*ttl)
            thermo(9,3) = -templ(1)*dlt + thermo(9,2) + templ(9)
     &                    - templ(2)*ttl
          ENDIF
        ENDIF
C WRITE COEFFICIENTS ON SCRATCH I/O UNIT 13
        WRITE (13) name,ntl,date,(sym(j),fno(j),j=1,5),ifaz,tl,mwt,
     &                thermo
      ENDIF
      GOTO 100
C END OF DATA. COPY CONDENSED & REACTANT DATA FROM 13 & ADD TO 6.
 300  REWIND 13
      IF ( ns.EQ.0 ) ns = nall
      WRITE (6) tgl,ngl,ns,nall,Thdate
C WRITE GASEOUS PRODUCTS ON 6
      IF ( ngl.NE.0 ) THEN
        DO i = 1,ns
          READ (13) name,ntl,date,(sym(j),fno(j),j=1,5),ifaz,tl,mwt,
     &                 thermo
          IF ( ifaz.LE.0 ) WRITE (6) name,ntl,date,
     &                            (sym(j),fno(j),j=1,5),ifaz,tl,mwt,
     &                            thermo
        ENDDO
      ENDIF
      IF ( ngl.NE.nall ) THEN
C WRITE CONDENSED PRODUCTS AND REACTANTS ON 6
        REWIND 13
        DO i = 1,nall
          READ (13) name,ntl,date,(sym(j),fno(j),j=1,5),ifaz,tl,mwt,
     &                 thermo
          IF ( i.GT.ns ) THEN
            WRITE (6) name,ntl,date,(sym(j),fno(j),j=1,5),ifaz,tl,
     &                    mwt,thermo(1,1)
            IF ( ntl.GT.0 ) WRITE (6) thermo
          ELSEIF ( ifaz.GT.0 ) THEN
            WRITE (6) name,ntl,date,(sym(j),fno(j),j=1,5),ifaz,tl,
     &                    mwt,(thermo(k,1),k=1,9)
          ENDIF
        ENDDO
      ENDIF
      GOTO 1000
 400  WRITE (8,99007) name
 1000 STOP
99001 FORMAT (4F10.3,a10)
99002 FORMAT (a15,a65)
99003 FORMAT (i2,1x,a6,1x,5(a2,f6.2),i2,f13.5,f15.3)
99004 FORMAT (' ',a15,2x,a6,e15.6,2x,a65)
99005 FORMAT (2F11.3,i1,8F5.1,2x,f15.3)
99006 FORMAT (5D16.8/2D16.8,16x,2D16.8)
99007 FORMAT (/' ERROR IN PROCESSING thermo.inp AT OR NEAR ',A15,
     &        ' (UTHERM)')
      END

C***********************************************************************
C                      P R O G R A M      P A C 9 9
C
C           PROPERTIES AND COEFFICIENTS FOR INDIVIDUAL SPECIES
C***********************************************************************
C
C   Nov.22,1994 - EFTAPE - Remove restriction that "EFDA" with no data
C                 must end set of EFdata input.  
C   Mar.10,1995 - Change dimensions in WCOMMN to accomodate x's and y's
C                 for 9 nus rather than 6.
C   Mar.23,1995 - Put correction in EFTAPE.  We were getting multiple
C                 sets of data for MG which is in the sample problems.
C   Sep.20,1996 - Error in plot dump stuff.
C   Oct.4,1996  - Error corrected for nal>0 in ATOM.
C   Oct.30.1996 - Add CPONLY fitting option. This option is similar to
C                 the NOH and NOS combination but the original data are
C                 not replaced with data calculated using the Cp-fit
C                 coefficients.
C   Nov.4, 1996 - ATOM. Remove EQUIVALENCE statement and increase
C                 dimensions of Q, TDQDT, XTDQDT. There was a problem
C                 exceeding dimensions with the nal FILL option.
C   Nov.15,1996 - LOGK. To correct delta h and log K calculations
C                 when 'joules' tables are not called for.
C   Dec.19,1996 - main. Correct statement 560 for CTAB option.
C   Dec.19,1996 - RECO. Statement setting NF moved because it was not
C                 always being set.
C   Dec.27,1996 - POLY. Disallow theta corrections with IAIBIC input.
C                 Variable calcth added.
C   Jan. 6,1997 - LOGK. Logk and Deltah were wrong for some 
C                 combinations of CAL and JOULES in OUTP record.
C   Feb 11,1997 - WILHOI. Add 'TSTA' to METH record.
C   May  7,1997 - Corrected comman alignment. Errors were discovered
C                 when PAC97 was compiled on SGI.
C   Jul 25,1997 - ATOM. Increased dim of levels from 600 to 800.
C   Aug 20,1997 - ATOM. Add BETHE method.
C   Oct  3,1997 - POLY. Add additional check for number of vibs.
C   Oct  8,1998 - Change number of temperatures for property tables
C                 from 202 to 502.
C   Dec 24,1998 - Main. Add 'H0' and 'HF0' label options on formula line
C   Jan  4,1999 - EFTAPE. Add third decimal place for T in EFdata.
C   May 25,1999 - BLOCKDATA. New atomic weights.
C   June 4,1999 - PUNCH. Use f13.7 instead of f13.5 for molecular wt.
C   July29,1999 - Disable test for completed LS before *.plt dump.
C   Feb 1, 2000 - IROTOR. Made IxB double precision, eg 2.7992774d0.
C   Sep 5, 2000 - RECO. Correct H298-H0 when changing energy units.
C   Dec19, 2000 - COMMON. CPONLY(8) --> CPONLY(9).
C   Dec20, 2000 - COMMON. T(502) --> T(0:502).
C   Feb27, 2001 - LINK1. Change max test on QLNTOT from 88.d0 to 700.d0
C   Oct12, 2001 - ATOM. Limit no. of atomic levels to 900.
C   Jan31, 2002 - IROTOR and HMAT.  Tried to change maximum number of potential
C                 terms for hindered rotors from 6 to 8. Also number of B's
C                 from 4 to 6.  HMAT is general and has the most changes.
C   Jun27, 2002 - RECO. The K in KCAL and KJOULE were being ignored on METH 
C                 record when enthalpies were absolute (follow H).
C   Jul02, 2002 - HMAT. Add HINT to DOUBLE PRECISION list as required by
C                 single precision machines.
C   Sep06, 2002 - Minor changes including I/O variable names throughout.
C   Oct18, 2002 - BLOCKDATA. New atomic wts with N=14.0067. Most data in
C                 were corrected to these wts.  A few species were not.
C
      PROGRAM PAC99
C
C  PROPERTIES AND COEFFICIENTS CODE BY BONNIE MCBRIDE, NASA LEWIS
C
C     TEST(1)  LEAST SQUARES COEFFICIENTS HAVE BEEN CALCULATED.
C     TEST(2)  MOLECUTE IS LINEAR
C     TEST(3)  SPECIES IS AN ION.
C     TEST(4)  SPECIES IS A GAS.
C     TEST(5)  SPECIES IS A LIQUID.
C     TEST(6)  SPECIES IS A SOLID.
C     TEST(7)  METHOD RECORD HAS BEEN READ
C     TEST(8)  AN ASSIGNED H IS AVAILABLE
C     TEST(9)  CP/R, H-H0/RT, AND S/R ARE READY TO BE OUTPUTTED
C     TEST(10) SPECIES TO BE REFERENCE ELEMENT FOR HEAT-OF-FORMATION
C              AND LOGK CALCULATIONS.  REVISE unf.EFdata file.
C     TEST(12) LOG K CALLED FOR
C     TEST(13) DATA ARE IN THE FORM, H-H298 AND -(F-H298)
C     TEST(14) INTERMEDIATE OUTPUT CALLED FOR
C     TEST(15) LEAST SQUARES CALLED FOR
C     TEST(16) ERROR IN INPUT.  GO TO NEXT SPECIES
C     TEST(17) WRITE OUT READ-IN COEFFICIENTS  (I/O UNITS 12 & 16)
C     TEST(18) ENTHALPY IS ABSOLUTE
C     TEST(19) SPECH IS SET
C     TEST(20) TEMPERATURE SCHEDULE HAS BEEN STORED
C
      SAVE
      PARAMETER (IOCFT=10,IOELM=11,IOEFT=13,IOSCH=14,IOPLT=16)
      PARAMETER (IOUSCH=17,IOGRP=19)
      LOGICAL CFOUT,TAB8,exs,plot
      DOUBLE PRECISION CONV,EXL,TEX,TT,TCWD(32),cpsave,difcp,hsave
      DOUBLE PRECISION ssave
C
      CHARACTER*4 TCLB(32)
      CHARACTER*4 ORIG,COFS
C
      DIMENSION ORIG(2),COFS(4)
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      CHARACTER*200 prefix*196,infile,ofile,pfile,cfile,efile
      DATA COFS/'COEF','FICI','ENTS',' '/, ORIG/'ORIG','INAL'/
      WRITE (*,5)
 5    FORMAT (//' ENTER PREFIX ONLY FOR INPUT FILE, SUFFIX SHOULD BE', 
     &' .i97'/' OUTPUT FILES WILL HAVE THE SAME PREFIX WITH SUFFIXES:',
     & //,5x,'.o97  FOR STANDARD OUTPUT (I/O UNIT 6)',
     & /,5x,'.c97  FOR COEFFICIENTS IN FORMAT REQUIRED FOR CEA',
     & /,5x,'.p97  FOR DATA DUMPED FOR PLOTTING',
     & /,5x,'.e97  FOR ELEMENT DATA USED IN EFDATA FILE'//)
      READ (*,10) prefix
 10   FORMAT (a)
      ln = INDEX(prefix,' ') - 1
      infile = prefix(1:ln)//'.i97'
      ofile = prefix(1:ln)//'.o97'
      pfile = prefix(1:ln)//'.p97'
      cfile = prefix(1:ln)//'.c97'
      efile = prefix(1:ln)//'.e97'
      INQUIRE (FILE=infile,EXIST=exs)
      IF ( .NOT.exs ) THEN
        PRINT *, ' NONEXISTENT FILE ',infile
        STOP 
      ENDIF
      OPEN (5,FILE=infile,STATUS='old',FORM='formatted')
      OPEN (6,FILE=ofile,STATUS='unknown',FORM='formatted')
      OPEN (IOSCH,STATUS='scratch',FORM='formatted')
      OPEN (IOUSCH,STATUS='scratch',FORM='unformatted')
      OPEN (IOGRP,FILE='new.groups',STATUS='old',FORM='formatted')
      OPEN (IOEFT,FILE='unf.EFdata',FORM='unformatted')
      OPEN (IOCFT,FILE=cfile,FORM='formatted')
      WRITE (6,99001)
      WRITE (6,99002)
      WRITE (6,99001)
C
C  INITIALIZE ONCE.
C
      NEL=0
      R=RR/4.184D0
      REWIND IOSCH
      LINES=16
      GO TO 25
C
C  INITIALIZATION FOR EACH SPECIES.  FOLLOWS FINISH RECORD.
C
20    LINES=6
      mtab=-1
      idone=0
25    DO 30 I=1,4
30    SNM(I)=' '
      DO 40 I=1,502
      CPR(I)=0.
40    T(I)=0.
      DATE(1)=' '
      DATE(2)=' '
      TLST=0.
      NT=0
      INA=1
      NNA=0
      DO 60 I=1,19
      DO 55 K=1,6
55    NAME(I,K)=' '
60    TEST(I)=.FALSE.
      TEST(20)=.FALSE.
      DO 65 I=1,3
65    TOUT(I)=.FALSE.
      TAB8=.FALSE.
      plot=.FALSE.
      HEAT=' '
      TINTVL=0.0
      NIT=1
      NTMP=1
      NNN=1
      ASINDT=0.0
      ASINDH=0.0D0
      SPECH=0.0
      H298HR=0
      H298H0=0
      intvls=0
      ivl1=0
      NFZ=0
      PI=0.
      PTMELT=0.0
      CNST=.TRUE.
      CFOUT=.FALSE.
      NTCF=0
      TCONST=0.
c
      DO 70 I=1,9
      TRANGE(I)=0.
      NF(I)=0
      NOCP(I)=.FALSE.
      NOH(I)=.FALSE.
      NOS(I)=.FALSE.
      CPONLY(i) = .FALSE.
      DO 70 J=1,10
      COEF(J,I)=0.
70    EX(J,I)=0.
c
      OLD=.FALSE.
      IX=1
      ITR=0
      NTRANG=0
      STD=' '
      BAR=.TRUE.
      SCONST=SBAR
C
C  CALL INPUT TO READ AND WRITE CONTENTS OF ONE INPUT RECORD.
C
80    CALL INPUT
C
C     CHECK RECORD IDS.
C
90    IF (CODE(1).EQ.'FINI') GO TO 490
      IF (CODE(1).EQ.'LIST') GO TO 170
      IF (CODE(1).EQ.'ATM' ) GO TO 155
      IF (CODE(1).EQ.'OUTP') GO TO 210
      IF (CODE(1).EQ.'PHAS') GO TO 230
      IF (CODE(1).EQ.'INTE') GO TO 280
      IF (CODE(1).EQ.'DATE') GO TO 260
      IF (CODE(1).EQ.'TEMP') GO TO 300
      IF (CODE(1).EQ.'PINT') GO TO 330
      IF (CODE(1).EQ.'METH') GO TO 340
      IF (CODE(1).EQ.'EFTA') GO TO 290
      IF (CODE(1).EQ.'LOGK') GO TO 310
      IF (CODE(1).EQ.'REFN'.OR.CODE(1).EQ.' '.OR.CODE(1).EQ.'NAME') GOTO
     * 80
      IF (CODE(1).EQ.'NOLE') GO TO 160
      IF (CODE(1).EQ.'LSTS') GO TO 670
      IF (CODE(1).EQ.'EFDA') GO TO 200
      IF (CODE(1).EQ.'CTEM') GO TO 860
      IF (CODE(1).EQ.'STOP') GOTO 900
C
C  IF COLS 1-4 CONTAIN NO RECOGNIZABLE CODE, ASSUME formula RECORD.
C  CALL IDENT TO ANALYZE FORMULA
C
      CALL IDENT
      IF (TEST(16)) GO TO 420
C
C  STORE HEAT OF REACTION AND ASSIGNED T FROM FORMULA RECORD
C
      HEAT = ' '
      DO 120 I=2,4
      IF (ABEL(1,I).EQ.'T') THEN
        ASINDT = WORD(I)
      ELSEIF (ABEL(1,I).EQ.'DELT'.OR.ABEL(1,I).EQ.'HF0'.OR.
     &  ABEL(1,I).EQ.'Hf0') THEN
        HEAT = 'DELT'
        ASINDH = WORD(I)
      ELSEIF (ABEL(1,I).EQ.'ASIN'.OR.ABEL(1,I).EQ.'H0'.OR.
     &  ABEL(1,I).EQ.'HF29'.OR.ABEL(1,I).EQ.'Hf29') THEN 
        HEAT = 'ASIN'
        ASINDH = WORD(I)
        IF (ABEL(1,I).EQ.'HF29'.OR.ABEL(1,I).EQ.'Hf29') 
     &    ASINDT = 298.15D0
      ENDIF
120   CONTINUE
      IF (HEAT.NE.' '.AND.ASINDT.EQ.0.) TEST(19)=.TRUE.
      IF (HEAT.EQ.'ASIN'.AND.ASINDT.EQ.0.) TEST(8)=.TRUE.
C
C  CONVERT HEAT OF REACTION TO PROPER UNITS IF NECESSARY.
C
      CONV=1.D0
      DO 140 I=2,4
      IF (ABEL(1,I).EQ.'KCAL'.OR.ABEL(1,I).EQ.'KJOU') CONV=1000.D0
      IF (ABEL(1,I).EQ.'EV') CONV=23060.541D0
      IF (R.GT.8.D0.AND.(ABEL(1,I).EQ.'CAL'.OR.CONV.NE.1.)) CONV=
     1  CONV*4.184D0
      IF (ABEL(1,I).EQ.'INVC') CONV=R*HCK
      IF (R.GT.2.D0) GO TO 130
      IF (ABEL(1,I).EQ.'JOUL'.OR.ABEL(1,I).EQ.'KJOU')
     1  CONV=CONV/4.184D0
130   IF (CONV.NE.1.D0) GO TO 150
140   CONTINUE
      IF (R.GT.8.D0) CONV=CONV*4.184D0
150   ASINDH=ASINDH*CONV/R
      GO TO 80
C
155   IF (.NOT.TEST(4)) GO TO 80
      BAR=.FALSE.
      STD='ATM'
      SCONST=SATM
      GO TO 80
160   TEST(15)=.FALSE.
      GO TO 80
170   CALL EFLIST
      GO TO 80
 200  OPEN (IOELM,FILE=efile,FORM='formatted')
      CALL EFTAPE
      GO TO 80
C
C     PROCESS 'OUTP' RECORD
C
210   DO 220 I=1,4
        IF (ABEL (1,I).EQ.'JOUL') THEN
          TOUT (2)=.TRUE.
        ELSEIF (ABEL (1,I).EQ.'CAL') THEN
          TOUT (3)=.TRUE.
        ELSEIF (ABEL (1,I).EQ.'DMLE') THEN
          TOUT (1)=.TRUE.
          TAB8=.TRUE.
        ELSEIF (ABEL (1,I).EQ.'CTAB') THEN
          CFOUT=.TRUE.
        ELSEIF (ABEL (1,I).EQ.'LOGK') THEN
          TEST(12)=.TRUE.
        ELSEIF (ABEL (1,I).EQ.'INTE') THEN
          TEST (14)=.TRUE.
        ELSEIF (ABEL (1,I).EQ.'ATM'.AND.TEST(4)) THEN
          BAR=.FALSE.
          STD='ATM'
          SCONST=SATM
        ELSEIF (ABEL (1,I).EQ.'MFIG') THEN
          TAB8=.TRUE.
        ELSEIF (ABEL (1,I).EQ.'EFTA') THEN
          TEST (10)=.TRUE.
        ELSEIF (ABEL (1,I).EQ.'LSQS'.OR.ABEL (1,I).EQ.'LSTS') THEN
          TEST (15)=.TRUE.
        ELSEIF (ABEL (1,I).EQ.'PLOT') THEN
          plot = .TRUE.
          OPEN (IOPLT,FILE=pfile,FORM='formatted')
        ENDIF
220   CONTINUE
      GO TO 80
C
C  CONDENSED PHASE THAT CANNOT FIT ON FORMULA RECORD.  PUT L FOR LIQ OR
C     ANY CHARACTER FOR SOLID.  USE COLUMN 7,25,43,OR 61.
C
230   TEST(4)=.FALSE.
      DO 240 I=1,4
      IF (ABEL(1,I).EQ.' ') GO TO 240
      FAZ=ABEL(1,I)
      IF (FAZ.EQ.'L') TEST(5)=.TRUE.
      IF (FAZ.NE.'L') TEST(6)=.TRUE.
240   CONTINUE
      GO TO 80
C
C  STORE OPTIONS.
C
260   DO 270 IJ=1,4
      IF (ABEL(1,IJ).EQ.' ') GO TO 270
      DATE(1)=ABEL(1,IJ)
      DATE(2)=ABEL(2,IJ)
270   CONTINUE
      GO TO 80
280   TEST(14)=.TRUE.
      GO TO 80
290   TEST(10)=.TRUE.
      GO TO 80
300   CALL TEMPER
      TEST(20)=.TRUE.
      GO TO 80
310   TEST(12)=.TRUE.
      GO TO 80
C
330   mtab=1
      DO 335 I=1,4
        IF (ABEL(1,I).EQ.'JOUL') mtab=2
        IF (ABEL(1,I).EQ.'CAL') mtab=3
335   CONTINUE
      GO TO 80
C
C  METHOD RECORD HAS BEEN READ.
C
340   IF(BAR.AND.TEST(4)) STD='BAR'
      DO 350 I=1,4
      IF (ABEL(1,I).EQ.' ') GO TO 350
      IF (ABEL(1,I).EQ.'READ'.OR.ABEL(1,I).EQ.'COEF') CODE(1)=ABEL(1,I)
      IF (ABEL(1,I).EQ.'ADD'.OR.ABEL(1,I).EQ.'WILH') CODE(1)=ABEL(1,I)
      IF (ABEL(1,I).EQ.'NOAT') NOATMS=WORD(I)
      IF (ABEL(1,I).EQ.'IP') PI=WORD(I)
350   CONTINUE
      IF (CODE(1).NE.'WILH') GO TO 355
      IF (TEST (9)) THEN
      CALL WILHOI
      ELSE
      WRITE (6,*) 'NO DATA FOR WILHOIT EXTRAPOLATION'
      ENDIF
      GO TO 80
355   IF (TEST(15).OR.TEST(17)) IX=IX+1
      TEST(7)=.TRUE.
      IF (NT.NE.0 .OR. CODE(1).EQ.'READ') GO TO 370
C
C  STORE STANDARD T SCHEDULE IF NO TEMP RECORDS HAVE BEEN READ.
C
      IF (TEST(3)) GO TO 362
      T(1)=100.0
      T(2)=200.0
      T(3)=298.15D0
      T(4)=300.0
      DO 360 NT=5,61
360   T(NT)=T(NT-1)+100.0
      NT=61
      GO TO 370
C
362   T(1)=298.15D0
      T(2)=300.
      NT=59
      DO 364 I=3,59
364   T(I)=T(I-1)+100.D0
C
C      CALL RECO FOR READIN OR COEF METHODS
C      CALL ATOM FOR MONATOMIC GASES
C      CALL POLY FOR DIATOMIC OR POLYATOMIC GASES
C      CALL GROUP FOR GROUP ADDITIVITY PROGRAM
C
370   IF (CODE(1).NE.'ADD') GO TO 380
      STD=' '
C
C      ENTROPY DIFFERENCE FOR BAR AND ATMOSPHERE IGNORED
C
      CALL GROUP
      GO TO 470
380   IF (CODE(1).NE.'READ'.AND.CODE(1).NE.'COEF') GO TO 390
      CALL RECO
      GO TO 480
390   IF ((HCK.EQ.0.).OR.WEIGHT.EQ.0.) GO TO 400
      IF (NOATMS.EQ.1) GO TO 450
      IF (NOATMS.GE.2) GO TO 460
C
400   WRITE (6,410)
410   FORMAT (/,' ERROR IN INPUT, GO TO NEXT SPECIES, (MAIN PGM)')
C
420   IF (CODE(1).EQ.'FINI') GO TO 440
      READ (5,430) CODE(1)
430   FORMAT (A4)
      GO TO 420
440   TEST(16)=.FALSE.
      LINES=LINES+2
      GO TO 20
450   CALL ATOM
      GO TO 470
460   CALL POLY
470   NIT=NT+1
480   IF (TEST(16)) GO TO 400
      TEST(7)=.FALSE.
      GO TO 90
C
490   IF (TEST(9)) GO TO 510
      WRITE (6,500)
500   FORMAT(/' CP/R,(H-H0)/RT,AND S/R ARE NOT READY FOR OUTPUT (MAIN)')
      GO TO 20
510   NLAST=NT
C
C  CALL DELH TO CALCULATE H0 IF NECESSARY.  DELH WILL CALL LEAST FOR
C      LEAST SQUARES FIT IF OPTION HAS BEEN REQUESTED.
C
      IF (NNN.LT.NLAST) CALL DELH
      SNM(1)=ORIG(1)
      SNM(2)=ORIG(2)
      SNM(3)=' '
      SNM(4)=' '
C
C  CALL TABLES TO PRINT FIRST TWO TABLES OF FUNCTIONS.
C
      CALL PAGEID
      if (.not.tout(1).and..not.tout(3)) tout(2)=.true.
      IF (TAB8) CALL TABLES
C
C  FOR EFTAPE OPTION, CALL EFTAPE TO PUNCH EF DATA AND PUT DATA ON TAPE.
C
      IF (TEST(10)) then
        OPEN (IOELM,FILE=efile,FORM='formatted')
        CALL EFTAPE
      ENDIF
C
C     IF LOGK OPTION, CALL LOGK TO CALCULATE DELTAH AND LOG K AND
C      PRINT TWO TABLES OF PROPERTIES.
C
      IF (TEST(12)) CALL LOGK
      IF (.NOT.CFOUT.AND..NOT.plot) GO TO 20
C  Following statement disabled 7/29/99
C     if (test(15) .and. .not.TEST(1)) go to 20
      DO 550 I=1,4
      SNM(I)=COFS(I)
550   ABEL(1,I)=' '
      IF ( plot ) GO TO 615
560   IF ( NTCF.EQ.0 ) GOTO 615
      IJ=0
      NT=0
      DO 600 J=1,NTCF
      IJ=IJ+1
      WORD(IJ)=TCWD(J)
      ABEL(1,IJ)=TCLB(J)
      IF (J.LT.NTCF) GO TO 580
      DO 570 IJ=IJ+1,4
570   ABEL(1,IJ)=' '
      GO TO 590
580   IF (IJ.LT.4) GO TO 600
590   CALL TEMPER
      IJ=0
600   CONTINUE
C
C  INSERT TRANSITION POINTS IN CTEM SCHEDULE
C
      if(nna.le.1) go to 615
      it=1
      do 610 n=1,nna-1
        tt=ttrans(n)
        do 604 i=it,nt-1
          IF( tt.le.t(i) ) THEN
            ii=i
            ix=2
            if(tt.eq.t(i))ix=1
          ENDIF
604     continue
        it=ii
        NT=NT+IX
        do 608 i=nt,it,-1
          t(i)=t(i-ix)
608     continue
        t(it)=tt
        t(it+1)=tt
610   continue
C
615   IT=0
      L=1
620   IT=IT+1
622   TT=T(IT)
      if (tt.ge.tc(L)) go to 630
      nt=nt-1
      if(nt.le.it) go to 665
      do 624 i=it,nt
      cpr(i)=cpr(i+1)
624   t(i)=t(i+1)
      go to 622
630   IF (TT.LT.TC(L+1).OR.L.EQ.intvls) GO TO 640
      if(tt.eq.tc(l+1) .and. tt.ne.t(it-1)) go to 640
      L=L+1
      IF (L.LE.intvls) GO TO 630
      nt=it-1
      GO TO 665
640   cpsave = CPR(IT)
      hsave = HHRT(IT)
      ssave = SR(IT)
      CPR(IT)=0.
      HHRT(IT)=0.
      SR(IT)=0.
      GHRT(IT)=0.
      NFL=NF(L)
      DO 650 J=1,NFL
      EXL=EX(J,L)
      TEX=COEF(J,L)
      IF (EXL.NE.0.) TEX=TEX*TT**EXL
      IF (EXL.EQ.-1.) HHRT(IT)=HHRT(IT)+COEF(J,L)*DLOG(TT)/TT
      IF (EXL.NE.-1.) HHRT(IT)=HHRT(IT)+TEX/(EXL+1.D0)
      CPR(IT)=CPR(IT)+TEX
      IF (EXL.EQ.0.) SR(IT)=SR(IT)+COEF(J,L)*DLOG(TT)
      IF (EXL.NE.0.) SR(IT)=SR(IT)+TEX/EXL
650   CONTINUE
      HHRT(IT)=HHRT(IT)+(COEF(9,L)-ASINDH)/TT
      SR(IT)=SR(IT)+COEF(10,L)
      GHRT(IT)=SR(IT)-HHRT(IT)
      IF ( plot ) THEN
        difcp = cpsave - CPR(IT)
        WRITE ( IOPLT,99010 ) T(IT),cpsave,CPR(IT),hsave,HHRT(IT),
     &           ssave,SR(IT)
      ENDIF
      IF (IT.LT.NT) GO TO 620
665   IF ( plot.AND.cfout ) THEN
        plot = .FALSE.
        GOTO 560
      ENDIF
      IF ( CFOUT ) THEN
        IF (TAB8) CALL TABLES
        IF (TEST(12)) CALL LOGK
      ENDIF
      GO TO 20
C
C  STORE DATA FROM LSTSQS RECORD.
C
670   IX=IC80
      if (ix.eq.0) ix=9
      DO 680 I=1,4
      IF (ABEL(1,I).EQ.'EXP') GO TO 690
      IF (ABEL(1,I).EQ.'NOCP'.OR.ABEL(1,I).EQ.'NOH'.OR.
     1 ABEL(1,I).EQ.'NOS') GOTO 690
680   CONTINUE
      GO TO 730
690   IF (IX.LE.9) GO TO 730
      WRITE (6,720)
720   FORMAT(/' ONLY 8 TEMPERATURE INTERVALS ALLOWED FOR LEAST SQUARES')
      GO TO 80
730   DO 850 I=1,4
      IF (ABEL(1,I).EQ.'T') GO TO 760
      IF (ABEL(1,I).EQ.'TCON'.OR.ABEL(1,I).EQ.'TPRO') GO TO 750
      IF (ABEL(1,I).EQ.'EXP') GO TO 780
      IF (ABEL(1,I).EQ.' ') GO TO 850
      IF (ABEL(1,I).EQ.'NOCN') GO TO 790
      IF (ABEL(1,I).EQ.'NOCP') GO TO 800
      IF (ABEL(1,I).EQ.'NOH') GO TO 810
      IF (ABEL(1,I).EQ.'OLD') go to 815
      IF (ABEL(1,I).EQ.'NOS') GO TO 820
      IF (ABEL(1,I).EQ.'CPON') GO TO 818
      WRITE (6,740) ABEL(1,I),WORD(I)
740   FORMAT (/,A4,' IS AN INCORRECT LABEL FOR THE NUMBER--',E12.4,
     1  '.  VALUE IGNORED (MAIN PGM)')
      GO TO 850
750   TCONST=WORD(I)
      GO TO 850
760   NTRANG=NTRANG+1
      IF (NTRANG.GT.9) GO TO 850
      TRANGE(NTRANG)=WORD(I)
      GO TO 850
780   NF(IX)=NF(IX)+1
      N=NF(IX)
      EX(N,IX)=WORD(I)
      if (ic80.eq.0) lscode(1) = -1
      GO TO 850
790   CNST=.FALSE.
      GO TO 850
800   NOCP(IX)=.TRUE.
      GO TO 830
810   NOH(IX)=.TRUE.
      GO TO 830
815   OLD=.TRUE.
      go to 830
818   CPONLY(IX) = .TRUE.
      NOH(IX) = .TRUE.
820   NOS(IX)=.TRUE.
830   IF (IC80.NE.0) GO TO 850
      DO 840 J=1,8
      CPONLY(J) = CPONLY(ix)
      NOCP(J)=NOCP(ix)
      NOS(J)=NOS(ix)
840   NOH(J)=NOH(ix)
850   CONTINUE
      GO TO 80
860   DO 890 I=1,4
      IF (ABEL(1,I).EQ.'T'.OR.ABEL(1,I).EQ.'I') GO TO 870
      IF (ABEL(1,I).EQ.' ') GO TO 890
      WRITE (6,740) ABEL(1,I),WORD(I)
      GO TO 890
870   NTCF=NTCF+1
      TCWD(NTCF)=WORD(I)
      TCLB(NTCF)=ABEL(1,I)
890   CONTINUE
      GO TO 80
900   CLOSE (5)
      CLOSE (6)
      CLOSE (IOSCH)
      CLOSE (IOUSCH)
      CLOSE (IOGRP)
      CLOSE (IOEFT)
      CLOSE (IOELM)
      CLOSE (IOPLT)
      STOP
99001 FORMAT (/' ***************************************************',
     & '****************************',/)
99002 FORMAT (11x,'NASA-LEWIS PROPERTIES AND COEFFICIENTS PROGRAM,',
     & '  P A C 99',/ 9x,'BY  BONNIE MCBRIDE AND',
     & ' SANFORD GORDON  REF: NASA RP-1271,1992 & TP-2002-211556')
c99010 FORMAT (1x,1p,8E12.5)
99010 FORMAT (1x,1p,E12.4,2E13.6,5E12.4)
      END
      SUBROUTINE ATOM 
      SAVE 
C 
C  ROUTINE CALCULATES PROPERTIES OF ATOMIC GASES FROM ENERGY LEVELS.  
C 
C  BUILT-IN FILL PARAMETERS WERE TAKEN FROM : J.R.DOWNEY,JR., 
C    "CALCULATION OF THERMODYNAMIC PROPERTIES OF IDEAL GASES AT HIGH 
C    TEMPERATURES," THE DOW CHEMICAL CO.,MIDLAND,MI,CONTRACT NOS 
C    F44620-75-C-0048 AND AFOSR-TR-78-0960, MARCH 9,1978.  
C    PARAMETERS ARE NOT BUILT IN FOR ATOMIC NOS 58-71 AND NOS LARGER 
C    THAN 86.  FOR THESE ATOMS AND IONIC SPECIES VALUES MAY BE READ IN 
C    ON THE METH RECORD WITH LABELS SUMG AND B.  SUMG REPRESENTS THE 
C    TOTAL QUANTUM WEIGHT OF THE GROUND STATE.  FOR POSITIVE B VALUES 
C    THE TOTAL QUANTUM WEIGHT OF AN EXCITED STATE IS BN**2. FOR NEGATIVE 
C    B VALUES THE TOTAL QUANTUM WEIGHT IS THE ABSOLUTE VALUE OF B.  
C
      CHARACTER*4 CUTOFF
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      DIMENSION AJ(900),G(900),NN(900),nnlast(400)
      REAL*8 ALNWT,QSUM,TEMPY,TMP,TDQDTS,X,XTDQDS,gfill(400),anum1
      REAL*8 ANU(900),Q(1500),TDQDT(1500),XTDQDT(1500),anui(400),anuk
C
      LOGICAL TSTFIL,GLABEL,limitL
C
C  INITIALIZE TO NO CUT-OFF AND NO FILL
C
      NATOM=100
      CUTOFF=' '
      TSTFIL=.FALSE.
      GLABEL=.FALSE.
      limitL=.false.
      B=0
      FORM=0
      NFIXED=10000

C
C  CHECK FOR FILL AND CUTOFF ON METHOD RECORD.
C
      DO 20 I=1,4
      IF (ABEL(1,I).EQ.'FILL') then
         TSTFIL=.TRUE.
         nal=word(i)
      ELSEIF (ABEL(1,I).EQ.'GLAB') then
         GLABEL=.TRUE.
      ELSEIF (ABEL(1,I).EQ.'TEMP') then
         CUTOFF='TEMP'
      ELSEIF (ABEL(1,I).eq.'FIXE') then
         NFIXED=WORD(I)
         CUTOFF='FIXE'
      ELSEIF (ABEL(1,I).eq.'BETH') then
         NFIXED=WORD(I)
         CUTOFF='BETH'
         one6th=1.d0/6.d0
      ELSEIF (ABEL(1,I).EQ.'B') then
         B=WORD(I)
      ELSEIF (ABEL(1,I).EQ.'SUMG') then
         FORM=WORD(I)
      ENDIF
20    CONTINUE
      K=0
      ALNWT=DLOG(WEIGHT)*1.5 D0
      NFIRST=0
      WRITE (6,30) WEIGHT
30    FORMAT (/,' ATOMIC WEIGHT =',F12.7)
      LINES=LINES+2
      IF(.NOT.TEST(14)) GO TO 40
      DO 36 I=1,100
      WRITE (6,33) SYMBOL(1,I),SYMBOL(2,I),ATMWT(I),NMAT(I),NMLA(I),
     1 GG(I),AG(I)
33    FORMAT (5X,2A1,F15.5,2I6,2F8.0)
36    CONTINUE
C
C  CALL INPUT TO READ AND LIST A DATA RECORD.
C
40    CALL INPUT
      IF (NFIRST.NE.0) GO TO 50
      SUB=CODE(1)
      NFIRST=1
50    IF (CODE(1).NE.SUB) GO TO 120
      If (limitL) goto 40
      DO 110 I=1,4
      IF (ABEL(1,I).NE.'IP') GO TO 60
      PI=WORD(I)
      GO TO 110
60    IF (FWORD(I).LT.0.) GO TO 110
      IF (K.EQ.900) GO TO 90
      K=K+1
      NN(K)=IC80
      IF (NN(K).EQ.0.AND.CUTOFF.NE.' ') GO TO 70
          if (GLABEL) then
              g(k)=fword(i)
                  if (g(k).le.0.) then
                  WRITE (6,65)
65                FORMAT (/,' **** g <= 0 ')
                  RETURN
                  endif
              AJ(K)=(g(K)-1.)/2.
          else
              AJ(K)=FWORD(I)
              G(K)=2.*AJ(K)+1.
          endif
      ANU(K)=WORD(I)
      IF ((WORD(I).EQ.0.).AND.(K.GT.1)) ANU(K)=ANU(K-1)
      GO TO 110
70    WRITE (6,80) ABEL(1,I),NN(K)
80    FORMAT (/,' ERROR IN DATA--J =',A6,6X,7HLEVEL =,I3)
      LINES=LINES+2
      GO TO 110
90    WRITE (6,100)
100   FORMAT (/,' PROGRAM CAN ACCOMMODATE ONLY 900 LEVELS')
      limitL = .true.
      goto 680
110   CONTINUE
      GO TO 40
120   KLAST=K
C
C  SORT ENERGY LEVELS IN INCREASING NUMERICAL ORDER.
C
      J=1
130   M=J
      DO 150 I=J,KLAST
      IF (ANU(M)-ANU(I)) 150,150,140
140   M=I
150   CONTINUE
      IF (M-J) 160,170,160
160   TEMPY=ANU(M)
      ANU(M)=ANU(J)
      ANU(J)=TEMPY
      TEMPY=G(M)
      G(M)=G(J)
      G(J)=TEMPY
      KTEMPY=NN(M)
      NN(M)=NN(J)
      NN(J)=KTEMPY
      TEMPY=AJ(M)
      AJ(M)=AJ(J)
      AJ(J)=TEMPY
170   J=J+1
      IF (KLAST-J) 180,180,130
180   CONTINUE
      NN(KLAST+1)=0
      AJ(KLAST+1)=0.0
      G(KLAST+1)=0.0
      ANU(KLAST+1)=0.0
      IF (.NOT.TEST(14)) GO TO 220
      WRITE (6,190)
190   FORMAT (/,4X,1HN,6X,1HJ,7X,1HG,5X,13HENERGY LEVEL ,12X,1HN,6X,
     1'J',7X,1HG,5X,13HENERGY LEVEL )
      LINES=LINES+2
      DO 210 I=1,KLAST,2
      INN=I+1
      WRITE (6,200) (NN(IN),AJ(IN),G(IN),ANU(IN),IN=I,INN)
200   FORMAT (2(I6,F8.1,F8.1,F14.3,10X))
      LINES=LINES+1
210   continue
220   IF (CUTOFF.NE.'FIXE') GO TO 240
      IF (NFIXED.GE.NN(1)) GO TO 240
      WRITE (6,230) NN(1)
230   FORMAT (/' SINCE FIXEDN IS LESS THAN FIRST N, FIXEDN IS SET EQUAL'
     1  ,I3, '(ATOM)')
      NFIXED=NN(1)
      LINES=LINES+2
C
C  FILL OPTION
C
240   IF (.NOT.TSTFIL) GO TO 390
      INDX=JF(1)
      IF (NKIND.EQ.1) GO TO 260
C
C  ION WITH FILL
C
      IF(MLA(2).GT.0) GO TO 260
      INDX=INDX+MLA(2)
      IF (INDX.GT.3) GO TO 260
      IF (INDX.LT.3) GO TO 270
      INDX=2
C
260   IF (B.EQ.0.) B=AG(INDX)
      IF (FORM.EQ.0.) FORM=GG(INDX)
270   IF ((B.EQ.0.).OR.FORM.EQ.0.) GO TO 370
      WRITE (6,275) nal
275   FORMAT (/,' NUMBER OF ADDITIONAL LEVELS =',i4)
      WRITE (6,280)
280   FORMAT ('  B/-C*',8X,1HN,2X,'PRED.SUM(2J+1)',2X,'ACT.SUM(2J+1)'
     1 ,2X,'DIFF',6X,'MAX LEVEL',5X,'2J+1  T CUTOFF')
      KX=1
      NN1=NN(1)
290   KUREN=NN(KX)
      SUM=0.0
      L=1
      K=KX
      DO 360 J=K,KLAST
      IF (NN(J).LT.0) GO TO 320
      IF (NN(J)-KUREN) 295,300,310
295   if (KUREN.NE.NN1) go to 310
300   SUM=SUM+G(J)
      M=J
      NN(J)=-NN(J)
      IF (J.NE.KLAST) GO TO 360
      GO TO 330
310   IF (L.NE.1) GO TO 320
      L=0
      KX=J
320   IF (J.NE.KLAST) GO TO 360
330   IF (KUREN.EQ.NN1) GO TO 340
      IF (B.GT.0.) GO TO 335
      FORM=ABS(B)
      GO TO 340
335   TEMPY=KUREN*KUREN
      FORM=B*TEMPY
340   DIFF=FORM-SUM
      IF (KUREN.LT.NN1) DIFF=0.0
      NNM=MAX(-NN(M),NN1)
      IF (DIFF.GT.0.0) then
         if (nal.gt.0) then
            gfill(nnm)=diff/nal
            nnlast(nnm)=m
            anui(nnm)= (PI-ANU(M))/(nal+1)
         else
            g(m)=g(m)+diff
            nnlast(nnm)=0
         endif
      ENDIF
      tcut = (pi - ANU(M))*HCK
      WRITE (6,350) B,NNM,FORM,SUM,DIFF,ANU(M),G(M),tcut
350   FORMAT (/,F9.1,I7,F12.1,F15.1,F11.1,F14.3,F9.1,F10.1)
      IF (L.NE.1) GO TO 290
      GO TO 390
360   CONTINUE
370   WRITE (6,380)
380   FORMAT (/,' NO FILL--B OR SUMG MISSING ON METHOD RECORD, (ATOM)')
C
C  END FILL OPTION
C
390   IF (ASINDT.NE.0.0) GO TO 400
      NT1=NT
      GO TO 410
400   NT1=NT+1
      T(NT1)=ASINDT
C
C  M = INDEX FOR T.   K = INDEX FOR ELECTRONIC LEVELS.
410   DO 650 M=NIT,NT1
      I=0
      JJ=1
      mic = 2.461D0*T(M)**one6th
      IF(CUTOFF.eq.'BETH') NFIXED=MAX(iabs(NN(1)),mic)
C
C  CALCULATE THE PARTITION FUNCTION AND DERIVATIVES FOR EACH ELECTRONIC
C      LEVEL AND TEMPERATURE.
      anum1=anu(1)
      nout=-nn(1)
      DO 555 K=1,KLAST
      infill=0
      IF (nal.gt.0) then
         nnk=max(-NN(k),NN1)
         if (k.eq.nnlast(nnk))then
            infill=nal
         endif
      ENDIF
      gk=g(k)
      anuk=ANU(K)
      do 551 in=0,infill
         if (in.gt.0) then
            gk=gfill(nnk)
            anuk=anuk+ anui(nnk)
         endif
      X=(HCK/T(M))*ANUK
      IF (X-85.) 440,420,420
420   IF (.NOT.TEST(14)) GO TO 580
      WRITE (6,430)
430   FORMAT (/,' NOT ALL LEVELS WERE USED.  X IS GREATER THAN 85.')
      GO TO 580
440   IF (CUTOFF.NE.'TEMP') GO TO 490
      IF (PI.NE.0.) GO TO 460
      WRITE (6,450)
450   FORMAT (/,' IONIZATION POTENTIAL IS MISSING')
      GO TO 680
460   THERM=PI-T(M)/HCK
      IF (ANUK-THERM) 500,500,470
470   IF (TEST(14)) then
         WRITE (6,480) THERM,anum1,nout
480      FORMAT (/,' ALL LEVELS USED TO THE THERMAL BINDING ENERGY'
     1     ,F12.3,/'   LAST LEVEL USED =',F12.3,';    N =',I4)
      ELSEIF (in.eq.0) then
         go to 580
      ENDIF
      go to 555
490   IF (IABS(NN(K)).gt.NFIXED) THEN
        JJ=0
        GO TO 550
      ENDIF
500   I=I+1
      if (I.GT.1500) then
        limitL = .true.
        WRITE (6,100)
        goto 680
      endif
      Q(I)=GK*DEXP(-1.D0*X)
      TDQDT(I)=Q(I)*X
      XTDQDT(I)=TDQDT(I)*X
      IF (Q(I)-0.1E-9) 510,510,550
510   IF (X-2.0) 550,550,520
520   IF (XTDQDT(I)-0.1E-9) 530,530,550
530   IF (.NOT.TEST(14)) GO TO 580
      WRITE (6,540) anum1,nout
540   FORMAT (/' NOT ALL ASSIGNED LEVELS USED, Q AND DERIVS ARE TOO SMALL
     *;'/'  LAST LEVEL USED =',F12.3,' ;  N =',I4)
      GO TO 580
550   anum1=anuk
      nout=nnk
551   continue
555   CONTINUE
      IF (.NOT.TEST(14)) GO TO 580
      IF (JJ.EQ.0) WRITE (6,560) NFIXED
560   FORMAT (/,' ALL LEVELS USED THROUGH N =',I5)
      IF (JJ.NE.0) WRITE (6,570)
570   FORMAT (/,' ALL ASSIGNED LEVELS HAVE BEEN USED')
C  CALCULATE TOTAL Q, DERIVATIVES, AND THERMODYNAMIC FUNCTIONS FOR T.
580   QSUM=0.0
      TDQDTS=0.0
      XTDQDS=0.0
      J=I
      DO 590 II=1,J
      QSUM=QSUM+Q(I)
      TDQDTS=TDQDTS+TDQDT(I)
      XTDQDS=XTDQDS+XTDQDT(I)
590   I=I-1
      IF (TDQDTS-0.1D-9) 600,610,610
600   TMP=0.0
      GO TO 620
610   TMP=TDQDTS/QSUM
620   HHRT(M)=TMP+2.5
      IF (M.GT.NT) GO TO 660
      CPR(M)=2.5+XTDQDS/QSUM-TMP*TMP
      GHRT(M)=DLOG(QSUM)+2.5*DLOG(T(M))+ALNWT+SCONST
      SR(M)=GHRT(M)+HHRT(M)
      IF (.NOT.TEST(14)) GO TO 650
      WRITE (6,630) T(M),CPR(M),HHRT(M),GHRT(M)
630   FORMAT (1X,'T',F11.2,6X,'CP/R',F12.6,6X,'H-H0/RT',F11.6,6X,
     1'G-H0/RT',F12.6)
      x=anum1*hck/t(m)
      WRITE (6,640) X,QSUM,TDQDTS,XTDQDS
640   FORMAT (1X,'X',F12.7,6X,'QSUM',F12.7,6X,'T(DQ/DT)S',F13.7,6X,
     1 'XT(DQ/DT)S',F13.7)
650   CONTINUE
      GO TO 670
660   SPECH=HHRT(NT1)*ASINDT
      IF (DABS(ASINDT-298.15D0).LT..05) SPECH=HHRT(NT1)*298.15D0
C
C  TEST(19)-- ENTHALPY HAS BEEN CALCULATED FOR T  ON FORMULA RECORD.
C  TEST(9)--FUNCTIONS HAVE BEEN CALCULATED.
C
      TEST(19)=.TRUE.
670   TEST(9)=.TRUE.
680   if (limitL) TEST(9)=.false.
      RETURN
      END
      SUBROUTINE DELH
      SAVE
C
C  CALCULATES THE ASSIGNED H VALUE.  CALLS LEAST AND PUNCH.
C
      PARAMETER (IOEFT=13)
      DIMENSION ELMT(2)
      DOUBLE PRECISION TP(3,502),HZERO,AMP,TNO,HA,TI
C
      CHARACTER*4 DELTAH,ASH,ELMT,PHAZ
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      EQUIVALENCE  (TP,TAPE)
      DATA DELTAH/'DELT'/, ASH/'ASIN'/
C
      IF (TEST(18)) GO TO 30
      IF (H298HR.EQ.0. .AND. .NOT.TEST(13)) GO TO 30
15    IF (HEAT.EQ.BLANK) GO TO 120
      IF (TEST(13).AND.ASINDT.EQ.298.15D0) TEST(8)=.TRUE.
      IF (TEST(8)) GO TO 55
      IF (TEST(19)) GO TO 110
      WRITE (6,20)
20    FORMAT (/,' INSUFFICIENT DATA FOR AN H0 VALUE, (DELH)')
      GO TO 310
30    DO 40 I=1,NT
      IF (DABS(T(I)-298.15D0).GT.5.D-02) GO TO 40
      IF(TEST(18))GO TO 44
      IF(H298HR.EQ.0.)H298HR=298.15D0*HHRT(I)
      GO TO 15
40    CONTINUE
      IF(TEST(18))GO TO 70
      GO TO 15
44    IF(TEST(8))GO TO 47
      IF(H298HR.EQ.0.)GO TO 45
      ASINDH=HHRT(I)*298.15D0-H298HR
      ASINDT=0.
      GO TO 46
45    ASINDT=298.15D0
      ASINDH=HHRT(I)*298.15D0
      H298HR=ASINDH
46    HEAT=ASH
      TEST(8)=.TRUE.
47    DO 48 I=1,NT
      TI=T(I)
      IF(DABS(TI-298.15).LT..05)TI=298.15D0
      GHRT(I)=GHRT(I)+ASINDH/TI
48    HHRT(I)=HHRT(I)-ASINDH/TI
      IF(ASINDT.EQ.298.15D0)TEST(13)=.TRUE.
      TEST(18)=.FALSE.
      DO 50 IA=ivl1,intvls
      IF (COEF(1,IA).EQ.0.D0 .AND. COEF(2,IA).EQ.0.D0) GO TO 50
      COEF(9,IA)=COEF(9,IA)-asindh
50    CONTINUE
55    IF (.NOT.TEST(17)) GO TO 60
      if (ivl1.le.idone) go to 310
      CALL PUNCH
      TEST(17)=.FALSE.
      GO TO 66
60    if(.not.TEST(15)) go to 65
      CALL LEAST
65    if(.not.TEST(1) .or. ivl1.le.idone) go to 310
      CALL PUNCH
66    TTRANS(INA)=TC(INTVLS+1)
      INA=MIN0(NNA,INA+1)
C     idone=intvls
      GO TO 310
C
70    IF(.NOT.TEST(8))GO TO 15
      IF(ASINDT.EQ.0.)GO TO 90
      IF(ASINDT.NE.298.15D0)GO TO 15
      TEST(13)=.TRUE.
90    TEST(18)=.FALSE.
      DO 100 I=1,NT
      HHRT(I)=HHRT(I)-ASINDH/(T(I))
100   GHRT(I)=GHRT(I)+ASINDH/(T(I))
      GO TO 15
C
110   IF (HEAT.EQ.ASH) GO TO 140
      IF (HEAT.EQ.DELTAH) GO TO 150
120   WRITE (6,130)
130   FORMAT (/' EITHER ASINDH,DELTAH,OR HF298, WAS NOT FOUND ON THE',
     1' FORMULA RECORD, (DELH)')
      LINES=LINES+2
      TEST(8)=.FALSE.
      GO TO 310
140   ASINDH=ASINDH-SPECH
      IF (DABS(ASINDT-298.15D0).LT..05) H298HR=SPECH
      TEST(8)=.TRUE.
      GO TO 30
C
150   IF (HEAT.EQ.DELTAH) ASINDH=ASINDH-SPECH
      REWIND IOEFT
      ICT=0
160   READ (IOEFT,END=250) ELMT,NELM,PHAZ,CODE,HZERO,AMP,TNO,((TP(J,K),
     * J=1,3),K=1,101)
      IF (ELMT(1).EQ.BLANK) GO TO 250
      IF (HEAT.EQ.DELTAH) GO TO 170
      IF (NELM.GT.1) GO TO 160
      IF (PHAZ.NE.'G') GO TO 160
170   DO 200 I=1,NKIND
      J=JF(I)
      IF (PHAZ.EQ.EFAZ(J)) GO TO 180
      IF (PHAZ.EQ.'G'.OR.EFAZ(J).EQ.'G') GO TO 200
180   IF (NELM.NE.NMLA(J)) GO TO 200
      IF (ELMT(1).NE.FORMLA(1,I)) GO TO 200
      IF (ELMT(2).NE.FORMLA(2,I)) GO TO 200
      ICT=ICT+1
      GO TO 210
200   CONTINUE
      GO TO 160
210   IF (ASINDT.EQ.0.) GO TO 240
      N=TNO+.1
      DO 220 K=1,N
      IF (DABS(TP(1,K)-ASINDT).LT..000001) GO TO 270
220   CONTINUE
      WRITE (6,230)
230   FORMAT (/' HHRT FOR ASINDT WAS NOT FOUND ON EF TAPE, (DELH)')
      GO TO 300
240   HA=HZERO
      GO TO 280
250   WRITE (6,260) FORMLA(1,I),FORMLA(2,I)
260   FORMAT (/,1x,2A1,'DATA WERE NOT FOUND ON EF TAPE, (DELH)')
      GO TO 300
270   HA=TP(2,K)*(TP(1,K)+HZERO)
280   IF (HEAT.EQ.DELTAH) ASINDH=ASINDH+FLOAT(MLA(I))*HA/FLOAT(NMLA(J))
      IF (ICT.GE.NKIND) GO TO 290
      GO TO 160
290   TEST(8)=.TRUE.
300   REWIND IOEFT
      IF (TEST(8)) GO TO 30
310   RETURN
      END
      SUBROUTINE DERIV (I1,I2,I3,I4,I5,J1,J2,J3,J4,J5,J6)
      SAVE
C
C  FIND Q DERIVATIVES.
C
      double precision QCORT
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      real*8 v,x,y,alfa,alfb,alfc,g,wx,beta,a,b,c,dard,dd,wf,w,sym,stwt,
     1 t00,theta,rh,r,s,ql,q,qln,dq,ddq,qtot,qlntot,dqtot,ddqtot,aij,
     2 aiii,ai
      logical testw
      COMMON /WCOMMN/ V(300),X(9,9),Y(9,9,9),ALFA(9),ALFB(9),ALFC(9),
     1 G(9),WX(9),BETA(4),A,B,C,DARD,DD,WF,W,SYM,STWT,T00,THETA(3),
     2 RH(6),R(300,3),S(300,3),QL(3),Q,QLN,DQ,DDQ,QTOT,QLNTOT,DQTOT,
     3 DDQTOT,AIJ(9,9),AIII,AI(9),DN(300),ND(300),CORT,NNU,TESTW(6)
C
      DIMENSION I(5), J(6)
C
      I(1)=I1
      I(2)=I2
      I(3)=I3
      I(4)=I4
      I(5)=I5
      J(1)=J1
      J(2)=J2
      J(3)=J3
      J(4)=J4
      J(5)=J5
      J(6)=J6
      QL(2)=0.
      QL(3)=0.
      DO 20 IR=1,5
      K=I(IR)
      IF (K.EQ.0) GO TO 30
      QL(1)=QL(1)*R(K,1)
      QL(2)=QL(2)+R(K,2)
20    QL(3)=QL(3)+R(K,3)
30    DO 40 IS=1,6
      K=J(IS)
      IF (K.EQ.0) GO TO 50
      QL(1)=QL(1)*S(K,1)
      QL(2)=QL(2)+S(K,2)
40    QL(3)=QL(3)+S(K,3)
50    QLN=QLN+QL(1)
      QCORT=QL(2)-CORT
      DQ=QCORT*QL(1)+DQ
      DDQ=QL(1)*(QL(3)+QCORT**2-QCORT)+DDQ
      RETURN
      END
      SUBROUTINE EFTAPE
      SAVE
C
C  PROCESS EF DATA.   DATA ARE STORED ON IO UNIT IOEFT FOR SUBSEQUENT
C     USE IN DELTA H AND LOG K CALCULATIONS.
C  USES IO UNIT IOUSCH AS SCRATCH TAPE FOR UNFORMATTED DATA.
C
      PARAMETER (IOELM=11,IOEFT=13,IOUSCH=17)
      DIMENSION ELMT(2),DD(2)
      DOUBLE PRECISION HOVERR,MELTPT,TNUM,FILL(3)
      CHARACTER*4 DD,PM,ANT,H0R,ELMT,PHAZ
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      EQUIVALENCE (WORD(2),FILL(1))
C
      DATA PM/'MP'/,ANT/'NT'/,H0R/'H0/R'/
C
C  TEST 10--WRITE EF DATA CALCULATED IN CURRENT RUN ON IO UNIT IOELM IN
C       FORMATTED FORM.  ALSO ADD TO UNFORMATTED DATA ON IO UNIT IOEFT.
C
      MELTPT=PTMELT
      HOVERR=ASINDH
      IF (.NOT.TEST(10)) GO TO 160
      TN=NT
      TNUM=TN
      WRITE (IOELM,20) 'EFDA',FORMLA(1,1),FORMLA(2,1),MLA(1),FAZ,DATE,
     1 H0R,HOVERR,PM,PTMELT,ANT,TN
20    FORMAT (A4,2X,2A1,I1,A1,3X,2A4,3X,3(A4,2X,F12.4),I2)
      WRITE (6,30) ' EFDA',FORMLA(1,1),FORMLA(2,1),MLA(1),FAZ,DATE,H0R,
     1 HOVERR,PM,PTMELT,ANT,TN
30    FORMAT (/,1x,A4,2X,2A1,I1,A1,3X,2A4,3X,3(A4,2X,F12.4),I2)
      WRITE (IOELM,60) (T(I),HHRT(I),GHRT(I),I=1,NT)
60    FORMAT (2(F12.3,2F14.6))
      WRITE (6,70) (T(I),HHRT(I),GHRT(I),I=1,NT)
70    FORMAT (1X,F12.3,2F14.6,F12.3,2F14.6)
C
C  SET POSITION ON TAPE IOEFT
C
      REWIND IOEFT
      REWIND IOUSCH
      ND=1
      DO 80 IX=1,220
      II=IX
      READ (IOEFT,END=115) ELMT,NLM,PHAZ,DD,FILL,TAPE
      IF (ELMT(1).EQ.BLANK) GO TO 110
      IF (ELMT(1).NE.FORMLA(1,1)) GO TO 80
      IF (ELMT(2).NE.FORMLA(2,1)) GO TO 80
      IF (NLM.NE.MLA(1).OR.PHAZ.NE.FAZ) GO TO 80
      ND=0
      GO TO 90
80    CONTINUE
C
90    DO 100 ix=II,220
      READ (IOEFT,END=115) ELMT,NLM,PHAZ,DD,FILL,TAPE
      WRITE (IOUSCH) ELMT,NLM,PHAZ,DD,FILL,TAPE
      ndfile = ix
      IF (ELMT(1).EQ.BLANK) GO TO 110
100   CONTINUE
c110   II=II-1
110   continue
115   REWIND IOUSCH
      REWIND IOEFT
      ii=ii-1
      IF (II.LT.1) GO TO 130
      DO 120 I=1,II
      READ (IOEFT,END=130) ELMT,NLM,PHAZ,DD,FILL,TAPE
120   CONTINUE
C
130   DO 140 I=1,502
140   TAPE(I)=T(I)
      WRITE (IOEFT) FORMLA(1,1),FORMLA(2,1),MLA(1),FAZ,DATE,HOVERR,
     1 MELTPT,TNUM,(TAPE(I),HHRT(I),GHRT(I),I=1,502)
      IF (ND.EQ.1) GO TO 260
      II=II+1
      DO 150 KI=II,NDFILE
      READ (IOUSCH) ELMT,NLM,PHAZ,DD,FILL,TAPE
      WRITE (IOEFT) ELMT,NLM,PHAZ,DD,FILL,TAPE
150   CONTINUE
c     GO TO 400
      GO TO 500
C
C   WRITE FORMATTED EF DATA READ FROM IO UNIT 5 TO IO UNIT IOEFT IN
C       UNFORMATTED FORM.
C
160   IF (FORMLA(1,1).EQ.BLANK) GO TO 260
      DO 170 J=1,100
      IF (SYMBOL(1,J).NE.FORMLA(1,1)) GO TO 170
      IF (SYMBOL(2,J).NE.FORMLA(2,1)) GO TO 170
      GO TO 190
170   CONTINUE
      WRITE (6,180) FORMLA(1,1),FORMLA(2,1)
180   FORMAT (/,1x,2A1,' NOT IN SYMBOL LIST (EFTAPE)')
190   N=WORD(4)*3.D0+.1
      READ (5,60) (TAPE(I),I=1,N)
C
      N1=N+1
      IF (N1.GT.1506)GO TO 255
      DO 250 J=N1,1506
250   TAPE(J)=0
255   WRITE (IOEFT) FORMLA(1,1),FORMLA(2,1),MLA(1),FAZ,DATE,FILL,TAPE
      GO TO 500
260   WRITE (IOEFT) BLANK,BLANK,NLM,FAZ,DATE,FILL,TAPE
      GO TO 500
C
C  LIST ENTHALPY AND FREE ENERGY DATA FOR THE ELEMENTS.
C
      ENTRY EFLIST
C
      WRITE (6,290)
290   FORMAT (//,1x,' EFDATA - DIMENSIONLESS ENTHALPY AND GIBBS '
     1 ,'FUNCTION FOR THE ELEMENTS',//)
      REWIND IOEFT
300   READ (IOEFT,END=500) ELMT,NLM,PHAZ,DD,FILL,TAPE
      N=FILL(3)*3.D0+.1
c     IF (ELMT(1).EQ.BLANK) GO TO 400
      IF (ELMT(1).EQ.BLANK) GO TO 500
      WRITE (6, 310) ELMT,NLM,PHAZ,DD,FILL
310   FORMAT (/' EFDATA',5X,2A1,I1,'(',A1,')',5X,2A4,5X,'H0/R',F11.4,
     1 5X,'MP',F10.4,5X,'NT',F5.0,/)
      WRITE (6,60) (TAPE(J),J=1,N)
      GO TO 300
C
c400   WRITE (6,410)
c410   FORMAT ('1   ')
500   RETURN
      END
C
      SUBROUTINE EIGEN (N) 
      SAVE 
C 
      DOUBLE PRECISION MU,NUF,NUI,A,OMEGA,SINT,COST,BIP,SINT2,COST2
      DOUBLE PRECISION SINCOS,APQ,BPP,BQQ,BPQ,BQP,SWAP
C
      COMMON /BLK3/A(188,188)
C
      NUI=0.D0
      FN=N
      DO 10 JX=1,N
      DO 10 JY=JX,N
      IF (JX.EQ.JY) GO TO 10
      NUI=NUI+A(JX,JY)**2
10    CONTINUE
      NUI=DSQRT(NUI+NUI)
      NUF=1.0D-8*NUI
20    NUI=NUI/FN
30    IQ=2
40    IP=1
50    IF (DABS(A(IP,IQ)).GE.NUI) GO TO 100
      IF (IP.NE.IQ-1) GO TO 90
60    IF (IQ.EQ.N) GO TO 70
      IQ=IQ+1
      GO TO 40
70    IF (IND.NE.1 .OR. NUI.EQ.0.) GO TO 80
      IND=0
      GO TO 30
80    IF (NUI.LE.NUF) GO TO 120
      GO TO 20
90    IP=IP+1
      GO TO 50
100   IND=1
      MU=0.5*(A(IP,IP)-A(IQ,IQ))
      OMEGA=-A(IP,IQ)/DSQRT(A(IP,IQ)**2+MU**2)
      IF (MU.LT.0.) OMEGA=-OMEGA
      SINT=OMEGA/DSQRT(2.*(1.+DSQRT(1.-OMEGA**2)))
      COST=DSQRT(1.-SINT**2)
      DO 110 I=1,N
      IF (I.EQ.IP.OR.I.EQ.IQ) GO TO 110
      BIP=A(I,IP)*COST-A(I,IQ)*SINT
      A(I,IQ)=A(I,IP)*SINT+A(I,IQ)*COST
      A(I,IP)=BIP
      A(IP,I)=A(I,IP)
      A(IQ,I)=A(I,IQ)
110   CONTINUE
      SINT2=SINT*SINT
      COST2=COST*COST
      SINCOS=SINT*COST
      APQ=2.*A(IP,IQ)*SINCOS
      BPP=A(IP,IP)*COST2+A(IQ,IQ)*SINT2-APQ
      BQQ=A(IP,IP)*SINT2+A(IQ,IQ)*COST2+APQ
      BPQ=(A(IP,IP)-A(IQ,IQ))*SINCOS+A(IP,IQ)*(COST2-SINT2)
      BQP=BPQ
      A(IP,IP)=BPP
      A(IQ,IQ)=BQQ
      A(IP,IQ)=BPQ
      A(IQ,IP)=BQP
      IF (IP.EQ.IQ-1) GO TO 60
      GO TO 90
120   NM1=N-1
      DO 130 I=1,NM1
      DO 130 J=I,N
      IF (A(I,I).LT.A(J,J)) GO TO 130
      SWAP=A(I,I)
      A(I,I)=A(J,J)
      A(J,J)=SWAP
130   CONTINUE
      RETURN
      END
      SUBROUTINE GROUP
      SAVE
      PARAMETER (IOGRP=19)
C
C  PROGRAM MODIFIED FOR INTERACTIVE USE BY S.E.STEIN ON 5/2/84
C  THERE ARE FOUR TYPES OF C-ATOMS USED IN GROUP DEFINITION
C    (1) BENSON-TYPE GROUPS'  CB (BENZENE LIKE); CD (DOUBLY BONDED);
C        CF (FUSED RING); C2ACE (ACENAPHTHYLENE RING-GROUP);
C      CT( TRIPLY BONDED); CBY (BENZYNE TYPE)
C   **** FOR ACTUAL GROUPS IN USE SEE FILE GROUP ****
C    (2) BOND STRENGTH CORRECTIONS- TO GENERATE RADICAL R. FROM
C        PRECURSOR MOLECULE R-H, SUBTRACT ONE OF THESE GROUPS FROM R-H.
C        THE GROUPS ARE' HVIN (VINYL-H); HVINS (STABILIZED VINYL-H);
C          HPHEN (PHENYL-H); HC2H (C2H-H)
C    (3) MISCELLANEOUS CORRECTIONS' NSY (SYMMETRY |); NIS (ISOMER |);
C          H298 (ENTHALPY CORRECTION AT 298K, IN KCAL);
C          ES298 (ENTROPY CORRECTION AT 298K, IN E.U.)
C    (4) ENTIRE MOLECULES' H2; H; C2H2; C4H2
C
      CHARACTER*4 TITLE,GRP,GFORM,SYMNO,STATWT,SRCO,HRCO,EL,SOMN
C
      DIMENSION TITLE(2),GRP(2,60)
      DIMENSION GRPN(60),SEL(5),GFORM(2,5),GMLA(5),EL(2,5),fmla(5)
      LOGICAL SUMOK
      DOUBLE PRECISION FWT,TFWT,AN(10,2),TLN,TT,TMIN,TMAX,TBE,TEN,htform
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      DATA SYMNO/'SYMN'/, STATWT/'STAT'/, SRCO/'SRCO'/, HRCO/'HRCO'/
      DATA SOMN /'NISO'/
C
C  INITIALIZE FOR EACH SET OF METHOD AND DATA RECORDS.
C
      DO 10 I=NIT,NT
      CPR(I)=0.0
      HHRT(I)=0.0
10    GHRT(I)=0.0
      HHRT(NT+1)=0.0
      GHRT(NT+1)=0.0
      ASINDT=298.15D0
      SUMOK=.TRUE.
      TFWT=0.
      TMIN=100.
      TMAX=6000.
      DO 20 I=1,5
      GFORM(1,I)=BLANK
      GFORM(2,I)=BLANK
      fmla(i)=mla(i)
20    GMLA(I)=0
      DO 40 K=1,2
      DO 40 J=1,10
40    COEF(J,K)=0.D0
      SYM=1.0
      NG=0
C
      WRITE (6,60) WEIGHT
60    FORMAT (/,' MOLECULAR WT.=',F12.7)
      NFIRST=0
      LINES=LINES+4
C
65    READ (5,70) CODE,(ABEL(1,I),ABEL(2,I),WORD(I),I=1,4)
70    FORMAT (A4,A2,4(A4,A2,F12.9))
      IF (NFIRST.NE.0) GO TO 95
C
C  INITIALIZE FOR FIRST RECORD ONLY.
      NFIRST=1
      SUB=CODE(1)
C
C  IF COLS 1-4 OR 79-80 ARE DIFFERENT FROM PREVIOUS RECORD, GO TO 323.
C
95    IF (CODE(1).NE.SUB) GO TO 323
      WRITE (6,75) CODE,(ABEL(1,I),ABEL(2,I),WORD(I),I=1,4)
75    FORMAT (/,1x,A4,A2,4(A4,A2,F12.6))
C
C  IN DO LOOP THRU 320 CHECK EACH LABEL ON DATA RECORD AND STORE DATA.
C
      DO 320 ID=1,4
      IF (ABEL(1,ID).EQ.BLANK) GO TO 320
      IF (ABEL(1,ID).EQ.SYMNO) GO TO 130
      IF (ABEL(1,ID).EQ.SOMN .OR. ABEL(1,ID).EQ.STATWT) GO TO 135
      IF (ABEL(1,ID).EQ.SRCO) GO TO 140
      IF (ABEL(1,ID).EQ.HRCO) GO TO 145
      IF (NG.LE.60) GO TO 120
      WRITE(6,110) ABEL(1,ID),ABEL(2,ID)
110   FORMAT(/,1x,2A4,'IS BEYOND GROUP NUMBER LIMIT OF 60')
      GO TO 320
120   NG=NG+1
      GRP(1,NG)=ABEL(1,ID)
      GRP(2,NG)=ABEL(2,ID)
      GRPN(NG)=WORD(ID)
      GO TO 320
130   COEF(10,1)=COEF(10,1)-DLOG(WORD(ID))
      GO TO 320
135   COEF(10,1)=COEF(10,1)+DLOG(WORD(ID))
      GO TO 320
140   COEF(10,1)=COEF(10,1)+WORD(ID)
      GO TO 320
145   COEF(9,1)=COEF(9,1)+WORD(ID)
320   CONTINUE
      GO TO 65
C
323   COEF(10,2)=COEF(10,1)
      COEF(9,2)=COEF(9,1)
      NGG=0
325   READ(IOGRP,330,END=388) TITLE,numint,(EL(1,I),EL(2,I),
     *  SEL(I),I=1,5),fwt,htform
330   FORMAT (2A4,/i2,8x,5(2a1,f6.2),2x,f13.5,f15.3)
      ij=1
      do 335 i=1,numint
      read(IOGRP,333) t1,ten,numexp
333   format(1x,2f10.3,i2)
      read (IOGRP,334) (an(j,ij),j=1,10)
334   format(5d16.8)
      if(ij.eq.2)go to 335
      ij=2
      tbe=t1
335   continue
      if(numexp.gt.5 .or. numint .gt. 2) go to 380
      DO 340 IG=1,NG
      IF (TITLE(1).NE.GRP(1,IG)) GO TO 340
      IF (TITLE(2).NE.GRP(2,IG)) GO TO 340
      GO TO 350
340   CONTINUE
      GO TO 325
C
350   TFWT=TFWT+FWT*GRPN(IG)
      NGG=NGG+1
      DO 370 I=1,5
      IF (EL(1,I).EQ.BLANK.OR.SEL(I).EQ.0.) GO TO 370
      DO 360 L=1,NKIND
      IF (FORMLA(1,L).NE.EL(1,I)) GO TO 360
      IF (FORMLA(2,L).NE.EL(2,I)) GO TO 360
      GFORM(1,L)=EL(1,I)
      GFORM(2,L)=EL(2,I)
      GMLA(L)=GMLA(L)+SEL(I)*GRPN(IG)
      GO TO 370
360   CONTINUE
370   CONTINUE
      go to 382
380   WRITE (6,381) TITLE
381   FORMAT(/,2x,2A4,' HAS ILLEGAL FORMAT FOR GROUPS')
      go to 325
C
382   ivl1=1
      intvls=2
      DO 386 K=1,2
      nf(k)=numexp
      do 383 kk=1,numexp
383   ex(kk,k)=kk-1
      DO 385 J=1,10
385   COEF(J,K)=COEF(J,K)+GRPN(IG)*AN(j,k)
386   CONTINUE
      TMIN=DMAX1(TMIN,TBE)
      TMAX=DMIN1(TMAX,TEN)
      DO 387 I=1,5
      IF (FMLA(I).NE.GMLA(I)) GO TO 325
387   CONTINUE
C
388   DO 390 I=1,5
      IF (FMLA(I).NE.GMLA(I)) GO TO 400
      IF (GFORM(1,I).NE.FORMLA(1,I)) GO TO 400
      IF (GFORM(2,I).NE.FORMLA(2,I)) GO TO 400
390   CONTINUE
      IF (NGG.EQ.NG .AND. DABS(WEIGHT-TFWT).LT..01) GO TO 420
400   WRITE (6,410) FORMLA,FMLA,WEIGHT,GFORM,GMLA,TFWT
410   FORMAT (/' MISMATCH OF FORMULA WITH GROUPS (GROUP)'/,(6X,5(2A1,2X)
     *  ,5F5.2,2X,F13.5))
      TEST(16)=.TRUE.
      GO TO 575
C
420   IF (TMIN.GE.298. .AND. TMIN.LE.300.) TMIN=298.15
      if (test(15)) go to 422
      tc(1)=tmin
      tc(2)=1000.
      tc(3)=tmax
422   do 470 i=nit,nt
      TT=T(I)
      IF (TT.GE.TMIN) GO TO 430
      WRITE(6,425) TT
425   FORMAT(/' >>> T =',F10.2,' OUT OF RANGE OF GROUP DATA. PROPERTIES
     *MAY HAVE LARGE ERRORS')
      LINES=LINES+1
430   TLN=DLOG(TT)
      K=1
      IF (TT.GT.1000.) K=2
      HHRT(I)=((((COEF(5,K)/5.)*TT+COEF(4,K)/4.)*TT+COEF(3,K)/3.)*TT+
     * COEF(2,K)/2.)*TT+COEF(1,K)+COEF(9,K)/TT
      SR(I)=((((COEF(5,K)/4.)*TT+COEF(4,K)/3.)*TT+COEF(3,K)/2.)*TT+
     * COEF(2,K))*TT+COEF(1,K)*TLN+COEF(10,K)
      CPR(I)=(((COEF(5,K)*TT+COEF(4,K))*TT+COEF(3,K))*TT+COEF(2,K))*TT+
     *  COEF(1,K)
      GHRT(I)=SR(I)-HHRT(I)
      IF (DABS(TT-298.15D0).GT..01) GO TO 440
      ASINDH=HHRT(I)*TT
      test(8)=.true.
C
440   IF (TT.GE.TMAX) GO TO 480
470   continue
      go to 490
C
480   NT=I
490   NLAST=NT
      NT1=NT+1
      TEST(1)=.TRUE.
      TEST(9)=.TRUE.
      TEST(18)=.TRUE.
575   REWIND IOGRP
      BACKSPACE 5
      CALL INPUT
      RETURN
      END
C
      SUBROUTINE HMAT (N1,N2,ns,nb,EL)
C     Extended Jan.2002.
      SAVE
C
      LOGICAL cosine
      DOUBLE PRECISION EL(N2),hs
C
      double precision sn,bn,st,hint
      COMMON /BLK1/ SN(9),BN(9),ST
      COMMON /BLK3/ HINT(188,188)
C
      Do 10 i=1,N2
      Do 10 j=i,N2
10    hint(i,j) = 0.
      if (N1.eq.1) then
        cosine = .false.
        nn = 0
      elseif (N1.eq.2) then
        cosine = .true.
        nn = 1
        hint(1,1) = ST
      endif
C
      DO 70 i=1+nn,N2
        if (cosine.and.i.le.ns+1)hint(1,i) = hint(1,i)-.707107d0*SN(i-1)
        k=i-1
        do 60 j=1,ns
        hs = SN(j)*.5d0
        jj = i + j
        if (jj.gt.N2) goto 65
        hint(i,jj) = hint(i,jj) - hs
        IF (j.ge.2*(i-nn)) then
          k=k+1
          if (cosine) hs=-hs
          hint(i,k) = hint(i,k) + hs
        ENDIF
60      continue
65    hint(i,i) = hint(i,i) + (i-nn)**2 + ST
70    CONTINUE
C
      Do 80 I = 1,nb
        noffd = n2 - i
        do 75 j=1,noffd
          jpi = j+i
75      hint(j+nn,jpi+nn) = hint(j+nn,jpi+nn) + DFLOAT(j*jpi)*.5d0*bn(i)
80    Continue
C
      do 114 m=1,nb
      do 114 mp=m,nb
        I = m+mp
        if (I.gt.nb) goto 114
        j = m+nn
        k = mp+nn
        mmp = DFLOAT(m*mp)
        if (cosine) mmp = -mmp
        HINT(j,k) = HINT(j,k) + .5d0*mmp*BN(I)
114   continue
C
118   DO 120 I=1,N2
      DO 120 J=I,N2
120   HINT(J,I)=HINT(I,J)
C
      CALL EIGEN (N2)
      DO 130 I=1,N2
130   EL(I)=HINT(I,I)
      RETURN
      END
      SUBROUTINE IDENT
      SAVE
      PARAMETER (IOSCH=14)
C
C  FROM FORMULA, DETERMINE--
C      1)  PHASE OF SPECIES,
C      2)  NUMBER OF ATOMS IN SPECIES,
C      3)  MOLECULAR WEIGHT,
C      4)  IF ION, NUMBER OF ELECTRONS ADDED OR SUBTRACTED FROM NEUTRAL
C              SPECIES.
      DIMENSION A(24),NO(20),NUM(20),FM(10)
C
      CHARACTER*4 A,PLUS,AMINUS,PARNSL,FM
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      DATA PLUS/'+'/, AMINUS/'-'/, PARNSL/'('/
      DATA FM/'1','2','3','4','5','6','7','8','9','0'/
C
      DO 10 I=1,20
      NO(I)=0
10    NUM(I)=0
      READ (IOSCH,20) (A(I),I=1,24)
20    FORMAT (24A1)
      BACKSPACE IOSCH
C
C WHICH CHARACTERS ARE NUMBERS AND WHAT ARE THEY
C
C     INO=NUMBER OF NUMBERS
C     NUM(I)= LOCATION OF NUMBERS IN IA ARRAY
C     NO(I)= NUMBERS IN THESE LOCATIONS
C
      WEIGHT=0.0
      INO=0
      IX=0
      IONNUM=0
      DO 70 N=2,24
      DO 40 I=1,10
      IF (A(N).EQ.FM(I)) GO TO 50
40    CONTINUE
      IF (A(N).EQ.BLANK) GO TO 80
      IF (A(N).EQ.PLUS) IONNUM=IONNUM-1
      IF (A(N).EQ.AMINUS) IONNUM=IONNUM+1
      GO TO 70
50    IF (INO.NE.0.AND.N.GT.NUM(INO)+3) GO TO 90
      IF (I.EQ.10) I=0
      IF (IONNUM.EQ.0) GO TO 60
      IF (IONNUM.LT.0) I=-I
      IF (IX.NE.0) IX=10*IONNUM+I
      IF (IX.EQ.0) IX=I
      IONNUM=IX
      GO TO 70
60    INO=INO+1
      NO(INO)=I
      NUM(INO)=N
70    CONTINUE
C
C  IF NO NUMBERS (INO=0) PROBABLY NOT A FORMULA RECORD.  RETURN TO PAC1.
C
80    IF (INO.NE.0) GO TO 110
90    WRITE (6,100)
100   FORMAT (/' ERROR IN ABOVE RECORD, IGNORE CONTENTS, (IDENT)')
      RETURN
110   IF (IONNUM.EQ.0) GO TO 120
C
C  IONIC SPECIES,  CALCULATE CORRECTION TO MOLECULAR WEIGHT.
C
      TEST(3)=.TRUE.
      FIONNO=IONNUM
      WEIGHT=FIONNO*ATMWT(1)
      GO TO 150
120   NEXT=NUM(INO)+1
C
C  DETERMINE PHASE OF SPECIES.
C
      IF (A(NEXT).EQ.BLANK.OR.A(NEXT+1).EQ.'G') GO TO 150
      IF (A(NEXT).EQ.PARNSL) GO TO 140
      WRITE (6,130)
C
130   FORMAT (' ERROR IN NAME, GO TO NEXT SPECIES, (IDENT)')
      TEST(16)=.TRUE.
      RETURN
140   IF (A(NEXT+1).EQ.'L') TEST(5)=.TRUE.
      IF (A(NEXT+1).NE.'L') TEST(6)=.TRUE.
      NPLUS=NEXT+1
      FAZ=A(NPLUS)
      GO TO 160
150   TEST(4)=.TRUE.
      FAZ='G'
C
160   I=1
      J=1
      K=0
      DO 170 LMN=1,5
      FORMLA(1,LMN)=BLANK
      FORMLA(2,LMN)=BLANK
170   MLA(LMN)=0
      NOATMS=0
C
C  STORE EACH ATOMIC SYMBOL IN FORMLA(J).  NUMBER OF ATOMS IN MLA(J).
C
180   FORMLA(1,J)=A(K+1)
      IF (NUM(I).EQ.(K+3)) FORMLA(2,J)=A(K+2)
      IF ((NUM(I)+1).EQ.NUM(I+1)) GO TO 190
      MLA(J)=NO(I)
      GO TO 200
190   MLA(J)=10*NO(I)+NO(I+1)
      I=I+1
C
C  NOATMS = TOTAL NUMBER OF ATOMS IN MOLECULE.
200   NOATMS=NOATMS+MLA(J)
C
C FIND ATOM FORMULA IN SYMBOL TABLE
C
      DO 220 L=1,100
      DO 210 II=1,2
      IF (FORMLA(II,J).NE.SYMBOL(II,L)) GO TO 220
210   CONTINUE
      GO TO 250
220   CONTINUE
230   WRITE (6,240)
240   FORMAT (/' ATOM RECORD MISSING OR FORMULA INCORRECT, (IDENT)' )
      WEIGHT=0
      GO TO 260
C
C  CALCULATE MOLECULAR WEIGHT.
C  STORE POSITION OF ELEMENT DATA IN JF.
C
250   JF(J)=L
      IF (ATMWT(L).EQ.0.0) GO TO 230
      WEIGHT=WEIGHT+ATMWT(L)*FLOAT(MLA(J))
260   IF (INO.LE.I) GO TO 270
      K=NUM(I)
      I=I+1
      J=J+1
      GO TO 180
270   IF (.NOT.TEST(3)) GO TO 280
      J=J+1
      JF(J)=1
      FORMLA(1,J)=SYMBOL(1,1)
      MLA(J)=IONNUM
C
C  NKIND = NUMBER OF ELEMENTS IN FORMULA.
C
280   NKIND=J
C
C  ADJUST FORMULA TO COMBINE LIKE ELEMENTS.
C
      NKINDS=NKIND
      IF (NKIND.EQ.1) GO TO 350
      DO 340 J=2,NKINDS
      JK=J-1
      DO 310 JJ=1,JK
      DO 300 II=1,2
      IF (FORMLA(II,JJ).NE.FORMLA(II,J)) GO TO 310
300   CONTINUE
      GO TO 320
310   CONTINUE
      GO TO 340
320   MLA(JJ)=MLA(JJ)+MLA(J)
      NK=NKIND
      NKIND=NKIND-1
      DO 330 K=J,NKIND
      FORMLA(1,K)=FORMLA(1,K+1)
      FORMLA(2,K)=FORMLA(2,K+1)
      MLA(K)=MLA(K+1)
330   CONTINUE
      FORMLA(1,NK)=BLANK
      FORMLA(2,NK)=BLANK
      MLA(NK)=0
      IF(J+1.GE.NK)GO TO 350
340   CONTINUE
350   RETURN
      END
C
C   READ AND WRITE INPUT RECORDS, USES SCRATCH TAPE 4
C
      SUBROUTINE INPUT
      SAVE
      PARAMETER (IOSCH=14)
C
C  READ AND WRITE INPUT RECORDS.
C  USES SCRACH TAPE IOSCH.
C
      CHARACTER*4 A,B,VFM,AN,AWD,REFN,EFDAT,ANAME
      CHARACTER*4 XREAD
      LOGICAL VD
      DIMENSION A(4),VFM(17),AN(11),AWD(18,4),XREAD(2,4)
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      DATA A/',A1',',A2',',A3',',A4'/,EFDAT/'EFDA'/,ANAME/'NAME'/
      DATA AN/'0','1','2','3','4','5','6','7','8','9','.'/
      DATA REFN/'REFN'/
      DATA VFM/'(6X', ',A4', ',A2', ',D12', '.0', ',A4', ',A2', ',D12',
     1 '.0', ',A4', ',A2', ',D12', '.0', ',A4', ',A2', ',D12', '.0)'/
C
      READ (5,20,END=260) CODE,(AWD(I,1),I=1,18)
20    FORMAT (20A4)
      WRITE (IOSCH,20) CODE,(AWD(I,1),I=1,18)
      WRITE (6,30) CODE,(AWD(I,1),I=1,18)
30    FORMAT (/,1x,20A4)
      IF (CODE(1).EQ.REFN) GO TO 270
      BACKSPACE IOSCH
      IF (CODE(1).EQ.ANAME) GO TO 50
C
C  EFDATA RECORD
C
      IF (CODE(1).NE.EFDAT) GO TO 60
      READ (IOSCH,40) FORMLA(1,1),FORMLA(2,1),MLA(1),FAZ,DATE,
     1 (ABEL(1,I),WORD(I),I=2,4),IC80
40    FORMAT (6X,2A1,I1,A1,3X,2A4,3X,3(A4,2X,D12.0),I2)
      GO TO 270
C
C  NAME RECORD
C
50    NNA=MIN0(NNA+1,6)
      READ(IOSCH,55)(NAME(I,NNA),I=1,19)
55    FORMAT(6X,18A4,A2)
      GO TO 270
C
60    IF (CODE(1).EQ.'METH'.OR.CODE(1).EQ.'DATE') TEST(7)=.FALSE.
      IF (TEST(7)) GO TO 80
      READ (IOSCH,70) (ABEL(1,I),ABEL(2,I),WORD(I),I=1,4),IC80
70    FORMAT (6X,4(A4,A2,D12.0),I2)
      GO TO 250
C
C  DATA RECORDS FOLLOWING METH RECORD
C
C  SOME DEFINITIONS --
C    FWORD - FIRST NUMBER
C    D(I) - DEGENERACY OR SECOND NUMBER, I.E. D(I)=3 IN V12(3)
C    LIT - NUMBER OF INITIAL LITERALS
C    NDEC - IF DECIMAL APPEARS IN LABEL, NDEC < 0
C    VD - IF TRUE, LABEL IS V WITH A DEGENERACY, SEE D(I)
C
80    READ (IOSCH,85) CODE,AWD,IC80
85    FORMAT (A4,A2,72A1,I2)
      BACKSPACE IOSCH
      DO 200 I=1,4
      D(I)=0.
      FWORD(I)=-1.
      LIT=0
      NDEC=0
      ABEL(1,I)=BLANK
      ABEL(2,I)=BLANK
      VD=.FALSE.
      DO 180 J=1,6
      B=AWD(J,I)
      DO 90 N=1,11
      IF (B.EQ.AN(N)) GO TO 130
90    CONTINUE
      IF (VD) GO TO 190
      IF (B.NE.BLANK) GO TO 110
      IF (LIT.EQ.0) GO TO 180
      GO TO 190
110   IF(FWORD(I).EQ.-1.) LIT=LIT+1
      IF(FWORD(I).GT.0.) VD=.TRUE.
      GO TO 180
130   IF(N.EQ.11) GO TO 140
      IF(VD) GO TO 160
      IF(NDEC.LT.0) GO TO 150
      IF(FWORD(I).GT.0.) FWORD(I)=FWORD(I)*10.+FLOAT(N-1)
      IF(FWORD(I).EQ.-1.) FWORD(I)=N-1
      GO TO 180
C
140   NDEC=-1
      FWORD(I)=MAX(FWORD(I),0.)
      GO TO 180
150   FWORD(I)=FWORD(I)+FLOAT(N-1)*10.**NDEC
      NDEC=NDEC-1
      GO TO 180
160   IF (D(I).NE.0.) D(I)=10.*D(I)+FLOAT(N-1)
      IF (D(I).EQ.0.) D(I)=N-1
180   CONTINUE
C
190   IVFM=4*I-2
      IVFM2=IVFM+1
      I1=4
      I2=2
      IF(LIT.EQ.0) GO TO 195
      IF(LIT.GT.1) GO TO 192
      ABEL(1,I)=AWD(1,I)
      GO TO 195
192   IF (LIT.LT.4) GO TO 193
      IF (LIT.EQ.5) ABEL(2,I)=AWD(5,I)
      GO TO 195
193   I1=LIT
      I2=6-I1
C
195   VFM(IVFM)=A(I1)
      VFM(IVFM2)=A(I2)
200   CONTINUE
C
      READ (IOSCH,VFM) (XREAD(1,I),XREAD(2,I),WORD(I),I=1,4)
      DO 220 I=1,4
      IF(ABEL(1,I).EQ.BLANK) ABEL(1,I)=XREAD(1,I)
      IF(ABEL(2,I).EQ.BLANK) ABEL(2,I)=XREAD(2,I)
220   CONTINUE
C
250   BACKSPACE IOSCH
      GO TO 270
260   CODE(1)='STOP'
270   RETURN
      END
      SUBROUTINE INTROT (T,HCK,DQ,DDQ,QLN,L,LT)
      SAVE
C   CALLED FROM LINK1
C     CALCULATES CONTRIBUTION OF INTERNAL ROTATION
C     ELS ARE THE (-) ENERGY LEVELS OF THE SIN FUNCTION
C     ELC ARE THE (+) ENERGY LEVELS OF THE COS FUNCTION
C     ETA IS A VECTOR OF THE COMBINED ENERGY LEVELS,THE FIRST NEL
C     MEMBERS ARE THE POSTIVE COS LEVELS FOLLOWED BY THE SIN LEVELS
C
      DOUBLE PRECISION ETA,ELS,ELC,T,HCK
      DOUBLE PRECISION Q,TSD,TSDD,ETAS,ARX,TP1
      DOUBLE PRECISION DQ,DDQ,QLN,TQ
      DIMENSION ETA(375)
C 
      COMMON /BLK2/ ELC(188,4),ELS(187,4),LL(4),RSYM(4),LR(4)
C
      NEL=LL(L)
      LT=LR(L)
C
C  FREE ROTOR
C
      IF (NEL.NE.0) GO TO 15
      Q=DSQRT(ELC(1,L)*T)
      DQ=.5D0
      DDQ=-.5D0
      GO TO 40
C
15    NEL2=2*NEL
      I=NEL
      J=1
      DO 20 K=1,NEL
      ETA(J)=ELC(I,L)
      J=J+1
      ETA(J)=ELS(I,L)
      J=J+1
      I=I-1
20    CONTINUE
      Q=0.
      TSD=0.
      TSDD=0.
C
      DO 30 I=1,NEL2
      ETAS=ETA(I)*HCK
      ARX=-ETAS/T
      IF (ARX.LT.-100.d0) GO TO 30
      TP1=DEXP(ARX)
      Q=TP1+Q
      TSD=TP1*ETAS+TSD
      TSDD=TP1*ETAS*ETAS+TSDD
30    CONTINUE
      TQ=T*Q
      DQ=TSD/TQ
      DDQ=((TSDD-TSD*TSD/Q)/T-2.*TSD)/TQ
40    IF (Q .GT. 1.D-25) QLN=DLOG(Q/RSYM(L))
      RETURN
      END
      SUBROUTINE IROTOR (IROT,NIR)
      SAVE
C
C  CONTRIBUTIONS FOR INTERNAL ROTORS - CALLED FROM SUBROUTINE POLY.
C
C  MAXIMUM NUMBER OF UNIQUE ROTORS IS 8.
C  NIR IS THE TOTAL NUMBER OF ROTORS.
C  LIR IS THE NUMBER OF ROTORS WITH PARTICULAR CHARACTERISTICS.
C  THE MAXIMUM NUMBER OF ENERGY LEVELS IS 187.
C  I2PI IS THE NUMBER OF ANGLES IN 2-PI RADIANS.
C  7/25/88 - POTENTIAL CONSTANTS V IN INPUT IN INVCM RATHER THAN CAL.
C
      LOGICAL IROT,FREE
      DOUBLE PRECISION POT,BROT(10),PHI,V,VN,V0,VMIN
      DIMENSION PHI(361),POT(361),IEL0(10),IEL1(10),V(9),VN(9)
      DOUBLE PRECISION PIM,TB0,FJ
C
      CHARACTER*4 RB,RIB,RNEL,RNOUT,RV,ROTORS,ROSYM,ANGLES
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      double precision sn,bn,st,elc,els,ELOW
      COMMON /BLK1/ SN(9),BN(9),ST
      COMMON /BLK2/ ELC(188,4),ELS(187,4),LL(4),RSYM(4),LR(4)
C
      DATA RB/'BROT'/, RIB/'IB'/, RNEL/'NEL'/, RNOUT/'NOUT'/, RV/ 'V'/
      DATA ROTORS/'NROT'/,  ROSYM/'ROSY'/, ANGLES/'ANGL'/
C
      KIR=0
      L=0
      NIQUE=1000
10    CALL INPUT
      IF (NIQUE.NE.1000) GO TO 50
C
20    V0=0.
      NIQUE=IC80
      L=L+1
      FREE=.TRUE.
      DO 30 I=1,9
      V(I)=0.
      VN(I)=0.
30    CONTINUE
      LIR=1
      IROT=.FALSE.
      I2PI=201
      RSYM(L)=1.
      NEL=100
      LL(L)=NEL
      NOUT=0
      DO 40 I=1,10
40    BROT(I)=0.D0
C
50    IF (SUB.NE.CODE(1).OR.IC80.NE.NIQUE) GO TO 180
      DO 170 ID=1,4
      IF (ABEL(1,ID).EQ.BLANK) GO TO 170
      I=FWORD(ID)
      IF (I.LT.0) I=0
      IF (ABEL(1,ID).EQ.RB) GO TO 70
      IF (ABEL(1,ID).EQ.RIB) GO TO 90
      IF (ABEL(1,ID).EQ.RNEL) GO TO 100
      IF (ABEL(1,ID).EQ.RNOUT) GO TO 110
      IF (ABEL(1,ID).EQ.ROTORS) GO TO 120
      IF (ABEL(1,ID).EQ.RV) GO TO 130
      IF (ABEL(1,ID).EQ.ROSYM) GO TO 150
      IF (ABEL(1,ID).EQ.ANGLES) GO TO 160
      WRITE (6,60) ABEL(1,ID),WORD(ID)
60    FORMAT (/,A4,' IS AN INCORRECT LABEL FOR --',E16.8,'. THUS THE V
     1ALUE WAS IGNORED (IROTOR)')
      GO TO 400
C
70    IF (I.GT.1) GO TO 80
      BROT(1)=WORD(ID)
      GO TO 170
80    BROT(I)=WORD(ID)
      GO TO 170
90    BROT(1)=2.7992774d0/WORD(ID)
      GO TO 170
100   NEL=WORD(ID)
      LL(L)=NEL
      GO TO 170
110   NOUT=WORD(ID)
      GO TO 170
120   LIR=WORD(ID)
      LR(L)=LIR
      KIR=KIR+LIR
      GO TO 170
130   if(i.eq.0) v0=word(id)
      if(i.gt.0) VN(I)=WORD(ID)
      GO TO 170
150   RSYM(L)=WORD(ID)
      GO TO 170
160   I2PI=WORD(ID)
170   CONTINUE
      GO TO 10
C
180   DO 190 I=1,9
      IF (VN(I).EQ.0.) GO TO 190
      V(I)=VN(I)/0.3497551D0
      FREE=.FALSE.
190   CONTINUE
      IF (BROT(2).NE.0.) FREE=.FALSE.
      IF (FREE) GO TO 285
C
      VMIN=1.E5
      PIM=I2PI-1
      DO 230 I=1,I2PI
      PHI(I)= (2*I-2)/PIM
      POT(I)=V0
      DO 220 J=1,9
      IF (V(J).EQ.0.0) GO TO 220
      FJ=J
      POT(I)=POT(I)+0.5*VN(J)*(1.0-DCOS(FJ*PHI(I)*3.14159265D0))
220   CONTINUE
      IF (POT(I).LT.VMIN) VMIN=POT(I)
230   CONTINUE
      WRITE (6,310) VMIN
      VMIN=ABS(VMIN)
      DO 240 I=1,10
      IEL0(I)=I-1
240   IEL1(I)=I
      IF (.NOT.TEST(14)) GO TO 260
      WRITE (6,320)
      DO 250 J=1,I2PI,10
      K=J+9
      IF (K.GT.I2PI) K=I2PI
      WRITE (6,330) (PHI(I),I=J,K)
250   WRITE (6,340) (POT(I),I=J,K)
260   CONTINUE
      ns=0
      nb=0
      do 265 i=9,1,-1
        if (ns.eq.0.and.vn(i).ne.0) ns=i
        if (nb.eq.0.and.brot(i).ne.0) nb=i
265   continue
      WRITE (6,350) (V(i),i=1,ns)
      WRITE (6,351) (VN(i),i=1,ns)
      WRITE (6,352) (BROT(i),i=1,nb)
      IF (NEL.GT.187) GO TO 300
      DO 268 I=2,nb
268   BN(I-1)=BROT(I)/BROT(1)
      nb = nb-1
      TB0=2.0*BROT(1)
      ST=0.0
      DO 270 I=1,ns
      SN(I)=VN(I)/TB0
270   ST=ST+SN(I)
      ST=ST+VMIN/BROT(1)
      NELP1=NEL+1
      CALL HMAT (1,NEL,ns,nb,ELS(1,L))
      CALL HMAT (2,NELP1,ns,nb,ELC(1,L))
      DO 275 I=1,NEL
      ELS(I,L)=BROT(1)*ELS(I,L)
275   ELC(I,L)=BROT(1)*ELC(I,L)
      IF (NOUT.LE.0) GO TO 277
      WRITE (6,360) (IEL0(I),I=1,10)
      CALL PRINT (NOUT,L)
277   ELOW=ELC(1,L)
      IF (ELS(1,L).LT.ELOW) ELOW=ELS(1,L)
      DO 280 I=1,NEL
      ELS(I,L)=ELS(I,L)-ELOW
280   ELC(I,L)=ELC(I,L)-ELOW
      IF (NOUT.LE.0) GO TO 295
      WRITE (6,370) (IEL0(I),I=1,10)
      CALL PRINT (NOUT,L)
      GO TO 295
C
C  FREE ROTOR - SET LEVELS TO ZERO.
C
285   LL(L)=0
      ELC(1,L)=3.14159265D0/(BROT(1)*HCK)
      WRITE (6,290) NIQUE
290   FORMAT (/,'  V=0 FOR ROTOR',I3,'. USE CLASSICAL PARTITION FUNCTION
     1 FOR FREE ROTOR (IROTOR).')
C
295   IF (KIR.GT.0) GO TO 298
      LR(1)=1
      KIR=1
      WRITE (6,296)
296   FORMAT(/,' NROT ASSUMED TO BE 1 (IROTOR)')
298   IF (SUB.NE.CODE(1)) GO TO 390
      IF (KIR.LT.NIR.AND.L.LT.4) GO TO 20
      GO TO 390
300   WRITE (6,380)
      GO TO 400
C
C         SOME FORMAT STATEMENTS
C
310   FORMAT (/,'  MINIMUM OF POTENTIAL FUNCTION IS',F9.3,' CM**(-1)')
320   FORMAT ('-',2X,'VALUES OF POTENTIAL FUNCTION IN CM**(-1) AT VARIOU
     1S ANGLES IN PI RADIAN')
330   FORMAT (11X,'PHI',7X,10F11.5)
340   FORMAT (11X,'POT',5X,10F11.3)
350   FORMAT (2X,'BARRIER POTENTIAL CONSTANTS IN CAL/MOL:'/5x,9F11.3)
351   FORMAT (2X,'BARRIER POTENTIAL CONSTANTS IN CM**(-1):'/5x,9F11.3/)
352   FORMAT (2X,'ROTATION CONSTANTS IN CM**(-1):',6X,(6F11.5))
360   FORMAT ('-',2X,'ENERGY LEVELS',10X,'EVEN----COS----ELC(+) IN CM**(
     1-1)',5X,'ODD----SIN----ELS(-) IN CM**(-1)',//,16X,10I11)
370   FORMAT ('-',2X,'ENERGY DIFFERENCE BETWEEN THE SPECIFIC LEVEL AND
     1THE LOWEST LEVEL IN CM**(-1)',5X,'TO BE USED FOR THERMODYNAMIC FUN
     2CTIONS',//16X,10I11)
380   FORMAT ('-',2X,'THE NUMBER OF ENERGY LEVELS IS TOO LARGE.')
390   IROT=.TRUE.
400   RETURN
      END
C
      real*8 function figs(xin)
C
C     Retain 9 rounded figures 
C
      real*8 xin,xout
      xout=dabs(xin)
      if (xout.gt.0.d0) then
         iex=-anint(dlog10(xout))+9
         xout=anint(xout*10.d0**iex)*10.d0**(-iex)
      endif
      figs=sign(xout,xin)
      END
      SUBROUTINE LEAST
      SAVE
      real*8 figs
      DOUBLE PRECISION A(15,16),TP, ANSTPY(15),F(4),FC(4),ERR(4),TFIX,
     1TOTERR(4),TOTREL(4),TOTSQ(4),TOTSQR(4),AVERR(4),RELERR(4),DH,
     2AVREL(4),AVSQ(4),AVSQR(4),MAXERR(4),MAXREL(4),TMAX(4),TMAXRL(4)
C
      DOUBLE PRECISION CPRFIX,EXI,EXJ,EXIJ,HHRTFX,HRTC,
     1 SRFIX,TEMPY,DLT,RPT,CP,HH,ICP,IS,IH,S,SFXS,TFXS,CFXS,HFXS
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      NCF=10
      its=0
      NCF1=NCF-1
      DO 20 I=1,8
20    INTV(I)=.FALSE.
      IF (NTRANG.EQ.0) GO TO 130
C
C  SORT IN INCREASING ORDER TEMPERATURES SPECIFYING INTERVALS
C
60    J=1
70    M=J
80    DO 100 I=J,NTRANG
      IF (TRANGE(I).GE.TRANGE(M)) GO TO 100
      M=I
100   CONTINUE
      IF (M.EQ.J) GO TO 120
      TEMPY=TRANGE(M)
      TRANGE(M)=TRANGE(J)
      TRANGE(J)=TEMPY
      GO TO 80
120   J=J+1
      IF (NTRANG.GT.J) GO TO 70
      go to 140
C
C  Set default TRANGE
C
130   TRANGE(1)=200.D0
      IF(TEST(3)) TRANGE(1)=298.15D0
      TRANGE(2)=1000.D0
      NTRANG=3
      if (.not.OLD.and..not.TEST(4)) ntrang=2
      TRANGE(NTRANG)=6000.0D0
140   TEST(1)=.false.
      if (t(nlast).le.trange(1).or.t(nnn).ge.trange(ntrang)) go to 2000
c
c  if transition point, insert initial t in trange schedule.
c
      if(nnn.eq.1.or.t(nnn).ne.t(nnn-1))go to 142
      do 141 i=1,ntrang
      if(dabs(t(nnn)-trange(i)).lt..001) go to 142
141   continue
      ntrang=ntrang+1
      trange(ntrang)=t(nnn)
      go to 60
142   TEST(1)=.true.
      CALL PAGEID
      WRITE (6,143)
143   FORMAT (/,' LEAST SQUARES' /)
      LINES=9
      IF (T(NNN).NE.TLST .OR. T(NNN).NE.T(NNN-1)) GO TO 153
      TCONST=TLST
      DH=HHRT(NNN)-HHRT(NNN-1)
      HHRTFX=HLST+DH
      SRFIX=SLST+DH
      GO TO 155
153   TLST=0.D0
      IF (TCONST.NE.0.) GO TO 155
      TCONST=DMAX1(TRANGE(1),298.15D0)
155   TFIX=TCONST
      IF (TFIX.GT.T(NLAST)) TFIX=T(NLAST)
      IF (NNN.EQ.1) GO TO 160
      if (tconst.ge.t(nnn) .and. tconst .le.t(nlast)) go to 160
      IF (T(NNN-1).EQ.T(NNN).OR.TFIX.LT.T(NNN)) TFIX=T(NNN)
C
160   NM1=NTRANG-1
      LT=NM1
      IT=1
      IF ((TRANGE(IT).GE.T(NNN)-.00001D0).AND.(TRANGE(NTRANG).LE.
     1 T(NLAST)+.00001D0)) GO TO 220
      LINES=LINES+2
      IT1=IT
      DO 170 I=IT1,NM1
      IF (TRANGE(I).EQ.TRANGE(I+1))GO TO 165
      IF (TRANGE(I).GE.T(NNN)-.00001D0) GO TO 190
      IF (T(NNN).LT.TRANGE(I+1)-.00001D0) GO TO 190
165   INTV(IT)=.TRUE.
      IT=IT+1
170   CONTINUE
190   DO 200 I=IT,NM1
      IF (TRANGE(LT).LE.T(NLAST)-.00001D0) GO TO 220
      IF (T(NLAST).GT.TRANGE(LT)+.00001D0) GO TO 220
      INTV(LT)=.TRUE.
      LT=LT-1
200   CONTINUE
C
C  LOCATE TEMPERATURE CONSTRAINTS
220   IT1=IT
      DO 230 I=IT1,LT
      IT=I
      IF (TRANGE(I+1).GT.TFIX-.00001D0) GO TO 240
230   CONTINUE
C
C  ADJUST TEMPERATURE INTERVALS, IF NECESSARY
C
240   DO 270 I=NNN,NLAST
      ICON=I
      IF (DABS(T(I)-TFIX).LT.0.00001D0) GO TO 280
270   CONTINUE
280   CPRFIX=CPR(ICON)
      IF (TLST.NE.0.) GO TO 285
      HHRTFX=HHRT(ICON)
      SRFIX=SR(ICON)
285   TLST=0.D0
      izz=3
      IF (OLD) izz=1
      dnf=izz+4
      do 290 i=1,it
      if(.not.intv(i)) go to 292
290   continue
292   iv=ivl1
      do 295 i=1,lt
      if(intv(i)) go to 295
      iv=iv+1
      if(i.ge.it) go to 296
295   continue
296   ivl1=ivl1+1
C
C  IF INTERVAL IS NOT SET, USE DEFAULT EXPONENT SET
C
300   IF (NF(IV).NE.0) GO TO 320
      if (nf(9).eq.0) then
         DO 310 I=1,dnf
310      EX(I,IV)=I-izz
         nf(IV)=dnf
         iz=izz
         go to 330
      else
         nf(iv)=nf(9)
         do 315 i=1,nf(9)
315      ex(i,iv) = ex(i,9)
      endif
C
C  ORDER EXPONENTS
C
320   IF(NF(IV).EQ.1) GO TO 326
      NFD=NF(IV)-1
      DO 324 I=1,NFD
      J1=I+1
      NFE=NF(IV)
      DO 324 J=J1,NFE
      IF (EX(J,IV).GT.EX(I,IV)) GO TO 324
      EXI=EX(I,IV)
      EX(I,IV)=EX(J,IV)
      EX(J,IV)=EXI
324   CONTINUE
C
C  set iz to exponent that is zero
C
326   do 327 i=1,nf(IV)
      if(ex(i,iv).eq.0.) goto 328
327   continue
328   iz=i
330   nfp=nf(IV)
      IF (IV.GT.8) GO TO 1180
      DO 336 I=1,10
336   COEF(I,IV)=0.D0
      DO 338 I=NNN,NLAST
      IF((T(I)+.00001D0).GT.TRANGE(IT)) GO TO 350
338   CONTINUE
      WRITE (6,340)
340   FORMAT (/' LEAST SQUARES NOT COMPLETED. INTERVAL TEMPERATURES NOT
     1FOUND IN TEMPERATURE SCHEDULE, (LEAST)')
      TEST(1)=.false.
      GO TO 1160
350   NBEGIN=I
C
      TC(IV)=T(I)
      DO 360 I=NBEGIN,NLAST
      IF (T(I)-.00001D0.GT.TRANGE(IT+1)) GO TO 370
      NEND=I
360   CONTINUE
370   TC(IV+1)=T(NEND)
      NPTS=NEND-NBEGIN+1
      IF (NPTS.GE.NF(IV)) GO TO 380
374   if (npts .ge. 2*iz-1) go to 378
      iz=iz-1
      do 376 i=iz,10
376   ex(i,iv)=ex(i+1,iv)
      go to 374
378   NFP=NPTS
      do 379 i=npts+1,10
379   ex(i,IV)=0
      NF(IV)=NPTS
380   ICP=1
      IH=1
      IS=1
      IF(NOCP(IV))ICP=0
      IF(NOH(IV))IH=0
      IF(NOS(IV))IS=0
      NF1=NFP+IH
      NF2=NF1+IS
      NF5=NF2
      IF(.NOT.CNST)GO TO 385
      NF3=NF2+ICP
      NF4=NF3+IH
      NF5=NF4+IS
385   NF6=NF5+1
C
C CLEAR MATRIX REGION
C
      DO 400 I=1,NF5
      DO 400 J=1,NF6
400   A(I,J)=0.0
C
C SET UP MATRIX ELEMENTS FOR DIAGONAL AND ABOVE FOR FIRST NF ROWS
C
      DO 722 L=NBEGIN,NEND
      DLT=DLOG(T(L))
      RPT=1.D0/T(L)
      S=SR(L)*IS
      CP=CPR(L)*ICP
      HH=HHRT(L)*IH
      DO 700 I=1,NFP
      EXI=EX(I,IV)
      IF (EXI.NE.(-1.D0)) GO TO 420
      IF(.NOT.NOH(IV))A(I,NF1)=A(I,NF1)+DLT*RPT*RPT
      IF(.NOT.NOS(IV))A(I,NF2)=A(I,NF2)-RPT
      A(I,NF6)=A(I,NF6)+(CP+HH*DLT-S)*RPT
      GO TO 460
C
420   IF (EX(I,IV).NE.0.0) GO TO 440
      IF(.NOT.NOH(IV))A(I,NF1)=A(I,NF1)+RPT
      IF(.NOT.NOS(IV))A(I,NF2)=A(I,NF2)+DLT
      A(I,NF6)=A(I,NF6)+CP+HH+S*DLT
      GO TO 460
C
440   IF(.NOT.NOH(IV))A(I,NF1)=A(I,NF1)+T(L)**(EXI-1.D0)/(EXI+1.D0)
      IF(.NOT.NOS(IV))A(I,NF2)=A(I,NF2)+(T(L)**EXI)/EXI
      A(I,NF6)=A(I,NF6)+(CP+HH/(EXI+1.D0)+S/EXI)*(T(L)**EXI)
C
460   DO 700 J=I,NFP
      EXJ=EX(J,IV)
      IF (EX(I,IV).GT.0..OR.EX(J,IV).LT.-1.) GO TO 690
      EXIJ=EXJ
      IF (EXI.EQ.-1.) GO TO 480
      IF (EXI.EQ.0.) GOTO 470
      EXIJ=EXI
      IF (EXJ.EQ.-1.) GO TO 550
      IF (EXJ.EQ.0.) GO TO 650
      GO TO 690
470   IF (EXJ.EQ.0.) GO TO 620
      GO TO 650
480   IF (EXJ.EQ.0.) GO TO 520
      IF (EXJ.NE.-1.) GO TO 550
      A(I,J)=A(I,J)+(ICP+IS+IH*DLT*DLT)*RPT**2
      GO TO 700
520   A(I,J)=A(I,J)+RPT*(ICP+(IH-IS)*DLT)
      GO TO 700
550   A(I,J)=A(I,J)+(ICP-IS/EXIJ+DLT*IH/(EXIJ+1.D0))*T(L)**(EXIJ-1.D0)
      GO TO 700
620   A(I,J)=A(I,J)+ICP+IH+IS*DLT**2
      GO TO 700
650   A(I,J)=A(I,J)+(ICP+IH/(EXIJ+1.D0)+IS*DLT/EXIJ)*T(L)**EXIJ
      GO TO 700
690   A(I,J)=A(I,J)+(ICP+IH/((EXI+1.D0)*(EXJ+1.D0))+IS/(EXI*EXJ))
     1 *T(L)**(EXI+EXJ)
700   CONTINUE
C
C SET UP MATRIX FOR DIAGONAL AND ABOVE FOR REMAINING ROWS
C
      IF(NOH(IV)) GO TO 702
      A(NF1,NF1)=A(NF1,NF1)+RPT**2
      A(NF1,NF6)=A(NF1,NF6)+HH*RPT
702   IF(NOS(IV)) GO TO 722
      A(NF2,NF2)=A(NF2,NF2)+1.D0
      A(NF2,NF6)=A(NF2,NF6)+S
722   CONTINUE
C
      IF (.NOT.CNST)GO TO 728
      IF(.NOT.NOH(IV))A(NF1,NF4)=1.D0/TFIX
      IF(.NOT.NOS(IV))A(NF2,NF5)=1.D0
      IF(.NOT.NOCP(IV))A(NF3,NF6)=CPRFIX
      IF(.NOT.NOH(IV))A(NF4,NF6)=HHRTFX
      IF(.NOT.NOS(IV))A(NF5,NF6)=SRFIX
      DO 726 I=1,NFP
      EXI=EX(I,IV)
      IF(EXI.NE.(-1.D0))GO TO 723
      IF(.NOT.NOCP(IV))A(I,NF3)=1.D0/TFIX
      IF(.NOT.NOH(IV))A(I,NF4)=DLOG(TFIX)/TFIX
      IF(.NOT.NOS(IV))A(I,NF5)=-1.D0/TFIX
      GO TO 726
723   IF(EXI.NE.0.)GO TO 724
      IF(.NOT.NOCP(IV))A(I,NF3)=1.D0
      IF(.NOT.NOH(IV))A(I,NF4)=1.D0
      IF(.NOT.NOS(IV))A(I,NF5)=DLOG(TFIX)
      GO TO 726
724   TEMPY=TFIX**EXI
      IF(.NOT.NOCP(IV))A(I,NF3)=TEMPY
      IF(.NOT.NOH(IV))A(I,NF4)=TEMPY/(EXI+1.D0)
      IF(.NOT.NOS(IV))A(I,NF5)=TEMPY/EXI
726   CONTINUE
C
C COMPLETE THE MATRIX BY REFLECTING SYMMETRICAL ELEMENTS ABOVE DIAGONAL
C
728   K=2
      NF5=NF6-1
      NF4=NF5-1
      DO 740 I=1,NF4
      DO 730 J=K,NF5
730   A(J,I)=A(I,J)
740   K=K+1
C
C SOLVE THE MATRIX.
C
      N=NF5
      DO 770 I=1,N
770   ANSTPY(I)=0.0
      DO 800 I=1,N
      DO 780 J=I,N
      A(I,J+1)=A(I,J+1)/A(I,I)
      IF (I.EQ.N) GO TO 810
780   CONTINUE
      K=I+1
      DO 790 II=K,N
      DO 790 JJ=I,N
790   A(II,JJ+1)=-A(II,I)*A(I,JJ+1)+A(II,JJ+1)
800   CONTINUE
810   if (n.ne.nf1) then
         ANSTPY(N)=figs(A(I,J+1))
      else
	 ANSTPY(NF1)=A(I,J+1)
      endif
      IF (N.EQ.1) GO TO 845
      J=N-1
      II=J
      DO 840 I=1,II
      K=J+1
      DO 830 MM=1,I
      ANSTPY(J)=ANSTPY(J)+ANSTPY(K)*A(J,K)
830   K=K+1
      if (j.ne.nf1) then
         ANSTPY(J)=figs(A(J,K)-ANSTPY(J))
      else
         ANSTPY(J)=A(J,K)-ANSTPY(J)
      endif
840   J=J-1
C
845   IF (.NOT.NOH(IV) .AND. .NOT.NOS(IV)) GO TO 860
      NF1=NFP+1
      NF2=NFP+2
      IF (NOH(IV)) ANSTPY(NF2)=figs(ANSTPY(NF1))
      FC(2)=0.
      FC(3)=0.
      DLT=DLOG(TFIX)
      DO 857 I=1,NFP
      EXI=EX(I,IV)
      TP=TFIX**EXI
      IF(EXI.NE.(-1.D0)) GO TO 853
      FC(2)=FC(2)+ANSTPY(I)*DLT/TFIX
      GO TO 855
853   FC(2)=FC(2)+ANSTPY(I)*TP/(EXI+1.D0)
      IF (EXI.NE.0.0)GO TO 855
      FC(3)=FC(3)+ANSTPY(I)*DLT
      GO TO 857
855   FC(3)=FC(3)+ANSTPY(I)*TP/EXI
857   CONTINUE
      IF(NOH(IV))ANSTPY(NF1)=(HHRTFX-FC(2))*TFIX
      IF(NOS(IV))ANSTPY(NF2)=figs(SRFIX-FC(3))
860   intvls=max0(iv,intvls)
      DO 865 I=1,NFP
865   COEF(I,iv)=ANSTPY(I)
      COEF(NCF1,iv)=ANSTPY(NF1)
      COEF(NCF,iv)=ANSTPY(NF2)
C
C CALCULATE FROM THE LEAST SQUARES COEFFICIENTS VALUES OF CP/R,H-H0/RT,
C   S/R,F-H0/RT, AND THE ERRORS AND RELATIVE ERRORS IN THESE AT EACH
C   TEMPERATURE. ALSO THE AVERAGE ERROR, AVERAGE RELATIVE ERROR,
C   LARGEST ERROR AND LARGEST RELATIVE ERROR.
C
      WRITE (6,870)
870   FORMAT (/,7X,1HT,6X,10HCP/R INPUT,4X,9HCP/R CALC,5X,11HHH/RT INPUT
     1,3X,10HHH/RT CALC,6X,9HS/R INPUT,5X,8HS/R CALC,6X,12H-GH/RT INPUT
     2,4X,11H-GH/RT CALC)
      WRITE (6,880)
880   FORMAT (1H ,14X,10HINPUT-CALC,5X,8HFRACTION,6X,10HINPUT-CALC,4X,8H
     1FRACTION,7X,10HINPUT-CALC,5X,8HFRACTION,7X,10HINPUT-CALC,4X,8HFRAC
     2TION)
C
      LINES=LINES+3
      DO 890 I=1,4
      TOTERR(I)=0.
      TOTREL(I)=0.
      TOTSQR(I)=0.
      TOTSQ(I)=0.
      MAXERR(I)=0.
      MAXREL(I)=0.
      TMAX(I)=0.
890   TMAXRL(I)=0.
C
      DO 1030 L=NBEGIN,NEND
      DLT=DLOG(T(L))
      RPT=1.D0/T(L)
      F(1)=CPR(L)
      F(2)=HHRT(L)
      F(3)=SR(L)
      F(4)=GHRT(L)
      FC(1)=0.
      FC(2)=ANSTPY(NF1)*RPT
      FC(3)=ANSTPY(NF2)
C
      DO 920 I=1,NFP
      EXI=EX(I,IV)
      TP=T(L)**EXI
      IF (EXI.NE.(-1.D0)) GO TO 900
      FC(2)=FC(2)+ANSTPY(I)*DLT*RPT
      GO TO 910
900   FC(2)=FC(2)+ANSTPY(I)*TP/(EXI+1.D0)
      IF (EXI.NE.0.0) GO TO 910
      FC(3)=FC(3)+ANSTPY(I)*DLT
      GO TO 920
910   FC(3)=FC(3)+ANSTPY(I)*TP/EXI
920   FC(1)=FC(1)+ANSTPY(I)*TP
      FC(4)=FC(3)-FC(2)
C
      IF (.NOT.NOCP(IV)) GO TO 922
      CPR(L)=FC(1)
      F(1)=FC(1)
922   IF (.NOT. NOH(IV).OR.CPONLY(IV)) GO TO 924
      HHRT(L)=FC(2)
      F(2)=FC(2)
924   IF (.NOT.NOS(IV).OR.CPONLY(IV)) GO TO 926
      F(3)=FC(3)
      SR(L)=FC(3)
926   GHRT(L)=SR(L)-HHRT(L)
      F(4)=GHRT(L)
      IF (L.NE.NBEGIN.OR.IT.EQ.1) GO TO 950
      IF (INTV(IT-1)) GO TO 950
      ITS=IT-1
      CFXS=FC(1)
      HFXS=FC(2)
      SFXS=FC(3)
      TFXS=T(L)
950   DO 990 I=1,4
      ERR(I)=F(I)-FC(I)
      ABSERR=DABS(ERR(I))
      TOTERR(I)=TOTERR(I)+ABSERR
      TOTSQ(I)=TOTSQ(I)+ABSERR*ABSERR
      IF (F(I).NE.0.) GO TO 970
      F(I)=1.
      IF (I.EQ.2.AND.DABS(T(L)-298.15).LT.1.) GO TO 970
      WRITE (6,960)
960   FORMAT (/' ERROR IN DATA.  LEAST SQUARES NOT COMPLETED, (LEAST)')
      TEST(1)=.false.
      GO TO 1160
970   IF (F(I).GT.1.D-06) GO TO 974
      IF (ERR(I).GT.1.D-06) GO TO 974
      RELERR(I)=ERR(I)
      GO TO 976
974   RELERR(I)=ERR(I)/F(I)
976   ABSREL=DABS(RELERR(I))
      TOTREL(I)=TOTREL(I)+ABSREL
      TOTSQR(I)=TOTSQR(I)+ABSREL*ABSREL
      IF (ABSERR.LT.MAXERR(I)) GO TO 980
      MAXERR(I)=ABSERR
      TMAX(I)=T(L)
980   IF (ABSREL.LT.MAXREL(I)) GO TO 990
      MAXREL(I)=ABSREL
      TMAXRL(I)=T(L)
990   CONTINUE
      IF (L.LT.NEND) GO TO 1000
      IF (T(L).LT.TLST) GO TO 1000
      IF (T(L).EQ.TFIX) GO TO 1000
      TLST=T(L)
      HLST=FC(2)
      SLST=FC(3)
1000  CONTINUE
C
      WRITE (6,1010) T(L),CPR(L),FC(1),HHRT(L),FC(2),F(3),FC(3),F(4),
     1 FC(4)
1010  FORMAT (F12.2,2F13.7,2X,2F13.7,2X,2F14.7,2X,2F14.7)
      WRITE (6,1020) (ERR(I),RELERR(I),I=1,4)
1020  FORMAT (12X,2F13.7,2X,2F13.7,2X,2F14.7,2X,2F14.7)
1030  CONTINUE
C
      POINTS=NEND-NBEGIN+1
      DO 1040 I=1,4
      AVERR(I)=TOTERR(I)/POINTS
      AVREL(I)=TOTREL(I)/POINTS
      AVSQ(I)=DSQRT(TOTSQ(I)/POINTS)
1040  AVSQR(I)=DSQRT(TOTSQR(I)/POINTS)
C
C
      IF (NOCP(IV)) GO TO 1055
      WRITE (6,1050) MAXREL(1),TMAXRL(1),AVREL(1),AVSQR(1)
1050  FORMAT (3X,19HMAX REL ERR CP/R  =,F10.6,4X,6HTEMP =,F7.0,6X,20HAVE
     1R REL ERR CP/R  =,F10.6,6X,22HREL LST SQ ERR CP/R  =,F10.6)
      LINES=LINES+1
1055  IF (NOH(IV).AND..NOT.CPONLY(IV)) GO TO 1065
      WRITE (6,1060) MAXREL(2),TMAXRL(2),AVREL(2),AVSQR(2)
1060  FORMAT (3X,19HMAX REL ERR HH/RT =,F10.6,4X,6HTEMP =,F7.0,6X,20HAVE
     1R REL ERR HH/RT =,F10.6,6X,22HREL LST SQ ERR HH/RT =,F10.6)
1065  IF (NOS(IV).AND..NOT.CPONLY(IV)) GO TO 1075
      WRITE (6,1070) MAXREL(3),TMAXRL(3),AVREL(3),AVSQR(3)
1070  FORMAT (3X,19HMAX REL ERR S/R   =,F10.6,4X,6HTEMP =,F7.0,6X,20HAVE
     1R REL ERR S/R   =,F10.6,6X,22HREL LST SQ ERR S/R   =,F10.6)
      LINES=LINES+1
1075  IF (NOH(IV).AND.NOS(IV).AND..NOT.CPONLY(IV)) GO TO 1085
      WRITE (6,1080) MAXREL(4),TMAXRL(4),AVREL(4),AVSQR(4)
1080  FORMAT (3X,19HMAX REL ERR GH/RT =,F10.6,4X,6HTEMP =,F7.0,6X,20HAVE
     1R REL ERR GH/RT =,F10.6,6X,22HREL LST SQ ERR GH/RT =,F10.6)
1085  IF (NOCP(IV)) GO TO 1095
      WRITE (6,1090) MAXERR(1),TMAX(1),AVERR(1),AVSQ(1)
1090  FORMAT (7X,15HMAX ERR CP/R  =,F10.6,4X,6HTEMP =,F7.0,10X,16HAVER E
     1RR CP/R  =,F10.6,10X,18HLST SQ ERR CP/R  =,F10.6)
1095  IF (NOH(IV).AND..NOT.CPONLY(IV)) GO TO 1105
      WRITE (6,1100) MAXERR(2),TMAX(2),AVERR(2),AVSQ(2)
1100  FORMAT (7X,15HMAX ERR HH/RT =,F10.6,4X,6HTEMP =,F7.0,10X,16HAVER E
     1RR HH/RT =,F10.6,10X,18HLST SQ ERR HH/RT =,F10.6)
1105  IF (NOS(IV).AND..NOT.CPONLY(IV)) GO TO 1115
      WRITE (6,1110) MAXERR(3),TMAX(3),AVERR(3),AVSQ(3)
1110  FORMAT (7X,15HMAX ERR S/R   =,F10.6,4X,6HTEMP =,F7.0,10X,16HAVER E
     1RR S/R   =,F10.6,10X,18HLST SQ ERR S/R   =,F10.6)
1115  IF (NOH(IV).AND.NOS(IV).AND..NOT.CPONLY(IV)) GO TO 1125
      WRITE (6,1120) MAXERR(4),TMAX(4),AVERR(4),AVSQ(4)
1120  FORMAT (7X,15HMAX ERR GH/RT =,F10.6,4X,6HTEMP =,F7.0,10X,16HAVER E
     1RR GH/RT =,F10.6,10X,18HLST SQ ERR GH/RT =,F10.6)
1125  WRITE (6,1130) (ANSTPY(I),EX(I,IV),I=1,NFP)
1130  FORMAT(' CP/R =',5(1Pd17.9,3HT**,0PF4.1)/8X,5(1Pd17.9,3HT**,0PF4.1
     1))
      HRTC=figs(ANSTPY(NF1)+ASINDH)
      WRITE (6,1140) ANSTPY(NF1),HRTC,ANSTPY(NF2)
1140  FORMAT (' (H-H0)/R CONSTANT = ',1pd19.11,', H/R CONSTANT =',d19.11
     1 ,', S/R CONSTANT =',d19.11)
      INTV(IT)=.TRUE.
      intvls=max(intvls,iv)
      IF (INTV(lt)) GO TO 1144
      CPRFIX=FC(1)
      HHRTFX=FC(2)
      SRFIX=FC(3)
      TFIX=T(NEND)
      IT=IT +1
      iv=iv+1
      GO TO 300
C
1144  if (its.eq.0) go to 1160
      DO 1147 I=lt,1,-1
      IF (.NOT.INTV(I)) GO TO 1148
1147  CONTINUE
      GO TO 1160
1148  IT=ITS
      CPRFIX=CFXS
      HHRTFX=HFXS
      SRFIX =SFXS
      TFIX=TFXS
      its=0
            iv=it
      IF(IT.GT.0) GO TO 300
C
1160  IF (TC(intvls).GE.TRANGE(NTRANG)) TEST(15)=.FALSE.
      GO TO 2000
C
1180  WRITE(6,1190) iv
1190  FORMAT(/' NUMBER OF TEMPERATURE INTERVALS =',I3,
     1  '--ONLY 8 ALLOWED')
C
2000  RETURN
      END
      SUBROUTINE LINK1 (IROT,NIR)
      SAVE
C
C  CALCULATE Q
C     TESTW(1)  MOLECULE IS NON-LINEAR
C     TESTW(2)  RIGID ROTATOR-HARMONIC OSCILLATOR APPROXIMATION
C     TESTW(3)  SECOND ORDER CORRECTIONS ARE CALLED FOR
C     TESTW(4)  PENNINGTON AND KOBE APPROXIMATION
C     TESTW(5)  JANAF METHOD FOR DIATOMIC MOLECULES
C     TESTW(6)  SPECIES HAS EXCITED ELECTRONIC STATES
C
      LOGICAL IROT
C
      CHARACTER*4 LEL,LHO,LRR,LXIJ,LRHO,LTHETA,LYIJK,LZ
      CHARACTER*4 LALPHA,LAX,LG,LIR,LX2,LXY,LG2,LAX2,LFERMI,LDARD
c
      real*8 dqs,ddqs,qlns,SQ(3,502),EDQ,EQLN,EDDQ,CT,U
      real*8 RS,RF,AL,CON,CTT
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      real*8 v,x,y,alfa,alfb,alfc,g,wx,beta,a,b,c,dard,dd,wf,w,sym,stwt,
     1 t00,theta,rh,ri,s,ql,q,qln,dq,ddq,qtot,qlntot,dqtot,ddqtot,aij,
     2 aiii,ai
      logical testw
      COMMON /WCOMMN/ V(300),X(9,9),Y(9,9,9),ALFA(9),ALFB(9),ALFC(9),
     1 G(9),WX(9),BETA(4),A,B,C,DARD,DD,WF,W,SYM,STWT,T00,THETA(3),
     2 RH(6),RI(300,3),S(300,3),QL(3),Q,QLN,DQ,DDQ,QTOT,QLNTOT,DQTOT,
     3 DDQTOT,AIJ(9,9),AIII,AI(9),DN(300),ND(300),CORT,NNU,TESTW(6)
C
      EQUIVALENCE (TAPE,SQ)
      DATA     LEL/'ELEC' /, LHO/'H.O.'/, LRR/'R.R.'/, LXIJ/'XIJ'/,
     1 LRHO/'RHO '/, LTHETA/'THTA' /, LYIJK/'YIJK'/, LALPHA/'ALFA' /,
     2 LZ  /'WEZE'/, LAX/'AXIJ'/, LG/'G+AG'/, LIR/'IROT'/, LX2 /'XIJ2'/,
     3 LXY /'XY  '/, LG2/'G2GX'/, LAX2 /'AX2 '/, LFERMI/'FERM'/,
     4 LDARD/'DARD'/
C
      KD(IX,JX)=MIN0(IX,JX)/MAX0(IX,JX)
C
C  TEST(14)--INTERM RECORD HAS BEEN READ CALLING FOR INTERMEDIATE OUTPUT
C
      IF (.NOT.TEST(14)) GO TO 30
      DO 10 I=1,NNU
      NND=DN(I)
10    WRITE (6,20) I,V(I),NND
20    FORMAT (/,' V(',I3,') =',F9.4,'(',I1,')')
30    IF (ASINDT.NE.0.0) GO TO 40
      NT1=NT
      GO TO 50
40    NT1=NT+1
      T(NT1)=ASINDT
C
C  DO LOOP CALCULATES Q & DERIVATIVES FOR ELECTRONIC LEVEL. IT=T INDEX.
C
50    DO 430 IT=NIT,NT1
      QTOT=1.0
      QLNTOT=0.0
      DQTOT=0.0
      DDQTOT=0.0
      Q=1.0
      IF (TEST(14)) WRITE (6,60) T(IT)
60    FORMAT (/,' T =',F9.3)
      CT=HCK/T(IT)
      IF (B.NE.0.) GO TO 70
      QLNTOT=SQ(1,IT)
      DQTOT=SQ(2,IT)
      DDQTOT=SQ(3,IT)
      GO TO 120
70    DO 100 I=1,NNU
      IF (V(I).EQ.0.) GO TO 100
      RI(I,1)=0.0
      U=CT*V(I)
      IF (U.GE.30.) GO TO 80
C
C  RI(I,1) = RI.   S(I,1) = SI.  A 2 OR 3 IN THE SECOND SUBSCRIPT
C     INDICATES FIRST OR  SECOND DERIVATIVE RESPECTIVELY OF RI AND SI.
C  THESE DERIVATIVES ARE USED TO OBTAIN THE DERIVATIVES OF THE Q
C     CONTRIBUTIONS IN SUBROUTINE DERIV.
C
      RI(I,1)=dEXP(-U)
80    S(I,1)=1./(1.-RI(I,1))
      RI(I,2)=U
      RI(I,3)=-U
      S(I,2)=RI(I,1)*S(I,1)*U
      S(I,3)=S(I,2)*(S(I,2)+U-1.)
      IF (TEST(14)) WRITE (6,90) U,RI(I,1),S(I,1),I
90    FORMAT (/'   U =',E14.7,'   R =',E14.7,'   S =',E14.7,3X,'I =',I3)
100   CONTINUE
      IF (TEST(14)) WRITE (6,110)
110   FORMAT (/' CONTRIBUTION',13X,1HQ,15X,4HLN Q,11X,8H H-H0/RT,13X,
     1 'CP/R')
C
C  QLN = LN Q.      DQ = TDLNQ/DT.      DDQ = T2D2(LN Q)/DT2.
C  SUBROUTINE QSUM ACCUMULATES CONTRIBUTIONS OF LN Q AND DERIVATIVES.
C
C  ELECTRONIC PARTITION FUNCTION--FORMULA 1.
C
120   DQ=CT*T00
      QLN=DLOG(STWT/SYM)-DQ
      DDQ=-2.0*DQ
      LABEL=LEL
      EDQ=DQ
      EQLN=QLN
      EDDQ=DDQ
      CALL QSUM (TEST(14))
      IF (V(1).EQ.0.) GO TO 390
C
C  HARMONIC OSCILLATOR PARTITION FUNCTION--FORMULA 2.
C
      DO 130 I=1,NNU
      IF (V(I).EQ.0.) GO TO 130
      QLN=QLN+DN(I)*DLOG(S(I,1))
      DQ=DQ+DN(I)*S(I,2)
      DDQ=DDQ+DN(I)*S(I,3)
130   CONTINUE
      DDQ=DDQ-DQ
      CORT=0.
      LABEL=LHO
      CALL QSUM (TEST(14))
C
C  RIGID ROTATOR PARTITION FUNCTION--FORMULAS 3 AND 4.
C
      LABEL=LRR
      IF (TESTW(1)) GO TO 140
      Q=1.0d0/(CT*B)
      DQ=1.0d0
      DDQ=-1.0d0
      GO TO 150
140   Q= dsqrt(3.1415927d0/(A*B*C*CT**3))
      DQ=1.5d0
      DDQ=-1.5d0
150   QLN=DLOG(Q)
      CALL QSUM (TEST(14))
C
C  END RRHO CALCULATIONS.  GO TO 900(C480) TO ACCUMULATE Q FOR LEVEL.
C
      IF (TESTW(2)) GO TO 340
C
C  ROTATIONAL STRETCHING--FORMULA 5.
C  HIGHER ORDER CORRECTION TERMS ADDED OCTOBER, 1986 FOR LINEAR AND
C    SPHERICAL-TOP (A=B=C) MOLECULES.  R.S.MCDOWELL, JCP V39,NO3,P526.
C
      LABEL=LRHO
      IF(RH(1).LT.2.) GO TO 167
      RS=0.
      IF(A.EQ.B.AND.B.EQ.C) RS=DD*HCK/(16.*T(IT))
      RF=RH(6)*T(IT)
      QLN=(((RH(4)*RF+RH(3))*RF+RH(2))*RF+RH(1))*RF+RH(5)+RS
      DQ=(((4.*RH(4)*RF+RH(3)*3.)*RF+2.*RH(2))*RF+RH(1))*RF-RS
      DDQ=((12.*RH(4)*RF+RH(3)*6.)*RF+2.*RH(2))*RF*RF+2.*RS
      GO TO 168
C
167   QLN=RH(1)*T(IT)
      DQ=QLN
      DDQ=0.0
      IF(RH(2).EQ.0) GO TO 168
C
C  CORRECTION FACTOR ADDED JULY, 1986.
C
      RF=(2*RH(2)-RH(1)**2)*T(IT)**2
      QLN=QLN+.5*RF
      DQ=DQ+RF
      DDQ=RF
168   CALL QSUM (TEST(14))
C
C     LOW TEMPERATURE ROTATION -- FORMULA 6.
C
      LABEL=LTHETA
      Q=1.+((THETA(3)/T(IT)+THETA(2))/T(IT)+THETA(1))/T(IT)
      QLN=DLOG(Q)
      DQ=-((3.*THETA(3)/T(IT)+2.*THETA(2))/T(IT)+THETA(1))/T(IT)/Q
      DDQ=((2.*THETA(3)/T(IT)+THETA(2))*3./T(IT)+THETA(1))*2./T(IT)/Q-DQ
     1**2
      CALL QSUM (TEST(14))
C
C  VIBRATIONAL-ROTATION INTERACTION USING ALPHA CONSTANTS--FORMULAS 8-10
C
      LABEL=LALPHA
      IF ( NNU.LE.9 ) THEN
      DO 180 I=1,NNU
      QL(1)=AI(I)*DN(I)
      CALL DERIV (I,0,0,0,0,I,0,0,0,0,0)
      IF (TESTW(4)) GO TO 180
      QL(1)=.5*DN(I)*AI(I)**2
      CALL DERIV (I,0,0,0,0,I,I,0,0,0,0)
      QL(1)=DN(I)/6.*AI(I)**3
      CALL DERIV (I,0,0,0,0,I,I,I,0,0,0)
      QL(1)=DN(I)/6.*AI(I)**3
      CALL DERIV (I,I,0,0,0,I,I,I,0,0,0)
      IF (TESTW(1)) GO TO 180
      QL(1)=AIJ(I,I)*DN(I)
      CALL DERIV (I,0,0,0,0,I,I,0,0,0,0)
      QL(1)=AIJ(I,I)*DN(I)*AI(I)
      CALL DERIV (I,0,0,0,0,I,I,I,0,0,0)
      QL(1)=AIJ(I,I)*DN(I)*AI(I)
      CALL DERIV (I,I,0,0,0,I,I,I,0,0,0)
      DO 170 J=1,NNU
      QL(1)=AIJ(I,J)*DN(I)*DN(J)
      IF (I.GT.J) GO TO 160
      CALL DERIV (I,J,0,0,0,I,J,0,0,0,0)
160   QL(1)=AI(I)*AIJ(I,J)*DN(I)*DN(J)
      IF (I.EQ.J) QL(1)=QL(1)*2.
170   CALL DERIV (I,J,0,0,0,I,I,J,0,0,0)
      IF (NOATMS.GT.2) GO TO 180
C
C  FORMULA 11.
C
      QL(1)=AIII
      CALL DERIV (I,0,0,0,0,I,I,I,0,0,0)
      QL(1)=4.*AIII
      CALL DERIV (I,I,0,0,0,I,I,I,0,0,0)
      QL(1)=AIII
      CALL DERIV (I,I,I,0,0,I,I,I,0,0,0)
180   CONTINUE
C
      IF (TEST(14)) WRITE (6,190)
190   FORMAT (/,' FIRST ORDER CORRECTIONS' )
      CALL QSUM (TEST(14))
      CORT=1.0
C
C  FIRST ORDER XIJ--FORMULA 12.
C
      LABEL=LXIJ
      DO 200 I=1,NNU
      DO 200 J=I,NNU
      CON=DN(I)*DN(J)
      IF (I.EQ.J) CON=CON+DN(I)
      QL(1)=CON*(-CT)*X(I,J)
200   CALL DERIV (I,J,0,0,0,I,J,0,0,0,0)
      CALL QSUM (TEST(14))
C
C  END CALCULATIONS FOR PANDK AND JANAF.
C
C  FIRST ORDER YIJK--FORMULA13.
C
      IF (TESTW(4)) GO TO 340
      LABEL=LYIJK
      DO 210 I=1,NNU
      DO 210 J=I,NNU
      DO 210 K=J,NNU
      CON=ND(I)*(ND(J)+KD(I,J))*(ND(K)+KD(I,K)+KD(J,K))
      QL(1)=CON*(-CT)*Y(I,J,K)
210   CALL DERIV (I,J,K,0,0,I,J,K,0,0,0)
      CALL QSUM (TEST(14))
C
C  FIRST ORDER ALPHA-XIJ INTERACTION--FORMULA 17.
C
      LABEL=LAX
      DO 220 I=1,NNU
      AL=AI(I)*(-CT)
      DO 220 J=1,NNU
      IF (I.EQ.J) QL(1)=AL*X(I,I)*2.*DN(I)*(DN(I)+1.)
      IF (I.NE.J) QL(1)=AL*X(I,J)*DN(I)*DN(J)
220   CALL DERIV (I,J,0,0,0,I,I,J,0,0,0)
      CALL QSUM (TEST(14))
C
      DO 230 I=1,NNU
      IF (G(I).EQ.0.) GO TO 230
C
C  GII CORRECTION-- FORMULA 16.
C
      LABEL=LG
      QL(1)=G(I)*(-CT)*2.d0
      CALL DERIV (I,0,0,0,0,I,I,0,0,0,0)
      QL(1)=4.*G(I)*AI(I)*CT
      CALL DERIV (I,I,0,0,0,I,I,I,0,0,0)
230   CONTINUE
      IF (LABEL.EQ.LG) CALL QSUM (TEST(14))
      IF (NOATMS.GT.2) GO TO 240
C
C  WEZE FOR DIATOMIC MOLECULES--FORMULA 15.
C
      LABEL=LZ
      QL(1)=24.*WX(3)*(-CT)
      CALL DERIV (1,1,1,1,0,1,1,1,1,0,0)
      CALL QSUM (TEST(14))
240   CTT=CT**2/2.
      ENDIF
      IF (WF.EQ.0.0 .AND. DARD.EQ.0.) GO TO 250
C
C  FERMI AND DARLING DENNISON RESONANCE--FORMULA 7.
C    5/3/89 - FERMI CONTRIBUTION CHANGED TO
C    EQUIVALENT FORMULATION.  RW AND SW CHANGED TO RI(9,I) & S(9,I).
C    ADDED DARLING DENNISON - GURVICH (1978) FORMULA, PAGE 61.
C
      CORT=2.
      IF (WF.NE.0.) THEN
        LABEL=LFERMI
        U=CT*2.*V(2)
        CON=WF**2
      ELSE
        LABEL=LDARD
        U=CT*(V(1)+V(2))*.5D0
        CON=2.D0*DARD**2
      ENDIF
      RI(9,1)=dEXP(-U)
      S(9,1)=1./(1.-RI(9,1))
      RI(9,2)=U
      RI(9,3)=-U
      S(9,2)=RI(9,1)*S(9,1)*U
      S(9,3)=S(9,2)*(S(9,2)+U-1.)
      CON=CON*CTT
      QL(1)=CON
      IF (WF.NE.0.) THEN
        CALL DERIV (9,0,0,0,0,2,2,9,0,0,0)
      ELSE
        CALL DERIV (1,2,0,0,0,9,9,9,9,0,0)
      ENDIF
      CALL QSUM (TEST(14))
C
C  END CALCULATIONS FOR NRRAO1.
C
250   IF (.NOT.TESTW(3)) GO TO 340
      IF (TEST(14)) WRITE (6,260)
260   FORMAT (/,25H SECOND ORDER CORRECTIONS)
C
C  XIJ - XIJ INTERACTION--FORMULAS 18 AND 19.
C
      IF ( NNU.LE.9 ) THEN 
        LABEL=LX2
        CORT=2.0
        DO 280 I=1,NNU
        DO 270 J=I,NNU
        CON=DN(I)*DN(J)
        IF (I.EQ.J) CON=2.*DN(I)*(DN(I)+1.)
        QL(1)=CON*X(I,J)**2*CTT
270     CALL DERIV (I,J,0,0,0,I,I,J,J,0,0)
        DO 280 J=1,NNU
        DO 280 K=J,NNU
        CON=(2-KD(J,K))*(1+KD(I,J))*(1+KD(I,K))*ND(I)*(ND(J)+KD(I,J))*
     &  (ND(K)+KD(I,K))
        QL(1)=CON*X(I,J)*X(I,K)*CTT
280     CALL DERIV (I,J,K,0,0,I,I,J,K,0,0)
        CALL QSUM (TEST(14))
C
C  XIJ - YIJK INTERACTION--FORMULAS 20 AND 21.
C
        LABEL=LXY
        DO 290 I=1,NNU 
        DO 290 J=I,NNU
        DO 290 K=1,NNU
        CON=2*(1+KD(I,J))*(1+KD(I,K)+KD(J,K))*(ND(I)+KD(I,J))*ND(J)*
     &    (ND(K)+KD(J,K)+KD(I,K))
        QL(1)=CON*CTT*X(I,J)*Y(I,J,K)
290     CALL DERIV (I,J,K,0,0,I,I,J,J,K,0)
        DO 300 I=1,NNU
        DO 300 J=1,NNU
        DO 300 K=1,NNU
        DO 300 L=K,NNU
        CON=(1+KD(I,J))*(1+KD(I,K)+KD(I,L))*ND(I)*(ND(J)+KD(I,J))*
     &      (ND(K)+KD(I,K))*(ND(L)+KD(I,L)+KD(K,L))*2
        QL(1)=CON*CTT*X(I,J)*Y(I,K,L)
300     CALL DERIV (I,J,K,L,0,I,I,J,K,L,0)
        CALL QSUM (TEST(14))
        DO 320 I=1,NNU
        IF (G(I).EQ.0.) GO TO 320
C
C  GII - GII AND GII - XIJ INTERACTIONS--FORMULAS 22 AND 23.
C
        LABEL=LG2
        QL(1)=2.*G(I)**2*CTT
        CALL DERIV (I,0,0,0,0,I,I,I,I,0,0)
        DO 310 J=1,NNU
        CON=4.*G(I)*X(I,J)*CTT
        IF (I.EQ.J) CON=16.*G(I)*(G(I)+2.*X(I,I))*CTT
        QL(1)=CON
        CALL DERIV (I,J,0,0,0,I,I,I,J,0,0)
        QL(1)=CON
        IF (I.EQ.J) QL(1)=CTT*2.*(G(I)+12.*X(I,I))*G(I)
310     CALL DERIV (I,I,J,0,0,I,I,I,J,0,0)
320     CONTINUE
        IF (LABEL.EQ.LG2) CALL QSUM (TEST(14))
C
C  ALPHA - XIJ - XIJ INTERACTION--FORMULAS 24 THRU 27.
C
        LABEL=LAX2
        DO 330 I=1,NNU
        AL=AI(I)*CTT
        QL(1)=4.*AL*(X(I,I)*DN(I)*(DN(I)+1.))**2
        CALL DERIV (I,I,I,I,I,I,I,I,I,I,0)
        DO 330 J=1,NNU
        IF (I.EQ.J) CON=4.*DN(I)*(DN(I)+1.)
        IF (I.NE.J) CON=DN(I)*DN(J)
        QL(1)=CON*X(I,J)**2*AL
        CALL DERIV (I,J,0,0,0,I,I,I,J,J,0)
        DO 330 K=1,NNU
        CON=(1+KD(I,J))*(1+KD(I,K))*ND(I)*(ND(J)+KD(I,J))*(ND(K)+
     &     KD(I,K))
        QL(1)=CON*AL*X(I,J)*X(I,K)
        CALL DERIV (I,J,K,0,0,I,I,I,J,K,0)
        QL(1)=CON*AL*X(I,J)*X(I,K)
        CALL DERIV (I,J,K,I,0,I,I,I,J,K,0)
        CON=(1+KD(I,J))*(1+KD(J,K))*(2-KD(I,K))*ND(I)*(ND(J)+KD(I,J))*
     &  ((1+KD(I,K))*ND(K)+KD(I,K)+KD(J,K)+KD(I,J)*KD(J,K))
        QL(1)=CON*AL*X(I,J)*X(J,K)
        CALL DERIV (I,J,K,0,0,I,I,J,J,K,0)
330     CONTINUE
        CALL QSUM (TEST(14))
      ENDIF
C
C  INTERNAL ROTATION
C
340   IF (.NOT.IROT) GO TO 370
      LABEL=LIR
      K=0
      L=1
350   CALL INTROT (T(IT),HCK,DQS,DDQS,QLNS,L,LT)
      DO 360 J=1,LT
      K=K+1
      DQ=DQS
      DDQ=DDQS
      QLN=QLNS
      CALL QSUM (TEST(14))
360   CONTINUE
      L=L+1
      IF (K.LT.NIR) GO TO 350
370   IF (TESTW(6)) GO TO 380
C
C   CALCULATIONS FOR SPECIES WITH ONE ELECTRONIC STATE
C
      GHRT(IT)=QLNTOT
      HHRT(IT)=DQTOT
      CPR(IT)=DDQTOT+2.d0*DQTOT
      GO TO 430
C
C   CALCULATIONS FOR SPECIES WITH EXCITED ELECTRONIC STATES
C
380   SQ(1,IT)=QLNTOT-EQLN
      SQ(2,IT)=DQTOT-EDQ
      SQ(3,IT)=DDQTOT-EDDQ
390   IF (QLNTOT.LE.700.d0) GO TO 420
      WRITE (6,400)
400   FORMAT (/,' Q TOO LARGE TO INCLUDE EXCITED STATES, (LINK1)')
410   IF (CODE(1).NE.SUB) RETURN
      CALL INPUT
      GO TO 410
420   QTOT=0.
      IF (QLNTOT.GT.-20.) QTOT=dEXP(QLNTOT)
      GHRT(IT)=QTOT+GHRT(IT)
      HHRT(IT)=DQTOT*QTOT+HHRT(IT)
      CPR(IT)=(DDQTOT+DQTOT**2)*QTOT+CPR(IT)
430   CONTINUE
      RETURN
      END
      SUBROUTINE LOGK
      SAVE
      PARAMETER (IOEFT=13)
C
C  CALCULATE ROUNDED TABLES WITH DELTAH AND LOGK CALCULATIONS.
C
C   TEST(4) - SPECIES IS A GAS.
C   TEST(8) - AN ASSIGNED H IS AVAILABLE.
C   TEST(13) - DATA ARE IN THE FORM, H-H298 AND -(G-H298)
C   TEST(18) - ENTHALPY IS ABSOLUTE
C
      DIMENSION ENT(2,20),PT(20),NQ(5),MARK(20),TK(3),VFM2(15),itn(20)
C
      DOUBLE PRECISION TP(3,502),HZERO,AMP,TNO,H00RT,RT,RUSE(2)
      DOUBLE PRECISION ALK(502),DH0,FRT,CP,S,H,HH,GH,DH(502),H0
      DOUBLE PRECISION HH0,DMLA,DNMLA,H298
C
      CHARACTER*4 CHH,CHDH,BZ,VFM2,FSTAR,F2B,ZERO,FI6,ENT
      CHARACTER*4 FA4,F3X,F8X,F9,F12,FP2,FP3,FP4
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      EQUIVALENCE (IT,TI), (TAPE,TP)
C
      DATA  FSTAR/'2H *'/,F9/',F9'/,FP2/'.2'/, FI6/',I6'/,F3X/',3X'/
     1 ,FA4/',A4'/,FP4/'.4'/,FP3/'.3'/, ZERO/'0'/
     2 , F12/',F12'/, F8X/',8X'/, F2B/'2H  '/
C
      DATA VFM2/'(', '2H  ', ',F9', '.2', ',F9', '.3,3', 'F12', '.4',
     1   ',F12', '.4', ',F12', '.4',  ',F12', '.4', ')'/
C
      REWIND IOEFT
      CHH=FSTAR
      CHDH=FSTAR
      RUSE(1)=R
      IF (R.LT.8.D0)RUSE(1)=R*4.184D0
      RUSE(2)=RUSE(1)/4.184D0
      H298=H298HR
      IF (TEST(13))H298=0.
      IF (TEST(18))H298=ASINDH
      IK=0
      DO 10 I=1,NT
      DH(I)=0.D0
10    ALK(I)=0.D0
      INIT=1
      NTX=0
      DH0=0.D0
C
C  NQ = 0 - EFDATA FOR ELEMENT NOT AVAILABLE
C  NQ = 1 - EFDATA FOR ELEMENT IS AVAILABLE
C  NQ = 2 - MOLECULE IS AN ELEMENT ITSELF
C  CHDH = BLANK OR ZERO - USE CHARACTER FOR DELTA H AND LOGK COLUMNS
C  CHH = BLANK - USE BLANK FOR H COLUMN
C
C  SEARCH IOEFT FOR EFDATA FOR THIS MOLECULE.
C
      DO 20 I=1,NKIND
      J=JF(I)
20    NQ(I)=0
      IF (NKIND.GT.1) GO TO 30
      J=JF(1)
      IF (MLA(1).EQ.NMLA(J).AND.FAZ.EQ.EFAZ(J)) NQ(1)=2
30    READ (IOEFT,END=210) CODE,NA,SUB,DATE,HZERO,AMP,TNO,((TP(J,K),
     * J=1,3),K=1,502)
      IF (CODE(1).EQ.BLANK) GO TO 210
      DO 40 II=1,NKIND
      J=JF(II)
      IF (CODE(1).NE.FORMLA(1,II)) GO TO 40
      IF (CODE(2).NE.FORMLA(2,II)) GO TO 40
      GO TO 50
40    CONTINUE
      GO TO 30
50    LL=1
      IF (SUB.NE.EFAZ(J)) GO TO 30
      IF (NA.NE.NMLA(J)) GO TO 30
      IF (NQ(II).EQ.2) GO TO 190
      NQ(II)=1
      MX=TNO+.1
      DMLA=MLA(II)
      DNMLA=NMLA(J)
      DH0=DH0-HZERO*DMLA*RUSE(1)/DNMLA
C
C  FIND TRANSITION POINTS FOR REACTANT
C
      k1=1
      ntn=1
      DO 80 K=1,MX-1
      IF (TP(1,K).NE.TP(1,K+1)) GO TO 80
      itn(ntn)=k
      ntn=ntn+1
80    CONTINUE
      itn(ntn)=MX
      M=itn(1)
      DO 180 I=1,NT
C
C   FIND T IN EFDATA
C
      if (t(i).ge.tp(1,k1).and.t(i).le.tp(1,m))go to 130
      if (tp(1,1).gt.t(i)) go to 110
      if (t(i).gt.tp(1,mx)) go to 130
      do 100 j=2,ntn
      jx=j-1
      jj=itn(j)
      if(t(i).le.tp(1,jj)) go to 104
100   continue
104   k1=itn(jx)+1
      M=jj
      go to 120
110   INIT=INIT+1
      GO TO 180
C
C  MP OF REACTANT, PUT * IN MARK FOR FOOTNOTE
C
120   IF (IK.LT.20) IK=IK+1
      MARK(IK)=I
      PT(IK)=tp(1,k1)
      ENT(1,IK)=CODE(1)
      ENT(2,IK)=CODE(2)
130   DO 160 K=K1,M
      TK(2)=TP(2,K)
      TK(3)=TP(3,K)
      IF (DABS(TP(1,K)-T(I)).LT.0.01) GO TO 170
      IF (TP(1,K).LT.T(I)) GO TO 160
      IF ((M-K1).EQ.0) GO TO 160
C
C  INTERPOLATION OF EF DATA
C
      N=4
      IF ((M-K1).LT.3) N=M-K1+1
      K2=K-2
      IF (K.EQ.K1) K2=K
      IF (K.EQ.(K1+1)) K2=K-1
      NK=K2+N-1
      DO 150 L=2,3
      TK(L)=0.0
      DO 150 JJ=K2,NK
      TK(1)=1.0
      DO 140 JM=1,N
      IM=K2+JM-1
      IF (TP(1,JJ).EQ.TP(1,IM)) GO TO 140
      TK(1)=TK(1)*(T(I)-TP(1,IM))/(TP(1,JJ)-TP(1,IM))
140   CONTINUE
150   TK(L)=TK(L)+TK(1)*TP(L,JJ)
      GO TO 170
160   CONTINUE
      IF ((NTX.EQ.0).OR.((I-1).LT.NTX)) NTX=I-1
      GO TO 190
C
C  CALCULATE DELTA H AND DELTA F
C
170   DH(I)=DH(I)-TK(2)*DMLA/DNMLA
      ALK(I)=ALK(I)-TK(3)*DMLA/DNMLA
180   CONTINUE
190   DO 200 I=1,NKIND
      IF (NQ(I).EQ.0) GO TO 30
200   CONTINUE
210   DH0=DH0/1000.
      IF (TEST(18).AND.ASINDT.NE.0.)GO TO 215
      IF (TEST(8))DH0= DH0 + (RUSE(1)*ASINDH)/1000.D0
215   DO 220 I=1,NKIND
      IF (NQ(I).EQ.1) GO TO 220
      IF (NQ(I).EQ.0) CHDH=BLANK
      IF (NQ(I).EQ.2) CHDH=ZERO
220   CONTINUE
C
C  PRINT TABLES
C
      DO 510 NTABLE=1,2
      IF (.NOT.TOUT(NTABLE+1)) GO TO 510
      WRITE (6,230) (SNM(I),I=1,4),((NAME(I,J),I=1,4),J=1,nna)
230   FORMAT (1H ,4A4,6(3X,4A4)///)
      IF (TEST(18).AND.ASINDT.EQ.0.)GO TO 233
      IF (TEST(13).OR.H298.NE.0.)GO TO 238
233   WRITE (6,235)
235   FORMAT (/'     T         CP         H-H0         S       -(G-H0)/
     1T      H        DELTA H      LOG K')
      GO TO 245
238   WRITE (6,240)
240   FORMAT (/'     T         CP        H-H298        S      -(G-H298)/
     1T      H        DELTA H      LOG K')
245   IF (NTABLE.EQ.1)WRITE(6,250)
      IF (NTABLE.EQ.2)WRITE(6,255)
250   FORMAT ('    DEG-K    J/MOL-K      KJ/MOL     J/MOL-K     J/MOL-K
     *     KJ/MOL      KJ/MOL'/)
255   FORMAT ('    DEG-K   CAL/MOL-K    KCAL/MOL   CAL/MOL-K   CAL/MOL-K
     *    KCAL/MOL    KCAL/MOL'/)
      IF (.NOT.TEST(8)) GO TO 290
      IF ((TEST(13).OR.TEST(18)).AND.ASINDT.NE.0.)GO TO 290
      H0=(ASINDH*RUSE(NTABLE))/1000.
      HH0=-H298HR*RUSE(NTABLE)/1000.
      IF (CHDH.EQ.BLANK .OR. CHDH.EQ.ZERO) GO TO 280
      WRITE (6,275) HH0,H0,DH0
275   FORMAT (6X,'0',6X,'-------',F12.4,5X,'-------',5X,'-------',2F12.4
     * ,5X,'-------')
      GO TO 290
280   WRITE (6,285) HH0,H0,CHDH
285   FORMAT (6X,'0',6X,'-------',F12.4,5X,'-------',5X,'-------',F12.4,
     * 8X,A4,5X,'-------')
290   LINES=10
      H=0.
      IF (TEST(8).OR.TEST(18)) GO TO 298
      CHH=BLANK
      CHDH=BLANK
C
298   DO 420 I=1,NT
      IT=T(I)
      VFM2(3)=FI6
      VFM2(4)=F3X
      IF (DMOD(T(I),1.D0).EQ.0.) GO TO 300
      TI=T(I)
      VFM2(3)=F9
      VFM2(4)=FP2
300   RT=RUSE(NTABLE)*T(I)
      H00RT=ASINDH/T(I)
      IF (.NOT.TEST(18)) H=H00RT
      H=(H+HHRT(I))*RT/1000.D0
      FRT=GHRT(I)-H00RT
      CP=CPR(I)*RUSE(NTABLE)
      S=SR(I)*RUSE(NTABLE)
      HH=(HHRT(I)-H298/T(I))*RT/1000.D0
      GH=(GHRT(I)+H298/T(I))*RUSE(NTABLE)
C
C
      VFM2(2)=F2B
      IF (IK.EQ.0) GO TO 320
      DO 310 IX=1,IK
      IF (MARK(IX).EQ.I) VFM2(2)=FSTAR
310   CONTINUE
320   BZ=ZERO
      IF (CHDH.EQ.ZERO)GO TO 350
      BZ=BLANK
      IF (CHDH.EQ.BLANK) GO TO 350
      IF ((I.GT.NTX.AND.NTX.NE.0).OR.I.LT.INIT) GO TO 350
      IF ( ntable.EQ.1.OR..NOT.Tout(2) ) THEN
        DH(I)=(DH(I)+HHRT(I))*RT/1000.D0+DH0
        ALK(I)=(GHRT(I)+ALK(I)-DH0*1000.D0/RT)/2.3025851D0
      ELSE
        DH(I)=DH(I)/4.184D0
      ENDIF
      VFM2(11)=F12
      VFM2(12)=FP4
      VFM2(13)=F12
      VFM2(14)=FP4
      IF(VFM2(3).EQ.F9)WRITE (6,VFM2)TI,CP,HH,S,GH,H,DH(I),ALK(I)
      IF(VFM2(3).EQ.FI6)WRITE (6,VFM2)IT,CP,HH,S,GH,H,DH(I),ALK(I)
      GO TO 400
350   VFM2(11)=F8X
      VFM2(12)=FA4
      VFM2(13)=F8X
      VFM2(14)=FA4
      IF (CHH.EQ.BLANK) GO TO 360
      IF(VFM2(3).EQ.F9)WRITE (6,VFM2)TI,CP,HH,S,GH,H,BZ,BZ
      IF(VFM2(3).EQ.FI6)WRITE (6,VFM2)IT,CP,HH,S,GH,H,BZ,BZ
      GO TO 400
360   IF(VFM2(3).EQ.F9)WRITE (6,VFM2)TI,CP,HH,S,GH
      IF(VFM2(3).EQ.FI6)WRITE (6,VFM2)IT,CP,HH,S,GH
C
400   LINES=LINES+1
      IF (DMOD(T(I),500.D0).NE.0.0) GO TO 420
      IF (T(I).GT.10000.D0.AND.DMOD(T(I),2500.D0).NE.0.) GO TO 420
      WRITE (6,410)
410   FORMAT (1H )
420   continue     
      IF (IK.EQ.0) GO TO 460
C
C     WRITE FOOTNOTE
C
      WRITE (6,440)
440   FORMAT (/,' *A CHANGE IN PHASE OF AN ASSIGNED REFERENCE ELEMENT'
     1,' HAS OCCURRED BETWEEN THIS TEMPERATURE AND THE PRECEDING ONE,')
      WRITE (6,450) (ENT(1,I),ENT(2,I),PT(I),I=1,IK)
450   FORMAT ('  ',2A1,'-- ',F8.3///)
460   CALL PAGEID
510   DH0=DH0/4.184D0
      REWIND IOEFT
      RETURN
      END
      SUBROUTINE PAGEID
      SAVE
C
C  PRINTS CHEMICAL FORMULA AT BOTTOM OF PAGE.
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      WRITE (6,20) (SNM(I),I=1,4),STD,((NAME(I,J),I=1,4),J=1,NNA)
20    FORMAT (/,15X,4A4,2X,A3,2X,6(2X,4A4)///)
      RETURN
      END
      SUBROUTINE POLY
      SAVE
C
C  CALCULATE PROPERTIES FOR DIATOMIC AND POLYATOMIC MOLECULES.
C
C               IF TEST IS TRUE--
C     TESTW(1)  MOLECULE IS NON-LINEAR
C     TESTW(2)  RIGID ROTATOR-HARMONIC OSCILLATOR APPROXIMATION
C     TESTW(3)  SECOND ORDER CORRECTIONS ARE CALLED FOR
C     TESTW(4)  PENNINGTON AND KOBE APPROXIMATION
C     TESTW(5)  JANAF METHOD FOR DIATOMIC MOLECULES
C     TESTW(6)  SPECIES HAS EXCITED ELECTRONIC STATES
C
      CHARACTER*4 AJANAF,ALF,ALPHA,ANRRA,A1,A2,BE,BET,B1,B2,C1,C2,DE,DJ
      CHARACTER*4 DJK,DK,D1,D2,D222,ENA,ENB,ENC,EIAIB,G2,O1,O2,PANDK
      CHARACTER*4 RHO,RRHO,STATWT,SYMNO,TAAA,TAAB,TAAC,TABA,TACA
      CHARACTER*4 TBBB,TBBC,TBCB,TCCC,TROT,T1,T2,VV,WE,WEXE,WEYE,WEZE
      CHARACTER*4 WXX,W1,W2,XX,YY,DRD
C
      LOGICAL IROT, CALRHO, calcth
      DOUBLE PRECISION DJKN,DKN,TAU(9),BEJ,ASQ,BSQ,CSQ,CY,BCONV,
     & IAIBIC,DJN,TAB,TBC,TAC,Z,E1,F1,G1,H1
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      real*8 v,x,y,alfa,alfb,alfc,g,wx,beta,a,b,c,dard,dd,wf,w,sym,stwt,
     1 t00,theta,rh,ri,s,ql,q,qln,dq,ddq,qtot,qlntot,dqtot,ddqtot,aij,
     2 aiii,ai
      logical testw
      COMMON /WCOMMN/ V(300),X(9,9),Y(9,9,9),ALFA(9),ALFB(9),ALFC(9),
     1 G(9),WX(9),BETA(4),A,B,C,DARD,DD,WF,W,SYM,STWT,T00,THETA(3),
     2 RH(6),RI(300,3),S(300,3),QL(3),Q,QLN,DQ,DDQ,QTOT,QLNTOT,DQTOT,
     3 DDQTOT,AIJ(9,9),AIII,AI(9),DN(300),ND(300),CORT,NNU,TESTW(6)
C
      DATA RRHO/'RRHO'/, AJANAF/'JANA'/, ANRRA/'NRRA'/, O2/'O2'/
      DATA PANDK/'PAND'/, BCONV/2.7992774D0/, O1/'O1'/
C
      DATA             SYMNO /'SYMN'/, STATWT/'STAT'/,  A1   /'A   '/
     1,  B1  /'B'   /,   C1  /'C'   /,   ENA /'IA'  /,  ENB  /'IB'  /
     2,  RHO /'RHO '/, ALPHA /'ALPH'/,   WE  /'WE  '/, WEXE  /'WEXE'/
     3, WEYE /'WEYE'/,  WEZE /'WEZE'/,   DE  /'DE  '/,  ALF  /'ALFA'/
     4,  W1  /'W   '/,   T2  /'TO  '/,   A2  /'AO  '/,  B2   /'BO  '/
     5,  C2  /'CO  '/,   D1  /'D   '/,   DRD /'DARD'/,  D2   /'DO  '/
     6, D222 /'DOOO'/,   WXX /'WX  '/,   BET /'BETA'/,  W2   /'WO  '/
     7,  BE  /'BE  '/,   ENC /'IC  '/,   T1  /'T   '/,  VV   /'V   '/
     8,  XX  /'X   '/,   YY  /'Y   '/,   G2  /'G   '/,  EIAIB/'IAIB'/
      DATA TROT/'INTR'/ ,DJ/'DJ'/,DJK/'DJK'/,DK/'DK'/,TAAA/'TAAA'/,
     1 TBBB/'TBBB'/,TCCC/'TCCC'/,TAAC/'TAAC'/,TAAB/'TAAB'/,
     2 TBBC/'TBBC'/,TABA/'TABA'/,TACA/'TACA'/,TBCB/'TBCB'/
C
C  INITIALIZE FOR EACH SET OF METHOD AND DATA RECORDS.
C
      DO 10 I=NIT,NT
      CPR(I)=0.0
      HHRT(I)=0.0
10    GHRT(I)=0.0
      HHRT(NT+1)=0.0
      GHRT(NT+1)=0.0
      SYM=1.0
      STWT=1.0
      DO 15 I=2,6
15    TESTW(I)=.FALSE.
C
C  CHECK METHOD
C
      DO 25 I=1,4
      IF (ABEL(1,I).EQ.RRHO) GO TO 35
      IF (ABEL(1,I).EQ.ANRRA) GO TO 20
      IF (ABEL(1,I).EQ.PANDK) GO TO 45
      IF (ABEL(1,I).EQ.AJANAF) GO TO 50
      GO TO 25
20    IF (ABEL(2,I).EQ.O1) GO TO 55
      IF (ABEL(2,I).EQ.O2) GO TO 40
25    CONTINUE
      WRITE (6,30)
30    FORMAT (/,' METHOD CODE WAS NOT RECOGNIZED, USED NRRAO1, (POLY)')
      GO TO 55
35    TESTW(2)=.TRUE.
      GO TO 55
40    TESTW(3)=.TRUE.
      GO TO 55
45    TESTW(4)=.TRUE.
      GO TO 55
50    TESTW(5)=.TRUE.
      IF (NOATMS.GT.2) TESTW(2)=.TRUE.
55    WRITE (6,60) WEIGHT
60    FORMAT (/,' MOLECULAR WT.=',F12.7)
      NFIRST=0
      LINES=LINES+4
C
C  CALL INPUT TO READ AND PRINT CONTENTS OF INPUT RECORD.
C
65    CALL INPUT
      IF (NFIRST.NE.0) GO TO 95
C
C  INITIALIZE FOR FIRST RECORD ONLY.
      NFIRST=1
      SUB=CODE(1)
C
C  INITIALIZE FOR EACH ELECTRONIC LEVEL.
C
70    IROT=.FALSE.
      T00=0.0
      A=0.0
      B=0.0
      C=0.0
      DJN=0
      DJKN=0
      DKN=0
      DO 75 I=1,9
75    TAU(I)=0
      CALRHO=.FALSE.
      calcth = .true.
      DD=0.0
      WF=0.0
      DARD=0.0
      W=0.0
      THETA(3)=0.0
      AIII=0.0
      DO 80 I=1,9
      ALFA(I)=0.0
      ALFB(I)=0.0
      ALFC(I)=0.0
      G(I)=0.0
      WX(I)=0.0
      if (i.le.6) RH(I)=0.0
      DO 80 J=1,9
      X(I,J)=0.0
      AIJ(I,J)=0.0
80    CONTINUE
      DO 85 I=1,300
      V(I)=0.0
      ND(I)=1
85    DN(I)=1.0d0
      DO 87 I=1,4
      BETA(I)=0.0
87    CONTINUE
      DO 90 I=1,9
      DO 90 J=1,9
      DO 90 K=1,9
90    Y(I,J,K)=0.0
      LELC=IC80
C
C  ASSUME LINEAR MOLECULE WITH 3N-5 FREQS.  IF THERE IS AN A OR IA
C      IN THE INPUT, CHANGE TO 3N-6.
C
      NV=3*NOATMS-5
      TESTW(1)=.FALSE.
      GO TO 100
C
C  IF COLS 1-4 OR 79-80 ARE DIFFERENT FROM PREVIOUS RECORD, GO TO 510.
C
95    IF (CODE(1).NE.SUB.OR.LELC.NE.IC80) GO TO 325
C
C  IN DO LOOP THRU 500 CHECK EACH LABEL ON DATA RECORD AND STORE DATA.
C
100   DO 320 ID=1,4
      IF (ABEL(1,ID).EQ.BLANK) GO TO 320
      I=FWORD(ID)
      IF (I.LT.0) I=0
      IF (ABEL(1,ID).EQ.T1.OR.ABEL(1,ID).EQ.T2) GO TO 115
      IF (ABEL(1,ID).EQ.STATWT) GO TO 125
      IF (ABEL(1,ID).EQ.SYMNO) GO TO 130
      IF (ABEL(1,ID).EQ.B1.OR.ABEL(1,ID).EQ.B2.OR.ABEL(1,ID).EQ.BE)
     1  GO TO 135
      IF (ABEL(1,ID).EQ.ENB) GO TO 140
      IF (ABEL(1,ID).EQ.ALPHA.OR.ABEL(1,ID).EQ.ALF) GO TO 260
      IF (ABEL(1,ID).EQ.D1) GO TO 150
      IF (ABEL(1,ID).EQ.D2.OR.ABEL(1,ID).EQ.D222) GO TO 150
C
      IF (NOATMS.EQ.2) GO TO 280
      IF (ABEL(1,ID).EQ.RHO) GO TO 145
      IF (ABEL(1,ID).EQ.ENA) GO TO 235
      IF (ABEL(1,ID).EQ.ENC) GO TO 220
      IF (ABEL(1,ID).EQ.EIAIB) GO TO 218
      IF (ABEL(1,ID).EQ.A1.OR.ABEL(1,ID).EQ.A2) GO TO 245
      IF (ABEL(1,ID).EQ.C1.OR.ABEL(1,ID).EQ.C2) GO TO 225
      IF (ABEL(1,ID).EQ.W1.OR.ABEL(1,ID).EQ.W2) GO TO 230
      IF (ABEL(1,ID).EQ.DRD) GO TO 232
      IF (ABEL(1,ID).EQ.VV) GO TO 265
      IF (ABEL(1,ID).EQ.XX) GO TO 270
      IF (ABEL(1,ID).EQ.YY) GO TO 275
      IF (ABEL(1,ID).EQ.G2) GO TO 255
      IF (ABEL(1,ID).EQ.TROT) GO TO 120
      IF (ABEL(1,ID).EQ.DJ) GO TO 155
      IF (ABEL(1,ID).EQ.DJK) GO TO 160
      IF (ABEL(1,ID).EQ.DK) GO TO 165
      IF (ABEL(1,ID).EQ.TAAA) GO TO 170
      IF (ABEL(1,ID).EQ.TBBB) GO TO 175
      IF (ABEL(1,ID).EQ.TCCC) GO TO 180
      IF (ABEL(1,ID).EQ.TAAC) GO TO 185
      IF (ABEL(1,ID).EQ.TAAB) GO TO 190
      IF (ABEL(1,ID).EQ.TBBC) GO TO 195
      IF (ABEL(1,ID).EQ.TABA) GO TO 200
      IF (ABEL(1,ID).EQ.TACA) GO TO 205
      IF (ABEL(1,ID).EQ.TBCB) GO TO 210
105   WRITE (6,110) ABEL(1,ID),WORD(ID)
110   FORMAT (/,A6,' IS AN INCORRECT LABEL FOR THE NUMBER--',E16.8,'.
     1 THUS THE VALUE WAS IGNORED (POLY)')
      GO TO 320
C
C
115   T00=WORD(ID)
      GO TO 320
120   IROT=.TRUE.
      NIR=WORD(ID)+.01
      CALL IROTOR (IROT,NIR)
      GO TO 95
125   STWT=WORD(ID)
      GO TO 320
130   SYM=WORD(ID)
      GO TO 320
135   B=WORD(ID)
      GO TO 320
140   B=BCONV/WORD(ID)
      GO TO 320
145   IF (I.GE.1)RH(I)=WORD(ID)
      IF (I.EQ.0)RH(1)=WORD(ID)
      GO TO 320
150   DD=WORD(ID)
      GO TO 320
155   DJN=WORD(ID)
      GO TO 215
160   DJKN=WORD(ID)
      GO TO 215
165   DKN=WORD(ID)
      GO TO 215
170   TAU(1)=WORD(ID)
      GO TO 215
175   TAU(2)=WORD(ID)
      GO TO 215
180   TAU(3)=WORD(ID)
      GO TO 215
185   TAU(4)=WORD(ID)
      GO TO 215
190   TAU(5)=WORD(ID)
      GO TO 215
195   TAU(6)=WORD(ID)
      GO TO 215
200   TAU(7)=WORD(ID)
      GO TO 215
205   TAU(8)=WORD(ID)
      GO TO 215
210   TAU(9)=WORD(ID)
215   CALRHO=.TRUE.
      GO TO 320
218   A=BCONV
      B=BCONV/WORD(ID)
      C=BCONV
      calcth = .false.
      GO TO 240
220   C=BCONV/WORD(ID)
      GO TO 320
225   C=WORD(ID)
      GO TO 320
230   WF=WORD(ID)
      GO TO 320
232   DARD=WORD(ID)
      GO TO 320
C
C  IF IA OR A LABEL, NON-LINEAR MOLECULE IS ASSUMED.
C
235   A=BCONV/WORD(ID)
240   TESTW(1)=.TRUE.
      NV=3*NOATMS-6
      GO TO 320
245   IF (I.EQ.0) GO TO 250
      IX=I/10
      JX=I-10*IX
      AIJ(IX,JX)=WORD(ID)
      GO TO 320
250   A=WORD(ID)
      GO TO 240
255   IF (I.GT.10) I=I/10
      G(I)=WORD(ID)
      GO TO 320
260   IF (I.EQ.0) I=1
      IF (ABEL(1,ID).NE.ALPHA.AND.ABEL(2,ID).NE.B1) GO TO 262
      ALFB(I)=WORD(ID)
      GO TO 320
262   IF (ABEL(2,ID).NE.A1) GO TO 264
      ALFA(I)=WORD(ID)
      GO TO 320
264   IF (ABEL(2,ID).NE.C1) GO TO 105
      ALFC(I)=WORD(ID)
      GO TO 320
C
C  STORE FREQUENCY AND DEGENERACY ACCORDING TO LABEL.
C
265   V(I)=WORD(ID)
      IF (D(ID).EQ.0.) D(ID)=1.
      DN(I)=D(ID)
      ND(I)=D(ID)
      GO TO 320
C
C  STORE XIJ ACCORDING TO LABEL
270   IX=I/10
      JX=I-10*IX
      X(IX,JX)=WORD(ID)
      GO TO 320
C
C  STORE YIJK ACCORDING TO LABEL.
275   IY=I/100
      I=I-100*IY
      JY=I/10
      KY=I-10*JY
      Y(IY,JY,KY)=WORD(ID)
      GO TO 320
C
C  SOME INPUT FOR DIATOMIC MOLECULES.
C
280   IF (ABEL(1,ID).EQ.WE) GO TO 285
      IF (ABEL(1,ID).EQ.WEXE) GO TO 290
      IF (ABEL(1,ID).EQ.WEYE) GO TO 295
      IF (ABEL(1,ID).EQ.WEZE) GO TO 300
      IF (ABEL(1,ID).EQ.WXX) GO TO 305
      IF (ABEL(1,ID).EQ.BET) GO TO 310
      IF (ABEL(1,ID).EQ.DE) GO TO 315
      GO TO 105
285   W=WORD(ID)
      GO TO 320
290   WX(1)=WORD(ID)
      GO TO 320
295   WX(2)=WORD(ID)
      GO TO 320
300   WX(3)=WORD(ID)
      GO TO 320
305   WX(I)=WORD(ID)
      GO TO 320
310   BETA(I)=WORD(ID)
      GO TO 320
315   DD=WORD(ID)
320   CONTINUE
C
C  DATA FOR RECORD HAS BEEN STORED.  READ THE NEXT RECORD.
C
      GO TO 65
C
C
C  DATA FOR ELECTRONIC LEVEL HAS BEEN STORED--CALCULATE SOME VARIABLES
C     REQUIRED IN EQUATIONS.
C
325   NNU=0
      IRT=0
      IF (CODE(1).EQ.SUB) TESTW(6)=.TRUE.
      I=0
      IF (NOATMS.NE.2) GO TO 335
C
C  DIATOMIC MOLECULES--
C
      IF (TESTW(6).AND.W.EQ.0.) GO TO 510
      IF (W.LE.0.) GO TO 540
      V(1)=W-2.0*WX(1)+3.25*WX(2)+5.0*WX(3)+7.5625*WX(4)
      X(1,1)=-WX(1)+4.5*WX(2)+14.5*WX(3)
      Y(1,1,1)=WX(2)+8.*WX(3)
      AI(1)=ALFB(1)-ALFB(2)-.75*ALFB(3)
      AIJ(1,1)=-ALFB(2)-1.5*ALFB(3)
C
C  CALCULATE AND CHECK NUMBER OF FREQS. (NNU).  MAXIMUM 9 FOR NON-RRHO.
C
335   NNU=NNU+1
      IF (TESTW(6).AND.B.EQ.0.) GO TO 510
      IF (V(NNU).NE.0.0) GO TO 338
      IF (.NOT.IROT) GO TO 540
      IRT=IRT+1
      IF (IRT.GT.NIR) GO TO 540
338   I=I+ND(NNU)
      IF (I.LT.NV) GO TO 335
      IF (NNU.LT.300.AND.V(NNU+1).NE.0.) GO TO 540
C  Added next statement 10/3/97 to check for number of vibs (NV)
      if (I.GT.NV) goto 540
      IF (B.EQ.0.0) GO TO 550
      IF (NNU.GT.9) THEN
        IF ( .NOT.TESTW(2) ) WRITE (6,339)
339    FORMAT (/' ANHARMONICITIES NOT INCLUDED WHEN NUMBER OF NuS > 9')
      ENDIF
      IF (NOATMS.EQ.2) GO TO 340
      IF (TESTW(2)) GO TO 480
      IF (TESTW(1)) GO TO 390
      GO TO 350
C
C  DIATOMIC MOLECULES.
C
340   DD=((BETA(3)*0.5+BETA(2))*0.5-BETA(1))*0.5+DD
      IF (DD.EQ.0.0) DD=(4.0*B**3)/W**2
      BEJ=B
      B=((ALFB(3)*0.5+ALFB(2))*0.5-ALFB(1))*0.5+B
      IF (.NOT.TESTW(5)) GO TO 345
C
C  JANAF CORRECTIONS
C
      AI(1)=AI(1)/BEJ
      X(1,1)=X(1,1)*V(1)/W
      RH(1)=4.*dSQRT(DD/BEJ)/(HCK*V(1))
      GO TO 365
C
C  IF RRHO, SKIP TO 850.
C
345   IF (TESTW(2)) GO TO 510
C
C  DIATOMICS--NOT JANAF.
C
      IF (TESTW(4)) AI(1)=ALFB(1)-2.*ALFB(2)-3.25*ALFB(3)
      AI(1)=AI(1)/B
      AIJ(1,1)=AIJ(1,1)/B
      AIII=-ALFB(3)/B
      IF (TESTW(4)) AI(1)=(AI(1)+1.)*AI(1)
      GO TO 365
C
C  LINEAR POLYATOMIC MOLECULES--
C
350   IF (NNU.LE.9 ) THEN
        DO 360 I=1,NNU
        AI(I)=ALFB(I)/B
        DO 355 J=1,NNU
        CON=DN(J)/2.d0
        IF (I.EQ.J) CON=DN(I)
        AIJ(I,J)=-AIJ(I,J)/B
        IF (J.LT.I) AIJ(I,J)=AIJ(J,I)
355     AI(I)=AI(I)+CON*AIJ(I,J)
        IF (TESTW(4)) AI(I)=(AI(I)+1.)*AI(I)
360     CONTINUE
      ENDIF
C
C  LINEAR AND DIATOMIC MOLECULES--CALULATE RHO TERMS.
C    HIGHER ORDER TERMS ADDED OCT 1986 FROM R.S.MCDOWELL, JCP V39,
C    NO3, AUG 1,1963, P526.
C
365   IF (RH(1).NE.0.0) GO TO 368
      RH(1)=2.
      RH(2)=10.
      RH(3)=98.6666667
      RH(5)=-.66666667*DD/B
      RH(6)=DD/(B**2*HCK)
C
C  LINEAR AND DIATOMIC MOLECULES--CALCULTE THETAS.
C
368   THETA(1)=(HCK*B)/3.0
      THETA(2)=THETA(1)**2*0.6
      THETA(3)=(THETA(1)*THETA(2)*4.0)/7.0
      IF (.NOT.TEST(14)) GO TO 405
      WRITE (6,370) B,DD
370   FORMAT (/,' B0 =',F10.6,5X,'D0 =',E13.6)
      IF ( NNU.LE.9 ) THEN
        DO 380 I=1,NNU
        WRITE (6,375) I,AI(I)
375     FORMAT (/,' AI(',I1,') =',F10.7)
380     WRITE (6,385) (I,J,AIJ(I,J),J=1,NNU)
385     FORMAT (/,6(' A(',I1,',',I1,') =',F10.7,5X))
        GO TO 405
      ENDIF
C
C  NON-LINEAR MOLECULES--
C
390   IF (C.EQ.0.0) GO TO 560
      IF (A.NE.B.OR.B.NE.C) GO TO 393
      RH(1)=3.75
      RH(2)=22.5
      RH(3)=258.75
      RH(4)=4218.75
      RH(5)=-.75*DD/B
      RH(6)=DD/(B**2*HCK)
393   IF ( NNU.LE.9 ) THEN
        DO 400 I=1,NNU
        AI(I)=(ALFA(I)/A+ALFB(I)/B+ALFC(I)/C)/2.
        IF (TESTW(4)) AI(I)=(.5*AI(I)+1.)*AI(I)+((ALFA(I)/A)**2+(ALFB(I)
     &   /B)**2+(ALFC(I)/C)**2)/4.D0
        IF (TEST(14)) WRITE (6,395) AI(I),ALFA(I),ALFB(I),ALFC(I),I
395     FORMAT (/,' AI =',F10.7,4X,'ALPHA A =',F10.7,4X,'ALPHA B =',
     &   F10.7,4X,'ALPHA C =',F10.7,4X,'I =',I1)
400     CONTINUE
      ENDIF
      IF ( calcth ) then
      ASQ=A**2
      BSQ=B**2
      CSQ=C**2
      THETA(1)=(2.0*(A+B+C)-A*B/C-A*C/B-B*C/A)*(HCK/12.0)
      THETA(2)=(10.0*(ASQ+BSQ+CSQ)+12.0*(A*B+B*C+A*C)-12.0*(ASQ*B/C+A*BS
     1Q/C+BSQ*C/A+B*CSQ/A+ASQ*C/B+A*CSQ/B)+7.0*(ASQ*BSQ/CSQ+ASQ*CSQ/BSQ+
     2BSQ*CSQ/ASQ))*HCK**2/480.d0
      THETA(3)=0.0
      else
        theta(1) = 0.
        theta(2) = 0.
      endif
405   IF (TEST(14)) WRITE (6,410) (I,THETA(I),I=1,3)
410   FORMAT (/,3(' THETA(',I1,') =',F12.6,4X)/)
      IF (NOATMS.EQ.2) GO TO 480
      IF (.NOT.CALRHO) GO TO 420
C
C  CALCULATE ROTATIONAL STRETCHING TERMS WHEN DATA ARE AVAILABLE.
C     GLUSHKO,GURVICH,ET.AL.,VOL 1,PART 1,1978, PAGE 59.
C
      IF (DJN.EQ.0.) GO TO 415
      Z=B/A
      E1=DJN*(DJN+2.D0*(DJKN+DKN))+(DJKN+DKN)**2
      F1=DJN*(2.D0*(DJN+DKN)+3.D0*DJKN)+DJKN*(DJKN+DKN)
      G1=2.D0*DJN*(3.D0*(DJN+DJKN)+DKN)+DJKN**2
      H1=DJN*(2.D0*DJN+DJKN)
      RH(2)=((((35.D0*E1*Z+20.D0*F1)*Z+8.D0*G1)*Z+32.D0*H1)*Z+128.D0*
     1 DJN**2)*3.D0/(32.D0*(BSQ*HCK)**2)
      RH(1)=((3.D0*Z*(DJN+DJKN+DKN)+2.D0*DJKN+4.D0*DJN)*Z+8.D0*DJN)/
     1 (HCK*4.D0*BSQ)
      GO TO 420
415   TAB=TAU(5)+2.D0*TAU(7)
      TBC=TAU(6)+2.D0*TAU(9)
      TAC=TAU(4)+2.D0*TAU(8)
      RH(1)=3.D0*(TAU(1)/ASQ+TAU(2)/BSQ+TAU(3)/CSQ)+2.D0*(TAB/(A*B)+TBC/
     1 (B*C)+TAC/(A*C))
      RH(1)=-RH(1)/(HCK*16.D0)
      RH(2)=0
C
420   IF (.NOT.TESTW(1)) GO TO 428
      IAIBIC=BCONV**3/(A*B*C)
425   FORMAT (/,' A0=',F10.6,5X,'B0=',F10.6,5X,'C0=',F10.6,/'0IAIBIC=',
     1  F15.6,'E-117 (G*CM**2)**3')
      WRITE (6,425) A,B,C,IAIBIC
      LINES=LINES+3
428   IF(.NOT.CALRHO) GO TO 432
      WRITE (6,430) RH(1),RH(2)
430   FORMAT (/,' RHO 1=',E15.8,5X,'RHO 2=',E15.8)
C
C  POLYATOMIC MOLECULES.  MAKE X AND Y MATRICES SYMMETRIC.
C
432   IF ( NNU.LE.9 ) THEN
      DO 435 I=1,NNU
      DO 435 J=I,NNU
      X(J,I)=X(I,J)
435   CONTINUE
      DO 455 I=1,NNU
      DO 455 J=I,NNU
      DO 455 L=J,NNU
      IF (I.NE.J) GO TO 440
      IF (J-L) 445,455,445
440   IF (J-L) 450,445,450
445   Y(J,L,I)=Y(I,J,L)
      Y(L,I,J)=Y(I,J,L)
      GO TO 455
450   Y(I,L,J)=Y(I,J,L)
      Y(J,I,L)=Y(I,J,L)
      Y(J,L,I)=Y(I,J,L)
      Y(L,I,J)=Y(I,J,L)
      Y(L,J,I)=Y(I,J,L)
455   CONTINUE
      IF (TEST(14)) WRITE (6,460) (((I,J,L,Y(I,J,L),L=J,NNU),J=I,NNU),I=
     11,NNU)
460   FORMAT (5(' Y(',I1,',',I1,',',I1,') =',F7.3,3X))
C
C  APPLY X CORRECTIONS FOR NRRAO1 AND 2.
      DO 470 I=1,NNU
      DO 470 J=1,NNU
      CY=0.0
      DO 465 K=1,NNU
      IF ((K.NE.I).AND.(K.NE.J)) CY=CY+DN(K)*Y(I,J,K)/2.
465   CONTINUE
      IF (I.EQ.J) X(I,I)=X(I,I)+Y(I,I,I)*(1.5*DN(I)+3.)+CY
      IF(I.NE.J)X(I,J)=X(I,J)+(DN(I)+1.)*Y(I,I,J)+(DN(J)+1.)*Y(I,J,J)+CY
470   CONTINUE
C
C  GII CORRECTIONS
      DO 475 I=1,NNU
      IF (G(I).EQ.0.) GO TO 475
      G(I)=G(I)+B
      IF (TESTW(4)) X(I,I)=X(I,I)+G(I)/3.
      IF (.NOT.TESTW(4)) V(I)=V(I)-G(I)
475   CONTINUE
      ENDIF
C
C  INTERMEDIATE OUTPUT--XIJS AND ELECTRONIC LEVEL.
C
480   IF (.NOT.TEST(14)) GO TO 505
      IF (TESTW(2)) GO TO 498
      WRITE (6,485)
485   FORMAT (/' X(I,J),G(I,I)' )
      DO 490 I=1,NNU
490   WRITE (6,495) (X(I,J),J=1,NNU),G(I)
495   FORMAT (1H ,10F10.4)
498   IF (TESTW(6)) WRITE (6,500) LELC
500   FORMAT (/,'1ELECTRONIC LEVEL =',I2)
505   IF (TESTW(5)) TESTW(4)=.TRUE.
C
C  CALL LINK1 TO CALCULATE PARTITION FUNCTION AND DERIVATIVES FOR LEVEL.
510   CALL LINK1 (IROT,NIR)
C
C IF COLS 1-4 = COLS 1-4 OF PREVIOUS RECORD, ASSUME THERE IS ANOTHER
C      ELECTRONIC LEVEL AND GO TO 140.
C  OTHERWISE CALCULATE FUNCTIONS FROM Q AND DERIVATIVES (VALUES FOR
C      MULTIPLE ELECTRONIC STATES HAVE BEEN SUMMED).
      IF (CODE(1).EQ.SUB) GO TO 70
      NT1=NT
      IF (ASINDT.NE.0..AND..NOT.TEST(19)) NT1=NT+1
      DO 520 I=NIT,NT1
      IF (.NOT.TESTW(6)) GO TO 515
      Q=GHRT(I)
      GHRT(I)=DLOG(Q)
      DQ=HHRT(I)/Q
      HHRT(I)=DQ
      CPR(I)=CPR(I)/Q+(2.-DQ)*DQ
515   GHRT(I)=GHRT(I)+1.5*DLOG(WEIGHT)+2.5*DLOG(T(I))+SCONST
      HHRT(I)=HHRT(I)+2.5
      SR(I)=GHRT(I)+HHRT(I)
520   CPR(I)=CPR(I)+2.5
C
      IF (ASINDT.EQ.0..OR.TEST(19)) GO TO 535
C
C  CALCULATE ENTHALPY FOR ASSIGNED T ON FORMULA RECORD.
C
      IF (DABS(ASINDT-298.15D0).GT..05) GO TO 525
      SPECH=HHRT(NT1)*298.15D0
      H298HR=SPECH
      GO TO 530
525   SPECH=HHRT(NT1)*ASINDT
530   TEST(19)=.TRUE.
535   TEST(9)=.TRUE.
      GO TO 575
540   WRITE (6,545)
545   FORMAT (/,' WRONG NUMBER OF NU-S(V-S) (POLY)')
      GO TO 570
550   WRITE (6,555)
555   FORMAT (/,' THE VALUE OF B IS MISSING (POLY)')
      GO TO 570
560   WRITE (6,565)
565   FORMAT (/,' THE VALUE OF C IS MISSING (POLY)')
570   TEST(16)=.TRUE.
575   RETURN
      END
      SUBROUTINE PRINT (N,L)
      SAVE
C
      DOUBLE PRECISION ECOS,ESIN
C
      COMMON/BLK2/ECOS(188,4),ESIN(187,4),LL(4),RSYM(4),LR(4)
C
      DO 30 J=1,N,10
      JM1=J-1
      K=JM1+10
      IF (K.GT.N) K=N
      WRITE (6,10) JM1
10    FORMAT (5X,I3,' +')
      WRITE (6,20) (ECOS(I,L),I=J,K)
20    FORMAT (10X,'LEVEL(+)',10F11.3)
30    WRITE (6,40) (ESIN(I,L),I=J,K)
40    FORMAT (10X,'LEVEL(-)',10F11.3)
      RETURN
      END
      SUBROUTINE PUNCH
      SAVE
      PARAMETER (IOCFT=10)
C
C     TEST(4)  SPECIES IS A GAS.
C     TEST(6)  SPECIES IS A SOLID.
C     TEST(13) DATA ARE IN THE FORM, H-H298 AND -(F-H298)
C
      DIMENSION FMLA(6)
      DOUBLE PRECISION HF298,HH0
      real*8 figs
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      HF298=ASINDH
      NL=intvls-ivl1+1
      DO 30 IA=ivl1,intvls
      IF (COEF(1,IA).EQ.0.D0 .AND. COEF(3,IA).EQ.0.D0 .AND.
     & COEF(4,IA).EQ.0.D0) GO TO 20
      COEF(9,IA)=figs(COEF(9,IA)+HF298)
      GO TO 30
20    NL=NL-1
30    CONTINUE
      J=3*NL+5
      WRITE (6,32)
32    FORMAT (/,' THERMODYNAMIC DATA COEFFICIENTS, RECORD IMAGES -')
      IF (TEST(13)) then
      HH0=0.
      else
      HF298=H298HR+HF298
      HH0=H298HR*RR
      endif
      HF298=HF298*RR
C
C  COEFFICIENTS - GENERAL FORM
C
      WRITE (6,310) (NAME(I,INA),I=1,19)
310   FORMAT (/,1x,18A4,A2)
      WRITE (IOCFT,315) (NAME(I,INA),I=1,19)
315   FORMAT (18A4,A2)
C
      DO 332 I=1,5
332   FMLA(I)=MLA(I)
      IF (.NOT.TEST(4)) NFZ=NFZ+1
      WRITE (6,338) NL,DATE,(FORMLA(1,I),FORMLA(2,I),FMLA(I),I=1,5),
     1 NFZ,WEIGHT,HF298
338   FORMAT (2X,I1,1X,A4,A2,1X,5(2A1,F6.2),I2,F13.7,F15.3)
      WRITE (IOCFT,340) NL,DATE,(FORMLA(1,I),FORMLA(2,I),
     1 FMLA(I),I=1,5),NFZ,WEIGHT,HF298
340   FORMAT (1X,I1,1X,A4,A2,1X,5(2A1,F6.2),I2,F13.7,F15.3)
      DO 500 L=ivl1,intvls
c  Following statement inserted 10/31/91
      IF (COEF(1,L).EQ.0.D0 .AND. COEF(2,L).EQ.0.D0) GO TO 500
      WRITE (6,368) TC(L),TC(L+1),NF(L),(EX(I,L),I=1,8),HH0,
     * (COEF(J,L),J=1,10)
368   FORMAT (2X,2F10.3,I2,8F5.1,2X,F15.3,1P/1X,5D16.9/1X,5D16.9)
      WRITE (IOCFT,370) TC(L),TC(L+1),NF(L),(EX(I,L),I=1,8),HH0,
     * (COEF(J,L),J=1,10)
370   FORMAT (1X,2F10.3,I2,8F5.1,2X,F15.3,1P/5D16.9/5D16.9)
500   CONTINUE
      ivl1=intvls
C  Following statement moved here from bottom of DELH 2/14/91
      idone=intvls
      BACK = .false.
      RETURN
      END
      SUBROUTINE QSUM (TEST)
      SAVE
C
C  ACCUMULATE VALUES OF Q AND ITS DERIVATIVES.
C
      double precision CPROUT
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      real*8 v,x,y,alfa,alfb,alfc,g,wx,beta,a,b,c,dard,dd,wf,w,sym,stwt,
     1 t00,theta,rh,r,s,ql,q,qln,dq,ddq,qtot,qlntot,dqtot,ddqtot,aij,
     2 aiii,ai
      logical testw
      COMMON /WCOMMN/ V(300),X(9,9),Y(9,9,9),ALFA(9),ALFB(9),ALFC(9),
     1 G(9),WX(9),BETA(4),A,B,C,DARD,DD,WF,W,SYM,STWT,T00,THETA(3),
     2 RH(6),R(300,3),S(300,3),QL(3),Q,QLN,DQ,DDQ,QTOT,QLNTOT,DQTOT,
     3 DDQTOT,AIJ(9,9),AIII,AI(9),DN(300),ND(300),CORT,NNU,TESTW(6)
C
      LOGICAL TEST
C
      IF (.NOT.TEST) GO TO 20
      Q=0.
      IF (DABS(QLN).LE.88.) Q=DEXP(QLN)
      CPROUT=DDQ+2.d0*DQ
      WRITE (6,10) LABEL,Q,QLN,DQ,CPROUT
10    FORMAT (4X,A4,E21.4,3F18.8)
20    QLNTOT=QLNTOT+QLN
      DQTOT=DQTOT+DQ
      DDQTOT=DDQTOT+DDQ
      QLN=0.0
      DQ=0.0
      DDQ=0.0
      RETURN
      END
      SUBROUTINE RECO
      SAVE
C
C  READ IN THERMO PROPERTIES DIRECTLY OR READ IN COEFFICIENTS.
C
      CHARACTER*4 AC,ACPR,SRCR,AE
      CHARACTER*4 AS,A0,A2,CAL,CH,CHHO,CP,CS,DELT,GH,GHO,BARS,ATMS
      CHARACTER*4 GMH,H,HH,HHD1,HHO,HH2C,HR,HRT,H29,PMLT,DATAR
      CHARACTER*4 PNCH,REDUC,S,SLT,SLT0,SLT2,SRC,SSR,TCOE,TI,RCODE
C
      DOUBLE PRECISION TT,RT,HCOEF,SCOEF,DOR,HCOE,SCOE,SS,TEX,HHRTT
      DOUBLE PRECISION TJ1,TJ2,RSAVE,SRCOR,TX(4),TZ,TY
      LOGICAL TSTRED,TSTCO,TSTK ,scset,hcset
      DIMENSION REX(10)
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      DATA SLT0/'0/T'/,SLT2/'2/T'/,  TI  /'T   '/,  PNCH /'TPUN'/
     2, CHHO /'CHHO'/, AE  /'E'   /,   HH2C /'CHH '/,  HR  /'CH/R'/
     3, SRC /'CS/R'/,  CAL /'CAL '/,   REDUC/'REDU'/,  HHD1 /'CH-H'/
     4, HH  /'H-H' /,  GMH /'-G-H'/,   S  /'S   '/,    SLT  /'/T  '/
     5, GH  /'-GH'/,   ACPR /'CP/R'/,  HRT /'H/RT'/,   SSR  /'S/R '/
     6, H29 /'H298'/,  DELT /'DELT'/,  AC /'C   '/,    AS  /'AS  '/
     7, PMLT  /'MELT'/, HHO  /'H-HO'/,  GHO  /'-GHO'/
     8, CS  /'CS  '/,  CH  /'CH  '/,   CP  /'CP  '/,   H  /'H   '/
     9, TCOE /'TCOE'/, A0  /'0   '/,   A2  /'2'/,      BARS/'BAR'/
     $, ATMS/'ATM'/,   SRCR/'SRCO'/,   DATAR/'R'/
C
C  INITIALIZE.  NIT IS INDEX FOR NEXT T AND CORRESPONDING FUNCTIONS.
C
      LST=0
      scset=.false.
      hcset=.false.
      NTT=NIT
      lsave=intvls
      isave=ivl1
      BACK=.TRUE.
      RSAVE=R
      SRCOR=0
      HHRT(NTT)=0.
      GHRT(NTT)=-1.0
      SR(NTT)=0.
      if (nt.gt.0) THEN
        TT=T(NIT-1)
        TJ1=T(NIT)
        TJ2=T(NT)
      endif
      TSTCO=.FALSE.
      TSTRED=.FALSE.
      TSTK=.FALSE.
      DOR=-1.D0
C
C  STORE INFORMATION FROM METHOD RECORD.
C
      DO 150 I=1,4
      IF (ABEL(1,I).EQ.'READ') GO TO 150
      IF (ABEL(1,I).EQ.H29) GO TO 30
      IF (ABEL(1,I).EQ.DELT) GO TO 120
      IF (ABEL(1,I).EQ.'COEF') GO TO 40
      IF (ABEL(1,I).EQ.'KCAL') GO TO 50
      IF (ABEL(1,I).EQ.'KJOU') GO TO 60
      IF (ABEL(1,I).EQ.CAL) GO TO 70
      IF (ABEL(1,I).EQ.'JOUL') GO TO 80
      IF (ABEL(1,I).EQ.datar) GO TO 65
C
C  IF LABEL = 'DMLE', COEFFICIENTS ARE FOR CP/R.
C
      IF (ABEL(1,I).EQ.REDUC) GO TO 90
      IF (ABEL(1,I).EQ.'DMLE') GO TO 90
      IF (ABEL(1,I).EQ.SRCR) GO TO 95
      IF (ABEL(1,I).EQ.BARS) GO TO 100
      IF (ABEL(1,I).EQ.ATMS) GO TO 105
      IF (ABEL(1,I).EQ.PMLT) GO TO 110
      IF (ABEL(1,I).EQ.PMLT) GO TO 110
      IF (ABEL(1,I).EQ.BLANK) GO TO 150
C
      WRITE (6,20) ABEL(1,I)
20    FORMAT (/,' ERROR IN CODE--',A4,6X,' (RECO)')
      GO TO 150
30    H298H0=WORD(I)
      H298HR=0.
      GO TO 150
40    TSTCO=.TRUE.
      GO TO 150
50    TSTK=.TRUE.
      IF (R.GT.8.) GO TO 70
      GO TO 150
60    TSTK=.TRUE.
      IF (R.LT.8.) GO TO 80
      GO TO 150
65    r=word(i)
      GO TO 150
70    IF(R.GT.8.D0)R=R/4.184D0
      GO TO 150
80    IF(R.LT.8.D0)R=R*4.184D0
      GO TO 150
90    TSTRED=.TRUE.
      GO TO 150
C
C  TO CORRECT S/R FROM TRC TABLES TO ATM, SUBTRACT LN 1.01325 OR .013163
C
 95   SRCOR=SRCOR+WORD(I)
      GO TO 150
100   IF (.NOT.BAR.AND.TEST(4)) SRCOR=-.013163D0 +SRCOR
      GO TO 150
105   IF (BAR.AND.TEST(4)) SRCOR= .013163+SRCOR
      GO TO 150
110   PTMELT=WORD(I)
      GO TO 150
C
C  DELTAH OR DELTAS FOR HEAT OF TRANSITION.  CALCULATE H-H0/RT AND
C      -(G-H0)/RT FOR NEW PHASE.
C
120   IF (ABEL(2,I).EQ.AS) WORD(I)=WORD(I)*TT
      IF (NIT.GT.1) GO TO 140
      TEST(16)=.TRUE.
      WRITE (6,130)
130   FORMAT (/' T FOR TRANSITION UNKNOWN. GO TO NEXT SPECIES. (RECO)')
      GO TO 880
140   DOR=WORD(I)
150   CONTINUE
C
      IF(.NOT.TSTK) GO TO 153
      IF(DOR.NE.-1.D0)  DOR=DOR*1000.D0
      IF(T(NIT-1).GT.298.15)GO TO 153
         H298H0=H298H0*1000.D0
         H298HR=H298HR*1000.D0
153   IF (DOR .LT. 0.D0) GO TO 155
      HHRT(NTT)=HHRT(NIT-1)+DOR/(R*TT)
      GHRT(NTT)=GHRT(NIT-1)
      SR(NTT)=GHRT(NTT)+HHRT(NTT)
155   IF (H298HR.EQ.0.) H298HR=H298H0/R
      IF (H298H0.EQ.0.) H298H0=H298HR*R
      IF (HHRT(NTT).EQ.0.) GO TO 160
      NLAST=NIT-1
C
C  IF THERE HAS BEEN A HEAT OF TRANSITION, CALL DELH TO CHECK FOR
C      LSTSQS OR PUNCHED COEFFICIENTS FOR PREVIOUS PHASE.
C
      CALL DELH
      if (BACK) then
           ivl1=isave
           intvls=lsave
      else
           isave=ivl1
           lsave=intvls
           BACK=.true.
      endif
      NNN=NIT
      NLAST=NT
C
160   DO 180 J=ivl1+1,8
      DO 180 I=1,10
180   COEF(I,J)=0.0
      TEST(17)=.false.
      NEX=0
      NDT=0
      JT=0
      NFIRST=0
      if(dabs(asindt-298.15).gt..001.or.h298h0.eq.0.) go to 190
      spech=h298h0/r
      TEST(19)=.true.
190   CALL INPUT
      NWORD=1
      IF (NFIRST.NE.0) GO TO 200
C
C  INITIALIZE FOR FIRST RECORD.
C
      SUB=CODE(1)
      HCOEF=0.0
      SCOEF=0.0
C
C  IF COLS 1-4 NOT = TO COLS 1-4 PREVIOUS RECORD, GO TO 210 (C240).
C
200   IF (CODE(1).NE.SUB) GO TO 690
      if(.not.tstco) go to 205
      if(nfirst.ne.0) go to 490
      if(nit.gt.nnn) then
	  ivl1=ivl1+1
      endif
205   DO 210 I=1,4
      IF (ABEL(2,I).EQ.A0.OR.ABEL(2,I).EQ.A2) ABEL(2,I)=BLANK
      IF (ABEL(2,I).EQ.SLT0.OR.ABEL(2,I).EQ.SLT2) ABEL(2,I)=SLT
210   CONTINUE
      NFIRST=NFIRST+1
      RCODE=BLANK
      DO 220 I=1,4
      IF (ABEL(1,I).EQ.TI) GO TO 240
220   CONTINUE
      RCODE=TI
      WRITE (6,230) RCODE
230   FORMAT (/' DATA RECORD WAS SKIPPED BECAUSE ',A4,
     & ' VALUE WAS MISSING',' (RECO)')
      LINES=LINES+2
      GO TO 190
C
C  IF TWO CONSECUTIVE T ABEL(1,I)S, ASSUME COEFFICIENTS
C
240   IF (ABEL(1,I+1).EQ.TI) GO TO 490
      TT=WORD(I)
      IF (DABS(TT-298.15D0).LT.5.D-02) TT=298.15D0
      RT=R*TT
      IF (TT.EQ.0.0) GO TO 280
C
C  CHECK FOR CP.
      DO 250 I=1,4
      IF (ABEL(1,I).EQ.CP) GO TO 260
      IF (ABEL(1,I).EQ.ACPR) GO TO 270
250   CONTINUE
      GO TO 280
260   CPR(NTT)=WORD(I)/R
      GO TO 280
270   CPR(NTT)=WORD(I)
C
C  CHECK FOR ENTHALPY.  SKIP IF CALCULATED FROM DELTAH.
C
280   IF ((HHRT(NTT).NE.0.).AND.NFIRST.EQ.1) GO TO 440
      DO 300 I=1,4
      IF (ABEL(1,I).EQ.HH.OR.ABEL(1,I).EQ.HHO) GO TO 310
      IF (ABEL(1,I).NE.H.AND.ABEL(1,I).NE.HRT) GO TO 300
      HHRT(NTT)=WORD(I)
      IF (ABEL(1,I).EQ.H) then
        HHRT(NTT)=WORD(I)/RT
        if (TSTK) HHRT(NTT) = HHRT(NTT)*1000.d0
      ENDIF
      IF (.NOT.TEST(8)) GO TO 290
      IF (ASINDT.NE.0..AND.ASINDT.NE.298.15D0) GO TO 290
      HHRT(NTT)=HHRT(NTT)-ASINDH/TT
      IF (ASINDT.EQ.298.15D0) TEST(13)=.TRUE.
      GO TO 330
290   TEST(18)=.TRUE.
      GO TO 330
300   CONTINUE
      RCODE=HHO
      GO TO 350
C
310   IF (TSTK) WORD(I)=WORD(I)*1000.D0
      HHRT(NTT)=WORD(I)
      IF (ABEL(2,I).EQ.SLT) HHRT(NTT)=WORD(I)/R
      IF (ABEL(2,I).EQ.BLANK.OR.ABEL(2,I).EQ.A2) HHRT(NTT)=WORD(I)/RT
      IF (FWORD(I).NE.2.) GO TO 330
      IF (TT.NE.0.) GO TO 320
      IF (H298H0.EQ.0.) H298H0=-WORD(I)
      GO TO 190
320   IF (H298H0.EQ.0.0) TEST(13)=.TRUE.
      HHRT(NTT)=HHRT(NTT)+H298H0/RT
C
C  CHECK FOR T= ASINDT ON FORMULA RECORD.
C
330   IF (DABS(TT-ASINDT).GT.0.005) GO TO 350
      SPECH=HHRT(NTT)*TT
      TEST(19)=.TRUE.
      IF (.NOT.TEST(18)) GO TO 350
      IF (.NOT.TSTCO.OR.DABS(SPECH-ASINDH).GT..1) GO TO 350
      WRITE (6,340)
340   FORMAT (/' H ALREADY SET, ASSUME H(T)-H298 = 0')
      SPECH=ASINDH
      HHRT(NTT)=H298H0/RT
      IF (H298H0.EQ.0.) TEST(13)=.TRUE.
      TEST(18)=.FALSE.
C
C  CHECK FOR FREE ENERGY FUNCTIONS.
C
350   GHRTT=-1.D0
      SS=-1.D0
      DO 390 I=1,4
      IF (ABEL(1,I).EQ.GHO) ABEL(1,I)=GH
      IF (ABEL(1,I).NE.GMH) GO TO 360
      GHRTT=WORD(I)/RT
      GO TO 370
360   IF (ABEL(1,I).NE.GH) GO TO 380
      GHRTT=WORD(I)
      IF (ABEL(2,I).EQ.SLT) GHRTT=WORD(I)/R
370   IF (FWORD(I).NE.2.) GO TO 400
      GHRTT=GHRTT-H298H0/RT
      IF (H298H0.EQ.0.) TEST(13)=.TRUE.
      GO TO 400
C
C  CHECK FOR ENTROPY FUNCTIONS.
C
380   IF (ABEL(1,I).EQ.S) SS=WORD(I)/R
      IF (ABEL(1,I).EQ.SSR) SS=WORD(I)
390   CONTINUE
400   IF (SS.NE.-1.D0) SR(NTT)=SS
      IF (GHRTT.NE.-1.D0) GHRT(NTT)=GHRTT
      IF (RCODE.NE.HHO) GO TO 410
      IF (SS.NE.-1.D0.AND.GHRTT.NE.-1.D0) HHRT(NTT)=SS-GHRTT
      GO TO 430
410   IF (GHRTT.EQ.-1.D0) GO TO 420
      SR(NTT)=GHRTT+HHRT(NTT)
      GO TO 430
420   IF (SS.NE.-1.D0) GHRT(NTT)=SS-HHRT(NTT)
430   SR(NTT)=SR(NTT)+SRCOR
      GHRT(NTT)=GHRT(NTT)+SRCOR
      IF (DABS(TT-ASINDT).GT.0.005) GO TO 440
      SPECH=HHRT(NTT)*TT
C
C  TEST(19)--THERE IS AN ENTHALPY FOR THE ASINDT ON THE FORMULA RECORD
C      STORED IN SPECH.
C
      TEST(19)=.TRUE.
C
C  TEST(9)--THERE ARE THERMODYNAMIC FUNCTIONS FOR AT LEAST ONE T.
C
440   TEST(9)=.TRUE.
      IF (NIT.EQ.NNN.or.tstco) GO TO 460
      IF (T(NIT-1).LT.PTMELT.AND.TT.GT.PTMELT) GO TO 450
      IF (TT.NE.T(NIT-1)) GO TO 460
450   NLAST=NIT-1
      CALL DELH
      if (BACK) then
           ivl1=isave
           intvls=lsave
      else
           isave=ivl1
           lsave=intvls
           BACK=.true.
      endif
      NNN=NIT
      NLAST=NT
460   IF (.NOT.TSTCO) GO TO 480
      NEX=0
      DO 470 J=ivl1+1,8
      DO 470 I=1,10
470   COEF(I,J)=0.
      GO TO 190
480   NT=NT+1
      T(NT)=TT
      NTT=NT+1
      NIT=NTT
      GO TO 190
C
C            PROCESS COEFFICIENTS
C
C  STORE CONTENTS OF DATA RECORD.
C  IF GHRT(NTT) IS NOT =  -1 (NTT=0,) CALCULATE INTEGRATION CONSTANTS
C     FROM THE ENTHALPY AND FREE ENERGY (OR S) WHICH HAVE JUST BEEN READ
C
490   IF (GHRT(NTT).NE.(-1.0)) GO TO 495
      NTT=MAX0(NTT-1,0)
495   ITX=0
      DO 670 ID=NWORD,4
      IF (ABEL(1,ID).EQ.BLANK) GO TO 670
      IF (ABEL(1,ID).EQ.TI) GO TO 560
      NDT=1
      IF (ABEL(1,ID).EQ.PNCH.OR.ABEL(1,ID).EQ.TCOE) GO TO 520
      IF (ABEL(1,ID).EQ.HHD1) GO TO 640
      IF (ABEL(1,ID).EQ.CHHO.OR.ABEL(1,ID).EQ.HH2C) GO TO 630
      IF (ABEL(1,ID).EQ.CS) GO TO 650
      IF (ABEL(1,ID).EQ.SRC) GO TO 660
      IF (ABEL(1,ID).EQ.CH) GO TO 600
      IF (ABEL(1,ID).EQ.HR) GO TO 610
      IF (ABEL(1,ID).EQ.AE) GO TO 580
      IF (ABEL(1,ID).EQ.AC) GO TO 590
      WRITE (6,500) ABEL(1,ID),WORD(ID)
C
500   FORMAT (/,A6,' IS AN INCORRECT LABEL FOR THE NUMBER --',E16.8,'.
     1  THUS THE VALUE WAS IGNORED.')
      GO TO 670
C
C  TEST(17)--WRITE COEFFICIENTS OUT ON I/O UNITS 12 AND 16
C    IF NO VALUE FOLLOWS THE TCOE CODE, USE LEAST SQUARES T RANGES.
C    TPUN ALSO TURNS OFF THE LEAST SQUARES (TEST(15)=.FALSE) FOR THE
C    REMAINDER OF THE PROBLEM UNLESS ANOTHER LSTS IS READ.
C
520   TEST(17)=.TRUE.
      if(word(id).eq.0.) go to 530
      itx=itx+1
      tx(itx)=word(id)
      GO TO 670
530   itx=2
      tx(2)=tj2
      tx(1)=tj1
      go to 670
C
C  TJ1 TO TJ2 = TEMPERATURE RANGE FOR WHICH COEFFICIENTS ARE GOOD.
C
560   IF (NDT.EQ.1) GO TO 570
      IF (JT.NE.1) TJ1=WORD(ID)
      IF (JT.EQ.1) TJ2=WORD(ID)
      JT=1
      GO TO 670
570   IDD=ID
      GO TO 680
580   NN=FWORD(ID)
      REX(NN)=WORD(ID)
      NEX=NEX+1
      GO TO 670
C
C  DIVIDE COEFFICIENTS BY R IF NO 'DMLE' LABEL ON METHOD RECORD
C  (TSTRED=F).
C
590   IF (.NOT.TSTRED) WORD(ID)=WORD(ID)/R
C
C  TEST(18)--ABSOLUTE VALUES FOR ENTHALPY.
C
      NN=FWORD(ID)
      COEF(NN,ivl1+1)=WORD(ID)
      GO TO 670
600   IF (.NOT.TSTRED) WORD(ID)=WORD(ID)/R
610   IF(NIT.EQ.1.OR..NOT.TEST(19)) GO TO 615
      if(.not.tstred) word(id)=word(id)/r
      HCOEF=WORD(ID)-SPECH
      hcset=.true.
      GO TO 670
615   TEST(18)=.TRUE.
      IF (ASINDT.NE.0.) WRITE (6,620)
620   FORMAT (/,' ENTHALPY IS ABSOLUTE--ASINDT SHOULD = 0.')
      LINES=LINES+2
630   if(.not.tstred) word(id)=word(id)/r
      HCOEF=WORD(ID)
      hcset=.true.
      GO TO 670
640   IF (.NOT.TSTRED) WORD(ID)=WORD(ID)/R
      GO TO 630
650   IF (.NOT.TSTRED) WORD(ID)=WORD(ID)/R
660   SCOEF=WORD(ID)
      scset=.true.
670   CONTINUE
      if (itx.eq.0) go to 190
      if (.not.TEST(15).or. TEST(17)) go to 677
      TZ= min(tx(1),tx(2),tx(3),tx(4))
      TY= max(tx(1),tx(2),tx(3),tx(4))
      if (ntrang.gt.0) go to 672
      if (TZ.le.200.) go to 675
      ntrang=2
      trange(1)=200.
      trange(2)=TZ
c     go to 675
c672   do 673 i=1,ntrang
c      n=i
c      if (trange(i).gt.TZ) go to 674
c673   continue
c      go to 674
c674   ntrang=n
c      trange(n)=TZ
c      if(n.le.1) go to 676
672   n=ntrang
      do 674 i=1,n
      if(abs(trange(i)-TZ).gt..01) go to 673
      ntrang=ntrang+1
      trange(ntrang)=tz
      go to 674
673   if(abs(trange(i)-ty).gt..01) go to 674
      ntrang=ntrang+1
      trange(ntrang)=TY
674   continue
                        go to 677
675   CALL DELH
c676   TEST(15)=.FALSE.
677   do 678 i=1,itx-1
c     intvls=intvls+1
c  intvls changed to ivl1 in next 2 statements 10/31/91
      tc(ivl1+i)=tx(i)
678   tc(ivl1+i+1)=tx(i+1)
      if (test(17).and.itx.gt.1) intvls=intvls+itx-1
      go to 190
C
680   NWORD=IDD
690   IF (.NOT.TSTCO) GO TO 880
      NF2=10
      NF1=NF2-1
      IVL1=IVL1+1
      intvls = max0(intvls,ivl1)
      NT1=NT
      IF ((ASINDT.EQ.0.).OR.TEST(19)) GO TO 710
      IF (ASINDT.GE.TJ1.AND.ASINDT.LE.TJ2) GO TO 700
      IF (DABS(ASINDT-298.15D0).GT.(.01).OR.H298HR.EQ.0.) GO TO 710
      SPECH=H298HR
      TEST(19)=.TRUE.
      GO TO 710
700   NT1=NT+1
      T(NT1)=ASINDT
710   I=NIT
720   IF (T(I).LT.TJ1.OR.T(I).GT.TJ2) GO TO 800
730   CPR(I)=0.0
      HHRTT=0.0
      SS=0.0
C
C  CALCULATE FUNCTIONS FROM EQUATION
C
      DO 740 J=1,NEX
      TEX=1.0
C
C  NTT = INDEX FOR THE ENTHALPY AND ENTROPY VALUES TO BE USED TO
C     CALCULATE THE INTEGRATION CONSTANTS.  IF THERE ARE NO SUCH VALUES,
C     NTT=0.
C
      IF (NTT.EQ.0) TT=T(I)
      IF (REX(J).NE.0.0) TEX=TT**REX(J)
      IF (REX(J).EQ.(-1.)) HHRTT=HHRTT+COEF(J,ivl1)*DLOG(TT)/TT
      IF (REX(J).NE.(-1.)) HHRTT=HHRTT+COEF(J,ivl1)/(REX(J)+1.0)*TEX
      IF (I.GT.NT) GO TO 740
      CPR(I)=CPR(I)+COEF(J,ivl1)*TEX
      IF (TEX.EQ.1.0) SS=COEF(J,ivl1)*DLOG(TT)+SS
      IF (TEX.NE.1.0) SS=SS+COEF(J,ivl1)/REX(J)*TEX
740   CONTINUE
      IF (NTT.EQ.0) GO TO 770
      if(.not.hcset)HCOEF=(HHRT(NTT)-HHRTT)*TT
      if(.not.scset)SCOEF=SR(NTT)-SS
      hcset=.false.
      scset=.false.
      IF (DABS(TT-TLST).GT..001.or.lst.eq.1) GO TO 760
c
c  The following correction was made 6/5/91 for intervals with no
c      transition enthalpy. One statement new and one changed.
c
      dor=0.
      if(dabs(t(ntt)-t(ntt-1)).lt..001)DOR=HHRT(NTT)-HHRT(NTT-1)
      HCOE=(HLST-HHRTT)*TLST+dor*tlst
      SCOE=SLST+DOR-SS
      WRITE (6,750) TLST
750   FORMAT (/' COEFFICIENTS ADJUSTED TO FIT UPPER PHASE AT',F8.2)
      LST=1
760   NTT=0
      GO TO 730
770   IF (I.GT.NT) GO TO 790
      HHRT(I)=HHRTT+HCOEF/T(I)
      SR(I)=SS+SCOEF+srcor
      GHRT(I)=SR(I)-HHRT(I)
      IF (I.LE.NT) NIT=I+1
      IF (I.EQ.NT1) GO TO 800
      I=I+1
      GO TO 720
790   SPECH=HHRTT*ASINDT+HCOEF
      TEST(19)=.TRUE.
C
C  ivl1 = INDEX FOR TEMPERATURE INTERVALS
C  INTVLS = TOTAL NO. OF INTERVALS
C
800   NTT=NIT-1
      IF (LST.NE.1) GO TO 810
c  The following 3 statements were added 3/20/91
      tlst=t(ntt)
      if(tlst.gt.0)hlst=hhrt(ntt)+(hcoe/tlst-hcoef/tlst)
      slst=sr(ntt)+(scoe-scoef)
      HCOEF=HCOE
      SCOEF=SCOE
      LST=0
810   DO 820 I=1,nex
820   EX(I,ivl1)=REX(I)
      NF2=10
      NF1=9
C  The following statements was moved from below 'if' statement 12/19/96
      NF(ivl1)=NEX
      if (.not.TEST(17)) go to 860
C     NF(ivl1)=NEX
      COEF(NF1,ivl1)=HCOEF
      COEF(NF2,ivl1)=SCOEF
      if(intvls.eq.ivl1) go to 860
      do 850 k=ivl1+1,intvls
      NF(k)=NF(k-1)
      DO 840 NN=1,10
      COEF(NN,k)=COEF(NN,k-1)
      EX(NN,k)=REX(NN)
840   CONTINUE
850   CONTINUE
860   TC(ivl1)=MAX(tc(ivl1),tj1)
      TC(intvls)=MIN(tc(intvls),tj2)
      IF (CODE(1).NE.SUB) GO TO 870
      NDT=0
      JT=0
      NEX=0
      GO TO 490
870   TEST(9)=.TRUE.
880   R=RSAVE
      if (TEST(17)) then
         ivl1=isave+1
      else
         intvls = lsave
         ivl1= isave
      endif
      RETURN
      END
       
      SUBROUTINE TABLES
      SAVE
C
C  WRITE OUTPUT FILE FOR THE FIRST 3 TABLES OF THERMODYNAMIC FUNCTIONS.
C
      LOGICAL HASIND,HH298,HABS,HHZERO
      DOUBLE PRECISION RUSE(3),TI,HH29,GH29,HH,AR,ART,S,CP,GH,G,H,H298
      DOUBLE PRECISION HR,HSG(7)
      DIMENSION VFM(20)
C
      CHARACTER*4 VFM,XX,F14,F16,P3,P6,P7,ht,hmh,hsubt,dml,hdml,rt,slhr
      CHARACTER*4 zero,two,href
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      EQUIVALENCE (TEST(8),HASIND),(TEST(13),HH298),(TEST(18),HABS)
      EQUIVALENCE (HH,HSG(1)),(HSG(2),HH29),(HSG(3),S),(HSG(4),GH),
     1  (HSG(5),GH29),(HSG(6),H),(HSG(7),G)
C
      DATA XX/',14X'/, F16/',F16'/, P7/'.7'/, P3/'.3'/
      DATA P6/'.6'/,F14/',F14'/,VFM(1)/'(1H '/, VFM(2)/',F12'/
      DATA VFM(3)/'.2'/, VFM(4)/',F12'/, VFM(5)/'.5'/, VFM(20)/')'/
      DATA HSUBT/'H'/,HMH/'H-H'/,SLHR/'/R'/,RT/'RT'/,zero/'0'/,two/'2'/
C
      RUSE(1)=R
      RUSE(2)=R
      IF(R.LT.8.)RUSE(2)=R*4.184D0
      RUSE(3)=RUSE(2)/4.184D0
      H298=H298HR
      HHZERO=.TRUE.
      IF(HH298.AND.(H298HR.EQ.0..OR.H298HR.EQ.ASINDH))HHZERO=.FALSE.
      IF(.NOT.HHZERO)H298=0.
      IF(HABS.AND.ASINDT.NE.0.)HHZERO=.FALSE.
C
C  INITIALIZE FORMAT FOR THE FIRST TABLE
C
      DO 30 I=6,14,2
      VFM(I)=F14
      VFM(I+1)=P7
30    CONTINUE
      VFM(16)=F16
      VFM(17)=P7
      NHSG=7
      IF (HHZERO) GO TO 40
      VFM(6)=BLANK
      VFM(7)=XX
      VFM(12)=BLANK
      VFM(13)=XX
      IF(ASINDT.EQ.298.15D0) GO TO 55
40    IF (H298HR.NE.0. .OR. HH298) GO TO 50
C
      VFM(8)=BLANK
      VFM(9)=XX
      VFM(14)=BLANK
      VFM(15)=XX
50    IF (HASIND.OR.HABS) GO TO 55
      NHSG=NHSG-2
      VFM(16)=BLANK
      VFM(17)=BLANK
55    if (mtab.eq.-1) go to 60
      ht=hmh
      if(habs)ht=hsubt
      dml=blank
      if(mtab.eq.1) dml=slhr
      hdml=blank
      if(mtab.eq.1)hdml=rt
      href=zero
      if(hh298) href=two
      if(habs) href=blank
C
C  PRINT MFIG TABLES
C
60    DO 190 NTABLE=1,3
      LINES=LINES+4
      IF (.NOT.TOUT(NTABLE)) GO TO 190
      WRITE(6,65) (SNM(I),I=1,4),((NAME(I,J),I=1,4),J=1,NNA)
65    FORMAT (/,1x,4A4,6(3X,4A4))
C
      if (ntable.ne.1) then
        IF (VFM(7).EQ.P7) VFM(7)=P3
        IF (VFM(9).EQ.P7) VFM(9)=P3
        VFM(11)=P6
        IF (VFM(13).EQ.P7) VFM(13)=P3
        IF (VFM(15).EQ.P7) VFM(15)=P3
        VFM(16)=F16
        VFM(17)=P3
      endif
C
      IF (.not.HASIND) then
        WRITE (6,70)
70      FORMAT (/,' NO HZERO VALUE IS AVAILABLE')
      else
        LINES=LINES+6
        HR=ASINDH*RUSE(NTABLE)
        IHT=0
        IF(.NOT.HHZERO)IHT=298
C
        IF(NTABLE.eq.1) then
          WRITE(6,80)IHT,ASINDH
80        FORMAT(/,' ASSIGNED H/R AT',I4,' K =',F12.3,' K'/)
          WRITE (6,85)
85        FORMAT (9X,'T',8X,'CP/R',8X,'(H-H0)/RT    (H-H298)/RT',6X,
     1    'S/R',8X,'-(G-H0)/RT   -(G-H298)/RT',8X,'H/RT',12X,'-G/RT'//)
C
        ELSEIF(NTABLE.EQ.2) then
          WRITE(6,90) IHT,HR
90        FORMAT(/,' ASSIGNED H AT',I4,' K =',F12.3,' J/MOLE')
          WRITE (6,100)
100       FORMAT (/,8X,'T',10X,'CP',11X,'H-H0',10X,'H-H298',8X,'S',11X
     1    ,'-(G-H0)',6X,'-(G-H298)',11X,'H',14X,'-G')
          WRITE (6,115)
115       FORMAT(7X,'DEG-K',5X,'J/MOL-K',8X,'J/MOL',10X,'J/MOL',6X,
     *    'J/MOL-K',9X,'J/MOL',9X,'J/MOL',11X,'J/MOL',11X,'J/MOL'/)
C
        ELSEIF(NTABLE.EQ.3) then
          WRITE(6,120) IHT,HR
120       FORMAT(/,' ASSIGNED H AT',I4,' K =',F12.3,' CAL/MOLE')
          WRITE (6,100)
          WRITE(6,130)
130    FORMAT(7X,'DEG-K',4X,'CAL/MOL-K',7X,'CAL/MOL',7X,'CAL/MOL',4X,
     * 'CAL/MOL-K',7X,'CAL/MOL',7X,'CAL/MOL',9X,'CAL/MOL',9X,'CAL/MOL'/)
        endif
C
      endif
      VFM(18)=VFM(16)
      VFM(19)=VFM(17)
C
      DO 180 I=1,NT
      TI=T(I)
      IF(DABS(T(I)-298.15D0).LT..02)TI=298.15D0
      CP=CPR(I)
      HH=HHRT(I)
      S=SR(I)
      GH=GHRT(I)
      IF (NTABLE.NE.1)GO TO 140
      AR=1./TI
      ART=1.
      GO TO 150
140   AR=RUSE(NTABLE)
      ART=AR*TI
      CP=CP*AR
      HH=HH*ART
      S=S*AR
      GH=GH*ART
C
150   IF (.NOT.HASIND.AND..NOT.HABS) GO TO 160
      H=HHRT(I)*ART
      G=GHRT(I)*ART
      IF(.NOT.HABS)GO TO 155
      IF(ASINDT.NE.0.)GO TO 160
      HH=HH-ASINDH*AR
      GH=GH+ASINDH*AR
      GO TO 160
155   H=H+ASINDH*AR
      G=G-ASINDH*AR
160   IF (H298.NE.0.) GO TO 165
      HH29=HH
      GH29=GH
      GO TO 170
165   HH29=(HHRT(I)-H298/TI)*ART
      GH29=(GHRT(I)+H298/TI)*ART
170   IF (H298.NE.0.D0.AND.HHZERO) GO TO 175
      WRITE (6,VFM) T(I),CP,HH,S,(HSG(J),J=5,NHSG)
      GO TO 178
175   WRITE (6,VFM) T(I),CP,(HSG(J),J=1,NHSG)
C
178   CONTINUE
C     IF(MTAB.EQ.NTABLE) WRITE (IOCFT,179)T(I),DML,CP,HT,HREF,HDML,HH,DML,S
C79   FORMAT(6X,'T',5X,F10.4,'  CP',a2,2X,F10.5,2x,A3,A1,A2,1P,D12.5,'S'
C    *,0P,A2,3X, F12.6)
180   CONTINUE
      CALL PAGEID
190   CONTINUE
      RETURN
      END

      SUBROUTINE TEMPER
      SAVE
C
C  STORES T SCHEDULE IN T ARRAY FROM DATA ON TEMP RECORDS.
C  NT = NUMBER OF TEMPERATURES
C  TINTVL = I VALUE ON TEMP RECORD.  PRESERVED IF LAST VALUE ON RECORD
C      SO IT WILL BE AVAILABLE FOR USE WITH DATA ON NEXT TEMP RECORD.
C
      CHARACTER*4 AT
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      DATA AT/'T'/
C
10    DO 160 J=1,4
      IF (ABEL(1,J).EQ.BLANK) GO TO 160
      IF (ABEL(1,J).EQ.AT) GO TO 60
      IF (ABEL(1,J).EQ.'I') GO TO 40
20    WRITE (6,30)
30    FORMAT (/,' ERROR IN LABELS ON TEMP RECORD, (TEMPER)')
      GO TO 190
40    IF (NT.GT.0) GO TO 50
      GO TO 20
50    TINTVL=WORD(J)
      GO TO 160
60    IF (NT.EQ.0) GO TO 120
      IF (TINTVL.EQ.0.0) GO TO 130
70    IF (T(NT).GE.(298.15D0-.0001)) GO TO 80
      IF ((T(NT)+TINTVL).GT.(298.15D0+.0001)) GO TO 110
80    NT=NT+1
      IF (NT.GT.502) GO TO 170
      T(NT)=T(NT-1)+TINTVL
90    IF (T(NT).GE.(WORD(J)-.0001)) GO TO 100
      GO TO 70
100   TINTVL=0.0
      GO TO 160
110   NT=NT+1
      T(NT)=298.15D0
      NT=NT+1
      T(NT)=T(NT-2)+TINTVL
      GO TO 90
120   NT=1
      T(NT)=WORD(J)
      GO TO 160
130   IF (T(NT).GE.(298.15D0-.0001)) GO TO 140
      IF (WORD(J).GT.(298.15D0+.0001D0)) GO TO 150
140   NT=NT+1
      IF (NT.GT.502) GO TO 170
      T(NT)=WORD(J)
      GO TO 160
150   NT=NT+1
      T(NT)=298.15D0
      GO TO 140
160   CONTINUE
      goto 200
C
170   NT=502
      WRITE (6,180)
180   FORMAT (/,' NUMBER OF TEMPERATURES EXCEEDS 502, (TEMPER)')
      RETURN
C
C   TEMP RECORD IS BLANK--USE STANDARD TEMPERATURE RANGE
C
190   ABEL(1,1)=AT
      WORD(1)=100.0 D0
      ABEL(1,2)='I'
      WORD(2)=100.0 D0
      ABEL(1,3)=AT
      WORD(3)=6000.0 D0
      GO TO 10
200   RETURN
      END
C
      SUBROUTINE WCALC(A,Y,T,CPO,CPI,SUM,C,H,G)
      SAVE
C
      DOUBLE PRECISION A(4),Y,T,SUM,C,H,G,SIGF(4),SIGC,SIGY,SIGS
C
      DO 200 J=1,4
      SIGF(J)=FLOAT(J+1)*A(J)
      DO 200 N=J,4
200   SIGF(J)=SIGF(J)+A(N)
      SIGC=(((A(4)*Y+A(3))*Y+A(2))*Y+A(1))*Y
      SIGS=(((A(4)*Y/5.+A(3)/4.)*Y+A(2)/3.)*Y+A(1)/2.)*Y
      SIGY=(((SIGF(4)*Y/3.+SIGF(3)/2.)*Y/5.+SIGF(2)/6.)*Y+SIGF(1)/3.)*
     1 Y/2.
      C=CPO+(CPI-CPO)*Y*(Y+(Y-1.)*SIGC)
      H=(CPO-(CPI-CPO)*((2.+SUM)*(Y/2.-1.+(1./Y-1.)*DLOG(T/Y))+Y*SIGY))
      G=CPI*DLOG(T)-(CPI-CPO)*(DLOG(Y)+(1.+SIGS)*Y)
      RETURN
      END
      SUBROUTINE WILHOI
      SAVE
C
C  A PROGRAM TO EXTRAPOLATE THERMO FOR GASES WITH WILHOIT POLYNOMIALS.
C
C     REFERENCE - WILHOIT,R.C.,"THERMODYNAMICS RESEARCH CENTER CURRENT
C          NEWS," VOL.3, TEXAS A&M UNIVERSITY (1975).
C
C       CPO=7/2*R FOR LINEAR MOLECULE. CPO=4*R FOR NON-LINEAR MOLECULE.
C       CPI=(3*N-3/2)*R FOR LINEAR MOLECULE. CPI=(3*N-2)*R FOR NONLINEAR
C
      DIMENSION M(15),L(15)
      DOUBLE PRECISION  HX,SX,AS(4),SUMS,CCAL(502),HCAL(502),GCAL(502),
     1 C(502),SCAL,HDIF1,SDIF1,HDIF(502),SDIF(502),SHPT(8),SPT(8),A(8),
     2 Y(502),TS(8,8),SUM,HCONS,SCONS,SD,SDMIN,HERR,SERR,THERR,TSERR,
     3 tstart
C
      CHARACTER*4 PREFIX,PXNL
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
      DATA PXNL/'NON-'/
C
      IF(NOATMS.GT.1) GO TO 8
      WRITE (6,6)
6     FORMAT (/,' WILHOIT EXTRAPOLATION NOT AVAILABLE FOR MONATOMICS')
      GO TO 330
8     tstart = 0.d0
      DO 10 I=1,4
      IF (ABEL(1,I).EQ.' ') GO TO 10
      IF (ABEL(1,I).EQ.'LINE') TEST(2)=.TRUE.
      IF (ABEL(1,I).EQ.'TSTA') tstart = WORD(I)
10    CONTINUE
      IF (TEST(2)) GO TO 20
      CPO=4.0
      CPI=(3*NOATMS-2)
      PREFIX=PXNL
      GO TO 30
20    PREFIX=BLANK
      CPO=3.5
      CPI=FLOAT(3*NOATMS)-1.5
30    B=0.0
      SDMIN=1.E+10
      IBEGIN = 1
      DO 35 I=1,NT
      IF (CPR(I).NE.0..AND.T(I).GE.tstart) GO TO 36
      IF (CPR(I).LE.0.) THEN
        WRITE(6,34)
34    FORMAT(/' >>> WILHOIT NOT USED TO EXTRAPOLATE TO LOWER T VALUES')
        LINES =LINES + 2
      ENDIF
      IBEGIN=I+1
35    continue
36    DO 310 IS=1,80
      B=B+50.0
      SD=0.
      DO 50 K=1,7
      SPT(K)=0.0
      DO 40 I=IBEGIN,NT
      IF (CPR(I).EQ.0.) GO TO 40
      Y(I)=(T(I)/(T(I)+B))
      SPT(K)=SPT(K)+(Y(I)*10.)**(K-1)
40    CONTINUE
50    CONTINUE
C
      DO 60 KR=1,4
      DO 60 KC=1,4
      K=KR+KC-1
60    TS(KC,KR)=SPT(K)
      DO 70 KR=1,4
      SHPT(KR)=0.0
      DO 70 I=IBEGIN,NT
      IF (CPR(I).EQ.0.) GO TO 70
      C(I)=(CPR(I)-CPO-((Y(I)**2)*(CPI-CPO)))/((CPI-CPO)*(Y(I)**2)*
     1 (Y(I)-1.))
      SHPT(KR)=SHPT(KR)+C(I)*(Y(I)*10.)**(KR-1)
70    CONTINUE
      DO 80 J=1,4
      L(J)=J
80    M(J)=J
      DO 160 J=1,4
      BIGEST=0.0
      DO 100 IL=J,4
      DO 90 IM=J,4
      KL=L(IL)
      KM=M(IM)
      IF (BIGEST.GE.DABS(TS(KL,KM))) GO TO 90
      BIGEST=DABS(TS(KL,KM))
      NL=IL
      NM=IM
90    CONTINUE
100   CONTINUE
      IF (BIGEST.NE.0.0) GO TO 120
      WRITE (6,110)
110   FORMAT ('1***ERROR IN WILHOIT EXTRAPOLATION***')
      GO TO 310
120   IT=L(J)
      L(J)=L(NL)
      L(NL)=IT
      IT=M(J)
      M(J)=M(NM)
      M(NM)=IT
      KL=L(J)
      KM=M(J)
      SHPT(KL)=SHPT(KL)/TS(KL,KM)
      DO 130 IA=1,4
      KLA=L(IA)
      IF (KLA.EQ.KL) GO TO 130
      SHPT(KLA)=SHPT(KLA)-SHPT(KL)*TS(KLA,KM)
130   CONTINUE
      IF (J.EQ.4) GO TO 170
      JP=J+1
      DO 140 IB=JP,4
      KMA=M(IB)
140   TS(KL,KMA)=TS(KL,KMA)/TS(KL,KM)
      DO 160 IA=1,4
      KLA=L(IA)
      IF (KLA.EQ.KL) GO TO 160
      DO 150 IB=JP,4
      KMA=M(IB)
150   TS(KLA,KMA)=TS(KLA,KMA)-TS(KL,KMA)*TS(KLA,KM)
160   CONTINUE
170   DO 180 I=1,4
      KLA=L(I)
      KMA=M(I)
180   A(KMA)=SHPT(KLA)
      SUM=0.
      DO 190 J=1,4
      A(J)=A(J)*10.0**(J-1)
190   SUM=SUM+A(J)
      HERR=0.
      SERR=0.
      NTS=0
      DO 210 I=IBEGIN,NT
      IF (CPR(I).EQ.0.) GO TO 210
      NTS=NTS+1
      CALL WCALC (A,Y(I),T(I),CPO,CPI,SUM,CCAL(I),HCAL(I),SCAL)
      HDIF(I)=(HCAL(I)-HHRT(I))*T(I)
      SDIF(I)=SCAL-SR(I)
      SD=SD+(CPR(I)-CCAL(I))**2
      GCAL(I)=SCAL-HCAL(I)
      IF(NTS.NE.1)GO TO 195
      HDIF1=HDIF(I)
      SDIF1=SDIF(I)
195   IT=I
      HX=DABS(HDIF(I)-HDIF1)
      IF (HX.LE.HERR) GO TO 200
      HERR=HX
      THERR=T(I)
200   SX=DABS(SDIF(I)-SDIF1)
      IF (SX.LE.SERR) GO TO 210
      SERR=SX
      TSERR=T(I)
210   CONTINUE
      SD=DSQRT(SD/NTS)
      IF (SD.GT.SDMIN) GO TO 230
      SDMIN=SD
      BMIN=B
      SCONS=-SDIF(IT)
      HCONS=-HDIF(IT)
      SUMS=SUM
      DO 220 J=1,4
220   AS(J)=A(J)
C
230   IF (.NOT.TEST(14)) GO TO 310
      WRITE (6,240)
240   FORMAT (/,3X,'WILHOIT COEFFICIENTS')
      WRITE (6,250) (A(J),J=1,3),A(4)
250   FORMAT (/,3X,'A(0) = ',E16.9,5X,'A(1) = ',E16.9,5X,'A(2)
     1 = ',E16.9,5X,'A(3) = ',E16.9)
      WRITE (6,260) B,CPO,CPI,PREFIX,NOATMS
260   FORMAT (/,' B =',F7.1,5X,'CPO/R =',F9.4,5X,'CPI/R =',F9.4,5X,A4,'
     1LINEAR',5X,'NO. ATOMS =',I4/)
      WRITE (6,270) SD,HERR,THERR,SERR,TSERR
270   FORMAT (1H ,'STD DEV =',F9.4,5X,'MAXERR H/R =',F9.4,2X,'T =',F9.2,
     15X,'MAXERR S/R =',F10.5,2X,'T =',F9.2)
      WRITE (6,280)
280   FORMAT (//8X,1HT,6X,'CP/R CALC',2X,'CP/R INPUT',6X,'H/RT CALC',10X
     1,'H/RT INPUT',8X,'H/R(CAL-INP)',4X,'-G/RT CAL',4X,'-G/RT INP',3X,'
     2S/R(CAL-INP)'/)
      DO 290 I=IBEGIN,NT
      IF (CPR(I).EQ.0.) GO TO 290
      WRITE (6,300) T(I),CCAL(I),CPR(I),HCAL(I),HHRT(I),HDIF(I),GCAL(I),
     1GHRT(I),SDIF(I)
290   CONTINUE
300   FORMAT (1X,3F11.3,3E19.7,3F13.5)
310   CONTINUE
      IF (SDMIN.GE.1.E+10) GO TO 330
C
C  EXTRAPOLATION
C
      DO 320 I=IBEGIN,NT
      IF (CPR(I).NE.0.) GO TO 320
      Y(I)=T(I)/(T(I)+BMIN)
      CALL WCALC (AS,Y(I),T(I),CPO,CPI,SUMS,CPR(I),HHRT(I),SR(I))
      SR(I)=SR(I)+SCONS
      HHRT(I)=HHRT(I)+HCONS/T(I)
      GHRT(I)=SR(I)-HHRT(I)
      IF (TEST(19).OR.DABS(T(I)-ASINDT).GT..05)GO TO 320
      SPECH=HHRT(I)*298.15D0
      IF (DABS(ASINDT-298.15D0).GT..05) SPECH=HHRT(I)*ASINDT
      TEST(19)=.TRUE.
320   CONTINUE
C
      if (lines.ge.53) call pageid
      WRITE (6,240)
      WRITE (6,250) (AS(J),J=1,3),AS(4)
      WRITE (6,325) HCONS,SCONS
325   FORMAT(/' INTEGRATION CONSTANTS:    H/R =',E16.9,5X,'S/R =',E16.9)
      WRITE (6,260) BMIN,CPO,CPI,PREFIX,NOATMS
      LINES=LINES+7
      if (lines.ge.55) call pageid
C
330   RETURN
      END
      BLOCKDATA
C
      CHARACTER*4 ABEL,BLANK,CODE,DATE,EFAZ,FAZ,FORMLA,HEAT,LABEL
      CHARACTER*4 NAME,SNM,STD,SUB,SYMBOL
      COMMON /CHAR4/ ABEL(2,4),BLANK,CODE(2),DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),HEAT,LABEL,NAME(19,6),SNM(4),STD,SUB,SYMBOL(2,100)
C
      DOUBLE PRECISION ATMWT,ASINDH,ASINDT,COEF,CPR,GHRT,H298HR,H298H0,
     1 HCK,HHRT,HLST,PI,PTMELT,R,RR,SATM,SBAR,SCONST,SLST,SPECH,SR,T,
     2 TAPE,TC,TCONST,TLST,TRANGE,WEIGHT,WORD,TTRANS
      COMMON /REAL8/ ATMWT(100),ASINDH,ASINDT,COEF(10,9),CPR(502),
     1 GHRT(502),H298HR,H298H0,HCK,HHRT(502),HLST,PI,PTMELT,R,RR,SATM,
     2 SBAR,SCONST,SLST,SPECH,SR(502),T(0:502),TAPE(1506),TC(9),TCONST,
     3 TLST,TRANGE(9),WEIGHT,WORD(4),TTRANS(6)
C
      COMMON /REAL4/ AG(100),D(4),EX(10,9),FWORD(4),GG(100)
C
      COMMON /INTGR/ IC80,intvls,IVL1,ITR,JF(5),LINES,LSCODE(8),MLA(5),
     1 MLAS(5),MTAB,NATOM,NDFILE,NEL,NF(9),NF1,NF2,NFP,NIT,NKIND,NKINDS,
     2 NLAST,NMAT(100),NMLA(100),NNN,NOATMS,NT,NTMP,NTRANG,NFZ,INA,NNA
     3 ,IDONE
C
      LOGICAL BACK,BAR,CNST,CPONLY,INTV,NOCP,NOH,NOS,OLD,TEST,TOUT
      COMMON /LOGCL/ BACK,BAR,CNST,CPONLY(9),INTV(8),NOCP(9),NOH(9),
     1 NOS(9),OLD,TEST(20),TOUT(3)
C
C    Physical Constants:  Cohen,R.E.; and Taylor, B.N.:
C    THE 1986 CODATA RECOMMENDED VALUES OF THE FUNDAMENTAL PHYSICAL 
C    CONSTANTS. J.Phys.Chem.Ref.Data, Vol.17, No.4, 1988, pp 1795-1803.
C
      DATA RR/8.314510D0/, HCK/1.438769D0/, SATM /-3.664856D0/
      DATA SBAR/-3.651693D0/
      DATA SYMBOL/  'E',' ','H',' ','D',' ','H','E','L','I','B','E','B',
     1  ' ','C',' ','N',' ','O',' ','F',' ','N','E','N','A','M','G','A',
     2  'L','S','I','P',' ','S',' ','C','L','A','R','K',' ','C','A','S',
     3  'C','T','I','V',' ','C','R','M','N','F','E','C','O','N','I','C',
     4  'U','Z','N','G','A','G','E','A','S','S','E','B','R','K','R','R',
     5  'B','S','R','Y',' ','Z','R','N','B','M','O','T','C','R','U','R',
     6  'H','P','D','A','G','C','D','I','N','S','N','S','B','T','E','I',
     7  ' ','X','E','C','S','B','A','L','A','C','E','P','R','N','D','P',
     8  'M','S','M','E','U','G','D','T','B','D','Y','H','O','E','R','T',
     9  'M','Y','B','L','U','H','F','T','A','W',' ','R','E','O','S','I',
     $  'R','P','T','A','U','H','G','T','L','P','B','B','I','P','O','A',
     $  'T','R','N','F','R','R','A','A','C','T','H','P','A','U',' ','N',
     $  'P','P','U','A','M','C','M','B','K','C','F'/
C
C  ATOMIC WEIGHTS - Coplen,T.B., Atomic Weights of the Elements 1999,
C    2001, J.Phys.Chem.Ref.Data, vol.20, no.3, pp.701-712.
C
      DATA ATMWT/5.48579911D-04,1.00794D0,2.014102D0,4.002602D0,
     1 6.941D0,9.012182D0,10.811D0,12.0107D0,14.0067D0,15.9994D0,
     2 18.9984032D0,20.1797D0,22.989770D0,24.305D0,26.981538D0,
     3 28.0855D0,30.973761D0,32.065D0,35.453D0,39.948D0,39.0983D0,
     4 40.078D0,44.95591D0,47.867D0, 50.9415D0,51.9961D0,54.938049D0,
     5 55.845D0,58.933200D0,58.6934D0,63.546D0,65.39D0,69.723D0,72.64D0,
     6 74.92160D0,78.96D0,79.904D0,83.80D0,85.4678D0,87.62D0,88.90585D0,
     7 91.224D0,92.90638D0,95.94D0,97.9072D0,101.07D0,102.9055D0,
     $ 106.42D0,
     8 107.8682D0,112.411D0,114.818D0,118.710D0, 121.760D0,127.6D0,
     9 126.90447D0,131.293D0,132.90545D0,137.327D0,138.9055D0,140.116D0,
     $ 140.90765D0,144.9127D0,145.D0,150.36D0,151.964D0,157.25D0,
     $ 158.92534D0,
     $ 162.50D0,164.93032D0,167.259D0,168.93421D0,173.04D0,174.967D0,
     $ 178.49D0,180.9479D0,183.84D0,186.207D0,190.23D0,192.217D0,
     $ 195.078D0,196.96655D0,200.59D0,204.3833D0,207.2D0,208.98038D0,
     $ 208.9824D0, 209.9871D0,
     $ 222.0176D0,223.0197D0,226.0254D0,227.0278D0,232.0381D0,
     $ 231.03588D0,238.02891D0,237.0482D0,244.0642D0,243.0614D0,
     $ 247.0703D0,247.0703D0,251.0587D0/
C
      DATA AG/2.,2.,2.,4., 2., 4., 2.,12., 30., 40., 30., 12., 2.,4.,2.,
     1  12.,30.,40.,30.,12.,2.,4.,-1170.,-3780.,-8100.,-12096.,-12852.,
     2 -9720.,-5130.,-1800.,2.,4.,2.,12.,30.,40.,30.,12.,2.,4.,-1170.,
     3 -3780.,-8100.,-12096.,-12852.,-9720.,-5130.,-1800.,2.,4.,2.,12.,
     4 30.,40.,30.,12.,2.,4.,-1170.,14*0.,-3780.,-8100.,-12096.,-12852.,
     5 -9720.,-5130.,-1800.,2.,4.,2.,12.,30.,40.,30.,12.,12*0. /
C
      DATA GG/2.,2.,2.,1.,8.,13.,6.,15.,20.,15.,6.,1.,18.,33.,16.,75.,
     1  170.,215.,156.,61.,42.,426.,1260.,3855.,7992.,11676.,12216.,
     2 9135.,4780.,1666.,362.,61.,30.,159.,380.,495.,366.,145.,74.,670.,
     3 1260.,3855.,7992.,11676.,12216.,9135.,4780.,1666.,394.,125.,92.,
     4 351.,860.,1135.,846.,337.,124.,1138.,2200.,14*0.,3855.,7992.,
     5 11676.,12216. ,9135.,4780.,1666.,434.,205.,132.,591.,1460.,1935.,
     6 1446.,577.,12*0/
C
      DATA EFAZ/4*'G',4*'S',4*'G',6*'S',2*'G',12*'S','S',3*'S','S','G',
     1 17*'S','G',25*'S','S',5*'S','G',12*'S'/, BLANK/'    '/
C
      DATA NMAT/0,1,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
     1 21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
     2 41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,
     3 61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
     4 81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98/
C
      DATA NMLA/ 1,2,2,5*1,3*2,7*1,2,17*1,2,17*1,2,45*1/
      END

C*********************************************************************** 
C           syntax.f for 'cleaning' CEA input for GUI February 12, 2004
C*********************************************************************** 
C     program syntax for CEA GUI
C	Nov. 12, 2002 created by Bonnie McBride
C				  inFile=GUIfile.txt , outFile=GUIfile2.txt
C	Dec. 03, 2002 Max char per a line (MAXNCHAR=120) ; LOGICAL  Moles
C		
      PARAMETER (MAXNGC=600)
      PARAMETER (MAXTR=30)
	PARAMETER (MAXNCHAR=120)
C DUMMY ARGUMENTS
      LOGICAL Caseok,Readok,Moles
      CHARACTER*15 Ensert(20)
C LOCAL VARIABLES
      CHARACTER*15 cin(MAXNGC),cx15
      CHARACTER*4 Code
      CHARACTER*1 cx1
      CHARACTER*2 cx2
      CHARACTER*3 cx3
      CHARACTER*4 cx4
      CHARACTER*5 cx5
      CHARACTER*6 cx6
      CHARACTER*26 lc,uc
      CHARACTER*120 rec,tmp
      LOGICAL pltdat
      INTEGER Lcin(MAXNGC),Mcin(MAXNGC)
      REAL*8 dpin(MAXNGC)
C
      DATA uc/'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA lc/'abcdefghijklmnopqrstuvwxyz'/ 
C
      OPEN (5,FILE='GUIfile.txt',STATUS='old',FORM='formatted')
	OPEN (6,FILE='GUIfile2.txt',STATUS='unknown',FORM='formatted')
      Caseok = .TRUE.
      Readok = .TRUE.
C CALL INFREE TO READ DATASET
 100  CALL INFREE(Readok,Cin,Ncin,Lcin,Mcin)
      IF ( .NOT.Readok ) GOTO 400
      Code = cin(1)
      IF ( Code.EQ.'    ' ) goto 100
c
c THE FOLLOWING 4 LINES MAY BE ACTIVATED FOR DEBUG PURPOSES
c     write (6,*)'           i     Cin(i)             Lcin(i)   Mcin(i)'
c     do i=1,Ncin
c       write (6,*) i,'     ',Cin(i),Lcin(i),Mcin(i)
c     enddo
c
	write (6, * ) '     '
      write (6,110) cin(1)
 110  FORMAT ( '     ',a15)
      if ( Code.EQ.'end' ) goto 400
      if ( Code.EQ.'only'.OR.Code.EQ.'inse'.OR.Code.EQ.'omit' ) then
        nn = MIN(MAXNGC,Ncin)
C	  Insert a blank line before each code
	  write (6, * ) '     '
        write (6,105) (cin(i),i=2,nn)
 105    format ( 5a16 )
        go to 100
      endif
      nrec = 1
      rec = ' '
c
C PROCESS 'OUTP' DATASET.
c
      IF ( Code.EQ.'outp' ) THEN
        pltdat = .FALSE.
        DO 120 i = 2,Ncin
          if ( Lcin(i).EQ.0 ) go to 120
          cx15 = cin(i)
          cx1 = cx15(:1)
          cx2 = cx15(:2)
          cx3 = cx15(:3)
          cx4 = cx15(:4)
          cx5 = cx15(:5)
          IF ( Lcin(i).LT.0 ) THEN
            if ( cx3.eq.'cal'.OR.cx5.eq.'short'.OR.cx5.eq.'massf'.OR.
     &           cx2.eq.'si' .OR.cx4.eq.'mole' ) then
              n = -Lcin(i) + 1
              if (nrec+n.ge.MAXNCHAR) call recout(nrec,rec)
              rec(nrec:nrec+n) = cx15(:n-1)//' '   
              nrec = nrec + n  
              pltdat = .FALSE.
              goto 120
            elseif ( cx4.EQ.'tran'.OR.cx3.EQ.'trn' ) THEN
              if (nrec+7.ge.MAXNCHAR) call recout(nrec,rec)
              rec(nrec:nrec+7) = 'transp '
              nrec = nrec + 7
              pltdat = .FALSE.
              goto 120
            elseif ( cx4.EQ.'trac' ) THEN
              n = -Lcin(i) + 1
              m = Mcin(i+1) + 1
              if (nrec+n+m.ge.MAXNCHAR) call recout(nrec,rec)
              rec(nrec:nrec+n+m) = cx15(:n-1)//'='//Cin(i+1)(:m-1)//' ' 
              nrec = nrec + n + m
              Lcin(i+1) = 0
              pltdat = .FALSE.
              goto 120
            elseif (cx4.eq.'plot') then
              pltdat = .true.
              n = 5
              if (nrec+n.ge.MAXNCHAR) call recout(nrec,rec)
              rec(nrec:nrec+n) = 'plot '
              nrec = nrec + n
              goto 120
            elseif ( cx3.EQ.'deb'.OR.cx3.EQ.'dbg' ) THEN
              if (nrec+6.ge.MAXNCHAR) call recout(nrec,rec)
              rec(nrec:nrec+6) = 'debug='
              nrec = nrec + 6
                DO j = i+1,i+9
                  IF ( Lcin(j).ne.i ) GOTO 120
                  n = Mcin(j) + 1
                  if (nrec+n.ge.MAXNCHAR) call recout(nrec,rec)
                  rec(nrec:nrec+n-1) = Cin(j)(:n-1)   
                  nrec = nrec +n
                    if ( Lcin(j+1).eq.i ) then
                      rec(nrec-1:nrec) = ',' 
                    else
                      rec(nrec-1:nrec) = ' ' 
                    endif
                  lcin(j) = 0
                ENDDO
              pltdat = .false.
              goto 120
            elseif ( pltdat ) then
              n = -Lcin(i) + 1
              if (nrec+n.ge.MAXNCHAR) call recout(nrec,rec)
              rec(nrec:nrec+n) = cx15(:n-1)//' '
              nrec = nrec + n
              go to 120
            else
              WRITE (8,99002) cin(i)
            endif
          ELSEIF ( Lcin(i).GT.0 ) THEN
            WRITE (8,99002) cin(i)
          ENDIF
 120    ENDDO
          goto 200
      ENDIF
C SORT AND STORE DATA FROM 'REAC' DATASET.
      IF ( Code.EQ.'reac' ) THEN
        Moles = .FALSE.
        Nreac = 0
        i = 1
 140    i = i + 1
        cx15 = cin(i)
        cx1 = cx15(:1)
        cx2 = cx15(:2)
        cx3 = cx15(:3)
        cx4 = cx15(:4)
        cx5 = cx15(:5)
        IF ( i.gt.Ncin.or.Lcin(i).eq.0 ) goto 200
        IF ( lcin(i).GT.0 ) THEN
		WRITE (6, * ) '     '
          WRITE (6,99003) cin(i)
          GOTO 140
        ENDIF
        IF ( cx2.EQ.'na'.OR.cx2.EQ.'ox'.OR.cx2.EQ.'fu' ) THEN
          nreac = nreac +1
          if (nrec.gt.1) call recout(nrec,rec)
          if (Lcin(i+1).gt.0) then
            Lcin(i+1) = -Lcin(i+1)
            write (6,99001)
            caseok = .false.
          endif
          n = -Lcin(i) + 1
          m = -Lcin(i+1) + 1
          if (nrec+n+m.gt.MAXNCHAR)call recout(nrec,rec)
          rec(nrec:nrec+n+m) = cx15(:n-1)//'='//Cin(i+1)(:m-1)//' '
          nrec = nrec + m + n
          Lcin(i)  = 0
          i = i + 1
          go to 140
C LOOK FOR PERCENTS
        ELSEIF ( cx1.EQ.'m'.OR.cx1.EQ.'w' ) THEN
          n = -Lcin(i) + 1
          m = Mcin(i+1) + 1
          if ( nrec+n+m.ge.MAXNCHAR ) call recout(nrec,rec)
          rec(nrec:nrec+n+m) = cx15(:n-1)//'='//Cin(i+1)(:m-1)//' '
          nrec = nrec + m + n
          Lcin(i)  = 0
          i = i + 1
          IF ( cx1.EQ.'m'.AND.Nreac.EQ.1 ) Moles = .TRUE.
          IF ( cx1.EQ.'m'.AND..NOT.Moles.OR.cx1.EQ.'w'.AND. Moles ) THEN
            Caseok = .FALSE.
            WRITE (6,99005)
          ENDIF
          GOTO 140
C LOOK FOR TEMPERATURE
        ELSEIF ( cx1.EQ.'t' ) THEN
          IF ( lcin(i+1).GT.0 ) THEN
            IF ( lcin(i).LT.1 ) THEN
              Lcin(i) = 0
              i = i + 1
              if ( nrec+5+mcin(i).gt.MAXNCHAR ) call recout(nrec,rec)
C			call recout(nrec,rec)
              rec(nrec:nrec+4) = 't,k='
              IF ( INDEX(cx15,'r').GT.0 ) rec(nrec:nrec+4) = 't,r='
              IF ( INDEX(cx15,'c').GT.0 ) rec(nrec:nrec+4) = 't,c='
              IF ( INDEX(cx15,'f').GT.0 ) rec(nrec:nrec+4) = 't,f='
              nrec = nrec + 4 
              rec(nrec:nrec+mcin(i)+1) = Cin(i)(:mcin(i))//' '
              nrec = nrec + mcin(i) + 1
            ENDIF
          ELSE
            WRITE (6,99006)
            Caseok = .FALSE.
          ENDIF
          GOTO 140
C LOOK FOR ENTHALPY
        ELSEIF ( cx1.EQ.'h'.OR.cx1.EQ.'u' ) THEN
          IF ( lcin(i+1).GT.0 ) THEN
            IF ( nrec+12+mcin(i+1).gt.MAXNCHAR) call recout(nrec,rec)
              rec(nrec:nrec+2) = cx1//','
              nrec = nrec + 2
            if ( INDEX(cin(i),'k').GT.0 ) then
              rec(nrec:nrec+1) = 'k'
              nrec = nrec + 1
            endif
            if ( INDEX(cin(i),'c').GT.0 ) then
              rec(nrec:nrec+8) = 'cal/mol='
              nrec = nrec + 8
            else
              rec(nrec:nrec+6) = 'j/mol='
              nrec = nrec + 6
            endif
            Lcin(i) = 0
            i = i + 1
            rec(nrec:nrec+mcin(i)+1) = Cin(i)(:mcin(i))//' '
            nrec = nrec + mcin(i) + 1
          ENDIF
          GOTO 140
C LOOK FOR DENSITY
        ELSEIF ( cx3.EQ.'rho'.OR.cx3.EQ.'den' ) THEN
          IF ( lcin(i+1).GT.0 ) THEN
            i = i + 1
C            if ( nrec+12+mcin(i).gt.MAXNCHAR ) call recout(nrec,rec)
		call recout(nrec,rec)
            IF ( INDEX(cx15,'kg').GT.0 ) THEN
              rec(nrec:nrec+12) = 'rho,kg/m**3='
              nrec = nrec + 12
            ELSE
              rec(nrec:nrec+9) = 'rho,g/cc='
              nrec = nrec + 9
            ENDIF
            n = mcin(i) + 1
            rec(nrec:nrec+n) = Cin(i)(:n-1)//' '
            nrec = nrec + n
          ENDIF
          GOTO 140
C CHECK FOR CHEMICAL SYMBOLS IN EXPLODED FORMULA
        ELSEIF ( (lcin(i).EQ.-1.OR.lcin(i).EQ.-2).AND.INDEX(uc,cx1)
     &               .GT.0 ) THEN
          IF ( lcin(i).EQ.-2 ) THEN
            ix = INDEX(lc,cx2(2:2))
            IF ( ix.GT.0 ) cx2(2:2) = uc(ix:ix)
          ENDIF
          n=  -Lcin(i) + 1
          m=  mcin(i+1) + 1
          if (nrec+n+m.gt.MAXNCHAR) call recout(nrec,rec)
          IF ( lcin(i+1).NE.i ) THEN
            rec(nrec:nrec+n+2) = cx2(:-Lcin(i))//' 1 '
            nrec = nrec + n + 2
          ELSE
            rec(nrec:nrec+n+m) = cx15(:n-1)//' '//Cin(i+1)(:m-1)//' '
            nrec = nrec + n + m
            i = i + 1
          ENDIF
          GOTO 140
        ENDIF
        WRITE (6,99007) cin(i)
      ENDIF
C SORT AND STORE INPUT FROM 'PROB' DATASET
      IF ( Code.EQ.'prob' ) THEN
C PROCESS LITERAL VARIABLES IN 'PROB' DATASET 
        i = 1
 160    i = i + 1
        cx15 = cin(i)
        cx1 = cx15(:1)
        cx2 = cx15(:2)
        cx3 = cx15(:3)
        cx4 = cx15(:4)
        cx5 = cx15(:5)
        cx6 = ' '
        if ( i.gt.Ncin ) goto 200
        IF ( Lcin(i).LT.0.AND.(i.EQ.Ncin.or.Lcin(i+1).NE.i) ) THEN
          IF ( cx4.EQ.'case' ) THEN
            i = i + 1
            n = -Lcin(i) + 6
            if ( nrec+n.gt.MAXNCHAR) call recout(nrec,rec)
            rec(nrec:nrec+n) = 'case='//Cin(i)(:n-6)//' '
            nrec = nrec + n
            Lcin(i) = 0
            goto 160
          ENDIF
          if ( cx2.EQ.'pt' ) cx2 = 'tp'
          if ( cx2.EQ.'ph' ) cx2 = 'hp'
          if ( cx2.EQ.'ps' ) cx2 = 'sp'
          if ( cx2.EQ.'vs' ) cx2 = 'sv'
          if ( cx2.EQ.'vu' ) cx2 = 'uv'
          if ( cx2.EQ.'vt' ) cx2 = 'tv'
          IF ( cx2.eq.'tp'.OR.cx2.eq.'hp'.OR.cx2.eq.'sp'.OR.
     &         cx2.eq.'tv'.OR.cx2.eq.'uv'.OR.cx2.eq.'sv' ) THEN
C		newline per each Problem Type
          call recout(nrec,rec)
C            if ( nrec+3.gt.MAXNCHAR ) CALL RECOUT(nrec,rec)
            rec(nrec:nrec+3) = cx2//' '
            nrec = nrec + 3
            goto 160
          ENDIF
          IF ( cx3.eq.'fac'.OR.cx3.eq.'det'.OR.cx3.eq.'ion'.OR.
     &         cx2.eq.'eq' .OR.cx2.eq.'sh' .OR.cx3.eq.'inc'.OR.
     &         cx3.eq.'ref' ) THEN
            n = -Lcin(i)+1
            if (nrec+n.gt.MAXNCHAR) CALL RECOUT(nrec,rec)
            rec(nrec:nrec+n) = Cin(i)(:n-1)//' '
            nrec = nrec  + n
            goto 160
          ENDIF
          if ( cx3.eq.'dbg'.OR.cx3.eq.'deb' ) cx6 = 'debug'
          if ( cx2.eq.'ro'.OR.cx3.eq.'rkt' ) cx6 = 'rocket'
          if ( cx2.eq.'fr'.OR.cx2.eq.'fz' ) cx6 = 'frozen'
          IF ( cx6.ne.' ' ) THEN
            n = 7
            if (cx6.eq.'debug') n = 6
            if (nrec+n.gt.MAXNCHAR) CALL RECOUT(nrec,rec)
            rec(nrec:nrec+n) = cx6(:n-1)//' '
            nrec = nrec + n
            cx6 = ' '
            goto 160
          ENDIF
          WRITE (6,99002) cx15
          lcin(i) = 0
          goto 160
      ENDIF
C  PROCESS LITERALS WITH EQUAL SIGNS
      IF ( Lcin(i).LT.0.AND.Lcin(i+1).EQ.i ) THEN
        IF ( cx1.eq.'t'.AND.cx4.ne.'tces'.AND.cx4.ne.'trac' ) THEN
C            if ( nrec+4.gt.MAXNCHAR ) call recout(nrec,rec)
C		New line
		call recout(nrec,rec)	

            rec(nrec:nrec+4) = 't,k='
            if ( INDEX(cx15,'r').GT.0 ) rec(nrec:nrec+4) = 't,r='
            if ( INDEX(cx15,'c').GT.0 ) rec(nrec:nrec+4) = 't,c='
            if ( INDEX(cx15,'f').GT.0 ) rec(nrec:nrec+4) = 't,f='
            nrec = nrec + 4
          goto 160
          ENDIF
          IF ( (cx2.EQ.'pc'.OR.cx2.EQ.'pi').AND.INDEX(cx15(3:15),'p')
     &       .GT.0.AND.INDEX(cx15,'psi').EQ.0 ) THEN
C           if ( nrec+6.gt.MAXNCHAR ) CALL RECOUT(nrec,rec)
C		newline for pi/pe
		CALL RECOUT(nrec,rec)
           rec(nrec:nrec+6) = 'pi/pe='
           nrec = nrec + 6
           goto 160
          ENDIF
          IF ( cx1.EQ.'p'.AND.cx3.NE.'phi' ) THEN
C            if ( nrec+7.gt.MAXNCHAR ) call recout(nrec,rec)
		call recout(nrec,rec)
            cx15 = 'p,bar='
            if ( INDEX(Cin(i),'psi').NE.0 ) cx15='p,psia='
            if ( INDEX(Cin(i),'mmh').NE.0 ) cx15='p,mmhg='
            if ( INDEX(Cin(i),'atm').NE.0 ) cx15='p,atm='
            n = 7
            if ( cx15.eq.'p,atm='.OR.cx15.eq.'p,bar=' ) n= 6
            rec(nrec:nrec+n) = cx15(:n)
            nrec = nrec + n
            cx6 = ' '
            goto 160
          ENDIF
          IF ( cx3.EQ.'rho' ) THEN
C            if ( nrec+12.gt.MAXNCHAR ) call recout(nrec,rec)
		call recout(nrec,rec)
            IF ( INDEX(cx15,'kg').NE.0 ) THEN
              rec(nrec:nrec+12 ) = 'rho,kg/m**3='
              nrec = nrec + 12
            ELSE
              rec(nrec:nrec+9) = 'rho,g/cc='
              nrec = nrec + 9
            ENDIF
            goto 160
          ENDIF
          IF ( cx1.EQ.'v' ) THEN
C           if ( nrec+10.gt.MAXNCHAR ) call recout(nrec,rec)
		call recout(nrec,rec)
            IF ( INDEX(cx15,'kg').NE.0 ) THEN
              rec(nrec:nrec+10) = 'v,m**3/kg='
              nrec = nrec + 10
            ELSE
              rec(nrec:nrec+7) = 'v,cc/g='
              nrec = nrec + 7
            ENDIF
            goto 160
          ENDIF
          IF ( cx3.EQ.'nfz'.OR.cx3.EQ.'nfr' ) THEN
            if ( nrec+4.gt.MAXNCHAR ) call recout(nrec,rec)
            rec(nrec: ) = 'nfz='
            nrec = nrec + 4
            goto 160
          ENDIF
          IF ( cx3.eq.'u/r'.OR.cx2.eq.'ur'.OR.cx3.eq.'s/r'.OR.
     &         cx2.eq.'sr' .OR.cx3.eq.'h/r'.OR.cx2.eq.'hr' ) THEN
            if ( cx2.eq.'hr' ) cx3 = 'h/r'
            if ( cx2.eq.'ur' ) cx3 = 'u/r'
            if ( cx2.eq.'sr' ) cx3 = 's/r'
            if ( nrec+4.gt.MAXNCHAR ) call recout(nrec,rec)
            rec(nrec:nrec+4) = cx3//'='
            nrec = nrec + 4
            go to 160
          ENDIF
          IF ( cx2.eq.'u1' .OR.cx4.eq.'mach'.OR.cx3.eq.'sub' .OR.
     &         cx3.eq.'sup'.OR.cx3.eq.'phi' .OR.cx4.eq.'case'.OR.
     &         cx3.eq.'o/f'.OR.cx3.eq.'f/a' .OR.cx3.eq.'f/o' .OR.
     &         cx2.eq.'%f' .OR.cx1.eq.'r'   .OR.cx2.eq.'nf'  .OR.
     &         cx2.eq.'ac' .OR.cx4.eq.'tces' ) THEN
            n = -Lcin(i)+1
C		Newline
		if ( cx3.eq. 'sub' .OR. cx3 .eq. 'sup' ) call recout(nrec,rec)
            if ( nrec+n.gt.MAXNCHAR ) call recout(nrec,rec)
            rec(nrec:nrec+n) = cx15(:n-1)//'='
            nrec = nrec + n                                        
            go to 160
          ENDIF
          IF ( cx4.EQ.'mdot'.OR.cx2.eq.'ma' ) THEN
            if ( nrec+8.gt.MAXNCHAR ) call recout(nrec,rec)
            rec(nrec:nrec+8) = 'mdot/ac='
            nrec = nrec + 8                                        
            go to 160
          ENDIF
        ENDIF
C  ADD NUMBERS AS LITERALS 
        IF ( Lcin(i).GT.0 ) THEN
          n = Mcin(i) + 1
          if ( nrec+n.gt.MAXNCHAR ) call recout(nrec,rec)
          IF ( Lcin(i).eq.Lcin(i+1) ) THEN
            rec(nrec:nrec+n) = cx15(:n-1)//','
          ELSE
            rec(nrec: ) = cx15(:n-1)//' '
          ENDIF
          nrec = nrec + n
          GOTO 160
        ENDIF
        WRITE (6,99002) cx15
      ENDIF
 200  CALL RECOUT(nrec,rec)
      GOTO 100
 400  STOP
99001 FORMAT (' FUEL NAMES MUST NOT START WITH A NUMERIC' ) 
99002 FORMAT (' WARNING!!  DID NOT RECOGNIZE ',A15) 
99003 FORMAT (' WARNING!!  LITERAL EXPECTED FOR ',A15) 
99004 FORMAT (' REACTANT AMOUNT MISSING (INPUT)') 
99005 FORMAT (' MOLES AND WEIGHT PERCENTS SHOULD NOT BE MIXED') 
99006 FORMAT (' REACTANT TEMPERATURE MISSING') 
99007 FORMAT (' WARNING!! ',A15,' NOT RECOGNIZED')
      END
      SUBROUTINE INFREE(Readok,Cin,Ncin,Lcin,Mcin) 
C*********************************************************************** 
C FREE-FORM READ FOR CEA.  READS AND DECIPHERS DATA FOR ONE DATASET.
C
C DEFINITIONS:
C   CH1  - INDIVIDUAL CHARACTERS IN RECORD, MAXIMUM 132.
C   NCH1 - COLUMN NUMBER FOR THE LAST NON-BLANK CHARACTER IN RECORD.
C   NCIN - NUMBER OF VARIABLES IN DATASET.
C   CIN  - CHARACTER STRINGS IN DATASET. MAXIMUM 15 CHARACTERS.
C   LCIN - NEG. LENGTH OF LITERALS.  FOR NUMERICS, INDEX OF PREVIOUS 
C          LITERAL.  ZERO FOR UNACCEPTIBLE VARIABLES.  VARIABLE 
C          FOLLOWING "CASE" IS ALWAYS ASSUMED TO BE LITERAL.
C   NB   - NUMBER OF DELIMITERS IN STRING.
C   NX   - NUMBER OF CHARACTERS IN STRING.
C   Mcin - Number of characters in numeric string.
C   CNUM - CHARACTER STRING REPRESENTING DATASET NUMBERS. MAXIMUM 24 
C          CHARACTERS.
C***********************************************************************
      PARAMETER (MAXNGC=600)
C DUMMY ARGUMENTS
      CHARACTER*15 Cin(MAXNGC)
      INTEGER Ncin
      INTEGER Lcin(MAXNGC),Mcin(MAXNGC)
      LOGICAL Readok
C LOCAL VARIABLES
      CHARACTER*1 ch1(132),cx,nums(13)
      CHARACTER*24 cnum
      CHARACTER*3 fmtl(3)
      CHARACTER*4 w1
C
      DATA nums/'+','-','0','1','2','3','4','5','6','7','8','9','.'/
      Ncin = 1
      Lcin(1) = 0
      kcin = 0
      Mcin(1) = 0
 100  nb = 1
      nx = 0
      cnum = ' '
      Cin(Ncin) = ' '
      ch1(1) = ' '
      nch1 = 1
C READ CHARACTERS, ONE AT A TIME
      READ (5,99001,END=500,ERR=500) ch1 
C FIND FIRST AND LAST NON-BLANK CHARACTER
      DO i = 132,1, - 1
        nch1 = i
        IF ( ch1(i).NE.' '.AND.ch1(i).NE.'	' ) GOTO 200
      ENDDO
 200  DO i = 1,nch1
        ich1 = i
        IF ( ch1(i).NE.' '.AND.ch1(i).NE.'	' ) GOTO 300
      ENDDO
 300  IF ( nch1.EQ.1.OR.ch1(ich1).EQ.'#'.OR.ch1(ich1).EQ.'!' ) GOTO 100
      w1 = ch1(ich1)//ch1(ich1+1)//ch1(ich1+2)//ch1(ich1+3) 
C IS STRING A KEYWORD SIGNALLING START OR END OF DATASET?
      IF ( w1.EQ.'ther'.OR.w1.EQ.'tran'.OR.w1.EQ.'prob'.OR.
     &     w1.EQ.'reac'.OR.w1.EQ.'outp'.OR.w1.EQ.'omit'.OR.
     &     w1.EQ.'only'.OR.w1.EQ.'inse'.OR.w1(1:3).EQ.'end' ) THEN
        IF ( Ncin.EQ.1 ) THEN
          Cin(Ncin) = w1
          IF ( w1(1:3).EQ.'end'.OR.w1.EQ.'ther'.OR.w1.EQ.'tran' ) THEN 
c           WRITE (6,99002) (ch1(i),i=1,nch1)
            RETURN
          ENDIF
          ich1 = ich1 + 4
          nx = 4
          Lcin(1) = -4
        ELSE
C KEYWORD READ FOR NEXT DATASET. END PROCESSING
          BACKSPACE 5
          IF ( nx.EQ.0 ) Ncin = Ncin - 1
          RETURN
        ENDIF
      ELSEIF ( Ncin.EQ.1 ) THEN
        WRITE (6,99003)
        GOTO 500
      ENDIF
c     WRITE (8,99002) (ch1(i),i=1,nch1)
      DO i = ich1,nch1
        cx = ch1(i)
C LOOK FOR DELIMITER STRINGS
        IF ( cx.EQ.','.AND.(Lcin(Ncin).GT.0.OR.nx.EQ.0) ) cx = ' '
        IF ( cx.EQ.'='.AND.(Lcin(Ncin).LT.0.OR.nx.EQ.0) ) cx = ' '
        IF ( cx.NE.' '.AND.cx.NE.'	' ) THEN 
C LOOK FOR CHARACTER STRINGS
          nx = nx + 1
          IF ( Ncin.GT.1 ) THEN
            cnum(nx:nx) = cx
            IF ( nx.LE.15 ) Cin(Ncin) = cnum
            IF ( nx.EQ.1 ) THEN
C IS THIS A NUMERIC?
              DO j = 1,13
                IF ( ch1(i).EQ.nums(j) ) THEN
                  Lcin(Ncin) = kcin
                  Mcin(Ncin) = 1
                  GOTO 310
                ENDIF
              ENDDO
              Lcin(Ncin) = -1
              kcin = Ncin
            ELSEIF ( Lcin(Ncin).LT.0 ) THEN
              Lcin(Ncin) = -nx
            ENDIF
 310        nb = 1
          ENDIF
          IF ( i.LT.nch1.OR.Lcin(Ncin).LT.0 ) GOTO 400
        ENDIF
        IF ( nb.EQ.1..AND.nx.GT.0 ) THEN
          IF ( Ncin.GT.0.AND.Lcin(Ncin).GT.0 ) THEN 
C  NUMERIC CHARACTER STRINGS 
          Mcin(Ncin) = nx
          ENDIF
 340      Ncin = Ncin + 1
          Cin(Ncin) = ' '
          Lcin(Ncin) = 0
          Mcin(Ncin) = 0
          nx = 0
          cnum = ' '
        ENDIF
        nb = nb + 1
 400  ENDDO
      IF ( nx.GT.0 ) THEN
        Ncin = Ncin + 1
        Lcin(Ncin) = 0
        Mcin(Ncin) = 0
      ENDIF
      GOTO 100
 500  Readok = .FALSE.
      RETURN
99001 FORMAT (132A1)
99002 FORMAT (1x,120A1)
99003 FORMAT (/' FATAL ERROR IN INPUT FORMAT (INFREE)') 
99004 FORMAT (/' WARNING!!  UNACCEPTABLE NUMBER ',A15,' (INFREE)')
      END
      SUBROUTINE RECOUT(nrec,rec)
c*********************************************************************** 
c  Routine to write a record.
c***********************************************************************
      CHARACTER*120 rec
      write (6,10) rec
 10   FORMAT ( A120 )
      nrec = 1
      rec = ' '
      RETURN
      END

      PROGRAM CAP
C   1/9/01
C  CAP stands for Coefficients and Properties.  It calculates
C     thermodynamic functions, including delta H and log K from
C     coeficients in the new form as produced by the PAC91 program.
C     In a way CAP is the reverse of PAC.
C
C  INPUT FILE: Two header records followed by any number of sets of
C     coefficients in the most recent format (See NASA TP-1311).
C
C  Record one contains 6 possible character variables in single quotes
C     with space and/or commas between them.  They may be either all 
C     upper or all lower case.  They contain the options as follows:
C
C     'logk'   Include delta H and log K values with rounded thermo
C              functions.
C     'mfig'   Do tables of thermo functions with many figures and no
C              delta H and log K values.
C     'joules' Energy units for the output will be in joules or
C              kilojoules.  (JOULES is the default option)
C     'cal'    Energy units for the output will be in calories or Kcal.
C     'engr'   Engineering units with temperature in degR.
C     'nodim'  Thermodynamic functions for a many-figured table will
C              be dimensionless.  (i.e. NODIM is only valid when used
C              with MFIG)
C     'plot'   Dump T, Cp/R, H-H0/RT, S/R, -(G-H0)/RT, H/RT,and -G/RT in 
C              columns.
C
C  Record two gives the temperature schedule in the form of temperatures
C     and temperature intervals.  The even-numbered values are 
C     intervals to be used between the odd-numbered temperature values.
C     The schedule will be used for the entire computer run.
C     For each set of coefficients, CAP automatically
C     limits the schedule according to the temperatures ranges given
C     with the coefficients.  Endpoints, 298.15, and transition points
C     are automatically added if they are within the requested range.
C     For transition points, values will be given for each phase at
C     the common point.  Up to 490 values may be given.  They are
C     read with a list-directed format.  That is, values are given
C     with either space or commas between them.
C     Even numbered interval values must be included even
C     if they are zero.  Two adjacent commas will indicate a zero value.
C     For example, to get the temperature set: 100,298.15,500,1000,1500,
C     2000,and 3000, the record might be as follows.
C       100,0,500,500. 2000,,3000./
C
C     The following is a sample set for the two header records:
C 
C        'mfig' 'LOGK' 'joules' 'cal' /
C    200,100,500,500,3000,1000,6000. /
C     
C      This should give both many-figured tables and rounded tables
C      with delta H and log K for both sets of enery units, joules and
C      calories.  The temperature schedule should be 200 K every 100 K
C      to 500 K, every 500 K to 3000 K, and every 1000 K to 
C      6000 K with 298.15 inserted between 200 and 300 K.  (i.e. 200,
C      298.15,300,400,500,1000,1500,2000,2500,3000,4000,5000,6000.)
C
      LOGICAL mfig,calclk,rec3,plot
      DOUBLE PRECISION EXL,TEX,TT,temps(500),htf,hplot,hh,gh,molwt

C     added 10/26/99 to initialize tin() array:
      DOUBLE PRECISION tin(500)/500*0.0d+00/

      dimension sl(5)
C 
      CHARACTER*4 rec1(4)
      CHARACTER*4 fmla(2,5)
      character*8 output(8),code
      character*64 record
C 
      CHARACTER*4 BLANK,DATE,EFAZ,FAZ,FORMLA
      CHARACTER*4 NAME,SYMBOL
      COMMON /CHAR4/ BLANK,DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),NAME(4,9),SYMBOL(2,100)
C 
      DOUBLE PRECISION asindt,COEF,CPR,GHRT,htform,enth29,
     1 HHRT,R,RR,tconv,Reng,SR,T,tcoef,term,z,wt,WORD,TTRANS
      COMMON /REAL8/ asindt,COEF(10,20),CPR(500),
     1 GHRT(500),htform,enth29,HHRT(500),R,RR,tconv,Reng,
     2 SR(500),T(500),tcoef(2,20),term,z,wt,WORD(4),TTRANS(6)
C 
      COMMON /REAL4/ EX(8,20),sel(5),sels(5)
C 
      COMMON /INTGR/ IC80,itr,JF(5),
     1 numexp(20),NEL,NKIND,NKINDS,
     2 NMAT(100),NMLA(100),NOATMS,NT,NTMP,NFZ,INA,NNA
C 
      LOGICAL hasind,refel,TOUT,mfig,eng
      COMMON /LOGCL/ hasind,refel,TOUT(3),mfig,eng
C 
C  INITIALIZE ONCE. 
C 
      OPEN (18,FILE='plotout',STATUS='unknown',FORM='formatted')
      WRITE(6,2)
2     FORMAT(/,' ****************************************************',
     & '*********************************')
      WRITE(6,3)
3     FORMAT(/,20x,'CAP (COEFFICIENTS AND PROPERTIES) PROGRAM',/ 28x,
     & 'NASA GLENN RESEARCH CENTER',//,4x,'CALCULATES THERMODYNAMIC ',
     & 'FUNCTIONS FROM COEFFICIENTS IN THE NASA GLENN FORMAT')
      WRITE(6,2)
      RR = 8.314510D0
      R=RR/4.184D0
      Reng = RR*453.59237d0/(1.8d0*1055.056d0)
      DO 10 I=1,500
      CPR(I)=0.   
      temps(i)=0.d0
      DO 5 i=1.8
        output(i)=blank
5     CONTINUE
10    T(I)=0.    
      NT=0      
      do 13 i=1,5
        formla(1,i)=blank
        sel(i) = 0.
13    continue
      DO 16 I=1,3
16      TOUT(I)=.FALSE.
      plot = .FALSE.
      mfig=.FALSE.  
      calclk=.false.
      eng=.false.
      tconv=1.d0
C 
C  READ AND WRITE CONTENTS OF INPUT RECORD with output information.
C 
      READ (5,*,err=248,END=250) output
      WRITE (6,20) output
20    FORMAT (//,'  KEYWORDS:  ',8(a4,3x))

C
C     PROCESS OUTPUT RECORD
C 
      DO 25  I=1,8
      IF (output(i).EQ.'joules' .or. output(i).eq.'JOULES') THEN 
        tout(2) =.TRUE.
      ELSEIF (output(i).EQ.'cal' .or. output(i).eq.'CAL') THEN 
        TOUT(3) =.TRUE. 
      ELSEIF (output(i).EQ.'nodim' .or. output(i).eq.'NODIM') THEN
        TOUT(1) =.TRUE.
      ELSEIF (output(i).EQ.'logk' .or. output(i).eq.'LOGK') THEN
        OPEN (13,FILE='cap.elms',STATUS='old',FORM='formatted')
        calclk=.TRUE.
      ELSEIF (output(i).EQ.'mfig' .or. output(i).eq.'MFIG') THEN
        mfig=.TRUE.
      ELSEIF (output(i).EQ.'engr' .or. output(i).eq.'ENGR') THEN
        eng=.TRUE.
        tconv=1.8d0
      ELSEIF (output(i).EQ.'plot' .or. output(i).eq.'PLOT') THEN
        WRITE (*,22)
22      FORMAT (/,'  DATA FOR PLOTTING IN FILE plotout')
        PLOT=.TRUE.
      elseif (output(i).NE.' ') then
        write (6,23) output(i)
23      format (//,' *** ',a4,' NOT RECOGNIZED. KEYWORD SHOULD',
     &  ' BE ALL UPPER OR ALL LOWER CASE WITH NO BLANKS')
      ENDIF
25    CONTINUE
      if (.not.tout(2).and..not.tout(3)) then
        if (.not.tout(1)) then
          tout(2) = .true.
          if (.not.calclk ) mfig = .true.
        endif
      else
        if (.not.calclk )mfig =.true.
        if (eng) WRITE (6,26)
26      FORMAT(/'  NOTE TO USER:',/'  KEYWORDS ''JOULES'' AND ',
     *    '''CAL'' ARE IGNORED WHEN ''ENGR'' HAS BEEN SPECIFIED')          
      endif
      if (eng) then
        tout(2) = .true.
        WRITE(6,27)
27      format(/'  KEYWORD ''ENGR'' IMPLIES TEMPERATURES IN SCHEDULE',
     &  ' ARE IN DEGREES RANKINE')
        tout(3) = .false.
        tout(2) = .true.
      endif
        
c
c  Read temperature schedule.
c
      nts=0
      READ (5,*,err=248,end=250) tin
      do 35 i=1,500,2
      if (tin(i).lt. 0.001) go to 40
      i1=i+1
      nts=nts+1
      temps(nts)=tin(i)
      if (tin(i1).eq.0.)go to 35
30    tt=temps(nts) + tin(i1)
      if(tt.lt.tin(i+2)-.0001d0)then
         nts=nts+1
         temps(nts) = tt
         if(nts.le.500) go to 30
      endif
35    continue
40    do 45 i=1,nts
      temps(i) = temps(i)
      if(temps(i).gt.298.15d0*tconv-.005) go to 60
      if (temps(i+1).lt.298.15d0*tconv+.005) go to 45
      it=i+1
      go to 50
45    continue
      go to 60
50    nts=nts+1
      do 55 i=nts,it+1,-1
      temps(i)=temps(i-1)
55    continue
      temps(it)=298.15d0*tconv 
60    WRITE(6,65) (TEMPS(I),I=1,NTS) 
65    FORMAT(//'  TEMPERATURE SCHEDULE',//(6f12.3))
      WRITE (6,70)
70    FORMAT (//35x,   '***** NOTE *****',//3x,'The temperature range of
     * the coefficients read in the standard input (I/O unit 5)',/,3x,
     * 'will be extended by 20 %.  E.g. a range of 300 to 5000 K will be
     * extended to 240'/,3x,'to 6000 K. The extrapolated data may have '
     *,'large errors. The element data cap.elms'/,3x,'(I/O unit 13) ',
     * 'will NOT be extrapolated when calculating delta H and log K.'///
     * /)
      rec3=.false.
c
c   End Initialization.
c
80    nt=nts
      WRITE (6,82) 
82    FORMAT(//22x,'COEFFICIENTS FOR FITTED THERMODYNAMIC FUNCTIONS')
      do 85 i=1,nt
      t(i)=temps(i)/tconv
85    continue
c
      DO 90 i=1,20
      DO 90 J=1,8 
      COEF(J,I)=0.
      EX(J,I)=0. 
90    CONTINUE
      IX=1
      ITR=0    
      INA=1
      NNA=0
      if (rec3) go to 130
95    READ(5,100,end=260) (rec1(i),i=1,4),record
      if (rec1(1).eq.' ') goto 95
100   FORMAT(4a4,a64)
      READ(5,105,ERR=900,END=1000) nit,code,(fmla(1,I),fmla(2,I),
     * SL(I),I=1,5),ifz,molwt,htf
105   FORMAT (i2,a8,5(2a1,f6.2),i2,f13.5,f15.3)
      if (formla(1,1).eq.blank) go to 130
      if (ifaz.eq.0.or.ifz.le.ifaz) go to 120
      do 110 i=1,5
      if (fmla(1,i).ne.formla(1,i)) go to 120
      if (fmla(2,i).ne.formla(2,i)) go to 120
      if (sel(i).ne.sl(i)) go to 120
110   continue
      go to 130
120   rec3=.true.
      go to 260
130   do 140 i=1,5
      formla(1,i)=fmla(1,i)
      formla(2,i)=fmla(2,i)
      sel(i)=sl(i)
140   continue
      rec3=.false.
      nna=nna+1
      do 145 i=1,4
      name(i,nna)=rec1(i)
145   continue
      numint=nit
      ifaz=ifz
      htform=htf
      wt=molwt
c
      WRITE(6,150) (name(I,nna),I=1,4),record
150   FORMAT(//,6x,4a4,a64)
      WRITE(6,155) NUMINT,code,(FORMLA(1,i),FORMLA(2,i),sel(i),
     * I=1,5),ifaz,molwt,htform
155   FORMAT (6x,i2,a8,5(2a1,f6.2),i2,f13.5,f15.3)
      do 180 i=1,numint
      itr=itr+1
      READ(5,160,err=900,end=1000) tcoef(1,itr),tcoef(2,itr),numexp(itr) 
     * ,(ex(j,itr),j=1,8),enth29
160   FORMAT(2f11.3,i1,8f5.1,f17.3)
      WRITE(6,165) TCOEF(1,ITR),TCOEF(2,ITR),NUMEXP(ITR) 
     * ,(ex(j,itr),j=1,8),enth29
165   FORMAT(7x,2f10.3,i2,8f5.1,f17.3)
      READ (5,170,end=1000) (coef(j,itr),j=1,10)
170   FORMAT(5d16.9)
      WRITE (6,175) (coef(j,itr),j=1,10)
175   FORMAT(6x,1p,5d16.9)
180   continue
      ttrans(nna)=tcoef(2,itr)
      do 200 i=1,5
      if (sel(i).eq.0.) go to 95
      nkind=i
200   continue
      go to 95
C 
248   WRITE (6,249)
249   FORMAT (/' ****ERROR IN KEYWORDS OR TEMPERATURE SCHEDULE RECORDS.'
     & ,/,10x, 'DID YOU END RECORDS WITH A SLASH (/)?')
      GOTO 1000
250   WRITE (6,255)   
255   FORMAT (//' ****ERROR IN INPUT, GO TO NEXT SPECIES, (MAIN PGM)')
      GOTO 1000    
C 
C  INSERT TRANSITION POINTS IN CTEM SCHEDULE & EXTEND T RANGE.
C
260   tcoef(1,1)=.8d0*tcoef(1,1)
      tcoef(2,itr)=1.2d0*tcoef(2,itr)
      if(nna.le.1) go to 315
      it=1
      do 310 n=1,nna-1
      tt=ttrans(n)
c     IF ( tt.lt.temps(1) .or. tt.gt.temps(nts)) goto 310
      IF ( tt.lt.t(1) .or. tt.gt.t(nts)) goto 310
      do 270 i=it,nt
      if(tt.gt.t(i)) go to 270
      ii=i
      ix=2
      if(tt.eq.t(i))ix=1
      go to 280
270   CONTINUE
      go to 310
280   it=ii
      NT=NT+IX
      do 300 i=nt,it,-1
300   t(i)=t(i-ix)
      t(it)=tt
      t(it+1)=tt
310   continue
315   IT=0 
      hasind = .false.
C
      if(nt.le.0) go to 250
      hplot = (htform - enth29)/8.3145d0
320   IT=IT+1
322   TT=T(IT)
      IF (TT.GT.Tcoef(2,itr)) THEN
        nt = it - 1
        goto 360
      ENDIF
C
      DO 330 i=1,itr
        L=i
323     IF ( tt.LT.tcoef(1,L)) THEN
          nt=nt-1
          if(nt.le.it) goto 360
          do 324 j=it,nt
324       t(j)=t(j+1)
          tt= t(it)
          IF( tt.gt.tcoef(2,L)) goto 330
          goto 323
        ENDIF
        IF (TT.GE.Tcoef(1,L).AND.TT.LT.Tcoef(2,L)) GOTO 340
        IF (TT.EQ.Tcoef(2,L)) THEN
          IF (it.EQ.1) GOTO 340
          IF (TT.NE.T(it-1)) GOTO 340
        ENDIF
330   CONTINUE
      GOTO 360
340   CPR(IT)=0.
      HHRT(IT)=0.
      SR(IT)=0.
      GHRT(IT)=0.
      DO 350 J=1,numexp(L)
      EXL=EX(J,L)
      TEX=COEF(J,L)
      IF (EXL.NE.0.) TEX=TEX*TT**EXL  
      IF (EXL.EQ.-1.) HHRT(IT)=HHRT(IT)+COEF(J,L)*DLOG(TT)/TT
      IF (EXL.NE.-1.) HHRT(IT)=HHRT(IT)+TEX/(EXL+1.D0)
      CPR(IT)=CPR(IT)+TEX                           
      IF (EXL.EQ.0.) SR(IT)=SR(IT)+COEF(J,L)*DLOG(TT)
      IF (EXL.NE.0.) SR(IT)=SR(IT)+TEX/EXL     
350   CONTINUE                                  
      HHRT(IT)=HHRT(IT)+(COEF(9,L))/TT    
      SR(IT)=SR(IT)+COEF(10,L)                    
      GHRT(IT)=SR(IT)-HHRT(IT)                     
      IF (plot) THEN
        hh = hhrt(it) - hplot/TT
        gh = ghrt(it) + hplot/TT
        WRITE (18,355) TT,cpr(IT),hh,sr(it),gh,hhrt(it),ghrt(it)
355     FORMAT (1p,7e12.4)
      ENDIF
      IF (IT.LT.NT) GO TO 320
c
c  Store element numbers from BLOCK DATA in JF array.  If
c    species is a reference element, set relel = .true.
c
360   refel=.false.
      do 400 k=1,nkind
      jf(k)=0
      do 380 i=1,100
      do 370 j=1,2
      if (SYMBOL(j,i).ne.formla(j,k)) go to 380
370   continue
      jf(k)=i
      if(nkind.gt.1 .or. htform.ne.0.) go to 400
      n=sel(1)+.001
      if (n.ne.nmla(i)) go to 400
      if (efaz(i).eq.'G' .and. ifaz.ne.0) go to 400
      if (efaz(i).ne.'G' .and. ifaz.eq.0) go to 400
      refel=.true.
      go to 400
380   continue
      WRITE (6,390) formla(1,k),formla(2,k)
390   FORMAT('0*** Element ',2A1,' not found in BLOCK DATA')
      calclk = .false.
      go to 405
400   continue
c
405   if(refel.or.htform.ne.0.d0) go to 430
      if(t(1).gt.298.151 .or. t(nt).lt.298.149) go to 430
      do 410 i=1,nt
      if(dabs(t(i)-298.15d0).gt..0001)go to 410
      htform = hhrt(i)*rr*298.15d0
      go to 430
410   continue
C
430   term=(htform-enth29)/rr
      asindt=0.
      if (htform.ne.0. .or. refel) then
           hasind=.true.
           if(enth29.eq.0.) asindt=298.15d0
      else
           hasind=.false.
      endif
      IF (mfig.or.tout(1)) CALL TABLES
      IF (calclk) CALL LOGK
      if(rec3) go to 80
      goto 1000
C 
900   write (6,910)
910   FORMAT (//' ***ERROR IN FORMAT OF THE NEXT COEFFICIENT DATA SET -'
     & ,' MAYBE OLD FORMAT ')
1000  CLOSE (18)
      CLOSE (13)
      stop
      END
c
      SUBROUTINE LOGK                                                   
C
C  CALCULATE ROUNDED TABLES WITH DELTAH AND LOGK CALCULATIONS.
C
      DIMENSION PT(30),MARK(30),VFM2(15),idone(5)
C 
      DOUBLE PRECISION HZERO,RT,RUSE(2),hconv
      logical kdone
      DOUBLE PRECISION ALK(500),DH0,CP,S,H,HH,GH,DH(500),H0
      DOUBLE PRECISION HH0,DNMLA,EXL,TEX,TT,H298,dmla,TI
C
      CHARACTER*4 CHH,CHDH,BZ,VFM2,FSTAR,F2B,ZERO,FI6,ename(2,30)
      CHARACTER*4 FA4,F3X,F8X,F9,F12,FP2,FP3,FP4,fm(2),fms(2),f312,f224
C
      CHARACTER*4 BLANK,DATE,EFAZ,FAZ,FORMLA
      CHARACTER*4 NAME,SYMBOL
      COMMON /CHAR4/ BLANK,DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),NAME(4,9),SYMBOL(2,100)
C 
      DOUBLE PRECISION asindt,COEF,CPR,GHRT,htform,enth29,
     1 HHRT,R,RR,tconv,Reng,SR,T,tcoef,term,z,wt,WORD,TTRANS
      COMMON /REAL8/ asindt,COEF(10,20),CPR(500),
     1 GHRT(500),htform,enth29,HHRT(500),R,RR,tconv,Reng,
     2 SR(500),T(500),tcoef(2,20),term,z,wt,WORD(4),TTRANS(6)
C 
      COMMON /REAL4/ EX(8,20),sel(5),sels(5)
C 
      COMMON /INTGR/ IC80,itr,JF(5),
     1 numexp(20),NEL,NKIND,NKINDS,
     2 NMAT(100),NMLA(100),NOATMS,NT,NTMP,NFZ,INA,NNA
C 
      LOGICAL hasind,refel,TOUT,mfig,eng
      COMMON /LOGCL/ hasind,refel,TOUT(3),mfig,eng
C
c     EQUIVALENCE (IT,TI)
C 
      DATA  FSTAR/'2H *'/,F9/',F9'/,FP2/'.2'/, FI6/',I6'/,F3X/',3X'/
     1 ,FA4/',A4'/,FP4/'.4'/,FP3/'.3'/, ZERO/'0'/
     2 , F12/',F12'/, F8X/',8X'/, F2B/'2H  '/,f312/'3f12'/,f224/'2f24'/
C 
      DATA VFM2/'(', '2H  ', ',F9', '.2', ',F9', '.3,', 'F12', '.3',
     1   ',F12', '.3', ',F12', '.3',  ',F12', '.4', ')'/
C
      REWIND 13
      CHH=FSTAR
      CHDH=FSTAR
      RUSE(1)=RR
      RUSE(2)=R
      z=1.d0
      hconv = 1.d0/1000.d0
      if (eng) then
        z= 1.d0/wt
        RUSE(1) = Reng*z
        hconv = 1.8d0
        VFM2(6) = '.4,'
      endif
      IK=1     
      fms(1)=blank
      iend=0
      INIT=1
      NTX=nt
      if (hasind) then
         vfm2(7)=f312
      else
         vfm2(7)=f224
      endif
      VFM2( 9)=F12
      VFM2(10)=FP3
      DO 10 I=1,NT
      DH(I)=0.D0 
10    ALK(I)=0.D0
      DH0=0.D0
C
C  CHDH = BLANK OR ZERO - USE CHARACTER FOR DELTA H AND LOGK COLUMNS
C  CHH = BLANK - USE BLANK FOR H COLUMN
C
C  SEARCH I/O 13 FOR ELEMENT DATA FOR THIS MOLECULE.
C
      DO 20 I=1,NKIND
      idone(i)=-1
20    continue     
30    READ (13,40,END=210) nint,fm,fel
40    FORMAT(/,i2,8x,2a1,f6.2)
      do 50 i=1,nint
      READ (13,45,end=1000) tcoef(1,i),tcoef(2,i),numexp(i),
     *  (ex(j,i),j=1,8),hzero,(coef(j,i),j=1,10)
45    FORMAT(2f11.3,i1,8f5.1,f17.3,/(5d16.9))
50    continue
      DO 60 Ij=1,NKIND
      J=JF(Ij)       
      IF (fm(1).NE.FORMLA(1,Ij)) GO TO 60 
      IF (fm(2).NE.FORMLA(2,Ij)) GO TO 60
      ii=ij
      GO TO 70
60    CONTINUE
      GO TO 30
70    LL=1 
      hzero=-hzero/rr
      IF (refel) GO TO 210  
      DMLA=SEL(II)
      DNMLA=NMLA(J)
      if (idone(ii).lt.0) then
          idone(ii)=0
          DH0=DH0-HZERO*DMLA/DNMLA
          istart=0
      endif
      if (fm(1).ne.fms(1) .or. fm(2).ne.fms(2)) then
         if(fms(1).ne.blank) ntx=min(ntx,iend)
      endif
C 
      i1=idone(ii)+1
      L1=1
      DO 180 I=I1,NTX
      TT=t(i)
      HH=0.d0
      S=0.d0
      GH=0.d0
C 
C   FIND INTERVAL FOR T
C 
      do 100 LL=L1,nint
      if(TT.lt.tcoef(1,LL)-.0001 .or. TT.gt.tcoef(2,LL)+.0001)
     * go to 100
      if (istart.eq.0) then
         istart=i
         INIT=max(INIT,i)
      endif
      L=LL
      go to 110
100   continue
      go to 180
c
c           CALCULATE ELEMENT H AND G PROPERTIES
c
110   DO 120 J=1,numexp(L)
      EXL=EX(J,L)
      TEX=COEF(J,L)
      IF (EXL.NE.0.) TEX=TEX*TT**EXL
      IF (EXL.EQ.-1.) HH=HH+COEF(J,L)*DLOG(TT)/TT
      IF (EXL.NE.-1.) HH=HH+TEX/(EXL+1.D0)
      IF (EXL.EQ.0.) S=S+COEF(J,L)*DLOG(TT)
      IF (EXL.NE.0.) S=S+TEX/EXL
120   CONTINUE
      HH=HH+(COEF(9,L))/TT
      S=S+COEF(10,L)
      GH=S-HH
      iend=i
      idone(ii)=i
C 
C  CALCULATE DELTA H AND DELTA F 
C 
      DH(I)=DH(I)-HH*DMLA/DNMLA               
      ALK(I)=ALK(I)-GH*DMLA/DNMLA            
C 
C  SET T INDEX IN MARK. IF THIS END NOT THE END OF THE DATA, IT
C     IS A TRANSITION POINT FOR THIS ELEMENT.
C  IK IS THE INDEX FOR THE TRANSITION POINTS.
C 
      if(fm(1).eq.fms(1) .and. fm(2).eq.fms(2)) then
         MARK(IK)=I         
         PT(IK)=Tcoef(1,L)*tconv
         ename(1,ik)=fm(1)
         ename(2,ik)=fm(2)
         IF (IK.LT.30) IK=IK+1
         fms(1)=blank
      endif
180   CONTINUE                                 
         fms(1)=fm(1)
         fms(2)=fm(2)
      go to 30
C
210   DH0=DH0*hconv
      IK=IK-1
      IF (hasind.and.asindt.eq.0.)DH0= DH0 + term*hconv
      DO 220 I=1,NKIND                    
      IF (idone(I).lt.0) CHDH=BLANK             
220   CONTINUE                                 
      IF (refel) CHDH=ZERO               
C 
C  PRINT TABLES
C
      ntx = min(ntx,iend)
      kdone=.false.
      DO 530 NTABLE=1,2
      IF (.NOT.TOUT(NTABLE+1)) GO TO 530
      DH0=DH0*ruse(ntable)
c
      WRITE (6,230) ((NAME(I,J),I=1,3),J=1,nna)
230   FORMAT (//// 3x,'THERMODYNAMIC FUNCTIONS CALCULATED FROM COEFFICIE
     *NTS FOR ',9A4,/57X,2(3X,6A4))
      if (.not.eng) WRITE (6,240)
240   FORMAT (//'      T         Cp        H-H298        S      -(G-H298
     1)/T      H        delta Hf     log K')
      if (eng) WRITE (6,242)
242   FORMAT (//'      T         Cp        H-H537        S      -(G-H537
     1)/T      H       delta Hf     log K')
      IF (NTABLE.EQ.1) then
        if (.not.eng) WRITE(6,250)
        if (eng) WRITE(6,252)
      ELSEIF (NTABLE.EQ.2) then
        WRITE(6,255)
      ENDIF
250   FORMAT ('    deg-K    J/mol-K      kJ/mol     J/mol-K     J/mol-K
     *     kJ/mol      kJ/mol'/)
252   FORMAT('   Rankine  BTU/lb-deg    BTU/lb    BTU/lb-deg  BTU/lb-deg
     *   BTU/lb      BTU/lb'/)
255   FORMAT ('    deg-K   cal/mol-K    kcal/mol   cal/mol-K   cal/mol-K
     *    kcal/mol    kcal/mol'/)
      IF (.NOT.hasind.or.asindt.ne.0.0) GO TO 290
      H0=(term*RUSE(NTABLE))*hconv
      HH0=-enth29*hconv
      if (eng) hh0=hh0*RUSE(NTABLE)/rr
      if(ntable.eq.2)hh0=hh0/4.184D0
      IF (CHDH.EQ.BLANK .OR. CHDH.EQ.ZERO) GO TO 280
      WRITE (6,275) HH0,H0,DH0
275   FORMAT (6X,'0',8X,'0.',F15.3,7X,'0.',8X,'INFINITE',F11.3,F12.3
     * ,4X,'INFINITE')
      GO TO 290    
280   WRITE (6,285) HH0,H0,CHDH
285   FORMAT (6X,'0',8X,'0.',F15.3,7X,'0.',8X,'INFINITE',F11.3,
     * 8X,A4,4X,'INFINITE')
290   H=0.
      H298=htform
      if (eng) H298=H298 * RUSE(1)/rr
      if(ntable.eq.2)H298=H298/4.184d0
      IF (hasind) GO TO 298
      CHH=BLANK  
      CHDH=BLANK  
C
298   DO 420 I=1,NT
      TI=T(I) *tconv 
      IT= TI + 1.d-7
      VFM2(3)=FI6  
      VFM2(4)=F3X   
      if (dabs(dfloat(it)-ti).lt.1.d-6) go to 300
c     IF (DMOD(TI,1.D0).EQ.0.) GO TO 300
      VFM2(3)=F9  
      VFM2(4)=FP2
300   RT=RUSE(NTABLE)*T(I)
      H=HHRT(I)*RT*hconv
      CP=CPR(I)*RUSE(NTABLE)
      S=SR(I)*RUSE(NTABLE) 
      HH=(HHRT(I)*RT-H298)*hconv
      GH=(GHRT(I)*RUSE(NTABLE)+H298/T(I))
C
      VFM2(2)=F2B
       IF (IK.EQ.0) GO TO 320    
       DO 310 IX=1,IK
       IF (MARK(IX).EQ.I) VFM2(2)=FSTAR
310   CONTINUE                                       
320   BZ=ZERO                                         
      IF (CHDH.EQ.ZERO)GO TO 350                       
      BZ=BLANK                                          
      IF (CHDH.EQ.BLANK)GO TO 350                       
      IF ((I.GT.NTX.AND.NTX.NE.0).OR.I.LT.INIT) GO TO 350 
      if (kdone) then
          DH(I)=DH(I)/4.184D0               
      else
          DH(I)=(DH(I)+HHRT(I))*RT*hconv
          ALK(I)=(GHRT(I)+ALK(I))/2.3025851D0 
      endif
      VFM2(11)=F12
      if ( hasind) then
         VFM2(12)=FP3
         VFM2(13)=F12 
         VFM2(14)=FP4  
         IF(VFM2(3).EQ.F9)WRITE (6,VFM2)TI,CP,HH,S,GH,H,DH(I),ALK(I)
         IF(VFM2(3).EQ.FI6)WRITE (6,VFM2)IT,CP,HH,S,GH,H,DH(I),ALK(I)
      else
         VFM2( 9)=F12
         VFM2(10)=FP3
         VFM2(12)=FP4
         IF(VFM2(3).EQ.F9)WRITE (6,VFM2)TI,CP,S,H,DH(I),ALK(I)
         IF(VFM2(3).EQ.FI6)WRITE (6,VFM2)IT,CP,S,H,DH(I),ALK(I)
      endif
      GO TO 400      
350   VFM2(11)=F8X
      VFM2(12)=FA4
      if (hasind) then
         VFM2(13)=F8X
         VFM2(14)=FA4
         IF(VFM2(3).EQ.F9)WRITE (6,VFM2)TI,CP,HH,S,GH,H,BZ,BZ
         IF(VFM2(3).EQ.FI6)WRITE (6,VFM2)IT,CP,HH,S,GH,H,BZ,BZ
      else
         VFM2( 9)=F8X
         VFM2(10)=FA4
         IF(VFM2(3).EQ.F9)WRITE (6,VFM2)TI,CP,S,H,BZ,BZ
         IF(VFM2(3).EQ.FI6)WRITE (6,VFM2)IT,CP,S,H,BZ,BZ
      endif
C 
400   IF (DMOD(T(I),500.D0).NE.0.0) GO TO 420
      IF (T(I).GT.10000.D0.AND.DMOD(T(I),2500.D0).NE.0.) GO TO 420
      WRITE (6,410) 
410   FORMAT ( )
420   CONTINUE
C 
C     WRITE FOOTNOTE 
C 
      IF (IK.EQ.0) GO TO 510
      if (.not.eng) WRITE (6,440) (PT(I),I=1,IK)
440   FORMAT (//'   *Assigned reference phase change at ',               
     *  f8.2,' K',6(',',f8.2,' K'))
      if (eng) WRITE (6,450) (PT(I),I=1,IK)
450   FORMAT (//'   *Assigned reference phase change at ',               
     *  f8.2,' degR',6(',',f8.2,' degR'))
      LINES=LINES+4                      
510   WRITE (6,520)
520   FORMAT (/////)
      kdone = .true.
530   continue
      REWIND 13                        
1000  RETURN                          
      END                           
      SUBROUTINE TABLES
C 
C  WRITE OUTPUT FILE FOR THE FIRST 3 TABLES OF THERMODYNAMIC FUNCTIONS. 
C 
      REAL*8 RUSE(3),TI,HH29,GH29,HH,AR,ART,S,CP,GH,G,H,HR,h298,AHT
C
      CHARACTER*7 VFM(7)
C
      CHARACTER*4 BLANK,DATE,EFAZ,FAZ,FORMLA,NAME,SYMBOL
      COMMON /CHAR4/ BLANK,DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),NAME(4,9),SYMBOL(2,100)
C 
      DOUBLE PRECISION asindt,COEF,CPR,GHRT,htform,enth29,
     1 HHRT,R,RR,tconv,Reng,SR,T,tcoef,term,z,wt,WORD,TTRANS
      COMMON /REAL8/ asindt,COEF(10,20),CPR(500),
     1 GHRT(500),htform,enth29,HHRT(500),R,RR,tconv,Reng,
     2 SR(500),T(500),tcoef(2,20),term,z,wt,WORD(4),TTRANS(6)
C 
      COMMON /REAL4/ EX(8,20),sel(5),sels(5)
C 
      COMMON /INTGR/ IC80,itr,JF(5),
     1 numexp(20),NEL,NKIND,NKINDS,
     2 NMAT(100),NMLA(100),NOATMS,NT,NTMP,NFZ,INA,NNA
C 
      LOGICAL hasind,refel,TOUT,mfig,eng
      COMMON /LOGCL/ hasind,refel,TOUT(3),mfig,eng
C 
      RUSE(1)=R
      RUSE(2)=RR
      RUSE(3)=R
      H298=htform/rr
      if (eng) RUSE(2)=Reng
C 
C  FORMAT STATEMENT STORED IN VFM ARRAY
C 
      VFM(1) = '(F11.2,'
      VFM(2) = 'F12.5,'
C 
C  PRINT MFIG TABLES
C 
      DO 190 NTABLE=1,3
      AHT=asindt*tconv
      HR=term*RUSE(NTABLE) 
      IF (.NOT.TOUT(NTABLE)) GO TO 190
      WRITE (6, 65) ((NAME(I,J),I=1,3),J=1,nna)
65    FORMAT (//// 3x,'THERMODYNAMIC FUNCTIONS CALCULATED FROM COEFFICIE
     *NTS FOR ',9A4,/58X,2(3X,6A4))
C
      if (ntable.eq.1) then
          if(hasind) then
            if (.not.eng) WRITE(6,80)AHT,term  
80        FORMAT(///'        Assigned H(T)/R at',f7.2,' K =',F12.3,' K')
            if (eng) WRITE(6,81)AHT,term*tconv
81        FORMAT(///'        Assigned H(T)/R at',f7.2,' Rankine =',F12.3,
     1      ' Rankine')
          endif
          if (asindt .eq. 0.) then
            WRITE (6,85)   
85          FORMAT (//,7X,'T',9X,'Cp/R',6X,'(H-H0)/RT',7X,
     1      'S/R',6X,'-(G-H0)/RT',7X,'H/RT',9X,'-G/RT'/)
          else
            if(.not.eng) WRITE (6,86)
86          FORMAT (//,7X,'T',9X,'Cp/R',5X,'(H-H298)/RT',6X,
     1      'S/R',5X,'-(G-H298)/RT',6X,'H/RT',9X,'-G/RT'/)
            if(eng) WRITE (6,87)
87          FORMAT (//,7X,'T',9X,'Cp/R',5X,'(H-H537)/RT',6X,
     1      'S/R',5X,'-(G-H537)/RT',6X,'H/RT',9X,'-G/RT'/)
          endif
        do 66 i=3,5
66      VFM (i) = 'F13.7,'
        VFM (6) = 'F14.7,'
        VFM (7) = 'F14.7)'
      else
        VFM(3) = 'F13.3,'
        VFM(4) = 'F13.6,'
        VFM(5) = 'F13.3,'
        VFM(6) = 'F14.3,'
        VFM(7) = 'F14.3)'
        if (eng) then
          VFM(3) = 'F13.4,'
          VFM(5) = 'F13.4,'
          VFM(6) = 'F14.4,'
          VFM(7) = 'F14.4)'
        endif
      endif
C
      IF (.not.hasind) then
        WRITE (6,70)                
70        FORMAT (//'           NO HZERO VALUE IS AVAILABLE')
          VFM(3) = '13x,'
          VFM(5) = '13x,'
      ENDIF
C
C
        IF(NTABLE.EQ.2) then
          if(hasind) then
            if(.not.eng) WRITE(6,90) AHT,HR
90          FORMAT(///'     Assigned H(T) at',f8.2,' K =',F12.3,
     *      ' J/mol')
            if(eng) WRITE(6,91) AHT,HR*tconv/wt
91          FORMAT(///'     Assigned H(T) at',f8.2,' Rankine =',F12.3,
     *      ' BTU/lb')
          endif
            if (asindt .eq. 0.) then
            WRITE (6,100) 
100         FORMAT (/,7X,'T',11X,'Cp',10X,'H-H0',9X,'S',9X
     1      ,'-(G-H0)',10X,'H',12X,'-G')
          else 
            if (.not.eng) WRITE (6,101) 
101         FORMAT (/,7X,'T',11X,'Cp',9X,'H-H298',8X,'S',8X
     1      ,'-(G-H298)',9X,'H',12X,'-G')
            if (eng) WRITE (6,102) 
102         FORMAT (/,7X,'T',11X,'Cp',9X,'H-H537',8X,'S',8X
     1      ,'-(G-H537)',9X,'H',12X,'-G')
          endif
          if (.not.eng) WRITE (6,115)
115       FORMAT(6X,'deg K',5X,'J/mol-K',7X,'J/mol',6X,
     *    'J/mol-K',7X,'J/mol',9X,'J/mol',9X,'J/mol'/)
          if (eng) WRITE (6,116)
116       FORMAT(4X,'Rankine',3X,'BTU/lb-deg',6X,'BTU/lb',4X,
     *    'BTU/lb-deg',5X,'BTU/lb',8X,'BTU/lb',8X,'BTU/lb'/)
C
        ELSEIF(NTABLE.EQ.3) then
          if(hasind) WRITE(6,120) AHT,HR 
120       FORMAT(///'    Assigned H(T) at',f8.2,' K =',F12.3,' cal/mol')
          if (asindt .eq. 0.) then
            WRITE (6,100) 
          else
            WRITE (6,101)
          endif
          WRITE(6,130)
130    FORMAT(6X,'deg-K',4X,'cal/mol-K',5X,'cal/mol',4X,
     * 'cal/mol-K',6X,'cal/mol',6X,'cal/mol',7X,'cal/mol'/)
        ENDIF
C
      DO 180 I=1,NT
      TI=T(I)*tconv
      IF(DABS(TI-298.15D0*tconv).LT..02)TI=298.15D0*tconv
      CP=CPR(I)                      
      H=HHRT(I)                     
      S=SR(I)                      
      G=GHRT(I)                   
      IF (NTABLE.NE.1)GO TO 140  
      AR=1./T(I)
      ART=1.                   
      GO TO 150               
140   AR=RUSE(NTABLE)
      ART=AR*TI
      CP=CP*AR                    
      H=H*ART                  
      S=S*AR                    
      G=G*ART                
      AR=AR*tconv
C
150   HH=H-term*AR 
      GH=G+term*AR 
      HH29= H-H298*AR 
      GH29= G+H298*AR 
      z=1.d0
      if (eng .AND. NTABLE.EQ.2) z=1.d0/wt
      if (hasind) then
         IF (asindt.ne.0.) then
            WRITE (6,VFM) TI,CP*z,hh29*z,s*z,gh29*z,h*z,g*z
         else
            WRITE (6,VFM) TI,CP*z,hh*z,s*z,gh*z,h*z,g*z
         endif
      else
         WRITE (6,vfm) TI,cp*z,s*z,h*z,g*z
      endif
180   CONTINUE                         
      WRITE (6,185)
185   FORMAT (/////)
      if ( .not.mfig ) goto 200
190   CONTINUE
200   RETURN
      END
c
      BLOCK DATA                                                        
C 
      CHARACTER*4 BLANK,DATE,EFAZ,FAZ,FORMLA
      CHARACTER*4 NAME,SYMBOL
      COMMON /CHAR4/ BLANK,DATE(2),EFAZ(100),FAZ,
     1 FORMLA(2,5),NAME(4,9),SYMBOL(2,100)
C 
      DOUBLE PRECISION asindt,COEF,CPR,GHRT,htform,enth29,
     1 HHRT,R,RR,tconv,Reng,SR,T,tcoef,term,z,wt,WORD,TTRANS
      COMMON /REAL8/ asindt,COEF(10,20),CPR(500),
     1 GHRT(500),htform,enth29,HHRT(500),R,RR,tconv,Reng,
     2 SR(500),T(500),tcoef(2,20),term,z,wt,WORD(4),TTRANS(6)
C 
      COMMON /REAL4/ EX(8,20),sel(5),sels(5)
C 
      COMMON /INTGR/ IC80,itr,JF(5),
     1 numexp(20),NEL,NKIND,NKINDS,
     2 NMAT(100),NMLA(100),NOATMS,NT,NTMP,NFZ,INA,NNA
C 
      LOGICAL hasind,refel,TOUT,mfig,eng
      COMMON /LOGCL/ hasind,refel,TOUT(3),mfig,eng
C 
C    CONSTANTS FROM THE 1986 CODATA RECOMMENDED VALUES OF THE FUND.
C    PHYSICAL CONSTANTS; J OF RES NAT BUR STDS; COHEN AND TAYLOR;
C    VOL 92, P 85, 1987.
C
      DATA SYMBOL/  'E',' ','H',' ','D',' ','H','E','L','I','B','E','B',
     1  ' ','C',' ','N',' ','O',' ','F',' ','N','E','N','A','M','G','A',
     2  'L','S','I','P',' ','S',' ','C','L','A','R','K',' ','C','A','S',
     3  'C','T','I','V',' ','C','R','M','N','F','E','C','O','N','I','C',
     4  'U','Z','N','G','A','G','E','A','S','S','E','B','R','K','R','R',
     5  'B','S','R','Y',' ','Z','R','N','B','M','O','T','C','R','U','R',
     6  'H','P','D','A','G','C','D','I','N','S','N','S','B','T','E','I',
     7  ' ','X','E','C','S','B','A','L','A','C','E','P','R','N','D','P',
     8  'M','S','M','E','U','G','D','T','B','D','Y','H','O','E','R','T',
     9  'M','Y','B','L','U','H','F','T','A','W',' ','R','E','O','S','I',
     $  'R','P','T','A','U','H','G','T','L','P','B','B','I','P','O','A',
     $  'T','R','N','F','R','R','A','A','C','T','H','P','A','U',' ','N',
     $  'P','P','U','A','M','C','M','B','K','C','F'/                    
C 
      DATA EFAZ/4*'G',4*'S',4*'G',6*'S',2*'G',12*'S','L',3*'S','S','G', 
     1 17*'S','G',25*'S','L',5*'S','G',12*'S'/, BLANK/'    '/           
C 
      DATA NMAT/0,1,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20, 
     1 21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,     
     2 41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,     
     3 61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,     
     4 81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98/           
C 
      DATA NMLA/ 1,2,2,5*1,3*2,7*1,2,17*1,2,17*1,2,45*1/                
      END

      BLOCKDATA 
C***********************************************************************
C FUNDAMENTAL CONSTANTS FROM:  COHEN,E.RICHARD & TAYLOR,BARRY N.,
C THE 1986 CODATA RECOMMENDED VALUES OF THE FUNDAMENTAL PHYSICAL
C CONSTANTS, J.PHYS.CHEM.REF.DATA, VOL.17, NO.4, 1988, PP 1795-1803.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C
      DATA Rr/8314.51D0/,Pi/3.14159265D0/,Avgdr/6.0221367D0/,
     &     Boltz/1.380658D0/
C ATOMIC SYMBOLS
      DATA Symbol/'H ','D ','HE','LI','BE','B ','C ','N ','O ','F ',
     &     'NE','NA','MG','AL','SI','P ','S ','CL','AR','K ','CA','SC',
     &     'TI','V ','CR','MN','FE','CO','NI','CU','ZN','GA','GE','AS',
     &     'SE','BR','KR','RB','SR','Y ','ZR','NB','MO','TC','RU','RH',
     &     'PD','AG','CD','IN','SN','SB','TE','I ','XE','CS','BA','LA',
     &     'CE','PR','ND','PM','SM','EU','GD','TB','DY','HO','ER','TM',
     &     'YB','LU','HF','TA','W ','RE','OS','IR','PT','AU','HG','TL',
     &     'PB','BI','PO','AT','RN','FR','RA','AC','TH','PA','U ','NP',
     &     'PU','AM','CM','BK','CF','ES','UA'/  ! added undissociated ammonia
C
C  ATOMIC WEIGHTS - Coplen,T.B., Atomic Weights of the Elements 1999. 
C     J.Phys.Chem.Ref.Data, vol.30, no.3, 2001, pp.701-712.
C
      DATA atmwt/               1.00794D0,2.014102D0,4.002602D0,6.941D0,
     1 9.012182D0,10.811D0,12.0107D0,14.0067D0,15.9994D0,18.9984032D0,
     2 20.1797D0,22.989770D0,24.305D0,26.981538D0,28.0855D0,30.973761D0,
     3 32.065D0,35.453D0,39.948D0,39.0983D0,40.078D0,44.95591D0,
     4 47.867D0, 50.9415D0,51.9961D0,54.938049D0,
     5 55.845D0,58.933200D0,58.6934D0,63.546D0,65.39D0,69.723D0,72.64D0,
     6 74.92160D0,78.96D0,79.904D0,83.80D0,85.4678D0,87.62D0,88.90585D0,
     7 91.224D0,92.90638D0,95.94D0,97.9072D0,101.07D0,102.9055D0,
     $ 106.42D0,
     8 107.8682D0,112.411D0,114.818D0,118.710D0, 121.760D0,127.6D0,
     9 126.90447D0,131.293D0,132.90545D0,137.327D0,138.9055D0,140.116D0,
     $ 140.90765D0,144.9127D0,145.D0,150.36D0,151.964D0,157.25D0,
     $ 158.92534D0,
     $ 162.50D0,164.93032D0,167.259D0,168.93421D0,173.04D0,174.967D0,
     $ 178.49D0,180.9479D0,183.84D0,186.207D0,190.23D0,192.217D0,
     $ 195.078D0,196.96655D0,200.59D0,204.3833D0,207.2D0,208.98038D0,
     $ 208.9824D0, 209.9871D0,
     $ 222.0176D0,223.0197D0,226.0254D0,227.0278D0,232.0381D0,
     $ 231.03588D0,238.02891D0,237.0482D0,244.0642D0,243.0614D0,
     $ 247.0703D0,247.0703D0,251.0587D0,252.083D0,17.03056D0/ ! added undissociated ammonia
C ATOMIC VALENCES
      DATA Valnce/1.,1.,0.,1.,2.,3.,4.,0., - 2., - 1.,0.,1.,2.,3.,4.,5.,
     &     4., - 1.,0.,1.,2.,3.,4.,5.,3.,2.,3.,2.,2.,2.,2.,3.,4.,3.,4.,
     &     - 1.,0.,1.,2.,3.,4.,5.,6.,7.,3.,3.,2.,1.,2.,3.,4.,3.,4.,
     &     - 1.,0.,1.,2.,3.,3.,3.,3.,3.,3.,3.,3.,3.,3.,3.,3.,3.,3.,3.,
     &     4.,5.,6.,7.,4.,4.,4.,3.,2.,1.,2.,3.,2., - 1.,0.,1.,2.,3.,4.,
     &     5.,6.,5.,4.,3.,3.,3.,3.,3.,0./ ! added undissociated ammonia
C INFORMATION USED IN VARIABLE OUTPUT FORMAT
      DATA Fmt/'(1X',',A15',',','F9.','0,','F9.','0,','F9.','0,','F9.',
     &     '0,','F9.','0,','F9.','0,','F9.','0,','F9.','0,','F9.','0,',
     &     'F9.','0,','F9.','0,','F9.','0,','F9.','0',')'/
      END
C////////////////////////////////////////////////////////////////////////
      subroutine SetInpLine(Ninp, Line)
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
      
      CHARACTER*132 Line
      Integer Ninp, i_cet
      
      InpLines(Ninp) = Line
c...      DO i_cet = 132,len_trim(Line), - 1
c...          InpLines(Ninp)(i_cet:i_cet) = ' '
c...      ENDDO
      if(Ninp .gt. NLinesSet) NLinesSet = Ninp
c...      print *,'set line ',Ninp,' to ',Line

      return
      end
C////////////////////////////////////////////////////////////////////////
      subroutine py_cea( prefix, myfile, make_out_files, read_data )
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'

C LOCAL VARIABLES
      CHARACTER*15 ensert(20)
      CHARACTER*200 infile,ofile,myfile
      CHARACTER*196 prefix
      LOGICAL caseok,ex,readok
      INTEGER i,inc,iof,j,ln,n, make_out_files, read_data,ln2,ld
c///      INTEGER INDEX
      REAL*8 xi,xln
      REAL*8 DLOG
c///      SAVE caseok,ensert,ex,i,inc,infile,iof,j,ln,n,ofile,prefix,readok,
c///     &  xi,xln
C
      makeio = make_out_files
      read_d = read_data
c///      print *,'prefix=','"'//prefix//'"'
c///      print *,'myfile=','"'//myfile//'"'
      
      NLine = -1
      if(NLinesSet .gt. 0)NLine = 0
      
C///      WRITE (*,99001)
c///      READ (*,99002) prefix

      ln = INDEX(prefix,' ') - 1
      ln2 = INDEX(myfile,' ') - 1
      ld  = INDEX(myfile,'.') - 1
      infile = prefix(1:ln)//myfile(1:ln2)
      ofile = prefix(1:ln)//myfile(1:ld)//'.out'
      Pfile = prefix(1:ln)//myfile(1:ld)//'.plt'
      INQUIRE (FILE=infile,EXIST=ex)
      IF ( .NOT.ex ) THEN
        if(makeio.ne.0)PRINT *,infile,' DOES NOT EXIST'
        GOTO 400
      ENDIF
      OPEN (7,FILE=infile,STATUS='old',FORM='formatted')
      
      if(makeio.ne.0)OPEN (8,FILE=ofile,STATUS='unknown',
     $               FORM='formatted')
c///      OPEN (IOSCH,STATUS='scratch',FORM='unformatted')
      OPEN (IOSCH,STATUS='unknown',FORM='unformatted',
     $   FILE=prefix(1:ln)//'temp.scr')
      if( read_d .eq. 1 )then
       OPEN (IOTHM,FILE=prefix(1:ln)//'thermo.lib',FORM='unformatted')
       OPEN (IOTRN,FILE=prefix(1:ln)//'trans.lib',FORM='unformatted')
      endif
      if(makeio.ne.0)WRITE (8,99006)
      if(makeio.ne.0)WRITE (8,99007)
      if(makeio.ne.0)WRITE (8,99006)
      readok = .TRUE.
      Newr = .FALSE.
 100  Iplt = 0
      Nplt = 0
      CALL INPUT(readok,caseok,ensert)
      IF ( caseok.AND.readok ) THEN
        DO iof = 1,Nof
          IF ( Oxf(iof).EQ.0..AND.B0p(1,1).NE.0. ) THEN
            DO i = 1,Nlm
              IF ( B0p(i,1).EQ.0..OR.B0p(i,2).EQ.0. ) THEN
                if(makeio.ne.0)WRITE (8,99008)
                GOTO 200
              ENDIF
            ENDDO
          ENDIF
        ENDDO
        IF ( Ions ) THEN
          IF ( Elmt(Nlm).NE.'E' ) THEN
            Nlm = Nlm + 1
            Elmt(Nlm) = 'E'
            B0p(Nlm,1) = 0.
            B0p(Nlm,2) = 0.
          ENDIF
        ELSEIF ( Elmt(Nlm).EQ.'E' ) THEN
          Nlm = Nlm - 1
        ENDIF
        DO n = 1,Nreac
          Jray(n) = 0
        ENDDO
        CALL SEARCH
        IF ( Ngc.EQ.0 ) GOTO 300
        Newr = .FALSE.
        IF ( Trnspt ) CALL READTR
C INITIAL ESTIMATES
        Npr = 0
        Gonly = .TRUE.
        Enn = .1D0
        Ennl = -2.3025851
        Sumn = Enn
        xi = Ng
        IF ( xi.EQ.0. ) xi = 1.
        xi = Enn/xi
        xln = DLOG(xi)
        DO inc = 1,Nc
          j = Ng + inc
          En(j,1) = 0.D0
          Enln(j) = 0.D0
        ENDDO
        DO j = 1,Ng
          En(j,1) = xi
          Enln(j) = xln
        ENDDO
        IF ( Nc.NE.0.AND.Nsert.NE.0 ) THEN
          DO i = 1,Nsert
            DO j = Ngc,Ngp1, - 1
              IF ( Prod(j).EQ.ensert(i) ) THEN
                Npr = Npr + 1
                Jcond(Npr) = j
                IF ( (.NOT.Short_bn) .and. (makeio.ne.0))WRITE(8,99003)
     $                                                 Prod(j)
                GOTO 120
              ENDIF
            ENDDO
            if(makeio.ne.0)WRITE (8,99004) ensert(i)
 120      ENDDO
        ENDIF
        IF ( Rkt ) THEN
          CALL ROCKET
        ELSEIF ( Tp.OR.Hp.OR.Sp ) THEN
          CALL THERMP
        ELSEIF ( Detn ) THEN
          CALL DETON
        ELSEIF ( Shock ) THEN
          CALL SHCK
        ENDIF
        IF ( Nplt.GT.0 ) THEN
          OPEN (IOPLT,FILE=Pfile,FORM='formatted')
          DO i = 1,Iplt
            WRITE (IOPLT,99005) (Pltout(i,j),j=1,Nplt)
          ENDDO
        ENDIF
      ENDIF
 200  IF ( readok ) GOTO 100
 300  CLOSE (7)
      if(makeio.ne.0)CLOSE (8)
      CLOSE (IOSCH)
      if( read_d .eq. 1 )then
        CLOSE (IOTHM)
        CLOSE (IOTRN)
      endif
      CLOSE (IOPLT)
 400  RETURN
C///99001 FORMAT (//' ENTER PREFIX ONLY FOR INPUT FILE, SUFFIX SHOULD BE',
C///     &        ' .inp'/
C///     &        '   THE OUTPUT FILES FOR LISTING AND PLOTTING WILL HAVE',/
C///     &       ' THE SAME PREFIX WITH SUFFIXES .out AND .plt RESPECTIVELY'
C///     &       //)

99002 FORMAT (a)
99003 FORMAT (1X,A16,'INSERTED')
99004 FORMAT (/' WARNING!!!',A16,'NOT FOUND FOR INSERTION')
99005 FORMAT (1x,1p,20E12.4)
99006 FORMAT (/' ***************************************************',
     &        '****************************')
99007 FORMAT (/,9x,'NASA-GLENN CHEMICAL EQUILIBRIUM PROGRAM CEA,',
     &        ' OCTOBER 18, 2002',/19x,'BY  BONNIE MCBRIDE',
     &        ' AND SANFORD GORDON',/5x,
     &        ' REFS: NASA RP-1311, PART I, 1994',
     &        ' AND NASA RP-1311, PART II, 1996')
99008 FORMAT (/,' OXIDANT NOT PERMITTED WHEN SPECIFYING 100% FUEL(main)'
     &        )
      END
      SUBROUTINE CPHS
C***********************************************************************
C CALCULATES THERMODYNAMIC PROPERTIES FOR INDIVIDUAL SPECIES
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      REAL*8 cx(7),hcx(7),scx(7)
      INTEGER i,ij,j,jj,k
      SAVE i,ij,j,jj,k,scx
C
      DATA cx/2*0.,1.D0,.5D0,.6666666666666667D0,.75D0,.8D0/
      DATA hcx(3)/1.D0/
      k = 1
      IF ( Tt.GT.Tg(2) ) k = 2
      IF ( Tt.GT.Tg(3) ) k = 3
      cx(2) = 1.D0/Tt
      cx(1) = cx(2)**2
      scx(3) = Tln
      scx(2) = -cx(2)
      hcx(2) = Tln*cx(2)
      hcx(1) = -cx(1)
      scx(1) = hcx(1)*.5D0
      DO i = 4,7
        hcx(i) = cx(i)*Tt
        scx(i) = cx(i-1)*Tt
      ENDDO
      DO j = 1,Ng
        H0(j) = 0.D0
        S(j) = 0.D0
      ENDDO
      DO i = 7,4, - 1
        DO j = 1,Ng
          S(j) = (S(j)+Coef(j,i,k))*scx(i)
          H0(j) = (H0(j)+Coef(j,i,k))*hcx(i)
        ENDDO
      ENDDO
      DO i = 1,3
        DO j = 1,Ng
          S(j) = S(j) + Coef(j,i,k)*scx(i)
          H0(j) = H0(j) + Coef(j,i,k)*hcx(i)
        ENDDO
      ENDDO
      DO j = 1,Ng
        S(j) = S(j) + Coef(j,9,k)
        H0(j) = H0(j) + Coef(j,8,k)*cx(2)
      ENDDO
      IF ( .NOT.Tp.OR.Convg ) THEN
        DO j = 1,Ng
          Cp(j) = 0.D0
        ENDDO
        DO i = 7,4, - 1
          DO j = 1,Ng
            Cp(j) = (Cp(j)+Coef(j,i,k))*Tt
          ENDDO
        ENDDO
        DO i = 1,3
          DO j = 1,Ng
            Cp(j) = Cp(j) + Coef(j,i,k)*cx(i)
          ENDDO
        ENDDO
      ENDIF
      IF ( Npr.NE.0.AND.k.NE.3.AND.Ng.NE.Ngc ) THEN
        DO ij = 1,Npr
          j = Jcond(ij)
          jj = Jcond(ij) - Ng
          Cp(j) = 0.D0
          H0(j) = 0.D0
          S(j) = 0.D0
          DO i = 7,4, - 1
            S(j) = (S(j)+Cft(jj,i))*scx(i)
            H0(j) = (H0(j)+Cft(jj,i))*hcx(i)
            Cp(j) = (Cp(j)+Cft(jj,i))*Tt
          ENDDO
          DO i = 1,3
            S(j) = S(j) + Cft(jj,i)*scx(i)
            H0(j) = H0(j) + Cft(jj,i)*hcx(i)
            Cp(j) = Cp(j) + Cft(jj,i)*cx(i)
          ENDDO
          S(j) = S(j) + Cft(jj,9)
          H0(j) = H0(j) + Cft(jj,8)*cx(2)
        ENDDO
      ENDIF
      GOTO 99999
      ENTRY ALLCON
      DO jj = 1,Nc
        j = jj + Ng
        Cp(j) = 0.D0
        H0(j) = 0.D0
        S(j) = 0.D0
        DO i = 7,4, - 1
          S(j) = (S(j)+Cft(jj,i))*scx(i)
          H0(j) = (H0(j)+Cft(jj,i))*hcx(i)
          Cp(j) = (Cp(j)+Cft(jj,i))*Tt
        ENDDO
        DO i = 1,3
          S(j) = S(j) + Cft(jj,i)*scx(i)
          H0(j) = H0(j) + Cft(jj,i)*hcx(i)
          Cp(j) = Cp(j) + Cft(jj,i)*cx(i)
        ENDDO
        S(j) = S(j) + Cft(jj,9)
        H0(j) = H0(j) + Cft(jj,8)*cx(2)
      ENDDO
99999 END
      SUBROUTINE DETON
C***********************************************************************
C CHAPMAN-JOUGUET DETONATIONS.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      CHARACTER*15 fdv,fg1,fh1,fhs1,fm1,fmm1,fpp1,frr1,ft1,ftt1
      CHARACTER*3 unit
      INTEGER i,ii,iof,itr,j,mdv,mgam,mh,mmach,mp,mson,mt,mxx(8)
c///      INTEGER INDEX
      REAL*8 a11,a12,a21,a22,alam,alfa,amm,b1,b2,cpl(NCOL),d,gam,
     &       gm1(NCOL),h1(NCOL),p1,pp1,pub(NCOL),rk,rr1,rrho(NCOL),t1,
     &       tem,tt1,tub(NCOL),ud,x1,x2
      SAVE a11,a12,a21,a22,alam,alfa,amm,b1,b2,cpl,d,gam,gm1,h1,i,ii,
     &  iof,itr,j,mdv,mgam,mh,mmach,mp,mson,mt,mxx,p1,pp1,pub,rk,rr1,
     &  rrho,t1,tem,tt1,tub,ud,unit,x1,x2
C
      EQUIVALENCE (mxx(1),mp)
      EQUIVALENCE (mxx(2),mt)
      EQUIVALENCE (mxx(3),mgam)
      EQUIVALENCE (mxx(4),mh)
      EQUIVALENCE (mxx(5),mdv)
      EQUIVALENCE (mxx(6),mson)
      EQUIVALENCE (mxx(7),mmach)
      DATA ft1/'T1, K'/,fh1/'H1, CAL/G'/,fhs1/'H1, KJ/KG'/,
     &     fm1/'M1, (1/n) '/,fg1/'GAMMA1'/,fpp1/'P/P1'/,ftt1/'T/T1'/,
     &     fmm1/'M/M1'/,frr1/'RHO/RHO1'/,fdv/'DET VEL,M/SEC'/
      iof = 0
      Eql = .TRUE.
      IF ( T(1).EQ.0. ) THEN
        T(1) = Rtemp(1)
        Nt = 1
      ENDIF
 100  Tt = T(1)
      iof = iof + 1
      Oxfl = Oxf(iof)
      CALL NEWOF
C BEGIN T LOOP.
      DO It = 1,Nt
        t1 = T(It)
C BEGIN P LOOP.
        DO Ip = 1,Np
          p1 = P(Ip)
          Tt = t1
          Pp = p1
          CALL HCALC
          IF ( Tt.EQ.0. ) RETURN
          IF ( Detdbg ) CALL OUT1
          h1(Npt) = Hsub0*R
          tub(Npt) = t1
          pub(Npt) = p1
          cpl(Npt) = Cpmix*R
          itr = 0
          Tt = 3800.
          pp1 = 15.
          Pp = pp1*p1
C CALCULATE ENTHALPY FOR INITIAL ESTIMATE OF T2(TT AFTER EQLBRM)
          Hsub0 = h1(Npt)/R + .75*t1*pp1/Wmix
          Tp = .FALSE.
          Hp = .TRUE.
          CALL EQLBRM
          Hsub0 = h1(Npt)/R
          Hp = .FALSE.
          IF ( Tt.NE.0. ) THEN
            gam = Gammas(Npt)
            tt1 = Tt/t1
            ii = 0
            tem = tt1 - .75*pp1/(Cpr(Npt)*Wmix)
            amm = Wm(Npt)/Wmix
            IF ( Detdbg .and. (makeio.ne.0) ) WRITE (8,99001) Tt
C LOOP FOR IMPROVING T2/T1 AND P2/P1 INITIAL ESTIMATE.
            DO ii = 1,3
              alfa = amm/tt1
              pp1 = (1.+gam)*(1.+(1.-4.*gam*alfa/(1.+gam)**2)**.5)
     &              /(2.*gam*alfa)
              rk = pp1*alfa
              tt1 = tem + .5*pp1*gam*(rk*rk-1.)/(Wmix*Cpr(Npt)*rk)
              IF ( Detdbg .and. (makeio.ne.0) ) WRITE (8,99002) 
     $                                          ii,pp1,tt1
            ENDDO
            Tp = .TRUE.
            Tt = t1*tt1
            rr1 = pp1*amm/tt1
C BEGIN MAIN ITERATION LOOP.
 110        itr = itr + 1
            Pp = p1*pp1
            CALL EQLBRM
            IF ( Npt.EQ.0 ) GOTO 200
            IF ( Tt.NE.0. ) THEN
              gam = Gammas(Npt)
              amm = Wm(Npt)/Wmix
              rr1 = pp1*amm/tt1
              a11 = 1./pp1 + gam*rr1*Dlvpt(Npt)
              a12 = gam*rr1*Dlvtp(Npt)
              a21 = .5*gam*(rr1**2-1.-Dlvpt(Npt)*(1.+rr1**2))
     &              + Dlvtp(Npt) - 1.
              a22 = -.5*gam*Dlvtp(Npt)*(rr1**2+1.) - Wm(Npt)*Cpr(Npt)
              b1 = 1./pp1 - 1. + gam*(rr1-1.)
              b2 = Wm(Npt)*(Hsum(Npt)-h1(Npt)/R)
     &             /Tt - .5*gam*(rr1*rr1-1.)
              d = a11*a22 - a12*a21
              x1 = (a22*b1-a12*b2)/d
              x2 = (a11*b2-a21*b1)/d
              alam = 1.
              tem = x1
              IF ( tem.LT.0. ) tem = -tem
              IF ( x2.GT.tem ) tem = x2
              IF ( -x2.GT.tem ) tem = -x2
              IF ( tem.GT.0.4054652 ) alam = .4054652/tem
              pp1 = pp1*EXP(x1*alam)
              tt1 = tt1*EXP(x2*alam)
              Tt = t1*tt1
              ud = rr1*(Rr*gam*Tt/Wm(Npt))**.5
              IF ( Detdbg .and. (makeio.ne.0) ) 
     &                 WRITE (8,99003) itr,pp1,tt1,rr1,x1,x2
C CONVERGENCE TEST
              IF ( itr.LT.8.AND.tem.GT.0.5E-04 ) GOTO 110
              IF ( itr.LT.8 ) THEN
                rrho(Npt) = rr1
                IF ( cpl(Npt).EQ.0. ) THEN
                  gm1(Npt) = 0.
                  Vmoc(Npt) = 0.
                ELSE
                  gm1(Npt) = cpl(Npt)/(cpl(Npt)-R/Wmix)
                  Vmoc(Npt) = ud/(Rr*gm1(Npt)*t1/Wmix)**.5
                ENDIF
              ELSE
                if(makeio.ne.0)WRITE (8,99004)
                Npt = Npt - 1
                Tt = 0.
              ENDIF
              IF ( Trnspt ) CALL TRANP
              Isv = 0
              IF ( Ip.NE.Np.OR.It.NE.Nt.AND.Tt.NE.0. ) THEN
                Isv = Npt
                IF ( Npt.NE.NCOL ) GOTO 120
              ENDIF
            ENDIF
C OUTPUT
            if(makeio.ne.0)WRITE (8,99005)
            CALL OUT1
C SET MXX ARRAY FOR PLOTTING PARAMETERS
            DO i = 1,8
              mxx(i) = 0
            ENDDO
            DO i = 1,Nplt
              IF ( INDEX(Pltvar(i)(2:),'1').NE.0 ) THEN
                IF ( Pltvar(i)(:3).EQ.'son' ) THEN
                  mson = i
                ELSEIF ( Pltvar(i)(:3).EQ.'gam' ) THEN
                  mgam = i
                ELSEIF ( Pltvar(i)(:1).EQ.'h' ) THEN
                  mh = i
                ELSEIF ( Pltvar(i)(:1).EQ.'t' ) THEN
                  mt = i
                ELSEIF ( Pltvar(i)(:1).EQ.'p' ) THEN
                  mp = i
                ENDIF
              ELSEIF ( INDEX(Pltvar(i),'vel').NE.0 ) THEN
                mdv = i
              ELSEIF ( INDEX(Pltvar(i),'mach').NE.0 ) THEN
                mmach = i
              ENDIF
            ENDDO
            if(makeio.ne.0)WRITE (8,99006)
            Fmt(4) = '13'
            Fmt(5) = ' '
            Fmt(7) = '4,'
            DO i = 1,Npt
              IF ( Siunit ) THEN
                V(i) = pub(i)
                unit = 'BAR'
              ELSE
                V(i) = pub(i)/1.01325D0
                unit = 'ATM'
              ENDIF
              IF ( mp.GT.0 ) Pltout(i+Iplt,mp) = V(i)
            ENDDO
            if(makeio.ne.0)
     &          WRITE (8,Fmt) 'P1, '//unit//'        ',(V(j),j=1,Npt)
            Fmt(7) = '2,'
            if(makeio.ne.0)WRITE (8,Fmt) ft1,(tub(j),j=1,Npt)
            IF ( (.NOT.Siunit) .and. (makeio.ne.0)) 
     &                   WRITE (8,Fmt) fh1,(h1(j),j=1,Npt)
            IF ( Siunit .and. (makeio.ne.0))
     $                  WRITE (8,Fmt) fhs1,(h1(j),j=1,Npt)
            DO i = 1,Npt
              V(i) = Wmix
              Sonvel(i) = (Rr*gm1(i)*tub(i)/Wmix)**.5
            ENDDO
            Fmt(7) = '3,'
            if(makeio.ne.0)WRITE (8,Fmt) fm1,(V(j),j=1,Npt)
            Fmt(7) = '4,'
            if(makeio.ne.0)WRITE (8,Fmt) fg1,(gm1(j),j=1,Npt)
            Fmt(7) = '1,'
            if(makeio.ne.0)WRITE(8,Fmt)'SON VEL1,M/SEC ',
     $                               (Sonvel(j),j=1,Npt)
            IF ( Nplt.GT.0 ) THEN
              DO i = 1,Npt
                IF ( mt.GT.0 ) Pltout(i+Iplt,mt) = tub(i)
                IF ( mgam.GT.0 ) Pltout(i+Iplt,mgam) = gm1(i)
                IF ( mh.GT.0 ) Pltout(i+Iplt,mh) = h1(i)
                IF ( mson.GT.0 ) Pltout(i+Iplt,mson) = Sonvel(i)
              ENDDO
            ENDIF
            if(makeio.ne.0)WRITE (8,99007)
            Fmt(4) = Fmt(6)
            CALL OUT2
            IF ( Trnspt ) CALL OUT4
            if(makeio.ne.0)WRITE (8,99008)
            Fmt(7) = '3,'
            DO i = 1,Npt
              V(i) = Ppp(i)/pub(i)
              Pcp(i) = Ttt(i)/tub(i)
              Sonvel(i) = Sonvel(i)*rrho(i)
              IF ( mmach.GT.0 ) Pltout(i+Iplt,mmach) = Vmoc(i)
              IF ( mdv.GT.0 ) Pltout(i+Iplt,mdv) = Sonvel(i)
            ENDDO
            if(makeio.ne.0)WRITE (8,Fmt) fpp1,(V(j),j=1,Npt)
            if(makeio.ne.0)WRITE (8,Fmt) ftt1,(Pcp(j),j=1,Npt)
            DO i = 1,Npt
              V(i) = Wm(i)/Wmix
            ENDDO
            Fmt(7) = '4,'
            if(makeio.ne.0)WRITE (8,Fmt) fmm1,(V(j),j=1,Npt)
            if(makeio.ne.0)WRITE (8,Fmt) frr1,(rrho(j),j=1,Npt)
            if(makeio.ne.0)WRITE (8,Fmt) 'DET MACH NUMBER',
     $                                    (Vmoc(j),j=1,Npt)
            Fmt(7) = '1,'
            if(makeio.ne.0)WRITE (8,Fmt) fdv,(Sonvel(j),j=1,Npt)
            Eql = .TRUE.
            CALL OUT3
            Iplt = MIN(Iplt+Npt,500)
            IF ( Isv.EQ.0.AND.iof.EQ.Nof ) GOTO 200
            IF ( Np.EQ.1.AND.Nt.EQ.1 ) GOTO 100
            if(makeio.ne.0)WRITE (8,99009)
            Npt = 0
 120        Npt = Npt + 1
            IF ( Isv.EQ.1 ) Isv = -1
            CALL SETEN
          ENDIF
        ENDDO
      ENDDO
      Iplt = MIN(Iplt+Npt,500)
      IF ( iof.LT.Nof ) GOTO 100
 200  Tp = .FALSE.
      RETURN
99001 FORMAT (/' T EST.=',F8.2/11X,'P/P1',17X,'T/T1')
99002 FORMAT (I5,2E20.8)
99003 FORMAT (/' ITER =',I2,5X,'P/P1 =',E15.8,/7X,'T/T1 =',E15.8,5X,
     &        'RHO/RHO1 =',E15.8,/7X,'DEL LN P/P1 =',E15.8,5X,
     &        'DEL LN T/T1 =',E15.8)
99004 FORMAT (/
     &        ' CONSERVATION EQNS NOT SATISFIED IN 8 ITERATIONS (DETON)'
     &        )
99005 FORMAT (//,21X,'DETONATION PROPERTIES OF AN IDEAL REACTING GAS')
99006 FORMAT (/' UNBURNED GAS'/)
99007 FORMAT (/' BURNED GAS'/)
99008 FORMAT (/' DETONATION PARAMETERS'/)
99009 FORMAT (///)
      END
      SUBROUTINE EFMT(Fone,Aa,Vx)
C***********************************************************************
C WRITE OUTPUT RECORD WITH NUMERICAL VALUES IN SPECIAL EXPONENT FORM.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C DUMMY ARGUMENTS
      CHARACTER*15 Aa
      CHARACTER*4 Fone
      REAL*8 Vx(MAXMAT)
C LOCAL VARIABLES
      CHARACTER*4 fmix(5),frmt(8)
      INTEGER i,j,j1,ne(NCOL)
      INTEGER IABS
      REAL*8 ee,fe,w(NCOL)
      REAL*8 DABS,DLOG10
      SAVE ee,fe,i,j,j1,ne,w
C
      DATA frmt/'(1H ',',A15',',','9X,','13(F','6.4,','I2,','1X))'/
      DATA fmix/'I3,','6.4,','I2,','9X,','5.3,'/
      frmt(6) = fmix(2)
      frmt(7) = fmix(3)
      j1 = 1
      frmt(4) = '1x,'
      IF ( Fone.EQ.'9X,' ) THEN
        j1 = 2
        frmt(4) = fmix(4)
      ENDIF
      DO i = j1,Npt
        IF ( Vx(i).NE.0. ) THEN
          ee = DLOG10(DABS(Vx(i)))
          ne(i) = ee
          fe = ne(i)
          IF ( ee.LT.-.2181E-05.AND.fe.NE.ee ) ne(i) = ne(i) - 1
          IF ( IABS(ne(i)).GE.10 ) THEN
            frmt(6) = fmix(5)
            frmt(7) = fmix(1)
          ENDIF
          w(i) = Vx(i)/10.**ne(i)
        ELSE
          w(i) = 0.
          ne(i) = 0.
        ENDIF
      ENDDO
      if(makeio.ne.0)WRITE (8,frmt) Aa,(w(j),ne(j),j=j1,Npt)
      END
      SUBROUTINE EQLBRM
C***********************************************************************
C CALCULATE EQUILIBRIUM COMPOSITION AND PROPERTIES.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      CHARACTER*12 ae,cmp(MAXEL)
      CHARACTER*16 amb
      LOGICAL cpcalc,i2many,newcom,reduce
      INTEGER i,il,ilamb,ilamb1,inc,ipr,iq2,iter,ix,ixsing,iz,j,ja,jb,
     &        jbx,jc,jcondi,jcons,jdelg,jex,jj,jkg,jneg,jsw,k,kc,kg,kk,
     &        kmat,kneg,l,lc,lcs(MAXEL),le,lelim,lk,ll,lncvg,ls,lsing,
     &        lz,maxitn,ncvg,njc,nn,numb
      INTEGER IABS
      REAL*8 aa,ambda,ambda1,bigen,bigneg,delg,dlnt,dpie,ensol,esize,
     &       gap,gasfrc,pie,pisave(MAXMAT-2),siz9,sizeg,smalno,smnol,
     &       sum,sum1,szgj,tem,tmelt,tsize,ween,xi,xln,xsize,xx(MAXMAT)
      REAL*8 DABS,DEXP,DLOG,DMAX1
      SAVE aa,ae,amb,ambda,ambda1,bigen,bigneg,cmp,cpcalc,delg,dlnt,
     &  dpie,ensol,esize,gap,gasfrc,i,i2many,il,ilamb,ilamb1,inc,ipr,
     &  iq2,iter,ix,ixsing,iz,j,ja,jb,jbx,jc,jcondi,jcons,jdelg,jex,jj,
     &  jkg,jneg,jsw,k,kc,kg,kk,kmat,kneg,l,lc,lcs,le,lelim,lk,ll,lncvg,
     &  ls,lsing,lz,maxitn,ncvg,newcom,njc,nn,numb,pie,pisave,reduce,
     &  siz9,sizeg,sum,sum1,szgj,tem,tmelt,tsize,ween,xi,xln,xsize,xx
C
      DATA smalno/1.E-6/,smnol/ - 13.815511/
      ixsing = 0
      lsing = 0
      jsw = 0
      jdelg = 0
      maxitn = 50
      ncvg = 0
      lncvg = 3*Nlm
      reduce = .FALSE.
      siz9 = Size_bn - 9.2103404D0
      tsize = Size_bn
      xsize = Size_bn + 6.90775528D0
      IF ( Trace.NE.0. ) THEN
        maxitn = maxitn + Ngc/2
        xsize = -DLOG(Trace)
        IF ( xsize.LT.Size_bn ) xsize = Size_bn + .1
      ENDIF
      IF ( xsize.GT.80. ) xsize = 80.D0
      esize = MIN(80.D0,xsize+6.90775528D0)
      jcons = 0
      pie = 0.
      i2many = .FALSE.
      Pderiv = .FALSE.
      Convg = .FALSE.
      numb = 0
      cpcalc = .TRUE.
      IF ( Tp ) cpcalc = .FALSE.
      IF ( Tt.NE.0.D0 ) THEN
        IF ( Npr.EQ.0.OR.(Tt.NE.T(1).AND..NOT.Tp) ) GOTO 400
        k = 1
      ELSE
        Tt = 3800.D0
        IF ( Npr.EQ.0 ) GOTO 400
        k = 1
      ENDIF
 100  j = Jcond(k)
      jc = j - Ng
      kg = -Ifz(jc)
      DO i = 1,9
        kg = kg + 1
        kc = jc + kg
        IF ( Tt.LE.Temp(2,kc) ) THEN
          IF ( kg.NE.0 ) THEN
            Jcond(k) = j + kg
            En(j+kg,Npt) = En(j,Npt)
            En(j,Npt) = 0.
            IF((Prod(j).NE.Prod(j+kg)).AND.(.NOT.Short_bn) .and.
     $        (makeio.ne.0))
     &        WRITE (8,99023)  Prod(j),Prod(j+kg)
          ENDIF
          GOTO 300
        ELSEIF ( kc.GE.Nc.OR.Ifz(kc+1).LE.Ifz(kc) ) THEN
          GOTO 200
        ENDIF
      ENDDO
 200  IF ( .NOT.Tp ) THEN
        Tt = Temp(2,kc) - 10.D0
        k = 1
        GOTO 100
      ENDIF
      if(makeio.ne.0)WRITE (8,99028) Prod(j)
      En(j,Npt) = 0.D0
      Enln(j) = 0.D0
      Deln(j) = 0.D0
      DO i = k,Npr
        Jcond(i) = Jcond(i+1)
      ENDDO
      Npr = Npr - 1
 300  k = k + 1
      IF ( k.LE.Npr ) GOTO 100
 400  Tln = DLOG(Tt)
      IF ( Vol ) Pp = Rr*Enn*Tt/Vv
      CALL CPHS
      Tm = DLOG(Pp/Enn)
      le = Nlm
      IF ( Lsave.NE.0.AND.Nlm.NE.Lsave ) THEN
        tem = EXP(-tsize)
        DO i = Lsave + 1,Nlm
          DO j = 1,Ng
            IF ( A(i,j).NE.0. ) THEN
              En(j,Npt) = tem
              Enln(j) = -tsize
            ENDIF
          ENDDO
        ENDDO
      ENDIF
      ls = Nlm
      lelim = 0
      lz = ls
      IF ( Ions ) lz = ls - 1
      IF ( Npt.EQ.1.AND.(.NOT.Shock).AND.(.NOT.Short_bn) .and. 
     $   (makeio.ne.0))
     &           WRITE (8,99001)  (Elmt(i),i=1,Nlm)
      IF ( Debug(Npt) ) THEN
        DO i = 1,Nlm
          cmp(i) = Elmt(i)
        ENDDO
      ENDIF
C BEGIN ITERATION
 500  IF ( cpcalc ) THEN
        Cpsum = 0.D0
        DO j = 1,Ng
          Cpsum = Cpsum + En(j,Npt)*Cp(j)
        ENDDO
        IF ( Npr.NE.0 ) THEN
          DO k = 1,Npr
            j = Jcond(k)
            Cpsum = Cpsum + En(j,Npt)*Cp(j)
          ENDDO
          cpcalc = .FALSE.
        ENDIF
      ENDIF
      numb = numb + 1
      CALL MATRIX
      iq2 = Iq1 + 1
      IF ( Convg ) Imat = Imat - 1
      IF ( Debug(Npt) ) THEN
        IF ( .NOT.Convg ) THEN
          if(makeio.ne.0)WRITE (8,99004) numb
        ELSE
          IF ( (.NOT.Pderiv) .and. (makeio.ne.0)) WRITE (8,99002)
          IF ( Pderiv .and. (makeio.ne.0)) WRITE (8,99003)
        ENDIF
        kmat = Imat + 1
        DO i = 1,Imat
          if(makeio.ne.0)WRITE (8,99006) (G(i,k),k=1,kmat)
        ENDDO
      ENDIF
      Msing = 0
      CALL GAUSS
      IF ( Msing.EQ.0 ) THEN
        IF ( Debug(Npt) ) THEN
          if(makeio.ne.0)WRITE (8,99005) (cmp(k),k=1,le)
          if(makeio.ne.0)WRITE (8,99006) (X(i),i=1,Imat)
        ENDIF
        IF ( .NOT.Convg ) THEN
C OBTAIN CORRECTIONS TO THE ESTIMATES
          IF ( Vol ) X(iq2) = X(Iq1)
          IF ( Tp ) X(iq2) = 0.
          dlnt = X(iq2)
          sum = X(Iq1)
          IF ( Vol ) THEN
            X(Iq1) = 0.
            sum = -dlnt
          ENDIF
          DO j = 1,Ng
            IF ( lelim.NE.0 ) THEN
              Deln(j) = 0.
              DO i = lelim,ls
                IF ( A(i,j).NE.0. ) GOTO 520
              ENDDO
            ENDIF
            Deln(j) = -Mu(j) + H0(j)*dlnt + sum
            DO k = 1,Nlm
              Deln(j) = Deln(j) + A(k,j)*X(k)
            ENDDO
            IF ( pie.NE.0. ) Deln(j) = Deln(j) + A(ls,j)*pie
 520      ENDDO
          IF ( Npr.NE.0 ) THEN
            DO k = 1,Npr
              j = Jcond(k)
              kk = Nlm + k
              Deln(j) = X(kk)
            ENDDO
          ENDIF
C CALCULATE CONTROL FACTOR,AMBDA
          ambda = 1.D0
          ambda1 = 1.D0
          ilamb = 0
          ilamb1 = 0
          sum = DMAX1(DABS(X(Iq1)),DABS(dlnt))
          sum = sum*5.
          DO j = 1,Ng
            IF ( Deln(j).GT.0. ) THEN
              IF ( (Enln(j)-Ennl+Size_bn).LE.0. ) THEN
                sum1 = DABS(Deln(j)-X(Iq1))
                IF ( sum1.GE.siz9 ) THEN
                  sum1 = DABS(-9.2103404D0-Enln(j)+Ennl)/sum1
                  IF ( sum1.LT.ambda1 ) THEN
                    ambda1 = sum1
                    ilamb1 = j
                  ENDIF
                ENDIF
              ELSEIF ( Deln(j).GT.sum ) THEN
                sum = Deln(j)
                ilamb = j
              ENDIF
            ENDIF
          ENDDO
          IF ( sum.GT.2.D0 ) ambda = 2.D0/sum
          IF ( ambda1.LE.ambda ) THEN
            ambda = ambda1
            ilamb = ilamb1
          ENDIF
          IF ( Debug(Npt) ) THEN
C INTERMEDIATE OUTPUT
            if(makeio.ne.0)WRITE (8,99011) Tt,Enn,Ennl,Pp,Tm,ambda
            IF ( ambda.NE.1.D0 ) THEN
              amb = 'ENN'
              IF ( DABS(X(iq2)).GT.DABS(X(Iq1)) ) amb = 'TEMP'
              IF ( ilamb.NE.0 ) amb = Prod(ilamb)
              if(makeio.ne.0)WRITE (8,99012) amb
            ENDIF
            IF ( Vol .and. makeio.ne.0) WRITE (8,99013) Vv*.001D0
            if(makeio.ne.0)WRITE (8,99014)
            DO j = 1,Ngc
              if(makeio.ne.0)WRITE (8,99015) Prod(j),En(j,Npt),Enln(j),
     &         Deln(j),H0(j), S(j),H0(j) - S(j),Mu(j)
            ENDDO
          ENDIF
C APPLY CORRECTIONS TO ESTIMATES
          Totn(Npt) = 0.D0
          DO j = 1,Ng
            Enln(j) = Enln(j) + ambda*Deln(j)
          ENDDO
          DO j = 1,Ng
            En(j,Npt) = 0.
            IF ( lelim.NE.0 ) THEN
              DO i = lelim,ls
                IF ( A(i,j).NE.0. ) GOTO 540
              ENDDO
            ENDIF
            IF ( (Enln(j)-Ennl+tsize).GT.0. ) THEN
              En(j,Npt) = DEXP(Enln(j))
              Totn(Npt) = Totn(Npt) + En(j,Npt)
            ENDIF
 540      ENDDO
          IF ( Ions.AND.Elmt(Nlm).EQ.'E' ) THEN
            DO j = 1,Ng
              IF ( A(ls,j).NE.0..AND.En(j,Npt).EQ.0. ) THEN
                IF ( (Enln(j)-Ennl+esize).GT.0. ) THEN
                  En(j,Npt) = DEXP(Enln(j))
                  Totn(Npt) = Totn(Npt) + En(j,Npt)
                ENDIF
              ENDIF
            ENDDO
          ENDIF
          Sumn = Totn(Npt)
          IF ( Npr.NE.0 ) THEN
            DO k = 1,Npr
              j = Jcond(k)
              En(j,Npt) = En(j,Npt) + ambda*Deln(j)
              Totn(Npt) = Totn(Npt) + En(j,Npt)
            ENDDO
          ENDIF
          IF ( .NOT.Tp ) THEN
            Tln = Tln + ambda*dlnt
            Tt = DEXP(Tln)
            cpcalc = .TRUE.
            CALL CPHS
          ENDIF
          IF ( Vol ) THEN
            Enn = Sumn
            Ennl = DLOG(Enn)
            IF ( Vol ) Pp = Rr*Tt*Enn/Vv
          ELSE
            Ennl = Ennl + ambda*X(Iq1)
            Enn = DEXP(Ennl)
          ENDIF
          Tm = DLOG(Pp/Enn)
          IF ( Elmt(Nlm).EQ.'E' ) THEN
C CHECK ON REMOVING IONS
            DO j = 1,Ngc
              IF ( A(Nlm,j).NE.0. ) THEN
                IF ( En(j,Npt).GT.0. ) GOTO 560
              ENDIF
            ENDDO
            pie = X(Nlm)
            lelim = Nlm
            Nlm = Nlm - 1
            GOTO 500
          ENDIF
C TEST FOR CONVERGENCE
 560      IF ( numb.GT.maxitn ) THEN
            if(makeio.ne.0)WRITE (8,99019) maxitn,Npt
            IF ( Nc.EQ.0.OR.i2many ) GOTO 1500
            i2many = .TRUE.
            IF ( .NOT.Hp.OR.Npt.NE.1.OR.Tt.GT.100. ) THEN
              IF ( Npr.NE.1.OR.Enn.GT.1.E-4 ) GOTO 1500
C HIGH TEMPERATURE, INCLUDED CONDENSED CONDITION
              if(makeio.ne.0)WRITE (8,99020)
              Enn = .1
              Ennl = -2.3025851
              Sumn = Enn
              xi = Ng
              xi = Enn/xi
              xln = DLOG(xi)
              DO j = 1,Ng
                En(j,Npt) = xi
                Enln(j) = xln
              ENDDO
              j = Jcond(1)
              k = 1
              GOTO 1000
            ELSE
              if(makeio.ne.0)WRITE (8,99008)
              GOTO 1500
            ENDIF
          ELSE
            sum = (X(Iq1)*Enn/Totn(Npt))
            IF ( DABS(sum).GT.0.5E-5 ) GOTO 500
            DO j = 1,Ng
              IF ( DABS(Deln(j))*En(j,Npt)/Totn(Npt).GT.0.5D-5 )
     &             GOTO 500
            ENDDO
            IF ( DABS(dlnt).GT.1.D-04 ) GOTO 500
            IF ( Npr.NE.0 ) THEN
              DO k = 1,Npr
                j = Jcond(k)
                IF ( DABS(Deln(j)/Totn(Npt)).GT.0.5D-5 ) GOTO 500
                IF ( En(j,Npt).LT.0. ) GOTO 700
              ENDDO
            ENDIF
            le = Nlm
            DO i = 1,Nlm
              IF ( DABS(B0(i)).GE.1.D-06 ) THEN
                sum = 0.
                DO j = 1,Ngc
                  sum = sum + En(j,Npt)*A(i,j)
                ENDDO
                IF ( DABS(B0(i)-sum).GT.Bcheck ) GOTO 500
              ENDIF
            ENDDO
            IF ( Trace.NE.0. ) THEN
              tsize = xsize
              tem = 1.
              IF ( numb.NE.1 ) THEN
                lk = lz
                IF ( Nlm.LT.lz ) lk = Nlm
                DO i = 1,lk
                  IF ( i.NE.lsing ) THEN
                    tem = 0.
                    IF ( X(i).NE.0. ) THEN
                      tem = DABS((pisave(i)-X(i))/X(i))
                      IF ( tem.GT..001 ) GOTO 565
                    ENDIF
                  ENDIF
                ENDDO
              ENDIF
 565          DO i = 1,Nlm
                pisave(i) = X(i)
              ENDDO
              IF ( tem.GT..001 ) GOTO 500
              IF ( Ions ) THEN
C CHECK ON ELECTRON BALANCE
                iter = 1
                IF ( pie.NE.0. ) THEN
                  le = Nlm + 1
                  X(le) = pie
                ENDIF
 566            sum1 = 0.
                sum = 0.
                pie = X(le)
                DO j = 1,Ng
                  IF ( A(ls,j).NE.0. ) THEN
                    En(j,Npt) = 0.
                    tem = 0.
                    IF ( Enln(j).GT.-87. ) tem = DEXP(Enln(j))
                    IF ( (Enln(j)-Ennl+tsize).GT.0..AND.Elmt(Nlm)
     &                   .EQ.'E' ) THEN
                      pie = 0.
                      En(j,Npt) = tem
                    ENDIF
                    aa = A(ls,j)*tem
                    sum = sum + aa
                    sum1 = sum1 + aa*A(ls,j)
                  ENDIF
                ENDDO
                IF ( sum1.NE.0. ) THEN
                  dpie = -sum/sum1
                  DO j = 1,Ng
                    IF ( A(ls,j).NE.0. ) Enln(j) = Enln(j) + A(ls,j)
     &                   *dpie
                  ENDDO
                  IF ( Debug(Npt).and. (makeio.ne.0) )
     $                        WRITE(8,99016) iter,dpie
                  IF ( DABS(dpie).GT..0001 ) THEN
                    X(le) = X(le) + dpie
                    iter = iter + 1
                    IF ( iter.LE.80 ) GOTO 566
                    if(makeio.ne.0)WRITE (8,99017)
                    GOTO 1500
                  ELSEIF ( Elmt(Nlm).EQ.'E'.AND.pie.NE.0. ) THEN
                    Nlm = Nlm - 1
                    newcom = .TRUE.
                  ENDIF
                ENDIF
              ENDIF
            ENDIF
          ENDIF
        ELSEIF ( .NOT.Pderiv ) THEN
C TEMPERATURE DERIVATIVES--CONVG=T, PDERIV=F
          Dlvtp(Npt) = 1. - X(Iq1)
          Cpr(Npt) = G(iq2,iq2)
          DO j = 1,Iq1
            Cpr(Npt) = Cpr(Npt) - G(iq2,j)*X(j)
          ENDDO
C PRESSURE DERIVATIVE--CONVG=T, PDERIV=T
          Pderiv = .TRUE.
          GOTO 500
        ELSE
          Dlvpt(Npt) = -1. + X(Iq1)
          IF ( Jliq.EQ.0 ) THEN
            Gammas(Npt) = -1./(Dlvpt(Npt)+(Dlvtp(Npt)**2)*Enn/Cpr(Npt))
          ELSE
            En(Jsol,Npt) = ensol
            Hsum(Npt) = Hsum(Npt) + En(Jliq,Npt)*(H0(Jliq)-H0(Jsol))
            Gammas(Npt) = -1./Dlvpt(Npt)
            Npr = Npr + 1
            Jcond(Npr) = Jliq
          ENDIF
          GOTO 1400
        ENDIF
C SINGULAR MATRIX
      ELSE
        IF ( Convg ) THEN
          if(makeio.ne.0)WRITE (8,99007)
          Dlvpt(Npt) = -1.
          Dlvtp(Npt) = 1.
          Cpr(Npt) = Cpsum
          Gammas(Npt) = -1./(Dlvpt(Npt)+(Dlvtp(Npt)**2)*Enn/Cpr(Npt))
          GOTO 1400
        ELSE
          if(makeio.ne.0)WRITE (8,99009) numb,Msing
          lsing = Msing
          ixsing = ixsing + 1
          IF ( ixsing.LE.8 ) THEN
            xsize = 80.
            tsize = xsize
            IF ( Msing.GT.Nlm.AND.numb.LT.1.AND.Npr.GT.1.AND.
     &           jdelg.GT.0 ) THEN
              ween = 1000.
              j = 0
              DO i = 1,Npr
                jcondi = Jcond(i)
                IF ( jcondi.NE.jdelg ) THEN
                  DO ll = 1,Nlm
                    IF ( A(ll,jdelg).NE.0.AND.A(ll,jcondi).NE.0. ) THEN
                      IF ( En(jcondi,Npt).LE.ween ) THEN
                        ween = En(jcondi,Npt)
                        j = jcondi
                        k = i
                      ENDIF
                      GOTO 570
                    ENDIF
                  ENDDO
                ENDIF
 570          ENDDO
              IF ( j.GT.0 ) THEN
                if(makeio.ne.0)WRITE (8,99020)
                GOTO 1000
              ENDIF
            ELSEIF ( .NOT.Hp.OR.Npt.NE.1.OR.Nc.EQ.0.OR.Tt.GT.100. ) THEN
              IF ( ixsing.GE.3 ) THEN
                IF ( Msing.LT.Iq1 ) THEN
                  IF ( reduce.AND.Msing.LE.Nlm ) THEN
                    IF ( Nlm.LT.lelim ) GOTO 1500
                    if(makeio.ne.0)WRITE (8,99010) Npt,Elmt(Nlm)
                    Nlm = Nlm - 1
                    GOTO 500
                  ELSEIF ( Msing.LE.Nlm ) THEN
C FIND NEW COMPONENTS
                    IF ( .NOT.Ions ) GOTO 1100
                    IF ( Elmt(Nlm).NE.'E' ) GOTO 1100
                    DO j = 1,Ng
                      IF ( A(Nlm,j).NE.0. ) En(j,Npt) = 0.D0
                    ENDDO
                    pie = X(Nlm)
                    Nlm = Nlm - 1
                    IF ( Msing.GT.Nlm ) GOTO 500
                    GOTO 1100
                  ELSE
C REMOVE CONDENSED SPECIES TO CORRECT SINGULARITY
                    k = Msing - Nlm
                    j = Jcond(k)
                    IF ( j.NE.jcons ) THEN
                      jcons = j
                      GOTO 1000
                    ENDIF
                  ENDIF
                ENDIF
              ENDIF
              DO jj = 1,Ng
                IF ( Ions ) THEN
                  IF ( Elmt(Nlm).NE.'E' ) THEN
                    IF ( A(ls,jj).NE.0. ) GOTO 575
                  ENDIF
                ENDIF
                IF ( En(jj,Npt).EQ.0. ) THEN
                  En(jj,Npt) = smalno
                  Enln(jj) = smnol
                ENDIF
 575          ENDDO
              GOTO 500
            ELSE
              if(makeio.ne.0)WRITE (8,99008)
            ENDIF
          ENDIF
        ENDIF
        GOTO 1500
      ENDIF
C CALCULATE ENTROPY, CHECK ON DELTA S FOR SP PROBLEMS
 600  Ssum(Npt) = 0.
      DO j = 1,Ng
        Ssum(Npt) = Ssum(Npt) + En(j,Npt)*(S(j)-Enln(j)-Tm)
      ENDDO
      IF ( Npr.GT.0 ) THEN
        DO k = 1,Npr
          j = Jcond(k)
          Ssum(Npt) = Ssum(Npt) + En(j,Npt)*S(j)
        ENDDO
      ENDIF
      IF ( .NOT.Sp ) THEN
        Convg = .TRUE.
      ELSE
        tem = Ssum(Npt) - S0
        IF ( DABS(tem).GT..0005 ) GOTO 500
        IF ( Debug(Npt).and. (makeio.ne.0) ) WRITE (8,99018) tem
        Convg = .TRUE.
      ENDIF
C CONVERGENCE TESTS ARE SATISFIED, TEST CONDENSED SPECIES.
 700  ncvg = ncvg + 1
      IF ( ncvg.GT.lncvg ) THEN
C ERROR, SET TT=0
        if(makeio.ne.0)WRITE (8,99034) lncvg
        GOTO 1500
      ELSE
        IF ( .NOT.Shock ) THEN
          DO il = 1,le
            xx(il) = X(il)
          ENDDO
          IF ( .NOT.Short_bn ) THEN
            IF ( newcom .and.(makeio.ne.0) ) 
     $                  WRITE (8,99021) (cmp(k),k=1,le)
            if(makeio.ne.0)
     $                  WRITE (8,99022) Npt,numb,Tt,(xx(il),il=1,le)
          ENDIF
          IF ( .NOT.Tp.AND.Npr.EQ.0.AND.Tt.LE.Tg(1)*.2D0 ) THEN
            if(makeio.ne.0)WRITE (8,99008)
            GOTO 1500
          ENDIF
          newcom = .FALSE.
        ENDIF
        IF ( Npr.NE.0 ) THEN
          bigneg = 0.
          jneg = 0
          DO k = 1,Npr
            j = Jcond(k)
            IF ( En(j,Npt)*Cp(j).LE.bigneg ) THEN
              bigneg = En(j,Npt)*Cp(j)
              jneg = j
              kneg = k
            ENDIF
          ENDDO
          IF ( jneg.NE.0 ) THEN
            j = jneg
            k = kneg
            IF ( j.EQ.Jsol.OR.j.EQ.Jliq ) THEN
              Jsol = 0
              Jliq = 0
            ENDIF
            GOTO 1000
          ENDIF
        ENDIF
        IF ( Ngc.NE.Ng.OR.Tp ) THEN
          Ng = Ngc
          CALL CPHS
          Ng = Ngp1 - 1
          cpcalc = .TRUE.
          IF ( Ngc.EQ.Ng ) GOTO 750
          CALL ALLCON
          IF ( Npr.NE.0.AND..NOT.Tp ) THEN
            gap = 50.
            DO ipr = 1,Npr
              j = Jcond(ipr)
              IF ( j.NE.Jsol.AND.j.NE.Jliq ) THEN
                inc = j - Ng
                kg = -Ifz(inc)
                DO iz = 1,20
                  kg = kg + 1
                  kc = inc + kg
                  IF ( Tt.LE.Temp(2,kc) ) THEN
                    IF ( kg.NE.0 ) THEN
                      jkg = j + kg
                      IF ( IABS(kg).GT.1.OR.Prod(j).EQ.Prod(jkg) )
     &                     GOTO 740
                      IF ( jkg.EQ.jsw ) GOTO 720
                      IF ( Tt.LT.Temp(1,inc)-gap.OR.Tt.GT.Temp(2,inc)
     &                     +gap ) GOTO 740
                      GOTO 720
                    ENDIF
                    GOTO 710
                  ELSEIF ( Ifz(kc+1).LE.Ifz(kc) ) THEN
                    GOTO 710
                  ENDIF
                ENDDO
                IF ( Tt.GT.Temp(2,kc)*1.2D0 ) GOTO 1000
              ENDIF
 710        ENDDO
          ENDIF
          sizeg = 0.
          szgj = 0.
          DO inc = 1,Nc
            j = inc + Ng
            IF ( (Debug(Npt)).and.(makeio.ne.0) ) WRITE (8,99024) 
     &                   Prod(j),Temp(1,inc), Temp(2,inc),En(j,Npt)
            IF ( En(j,Npt).LE.0. ) THEN
              IF ( Tt.GT.Temp(1,inc).OR.Temp(1,inc).EQ.Tg(1) ) THEN
                IF ( Tt.LE.Temp(2,inc) ) THEN
                  sum = 0.
                  DO i = 1,Nlm
                    sum = sum + A(i,j)*X(i)
                  ENDDO
                  delg = (H0(j)-S(j)-sum)/Mw(j)
                  IF ( delg.LT.sizeg.AND.delg.LT.0. ) THEN
                    IF ( j.NE.jcons ) THEN
                      sizeg = delg
                      jdelg = j
                    ELSE
                      szgj = delg
                    ENDIF
                    ipr = ipr - 1
                  ENDIF
                  IF ((Debug(Npt)).and.(makeio.ne.0))
     $                             WRITE(8,99025) delg,sizeg
                ENDIF
              ENDIF
            ENDIF
          ENDDO
          IF ( sizeg.EQ.0..AND.szgj.EQ.0. ) GOTO 750
          IF ( sizeg.NE.0. ) THEN
            j = jdelg
            GOTO 800
          ELSE
            if(makeio.ne.0)WRITE (8,99026) Prod(jcons)
            GOTO 1500
          ENDIF
 720      kk = MAX(0,kg)
          tmelt = Temp(kk+1,inc)
          Tt = tmelt
          Tln = DLOG(Tt)
          Jsol = MIN(j,jkg)
          Jliq = Jsol + 1
          En(jkg,Npt) = .5D0*En(j,Npt)
          En(j,Npt) = En(jkg,Npt)
          j = jkg
          GOTO 800
C WRONG PHASE INCLUDED FOR T INTERVAL, SWITCH EN
 740      En(jkg,Npt) = En(j,Npt)
          Jcond(ipr) = jkg
          En(j,Npt) = 0.
          jsw = j
          IF ( (Prod(j).NE.Prod(jkg)).AND.(.NOT.Short_bn) .and.
     $        (makeio.ne.0))
     &       WRITE (8,99023) Prod(j),Prod(jkg)
          j = jkg
          GOTO 900
        ENDIF
C CONVERGED WITH NO CONDENSED CHANGES.  IF BOTH SOLID & LIQ PRESENT,
C TEMPORARILY REMOVE LIQ TO PREVENT SINGULAR DERIVATIVE MATRIX.
 750    Sumn = Enn
        IF ( Jsol.NE.0 ) THEN
          ensol = En(Jsol,Npt)
          En(Jsol,Npt) = En(Jsol,Npt) + En(Jliq,Npt)
          Dlvtp(Npt) = 0.
          Cpr(Npt) = 0.
          Gammas(Npt) = 0.
          Pderiv = .TRUE.
          DO k = 1,Npr
            IF ( Jcond(k).EQ.Jliq ) GOTO 760
          ENDDO
 760      DO i = k,Npr
            Jcond(i) = Jcond(i+1)
          ENDDO
          Npr = Npr - 1
        ENDIF
        GOTO 500
      ENDIF
C ADD CONDENSED SPECIES
 800  Npr = Npr + 1
      i = Npr
      DO ix = 2,Npr
        Jcond(i) = Jcond(i-1)
        i = i - 1
      ENDDO
      Jcond(1) = j
      IF ( (.NOT.Short_bn).and. (makeio.ne.0) ) WRITE (8,99027) Prod(j)
 900  inc = j - Ng
      Convg = .FALSE.
      IF ( Tp ) cpcalc = .FALSE.
      numb = -1
      GOTO 500
C REMOVE CONDENSED SPECIES
 1000 En(j,Npt) = 0.D0
      Deln(j) = 0.D0
      Enln(j) = 0.D0
      DO i = k,Npr
        Jcond(i) = Jcond(i+1)
      ENDDO
      IF ( (.NOT.Short_bn).and.(makeio.ne.0) ) WRITE (8,99028) Prod(j)
      Npr = Npr - 1
      DO i = 1,Nlm
        IF ( cmp(i).EQ.Prod(j) ) THEN
          numb = -1
          Convg = .FALSE.
          IF ( Tp ) cpcalc = .FALSE.
          GOTO 1100
        ENDIF
      ENDDO
      GOTO 900
 1100 newcom = .FALSE.
      nn = Nlm
      IF ( Elmt(Nlm).EQ.'E' ) nn = Nlm - 1
C FIND ORDER OF SPECIES FOR COMPONENTS - BIGGEST TO SMALLEST
      njc = 0
      DO lc = 1,nn
        lcs(lc) = 0
      ENDDO
 1200 bigen = -1.D-35
      DO j = 1,Ng
        IF ( En(j,Npt).GT.bigen ) THEN
          IF ( .NOT.Ions.OR.A(ls,j).EQ.0. ) THEN
            bigen = En(j,Npt)
            jbx = j
          ENDIF
        ENDIF
      ENDDO
      IF ( bigen.GT.0. ) THEN
        DO lc = 1,nn
          IF ( jbx.EQ.0 ) jbx = Jx(lc)
          IF ( A(lc,jbx).GT.smalno ) THEN
            IF ( njc.NE.0 ) THEN
              DO i = 1,njc
                l = lcs(i)
                IF ( l.EQ.lc ) GOTO 1250
                IF ( l.EQ.0 ) GOTO 1210
                j = Jcm(l)
                DO l = 1,nn
                  IF ( A(l,jbx).NE.A(l,j) ) GOTO 1205
                ENDDO
                GOTO 1250
 1205         ENDDO
            ENDIF
 1210       DO i = 1,nn
              IF ( i.NE.lc ) THEN
                jex = Jx(i)
                IF ( DABS(A(lc,jbx)*A(i,jex)-A(lc,jex)*A(i,jbx))
     &               .LE.smalno ) GOTO 1250
              ENDIF
            ENDDO
            njc = njc + 1
            IF ( jbx.NE.Jcm(lc) ) newcom = .TRUE.
            Jcm(lc) = jbx
            lcs(njc) = lc
            GOTO 1300
          ENDIF
 1250   ENDDO
 1300   En(jbx,Npt) = -En(jbx,Npt)
        IF ( njc.LT.nn ) GOTO 1200
      ENDIF
      DO j = 1,Ng
        En(j,Npt) = DABS(En(j,Npt))
      ENDDO
      IF ( newcom ) THEN
C SWITCH COMPONENTS
        DO lc = 1,nn
          jb = Jcm(lc)
          IF ( A(lc,jb).EQ.0. ) THEN
            jb = Jx(lc)
            Jcm(lc) = jb
          ENDIF
          tem = A(lc,jb)
          IF ( tem.NE.0. ) THEN
            pisave(lc) = H0(jb) - S(jb)
            IF ( jb.LE.Ng ) pisave(lc) = pisave(lc) + Enln(jb) + Tm
            cmp(lc) = Prod(jb)
C CALCULATE NEW COEFFICIENTS
            IF ( tem.NE.1. ) THEN
              B0(lc) = B0(lc)/tem
              B0p(lc,1) = B0p(lc,1)/tem
              B0p(lc,2) = B0p(lc,2)/tem
              DO j = 1,Nspx
                A(lc,j) = A(lc,j)/tem
              ENDDO
            ENDIF
            DO i = 1,nn
              IF ( A(i,jb).NE.0..AND.i.NE.lc ) THEN
                tem = A(i,jb)
                DO j = 1,Nspx
                  A(i,j) = A(i,j) - A(lc,j)*tem
                  IF ( DABS(A(i,j)).LT.1.E-5 ) A(i,j) = 0.
                ENDDO
                B0(i) = B0(i) - B0(lc)*tem
                B0p(i,1) = B0p(i,1) - B0p(lc,1)*tem
                B0p(i,2) = B0p(i,2) - B0p(lc,2)*tem
              ENDIF
            ENDDO
          ENDIF
        ENDDO
        IF ( Debug(Npt) ) THEN
          if(makeio.ne.0)WRITE (8,99029)
          if(makeio.ne.0)WRITE (8,99030) (cmp(k),k=1,nn)
        ENDIF
      ENDIF
      IF ( Msing.NE.0 ) THEN
C SWITCH ORDER OF MSING AND NLM COMPONENTS
        reduce = .TRUE.
        lelim = Nlm
        lsing = Nlm
        IF ( Msing.NE.Nlm ) THEN
          DO j = 1,Nspx
            aa = A(Msing,j)
            A(Msing,j) = A(Nlm,j)
            A(Nlm,j) = aa
          ENDDO
          ja = Jcm(Msing)
          Jcm(Msing) = Jcm(Nlm)
          Jcm(Nlm) = ja
          ae = cmp(Msing)
          cmp(Msing) = cmp(Nlm)
          cmp(Nlm) = ae
          ae = Elmt(Msing)
          Elmt(Msing) = Elmt(Nlm)
          Elmt(Nlm) = ae
          ja = Jx(Msing)
          Jx(Msing) = Jx(Nlm)
          Jx(Nlm) = ja
          aa = Atwt(Msing)
          Atwt(Msing) = Atwt(Nlm)
          Atwt(Nlm) = aa
          aa = B0(Msing)
          B0(Msing) = B0(Nlm)
          B0(Nlm) = aa
          aa = pisave(Msing)
          pisave(Msing) = pisave(Nlm)
          pisave(Nlm) = aa
          DO i = 1,2
            aa = B0p(Msing,i)
            B0p(Msing,i) = B0p(Nlm,i)
            B0p(Nlm,i) = aa
          ENDDO
        ENDIF
      ELSEIF ( .NOT.newcom.AND.Trace.EQ.0. ) THEN
        GOTO 600
      ENDIF
      Msing = 0
      tsize = xsize
      GOTO 500
 1400 Ttt(Npt) = Tt
      Ppp(Npt) = Pp
      Vlm(Npt) = Rr*Enn*Tt/Pp
      Hsum(Npt) = Hsum(Npt)*Tt
      Wm(Npt) = 1./Enn
      gasfrc = Enn/Totn(Npt)
      IF ( (gasfrc.LT..0001) .and.(makeio.ne.0)) 
     $              WRITE (8,99031) Npt,gasfrc
      IF ( Trace.NE.0. ) THEN
        DO j = 1,Ng
          IF ( lelim.NE.0 ) THEN
            DO i = lelim,ls
              IF ( A(i,j).NE.0. ) GOTO 1450
            ENDDO
          ENDIF
          IF ( Enln(j).GT.-87. ) En(j,Npt) = DEXP(Enln(j))
 1450   ENDDO
      ENDIF
      IF ( (Debug(Npt)).and.(makeio.ne.0) ) WRITE (8,99032) 
     &                                  Npt,Pp,Tt,Hsum(Npt),Ssum(Npt),
     &                                  Wm(Npt),Cpr(Npt),Dlvpt(Npt),
     &                                  Dlvtp(Npt),Gammas(Npt),Vlm(Npt)
      IF ( Tt.GE.Tg(1).AND.Tt.LE.Tg(4) ) GOTO 1600
      IF ( Shock ) GOTO 1600
      if(makeio.ne.0)WRITE (8,99033) Tt,Npt
      IF ( Tt.GE.Tg(1)*.8D0.AND.Tt.LE.Tg(4)*1.1D0 ) GOTO 1600
      Npt = Npt + 1
 1500 Tt = 0.
      Npt = Npt - 1
      if(makeio.ne.0)WRITE (8,99035) Npt
 1600 Lsave = Nlm
      Nlm = ls
      IF ( Npr.GT.0 ) Gonly = .FALSE.
      RETURN
99001 FORMAT (/' POINT ITN',6X,'T',10X,4(A4,8X)/(18X,5(A4,8X)))
99002 FORMAT (/' T DERIV MATRIX')
99003 FORMAT (/' P DERIV MATRIX')
99004 FORMAT (/' ITERATION',I3,6X,'MATRIX ')
99005 FORMAT (/' SOLUTION VECTOR',/,6x,5A15/8X,5A15)
99006 FORMAT (3X,5E15.6)
99007 FORMAT (/' DERIVATIVE MATRIX SINGULAR (EQLBRM)')
99008 FORMAT (/' LOW TEMPERATURE IMPLIES A CONDENSED SPECIES SHOULD HA',
     &        'VE BEEN INSERTED,',
     &        /' RESTART WITH insert DATASET (EQLBRM)')
99009 FORMAT (/' SINGULAR MATRIX, ITERATION',I3,'  VARIABLE',I3,
     &        '(EQLBRM)')
99010 FORMAT (/' WARNING!! POINT',I3,
     &        ' USES A REDUCED SET OF COMPONENTS',/
     &       ' SPECIES CONTAINING THE ELIMINATED COMPONENT ARE OMITTED.'
     &       ,/
     &   ' IT MAY BE NECESSARY TO RERUN WITH INSERTED CONDENSED SPECIES'
     &   ,/' CONTAINING COMPONENT ',A8,'(EQLBRM)')
99011 FORMAT (/' T=',E15.8,' ENN=',E15.8,' ENNL=',E15.8,' PP=',E15.8,
     &        /' LN P/N=',E15.8,' AMBDA=',E15.8)
99012 FORMAT (/' AMBDA SET BY ',A16)
99013 FORMAT (' VOLUME=',E15.8,'CC/G')
99014 FORMAT (/24X,'Nj',12X,'LN Nj',8X,'DEL LN Nj',6X,'H0j/RT',/,41X,
     &        'S0j/R',10X,' G0j/RT',8X,' Gj/RT')
99015 FORMAT (1X,A16,4E15.6,/35x,3E15.6)
99016 FORMAT (/' ELECTRON BALANCE ITER NO. =',I4,'  DELTA PI =',E14.7)
99017 FORMAT (/' DID NOT CONVERGE ON ELECTRON BALANCE (EQLBRM)')
99018 FORMAT (/' DELTA S/R =',E15.8)
99019 FORMAT (/,I4,' ITERATIONS DID NOT SATISFY CONVERGENCE',/,15x,
     &        ' REQUIREMENTS FOR THE POINT',I5,' (EQLBRM)')
99020 FORMAT (/' TRY REMOVING CONDENSED SPECIES (EQLBRM)')
99021 FORMAT (/' POINT ITN',6X,'T',10X,4A12/(18X,5A12))
99022 FORMAT (I4,I5,5F12.3,/(12X,5F12.3))
99023 FORMAT (' PHASE CHANGE, REPLACE ',A16,'WITH ',A16)
99024 FORMAT (/1X,A15,2F10.3,3X,E15.7)
99025 FORMAT (' [G0j-SUM(Aij*PIi)]/Mj =',E15.7,9X,'MAX NEG DELTA G =',
     &        E15.7)
99026 FORMAT (/' REINSERTION OF ',A16,' LIKELY TO CAUSE SINGULARITY,',
     &        '(EQLBRM)')
99027 FORMAT (' ADD ',A16)
99028 FORMAT (' REMOVE ',A16)
99029 FORMAT (/' NEW COMPONENTS')
99030 FORMAT (/2x,6A12)
99031 FORMAT (/' WARNING!  RESULTS MAY BE WRONG FOR POINT',I3,' DUE TO',
     &        /' LOW MOLE FRACTION OF GASES (',E15.8,') (EQLBRM)')
99032 FORMAT (/' POINT=',I3,3X,'P=',E13.6,3X,'T=',E13.6,/3X,'H/R=',
     &        E13.6,3X,'S/R=',E13.6,/3X,'M=',E13.6,3X,'CP/R=',E13.6,3X,
     &        'DLVPT=',E13.6,/3X,'DLVTP=',E13.6,3X,'GAMMA(S)=',E13.6,3X,
     &        'V=',E13.6)
99033 FORMAT (' THE TEMPERATURE=',E12.4,' IS OUT OF RANGE FOR POINT',I5,
     &        '(EQLBRM)')
99034 FORMAT (/,I3,' CONVERGENCES FAILED TO ESTABLISH SET OF CONDENSED',
     &        ' SPECIES (EQLBRM)')
99035 FORMAT (/' CALCULATIONS STOPPED AFTER POINT',I3,'(EQLBRM)')
      END
      SUBROUTINE FROZEN
C***********************************************************************
C CALCULATE PROPERTIES WITH FROZEN COMPOSITION AT ASSIGNED ENTROPY
C AND PRESSURE.  CALLED FROM ROCKET.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      INTEGER i,inc,iter,j,k,nnn
      REAL*8 DABS,DEXP,DLOG
      REAL*8 dlnt,dlpm
      SAVE dlnt,dlpm,i,inc,iter,j,k,nnn
C
      Convg = .FALSE.
      Tln = DLOG(Tt)
      dlpm = DLOG(Pp*Wm(Nfz))
      nnn = Npt
      Npt = Nfz
      DO j = 1,Ng
        IF ( En(j,Nfz).NE.0.D0 ) Deln(j) = -(DLOG(En(j,Nfz))+dlpm)
      ENDDO
      DO iter = 1,8
        Ssum(nnn) = 0.D0
        Cpsum = 0.D0
        CALL CPHS
        DO j = 1,Ng
          Cpsum = Cpsum + En(j,Nfz)*Cp(j)
          Ssum(nnn) = Ssum(nnn) + En(j,Nfz)*(S(j)+Deln(j))
        ENDDO
        IF ( Npr.NE.0 ) THEN
          DO k = 1,Npr
            j = Jcond(k)
            Cpsum = Cpsum + En(j,Nfz)*Cp(j)
            Ssum(nnn) = Ssum(nnn) + En(j,Nfz)*S(j)
          ENDDO
        ENDIF
        IF ( Convg ) THEN
          Npt = nnn
          Hsum(Npt) = 0.D0
          DO j = 1,Ngc
            Hsum(Npt) = Hsum(Npt) + En(j,Nfz)*H0(j)
          ENDDO
          Hsum(Npt) = Hsum(Npt)*Tt
          Ttt(Npt) = Tt
          Gammas(Npt) = Cpsum/(Cpsum-1./Wm(Nfz))
          Vlm(Npt) = Rr*Tt/(Wm(Nfz)*Pp)
          Wm(Npt) = Wm(Nfz)
          Dlvpt(Npt) = -1.
          Dlvtp(Npt) = 1.
          Totn(Npt) = Totn(Nfz)
          Ppp(Npt) = Pp
          Cpr(Npt) = Cpsum
          IF ( Tt.GE.(Tg(1)*.8D0) ) THEN
            DO i = Ngp1,Ngc
              IF ( En(i,Nfz).NE.0. ) THEN
                inc = i - Ng
                IF ( Tt.LT.(Temp(1,inc)-50.).OR.Tt.GT.(Temp(2,inc)+50.)
     &               ) GOTO 100
              ENDIF
            ENDDO
            GOTO 200
          ENDIF
          GOTO 100
        ELSE
          dlnt = (Ssum(Nfz)-Ssum(nnn))/Cpsum
          Tln = Tln + dlnt
          IF ( DABS(dlnt).LT.0.5D-4 ) Convg = .TRUE.
          Tt = DEXP(Tln)
        ENDIF
      ENDDO
      if(makeio.ne.0)WRITE (8,99001)
 100  Tt = 0.
      Npt = Npt - 1
 200  RETURN
99001 FORMAT (/' FROZEN DID NOT CONVERGE IN 8 ITERATIONS (FROZEN)')
      END
      SUBROUTINE GAUSS
C***********************************************************************
C SOLVE ANY LINEAR SET OF UP TO MAXMAT EQUATIONS
C NUMBER OF EQUATIONS = IMAT
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      INTEGER i,imatp1,j,k,nn,nnp1
      REAL*8 bigno,coefx(50),tmp
      REAL*8 DABS,DMAX1
      SAVE coefx,i,imatp1,j,k,nn,nnp1,tmp
C
      DATA bigno/1.E+25/
C BEGIN ELIMINATION OF NNTH VARIABLE
      imatp1 = Imat + 1
      DO nn = 1,Imat
        IF ( nn.NE.Imat ) THEN
C SEARCH FOR MAXIMUM COEFFICIENT IN EACH ROW
          nnp1 = nn + 1
          DO i = nn,Imat
            coefx(i) = bigno
            IF ( G(i,nn).NE.0. ) THEN
              coefx(i) = 0.
              DO j = nnp1,imatp1
                coefx(i) = DMAX1(coefx(i),DABS(G(i,j)))
              ENDDO
              tmp = DABS(G(i,nn))
              IF ( bigno*tmp.GT.coefx(i) ) THEN
                coefx(i) = coefx(i)/tmp
              ELSE
                coefx(i) = bigno
              ENDIF
            ENDIF
          ENDDO
C LOCATE ROW WITH SMALLEST MAXIMUM COEFFICIENT
          tmp = bigno
          i = 0
          DO j = nn,Imat
            IF ( coefx(j).LT.tmp ) THEN
              tmp = coefx(j)
              i = j
            ENDIF
          ENDDO
          IF ( i.EQ.0 ) THEN
            Msing = nn
            GOTO 99999
C INDEX I LOCATES EQUATION TO BE USED FOR ELIMINATING THE NTH
C VARIABLE FROM THE REMAINING EQUATIONS
C INTERCHANGE EQUATIONS I AND NN
          ELSEIF ( nn.NE.i ) THEN
            DO j = nn,imatp1
              tmp = G(i,j)
              G(i,j) = G(nn,j)
              G(nn,j) = tmp
            ENDDO
          ENDIF
        ELSEIF ( G(nn,nn).EQ.0 ) THEN
          Msing = nn
          GOTO 99999
        ENDIF
C DIVIDE NTH ROW BY NTH DIAGONAL ELEMENT AND ELIMINATE THE NTH
C VARIABLE FROM THE REMAINING EQUATIONS
        k = nn + 1
        tmp = G(nn,nn)
        IF ( tmp.EQ.0. ) THEN
          Msing = nn
          GOTO 99999
        ELSE
          DO j = k,imatp1
            G(nn,j) = G(nn,j)/tmp
          ENDDO
          IF ( k.NE.imatp1 ) THEN
            DO i = k,Imat
CDIR$ IVDEP
              DO j = k,imatp1
                G(i,j) = G(i,j) - G(i,nn)*G(nn,j)
              ENDDO
            ENDDO
          ENDIF
        ENDIF
      ENDDO
C BACKSOLVE FOR THE VARIABLES
      k = Imat
 100  j = k + 1
      X(k) = 0.0D0
      tmp = 0.0
      IF ( Imat.GE.j ) THEN
        DO i = j,Imat
          tmp = tmp + G(k,i)*X(i)
        ENDDO
      ENDIF
      X(k) = G(k,imatp1) - tmp
      k = k - 1
      IF ( k.NE.0 ) GOTO 100
99999 END
      SUBROUTINE HCALC
C***********************************************************************
C CALCULATE PROPERTIES FOR TOTAL REACTANT USING THERMO DATA FOR
C ONE OR MORE REACTANTS. USED ONLY FOR SHOCK AND DETON PROBLEMS.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      CHARACTER*6 date(MAXNGC)
      CHARACTER*2 el(5)
      CHARACTER*15 sub
      INTEGER i,icf,ifaz,itot,j,k,l,m,n,nall,nint,ntgas,ntot
      REAL*8 bb(5),enj,er,sj,t1,t2,tem,thermo(9,3),tsave
      REAL*8 DLOG
      SAVE bb,date,el,enj,er,i,icf,ifaz,itot,j,k,l,m,n,nall,nint,ntgas,
     &  ntot,sj,sub,t1,t2,tem,thermo,tsave
C
      if( read_d .eq. 0 ) return

      tsave = Tt
      Tm = 0.
      IF ( Pp.GT.0. ) Tm = DLOG(Pp*Wmix)
      Ssum(Npt) = 0.
      Hpp(1) = 0.
      Hpp(2) = 0.
      Hsub0 = 0.
      Cpmix = 0.
      tem = (1.+Oxfl)
C LOOP ON REACTANTS.
C IF OXIDANT, K=1
C IF FUEL, K=2
      Nspr = Nspx
      DO n = 1,Nreac
        k = 2
        IF ( Fox(n)(:1).EQ.'O'.OR.Fox(n)(:1).EQ.'o' ) k = 1
        IF ( Tt.EQ.0. ) Tt = Rtemp(n)
        j = Jray(n)
        IF ( j.EQ.0 ) THEN
C SEARCH FOR REACTANT IN STORED THERMO SPECIES. STORE INDEX IN JRAY(N).
          ifaz = 0
          DO j = 1,Ngc
            IF ( Rname(n).EQ.Prod(j).OR.'*'//Rname(n).EQ.Prod(j) ) THEN
              Jray(n) = j
              IF ( j.GT.Ng ) THEN
                if(makeio.ne.0)WRITE (8,99001)
                GOTO 20
              ENDIF
              GOTO 50
            ENDIF
          ENDDO
C SEARCH THERMO.LIB FOR SPECIES.
          REWIND IOTHM
          READ (IOTHM) Tg,ntgas,ntot,nall
          Nspr = Nspr + 1
          DO itot = 1,nall
            IF ( itot.LE.ntot ) THEN
              icf = 3
              IF ( itot.GT.ntgas ) icf = 1
              READ (IOTHM) sub,nint,date(Nspr),(el(j),bb(j),j=1,5),ifaz,
     &                     t1,t2,Mw(Nspr),((thermo(l,m),l=1,9),m=1,icf)
            ELSE
              READ (IOTHM) sub,nint,date(Nspr),(el(j),bb(j),j=1,5),ifaz,
     &                     t1,t2,Mw(Nspr),er
              IF ( nint.NE.0 ) THEN
                READ (IOTHM) ((thermo(i,j),i=1,9),j=1,nint)
                icf = nint
              ENDIF
            ENDIF
            IF ( sub.EQ.Rname(n).OR.sub.EQ.'*'//Rname(n) ) THEN
              IF ( ifaz.LE.0.AND.nint.GT.0 ) THEN
                DO j = 1,5
                  IF ( bb(j).EQ.0. ) GOTO 2
                  Nfla(n) = j
                  Ratom(n,j) = el(j)
                  Rnum(n,j) = bb(j)
                ENDDO
 2              Jray(n) = Nspr
                j = Nspr
                DO l = 1,icf
                  DO m = 1,9
                    Coef(j,m,l) = thermo(m,l)
                  ENDDO
                ENDDO
                GOTO 50
              ELSE
                IF ( (ifaz.GT.0) .and.(makeio.ne.0)) WRITE (8,99001)
                IF ( (nint.EQ.0) .and.(makeio.ne.0)) 
     $                                    WRITE (8,99002) Rname(n)
                GOTO 20
              ENDIF
            ENDIF
          ENDDO
          Nspr = Nspr - 1
          if(makeio.ne.0)WRITE (8,99003) Rname(n)
          Energy(n) = ' '
 20       Tt = 0.
          Cpmix = 0.
          GOTO 100
        ENDIF
C CALCULATE EN FOR REACTANT AND CALCULATE PROPERTIES.
 50     IF ( Moles ) enj = Pecwt(n)/Wp(k)
        IF ( .NOT.Moles ) enj = Pecwt(n)/Rmw(n)
        enj = enj/tem
        IF ( k.EQ.1 ) enj = enj*Oxfl
        Tln = DLOG(Tt)
        En(j,Npt) = enj
        l = 1
        IF ( ifaz.LE.0 ) THEN
          IF ( Tt.GT.Tg(2) ) l = 2
          IF ( Tt.GT.Tg(3).AND.ifaz.LT.0 ) l = 3
        ENDIF
        S(j) = ((((Coef(j,7,l)/4.)*Tt+Coef(j,6,l)/3.)*Tt+Coef(j,5,l)/2.)
     &         *Tt+Coef(j,4,l))*Tt - (Coef(j,1,l)*.5D0/Tt+Coef(j,2,l))
     &         /Tt + Coef(j,3,l)*Tln + Coef(j,9,l)
        H0(j) = ((((Coef(j,7,l)/5.)*Tt+Coef(j,6,l)/4.)*Tt+Coef(j,5,l)/3.
     &          )*Tt+Coef(j,4,l)/2.)
     &          *Tt - (Coef(j,1,l)/Tt-Coef(j,2,l)*Tln-Coef(j,8,l))
     &          /Tt + Coef(j,3,l)
        Cp(j) = (((Coef(j,7,l)*Tt+Coef(j,6,l))*Tt+Coef(j,5,l))
     &          *Tt+Coef(j,4,l))*Tt + (Coef(j,1,l)/Tt+Coef(j,2,l))
     &          /Tt + Coef(j,3,l)
        IF ( H0(j).GT.-.01.AND.H0(j).LT..01 ) H0(j) = 0.
C ADD CONTRIBUTION TO CP, H, AND S OF TOTAL REACTANT.
        Cpmix = Cpmix + Cp(j)*enj
C FOR CONDENSED SPECIES:  SJ = S(J)
        sj = S(j) - DLOG(enj) - Tm
        Ssum(Npt) = Ssum(Npt) + enj*sj
        er = H0(j)*enj*Tt
        Hsub0 = Hsub0 + er
        Hpp(k) = Hpp(k) + er
      ENDDO
      IF ( tsave.NE.0. ) Tt = tsave
 100  RETURN
99001 FORMAT (/' REACTANTS MUST BE GASEOUS FOR THIS PROBLEM (HCALC)')
99002 FORMAT (/' COEFFICIENTS FOR ',A15,' ARE NOT AVAILABLE (HCALC)')
99003 FORMAT (/' ERROR IN DATA FOR ',A15,' CHECK NAME AND TEMPERATURE',
     &        ' RANGE IN',/,' thermo.inp (HCALC)')
      END
      SUBROUTINE INFREE(Readok,Cin,Ncin,Lcin,Dpin)
C***********************************************************************
C FREE-FORM READ FOR CEA.  READS AND DECIPHERS DATA FOR ONE DATASET.
C
C DEFINITIONS:
C   CH1  - INDIVIDUAL CHARACTERS IN RECORD, MAXIMUM 132.
C   NCH1 - COLUMN NUMBER FOR THE LAST NON-BLANK CHARACTER IN RECORD.
C   NCIN - NUMBER OF VARIABLES IN DATASET.
C   CIN  - CHARACTER STRINGS IN DATASET. MAXIMUM 15 CHARACTERS.
C   LCIN - NEG. LENGTH OF LITERALS.  FOR NUMERICS, INDEX OF PREVIOUS
C          LITERAL.  ZERO FOR UNACCEPTIBLE VARIABLES.  VARIABLE
C          FOLLOWING "CASE" IS ALWAYS ASSUMED TO BE LITERAL.
C   NB   - NUMBER OF DELIMITERS IN STRING.
C   NX   - NUMBER OF CHARACTERS IN STRING.
C   DPIN - NUMERICS AS DOUBLE PRECISION VARIABLE.
C   CNUM - CHARACTER STRING REPRESENTING DATASET NUMBERS. MAXIMUM 24
C          CHARACTERS.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C DUMMY ARGUMENTS
      CHARACTER*15 Cin(MAXNGC)
      INTEGER Ncin
      INTEGER Lcin(MAXNGC)
      LOGICAL Readok
      REAL*8 Dpin(MAXNGC)
C LOCAL VARIABLES
      CHARACTER*1 ch1(132),cx,nums(13)
      CHARACTER*24 cnum
      CHARACTER*3 fmtl(3)
      CHARACTER*2 numg(24)
      CHARACTER*4 w1
      INTEGER i,ich1,j,kcin,nb,nch1,nx
C
      DATA fmtl/'(g','16','.0)'/
      DATA nums/'+','-','0','1','2','3','4','5','6','7','8','9','.'/
      DATA numg/'1','2','3','4','5','6','7','8','9','10','11','12','13',
     &     '14','15','16','17','18','19','20','21','22','23','24'/
     
      
      Ncin = 1
      Lcin(1) = 0
      kcin = 0
      Dpin(1) = 0.D0
 100  continue
      if(NLine .ge. 0)NLine = NLine + 1
      if(NLine .gt. NLinesSet)goto 500
c...      print*,"loop ",NLine," of ",NLinesSet
c...      print*,"/"//InpLines(NLine)//"/"
      nb = 1
      nx = 0
      cnum = ' '
      Cin(Ncin) = ' '
      ch1(1) = ' '
      nch1 = 1
C READ CHARACTERS, ONE AT A TIME
      if(NLine .gt. 0)then
        READ (InpLines(NLine),99001,END=500,ERR=500) ch1
      else
        READ (7,99001,END=500,ERR=500) ch1
      endif
C FIND FIRST AND LAST NON-BLANK CHARACTER
      DO i = 132,1, - 1
        nch1 = i
        IF ( ch1(i).NE.' '.AND.ch1(i).NE.'	' ) GOTO 200
      ENDDO
 200  DO i = 1,nch1
        ich1 = i
        IF ( ch1(i).NE.' '.AND.ch1(i).NE.'	' ) GOTO 300
      ENDDO
 300  IF ( nch1.EQ.1.OR.ch1(ich1).EQ.'#'.OR.ch1(ich1).EQ.'!' ) THEN
        if(makeio.ne.0)WRITE (8,99002) (ch1(i),i=1,nch1)
        GOTO 100
      ENDIF
      w1 = ch1(ich1)//ch1(ich1+1)//ch1(ich1+2)//ch1(ich1+3)
C IS STRING A KEYWORD SIGNALLING START OR END OF DATASET?
      IF ( w1.EQ.'ther'.OR.w1.EQ.'tran'.OR.w1.EQ.'prob'.OR.
     &     w1.EQ.'reac'.OR.w1.EQ.'outp'.OR.w1.EQ.'omit'.OR.
     &     w1.EQ.'only'.OR.w1.EQ.'inse'.OR.w1(1:3).EQ.'end' ) THEN
        IF ( Ncin.EQ.1 ) THEN
          Cin(Ncin) = w1
          IF ( w1(1:3).EQ.'end'.OR.w1.EQ.'ther'.OR.w1.EQ.'tran' ) THEN
            if(makeio.ne.0)WRITE (8,99002) (ch1(i),i=1,nch1)
            RETURN
          ENDIF
          ich1 = ich1 + 4
          nx = 4
          Lcin(1) = -4
        ELSE
C KEYWORD READ FOR NEXT DATASET. END PROCESSING
          if(NLine .le. 0)then
            BACKSPACE 7
          else
            NLine = NLine -1
          endif
          IF ( nx.EQ.0 ) Ncin = Ncin - 1
          RETURN
        ENDIF
      ELSEIF ( Ncin.EQ.1 ) THEN
        if(makeio.ne.0)WRITE (8,99003)
        GOTO 500
      ENDIF
      if(makeio.ne.0)WRITE (8,99002) (ch1(i),i=1,nch1)
      DO i = ich1,nch1
        cx = ch1(i)
C LOOK FOR DELIMITER STRINGS
        IF ( cx.EQ.','.AND.(Lcin(Ncin).GT.0.OR.nx.EQ.0) ) cx = ' '
        IF ( cx.EQ.'='.AND.(Lcin(Ncin).LT.0.OR.nx.EQ.0) ) cx = ' '
        IF ( cx.NE.' '.AND.cx.NE.'	' ) THEN
C LOOK FOR CHARACTER STRINGS
          nx = nx + 1
          IF ( Ncin.GT.1 ) THEN
            cnum(nx:nx) = cx
            IF ( nx.LE.15 ) Cin(Ncin) = cnum
            IF ( nx.EQ.1 ) THEN
C IS THIS A NUMERIC?
              DO j = 1,13
                IF ( ch1(i).EQ.nums(j) ) THEN
                  Lcin(Ncin) = kcin
                  GOTO 310
                ENDIF
              ENDDO
              Lcin(Ncin) = -1
              kcin = Ncin
            ELSEIF ( Lcin(Ncin).LT.0 ) THEN
              Lcin(Ncin) = -nx
            ENDIF
 310        nb = 1
          ENDIF
          IF ( i.LT.nch1.OR.Lcin(Ncin).LT.0 ) GOTO 400
        ENDIF
        IF ( nb.EQ.1..AND.nx.GT.0 ) THEN
          IF ( Ncin.GT.0.AND.Lcin(Ncin).GT.0 ) THEN
C CONVERT NUMERIC CHARACTER STRINGS TO REAL*8 VARIABLES (DPIN)
            fmtl(2) = numg(MIN(24,nx))
C INTERNAL READ TO CONVERT TO NUMERIC
            READ (cnum,fmtl,ERR=320) Dpin(Ncin)
          ENDIF
          GOTO 340
 320      IF ( (Cin(Ncin-1)(:4).NE.'case') .and.(makeio.ne.0)) 
     &                            WRITE (8,99004) Cin(i)
          Lcin(Ncin) = 0
 340      Ncin = Ncin + 1
          Cin(Ncin) = ' '
          Lcin(Ncin) = 0
          Dpin(Ncin) = 0.D0
          nx = 0
          cnum = ' '
        ENDIF
        nb = nb + 1
 400  ENDDO
      IF ( nx.GT.0 ) THEN
        Ncin = Ncin + 1
        Lcin(Ncin) = 0
        Dpin(Ncin) = 0.D0
      ENDIF
      GOTO 100
 500  Readok = .FALSE.
      RETURN
99001 FORMAT (132A1)
99002 FORMAT (1x,80A1)
99003 FORMAT (/' FATAL ERROR IN INPUT FORMAT (INFREE)')
99004 FORMAT (/' WARNING!!  UNACCEPTABLE NUMBER ',A15,' (INFREE)')
      END
      SUBROUTINE INPUT(Readok,Caseok,Ensert)
C***********************************************************************
C DECIPHER KEYWORDS, LITERAL VARIABLES, & NUMERICAL VARIABLES IN INPUT.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C DUMMY ARGUMENTS
      LOGICAL Caseok,Readok
      CHARACTER*15 Ensert(20)
C LOCAL VARIABLES
      CHARACTER*15 cin(MAXNGC),cx15
      CHARACTER*4 code,cx4
      CHARACTER*1 cx1
      CHARACTER*2 cx2
      CHARACTER*3 cx3
      CHARACTER*26 lc,uc
      LOGICAL eqrats,incd,phi,pltdat,reacts,refl
      INTEGER i,ifrmla,ii,in,iv,ix,j,jj,k,lcin(MAXNGC),ncin,nmix
c///      INTEGER INDEX
      REAL*8 denmtr,dpin(MAXNGC),eratio,hr,mix(MAXNGC),ur,xyz
      REAL*8 DABS,DMIN1,DSQRT
      SAVE cin,code,cx1,cx15,cx2,cx3,cx4,denmtr,dpin,eqrats,eratio,hr,i,
     &  ifrmla,ii,in,incd,iv,ix,j,jj,k,lcin,mix,ncin,nmix,phi,pltdat,
     &  reacts,refl,ur,xyz
C
      DATA uc/'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      DATA lc/'abcdefghijklmnopqrstuvwxyz'/
      if(makeio.ne.0)WRITE (8,99001)
      Caseok = .TRUE.
      Nonly = 0
      Nomit = 0
      Nsert = 0
      reacts = .FALSE.
      Trace = 0
      Short_bn = .FALSE.
      Massf = .FALSE.
      DO i = 1,NCOL
        Debug(i) = .FALSE.
      ENDDO
      Nplt = 0
      Siunit = .TRUE.
      pltdat = .FALSE.
C CALL INFREE TO READ DATASET
 100  CALL INFREE(Readok,cin,ncin,lcin,dpin)
      IF ( .NOT.Readok ) GOTO 400
      code = cin(1)
      IF ( code.NE.'    ' ) THEN
C STORE PRODUCT NAMES FROM 'ONLY' DATASET
        IF ( code.EQ.'only' ) THEN
          Nonly = MIN(MAXNGC,ncin-1)
          DO i = 1,Nonly
            Prod(i) = cin(i+1)
          ENDDO
C STORE CONDENSED PRODUCT NAMES FROM 'INSERT' DATASET
        ELSEIF ( code.EQ.'inse' ) THEN
          Nsert = MIN(20,ncin-1)
          DO i = 1,Nsert
            Ensert(i) = cin(i+1)
          ENDDO
C STORE PRODUCT NAMES FROM 'OMIT' DATASET
        ELSEIF ( code.EQ.'omit' ) THEN
C CHECK OMIT DATASET
          Nomit = MIN(MAXNGC,ncin-1)
          DO i = 1,Nomit
            Omit(i) = cin(i+1)
          ENDDO
C KEYWORD 'THER' READ
C CALL UTHERM TO CONVERT FORMATTED THERMODYNAMIC DATA
        ELSEIF ( code.EQ.'ther' ) THEN
          Newr = .TRUE.
          REWIND IOTHM
          CALL UTHERM(Readok)
          IF ( .NOT.Readok ) THEN
            if(makeio.ne.0)WRITE (8,99025)
            GOTO 400
          ENDIF
C KEYWORD 'TRAN' READ
C CALL UTRAN TO CONVERT FORMATTED TRANSPORT PROPERTIES
        ELSEIF ( code.EQ.'tran' ) THEN
          CALL UTRAN(Readok)
          IF ( .NOT.Readok ) THEN
            if(makeio.ne.0)WRITE (8,99025)
            GOTO 400
          ENDIF
C PROCESS 'OUTP' DATASET.
        ELSEIF ( code.EQ.'outp' ) THEN
          DO i = 2,ncin
            IF ( lcin(i).LT.0 ) THEN
              cx2 = cin(i)(1:2)
              cx3 = cin(i)(1:3)
              cx4 = cin(i)(1:4)
              IF ( cx3.EQ.'cal' ) THEN
                Siunit = .FALSE.
              ELSEIF ( cx4.EQ.'tran'.OR.cx3.EQ.'trn' ) THEN
                Trnspt = .TRUE.
              ELSEIF ( cx4.EQ.'trac' ) THEN
                Trace = dpin(i+1)
              ELSEIF ( cin(i)(:5).EQ.'short' ) THEN
                Short_bn = .TRUE.
              ELSEIF ( cin(i)(:5).EQ.'massf' ) THEN
                Massf = .TRUE.
              ELSEIF ( cx3.EQ.'deb'.OR.cx3.EQ.'dbg' ) THEN
                DO j = i + 1,ncin
                  IF ( lcin(j).NE.i ) GOTO 120
                  k = dpin(j)
                  IF ( k.LE.NCOL ) Debug(k) = .TRUE.
                  lcin(j) = 0
                ENDDO
              ELSEIF ( cx2.EQ.'si' ) THEN
                Siunit = .TRUE.
              ELSEIF ( pltdat.AND.Nplt.LT.20 ) THEN
                Nplt = Nplt + 1
                Pltvar(Nplt) = cin(i)
              ELSEIF ( cx2.EQ.'pl' ) THEN
                pltdat = .TRUE.
              ELSE
                if(makeio.ne.0)WRITE (8,99002) cin(i)
              ENDIF
            ENDIF
 120      ENDDO
C SORT AND STORE DATA FROM 'REAC' DATASET.
        ELSEIF ( code.EQ.'reac' ) THEN
          reacts = .TRUE.
          Moles = .FALSE.
          Nreac = 0
          DO i = 1,MAXR
            Pecwt(i) = -1.
          ENDDO
          i = 1
 140      i = i + 1
          IF ( i.LE.ncin ) THEN
            IF ( lcin(i).NE.0 ) THEN
              IF ( lcin(i).GT.0 ) THEN
                if(makeio.ne.0)WRITE (8,99003) cin(i)
                GOTO 140
              ENDIF
              cx15 = cin(i)
              cx1 = cx15(:1)
              cx2 = cx15(:2)
              cx3 = cx15(:3)
              cx4 = cx15(:4)
C NEW REACTANT
              IF ( cx2.NE.'na'.AND.cx2.NE.'ox'.AND.cx2.NE.'fu' ) THEN
C LOOK FOR PERCENTS
                IF ( cx1.EQ.'m'.OR.cx1.EQ.'w' ) THEN
                  IF ( lcin(i+1).GT.0 ) THEN
                    i = i + 1
                    Pecwt(Nreac) = dpin(i)
                  ELSE
                    Caseok = .FALSE.
                    if(makeio.ne.0)WRITE (8,99004)
                  ENDIF
                  IF ( cx1.EQ.'m'.AND.Nreac.EQ.1 ) Moles = .TRUE.
                  IF ( cx1.EQ.'m'.AND..NOT.Moles.OR.cx1.EQ.'w'.AND.
     &                 Moles ) THEN
                    Caseok = .FALSE.
                    if(makeio.ne.0)WRITE (8,99005)
                  ENDIF
                  GOTO 140
                ENDIF
C LOOK FOR TEMPERATURES
                IF ( cx1.EQ.'t' ) THEN
                  IF ( lcin(i+1).GT.0 ) THEN
                    i = i + 1
                    Rtemp(Nreac) = dpin(i)
                    IF ( lcin(i-1).LT.1 ) THEN
                      IF ( INDEX(cx15,'r').GT.0 ) Rtemp(Nreac)
     &                     = Rtemp(Nreac)/1.8D0
                      IF ( INDEX(cx15,'c').GT.0 ) Rtemp(Nreac)
     &                     = Rtemp(Nreac) + 273.15D0
                      IF ( INDEX(cx15,'f').GT.0 ) Rtemp(Nreac)
     &                     = (Rtemp(Nreac)-32.D0)/1.8D0 + 273.15D0
                    ENDIF
                  ELSE
                    if(makeio.ne.0)WRITE (8,99006)
                    Caseok = .FALSE.
                  ENDIF
                  GOTO 140
                ENDIF
C LOOK FOR ENTHALPY
                IF ( cx1.EQ.'h'.OR.cx1.EQ.'u' ) THEN
                  Energy(Nreac) = cx15
                  IF ( lcin(i+1).GT.0 ) THEN
                    i = i + 1
                    Enth(Nreac) = dpin(i)*1000.D0/Rr
                    IF ( INDEX(cin(i-1),'c').GT.0 ) Enth(Nreac)
     &                   = Enth(Nreac)*4.184D0
                    IF ( INDEX(cin(i-1),'k').GT.0 ) Enth(Nreac)
     &                   = Enth(Nreac)*1000.D0
                  ENDIF
                  GOTO 140
                ENDIF
C LOOK FOR DENSITY
                IF ( cx3.EQ.'rho'.OR.cx3.EQ.'den' ) THEN
                  IF ( lcin(i+1).GT.0 ) THEN
                    i = i + 1
                    Dens(Nreac) = dpin(i)
                    IF ( INDEX(cx15,'kg').GT.0 ) Dens(Nreac)
     &                   = Dens(Nreac)/1000.D0
                  ENDIF
                  GOTO 140
                ENDIF
C CHECK FOR CHEMICAL SYMBOLS IN EXPLODED FORMULA
                IF ( (lcin(i).EQ.-1.OR.lcin(i).EQ.-2).AND.INDEX(uc,cx1)
     &               .GT.0 ) THEN
                  ifrmla = ifrmla + 1
                  Nfla(Nreac) = ifrmla
                  IF ( lcin(i).EQ.-2 ) THEN
                    ix = INDEX(lc,cx2(2:2))
                    IF ( ix.GT.0 ) cx2(2:2) = uc(ix:ix)
                  ENDIF
                  Ratom(Nreac,ifrmla) = cx2
                  IF ( lcin(i+1).EQ.i ) THEN
                    Rnum(Nreac,ifrmla) = dpin(i+1)
                  ELSE
                    Rnum(Nreac,ifrmla) = 1.
                  ENDIF
                  i = i + 1
                  GOTO 140
                ENDIF
                if(makeio.ne.0)WRITE (8,99007) cin(i)
              ELSE
                Nreac = MIN(Nreac+1,MAXR)
                Fox(Nreac) = cx15
                i = i + 1
                IF ( lcin(i).LT.0 ) Rname(Nreac) = cin(i)
                ifrmla = 0
                Nfla(Nreac) = 0
                Energy(Nreac) = 'lib'
                Enth(Nreac) = 0.
                Jray(Nreac) = 0
                Pecwt(Nreac) = -1.
                Rnum(Nreac,1) = 0.
                Rmw(Nreac) = 0.
                Rtemp(Nreac) = 0.
              ENDIF
            ENDIF
            GOTO 140
          ENDIF
C SORT AND STORE INPUT FROM 'PROB' DATASET
        ELSEIF ( code.EQ.'prob' ) THEN
          Case_bn = ' '
          DO i = 1,MAXPV
            P(i) = 0.
            V(i) = 0.
          ENDDO
          DO i = 1,MAXT
            T(i) = 0.
          ENDDO
          P(1) = 1.
          Trace = 0.
          Lsave = 0
          R = Rr/4184.D0
          S0 = 0.
          hr = 1.D30
          ur = 1.D30
          Tp = .FALSE.
          Hp = .FALSE.
          Sp = .FALSE.
          Rkt = .FALSE.
          Shock = .FALSE.
          Detn = .FALSE.
          Vol = .FALSE.
          Ions = .FALSE.
          Eql = .FALSE.
          Froz = .FALSE.
          Fac = .FALSE.
          Debugf = .FALSE.
          Acat = 0.
          Ma = 0.
          Nfz = 1
          Nsub = 0
          Nsup = 0
          Npp = 0
          Tcest = 3800.
          DO i = 1,NCOL
            Pcp(i) = 0.
            Pcp(i+NCOL) = 0.
            Supar(i) = 0.
            Subar(i) = 0.
            Mach1(i) = 0.
            U1(i) = 0.
          ENDDO
          Gamma1 = 0.
          phi = .FALSE.
          eqrats = .FALSE.
          incd = .FALSE.
          refl = .FALSE.
          Shkdbg = .FALSE.
          Incdeq = .FALSE.
          Incdfz = .FALSE.
          Refleq = .FALSE.
          Reflfz = .FALSE.
          Np = 0
          Nt = 1
          Trnspt = .FALSE.
C PROCESS LITERAL VARIABLES IN 'PROB' DATASET THAT DO NOT HAVE
C ASSOCIATED NUMERICAL DATA.
          DO i = 2,ncin
            IF ( lcin(i).LT.0 ) THEN
              DO j = i + 1,ncin
                IF ( lcin(j).EQ.i ) GOTO 160
              ENDDO
              cx15 = cin(i)
              cx2 = cx15(:2)
              cx3 = cx15(:3)
              cx4 = cx15(:4)
              IF ( cx4.EQ.'case' ) THEN
                Case_bn = cin(i+1)
                lcin(i+1) = 0
              ELSEIF ( cx2.EQ.'tp'.OR.cx2.EQ.'pt' ) THEN
                Tp = .TRUE.
              ELSEIF ( cx2.EQ.'hp'.OR.cx2.EQ.'ph' ) THEN
                Hp = .TRUE.
              ELSEIF ( cx2.EQ.'sp'.OR.cx2.EQ.'ps' ) THEN
                Sp = .TRUE.
              ELSEIF ( cx2.EQ.'sv'.OR.cx2.EQ.'vs' ) THEN
                Sp = .TRUE.
                Vol = .TRUE.
              ELSEIF ( cx2.EQ.'uv'.OR.cx2.EQ.'vu' ) THEN
                Hp = .TRUE.
                Vol = .TRUE.
              ELSEIF ( cx2.EQ.'tv'.OR.cx2.EQ.'vt' ) THEN
                Tp = .TRUE.
                Vol = .TRUE.
              ELSEIF ( cx2.EQ.'ro'.OR.cx3.EQ.'rkt' ) THEN
                Rkt = .TRUE.
              ELSEIF ( cx3.EQ.'dbg'.OR.cx3.EQ.'deb' ) THEN
                Debugf = .TRUE.
                Shkdbg = .TRUE.
                Detdbg = .TRUE.
              ELSEIF ( cx3.EQ.'fac' ) THEN
                Rkt = .TRUE.
                Eql = .TRUE.
                Fac = .TRUE.
                Froz = .FALSE.
              ELSEIF ( cx2.EQ.'eq' ) THEN
                Eql = .TRUE.
              ELSEIF ( cx2.EQ.'fr'.OR.cx2.EQ.'fz' ) THEN
                Froz = .TRUE.
              ELSEIF ( cx2.EQ.'sh' ) THEN
                Shock = .TRUE.
              ELSEIF ( cx3.EQ.'inc' ) THEN
                Shock = .TRUE.
                incd = .TRUE.
                IF ( INDEX(cx15,'eq').GT.0 ) Eql = .TRUE.
                IF ( INDEX(cx15,'fr').GT.0 ) Froz = .TRUE.
                IF ( INDEX(cx15,'fz').GT.0 ) Froz = .TRUE.
              ELSEIF ( cx3.EQ.'ref' ) THEN
                Shock = .TRUE.
                refl = .TRUE.
                IF ( INDEX(cx15,'eq').GT.0 ) Eql = .TRUE.
                IF ( INDEX(cx15,'fr').GT.0 ) Froz = .TRUE.
                IF ( INDEX(cx15,'fz').GT.0 ) Froz = .TRUE.
              ELSEIF ( cx3.EQ.'det' ) THEN
                Detn = .TRUE.
              ELSEIF ( cx4.EQ.'ions' ) THEN
                Ions = .TRUE.
              ELSE
                if(makeio.ne.0)WRITE (8,99002) cx15
              ENDIF
              lcin(i) = 0
            ENDIF
 160      ENDDO
          iv = 2
          Nof = 0
          GOTO 200
        ELSEIF ( code(1:3).EQ.'end' ) THEN
          IF ( Shock ) THEN
            IF ( incd.AND.Froz ) Incdfz = .TRUE.
            IF ( incd.AND.Eql ) Incdeq = .TRUE.
            IF ( refl.AND.Froz ) Reflfz = .TRUE.
            IF ( refl.AND.Eql ) Refleq = .TRUE.
          ENDIF
          Hsub0 = DMIN1(hr,ur)
          Size_bn = 0.
          IF ( hr.GT..9D30 ) hr = 0.D0
          IF ( ur.GT..9D30 ) ur = 0.D0
          IF ( Trnspt ) Viscns = .3125*DSQRT(1.E5*Boltz/(Pi*Avgdr))
          IF ( Siunit ) R = Rr/1000.
          IF ( Detn.OR.Shock ) Newr = .TRUE.
          IF ( .NOT.Short_bn ) THEN
            if(makeio.ne.0)WRITE (8,99008) 
     &                      Tp,(Hp.AND..NOT.Vol),Sp,(Tp.AND.Vol),
     &                      (Hp.AND.Vol),(Sp.AND.Vol),Detn,Shock,refl,
     &                      incd,Rkt,Froz,Eql,Ions,Siunit,Debugf,Shkdbg,
     &                      Detdbg,Trnspt
            IF ((T(1).GT.0.) .and.(makeio.ne.0) )
     $                       WRITE(8,99009)(T(jj),jj=1,Nt)
            if(makeio.ne.0)WRITE (8,99010) Trace,S0,hr,ur
            IF ( (Np.GT.0).AND. Vol .and.(makeio.ne.0)) WRITE (8,99011)
     &           (V(jj)*1.D-05,jj=1,Np)
          ENDIF
          IF ( Rkt ) THEN
            IF ( Nt.EQ.0 ) Hp = .TRUE.
            IF ( .NOT.Short_bn ) THEN
              if(makeio.ne.0)WRITE (8,99012) (P(jj),jj=1,Np)
              if(makeio.ne.0)WRITE (8,99013) (Pcp(jj),jj=1,Npp)
              if(makeio.ne.0)WRITE (8,99014) (Subar(i),i=1,Nsub)
              if(makeio.ne.0)WRITE (8,99015) (Supar(i),i=1,Nsup)
              if(makeio.ne.0)WRITE (8,99016) Nfz,Ma,Acat
            ENDIF
          ELSE
            IF ( (.NOT.Vol).AND.(.NOT.Short_bn) .and.(makeio.ne.0)) 
     &          WRITE (8,99017) (P(jj),jj=1,Np)
          ENDIF
          IF ( reacts ) CALL REACT
          IF ( Nreac.EQ.0.OR.Nlm.LE.0 ) THEN
            if(makeio.ne.0)WRITE (8,99018)
            Caseok = .FALSE.
            if(makeio.ne.0)WRITE (8,99025)
            GOTO 400
          ENDIF
          IF ( Nof.EQ.0 ) THEN
            Nof = 1
            Oxf(1) = 0.
            IF ( Wp(2).GT.0. ) THEN
              Oxf(1) = Wp(1)/Wp(2)
            ELSE
              Caseok = .FALSE.
              if(makeio.ne.0)WRITE (8,99004)
              if(makeio.ne.0)WRITE (8,99025)
              GOTO 400
            ENDIF
          ELSEIF ( phi.OR.eqrats ) THEN
            DO i = 1,Nof
              eratio = Oxf(i)
              IF ( eqrats ) THEN
                xyz = -eratio*Vmin(2) - Vpls(2)
                denmtr = eratio*Vmin(1) + Vpls(1)
              ELSE
                xyz = -Vmin(2) - Vpls(2)
                denmtr = eratio*(Vmin(1)+Vpls(1))
              ENDIF
              IF ( DABS(denmtr).LT.1.D-30 ) THEN
                Caseok = .FALSE.
                if(makeio.ne.0)WRITE (8,99019) eratio
                if(makeio.ne.0)WRITE (8,99025)
                GOTO 400
              ENDIF
              Oxf(i) = xyz/denmtr
            ENDDO
          ENDIF
          IF ( .NOT.Sp.AND..NOT.Tp.AND..NOT.Hp.AND..NOT.Rkt.AND.
     &         .NOT.Detn.AND..NOT.Shock ) THEN
            Caseok = .FALSE.
            if(makeio.ne.0)WRITE (8,99020)
          ELSEIF ( Tp.AND.T(1).LE.0. ) THEN
            Caseok = .FALSE.
            if(makeio.ne.0)WRITE (8,99021)
          ELSEIF ( Np.LE.0 ) THEN
            Caseok = .FALSE.
            if(makeio.ne.0)WRITE (8,99022)
          ENDIF
          IF ( (.NOT.(Caseok.AND.Nlm.GT.0)) .and.(makeio.ne.0)) 
     $                     WRITE(8,99025)
          GOTO 400
        ELSE
          if(makeio.ne.0)WRITE (8,99023)
        ENDIF
      ENDIF
      GOTO 100
C PROCESS NUMERICAL DATA FOLLOWING 'PROB' LITERALS
 200  in = 0
      nmix = 0
      ii = iv
      DO i = ii,ncin
        iv = i
        IF ( lcin(i).NE.0 ) THEN
          IF ( lcin(i).LT.0 ) THEN
            IF ( in.GT.0 ) GOTO 300
            in = i
          ELSE
            IF ( lcin(i).NE.in ) GOTO 300
            nmix = nmix + 1
            mix(nmix) = dpin(i)
            lcin(i) = 0
          ENDIF
        ENDIF
      ENDDO
 300  IF ( nmix.LE.0 ) THEN
        IF ( iv.LT.ncin ) GOTO 200
        GOTO 100
      ENDIF
      cx15 = cin(in)
      cx1 = cx15(:1)
      cx2 = cx15(:2)
      cx3 = cx15(:3)
      cx4 = cx15(:4)
      IF ( cx1.EQ.'t' ) THEN
        Nt = nmix
        IF ( nmix.GT.MAXMIX ) THEN
          Nt = MAXMIX
          if(makeio.ne.0)WRITE (8,99024) 't',Nt
        ENDIF
        DO i = 1,Nt
          IF ( cx4.NE.'tces' ) THEN
            T(i) = mix(i)
            IF ( lcin(in).LT.-1 ) THEN
              IF ( INDEX(cx15,'r').GT.0 ) T(i) = T(i)/1.8D0
              IF ( INDEX(cx15,'c').GT.0 ) T(i) = T(i) + 273.15D0
              IF ( INDEX(cx15,'f').GT.0 ) T(i) = (T(i)-32.D0)
     &             /1.8D0 + 273.15D0
            ENDIF
          ENDIF
        ENDDO
      ELSEIF ( (cx2.EQ.'pc'.OR.cx2.EQ.'pi').AND.INDEX(cx15(3:15),'p')
     &         .GT.0.AND.INDEX(cx15,'psi').EQ.0 ) THEN
        Npp = nmix
        IF ( nmix.GT.2*NCOL ) THEN
          Npp = 2*NCOL
          if(makeio.ne.0)WRITE (8,99024) 'pcp',Npp
        ENDIF
        DO i = 1,Npp
          Pcp(i) = mix(i)
        ENDDO
      ELSEIF ( cx1.EQ.'p'.AND.cx3.NE.'phi' ) THEN
        Np = nmix
        IF ( nmix.GT.MAXPV ) THEN
          Np = MAXPV
          if(makeio.ne.0)WRITE (8,99024) 'p',Np
        ENDIF
        DO i = 1,Np
          P(i) = mix(i)
          IF ( INDEX(cx15,'psi').NE.0 ) THEN
            P(i) = P(i)/14.696006D0
          ELSEIF ( INDEX(cx15,'mmh').NE.0 ) THEN
            P(i) = P(i)/760.D0
          ELSEIF ( INDEX(cx15,'atm').EQ.0 ) THEN
            GOTO 350
          ENDIF
          P(i) = P(i)*1.01325D0
 350    ENDDO
      ELSEIF ( cx3.EQ.'rho' ) THEN
        xyz = 1.D02
        IF ( INDEX(cx15,'kg').NE.0 ) xyz = 1.D05
        Np = nmix
        IF ( nmix.GT.MAXPV ) THEN
          Np = MAXPV
          if(makeio.ne.0)WRITE (8,99024) 'rho',Np
        ENDIF
        DO i = 1,Np
          V(i) = xyz/mix(i)
        ENDDO
      ELSEIF ( cx1.EQ.'v' ) THEN
        xyz = 1.D02
        IF ( INDEX(cx15,'kg').NE.0 ) xyz = 1.D05
        Np = nmix
        IF ( nmix.GT.MAXPV ) THEN
          Np = MAXPV
          if(makeio.ne.0)WRITE (8,99024) 'v',Np
        ENDIF
        DO i = 1,Np
          V(i) = mix(i)*xyz
        ENDDO
      ELSEIF ( cx3.EQ.'nfz'.OR.cx3.EQ.'nfr' ) THEN
        Nfz = mix(1)
        Froz = .TRUE.
      ELSEIF ( cx4.EQ.'tces' ) THEN
        Tcest = mix(1)
      ELSEIF ( cx4.EQ.'trac' ) THEN
        Trace = mix(1)
      ELSEIF ( cx3.EQ.'s/r' ) THEN
        S0 = mix(1)
      ELSEIF ( cx3.EQ.'u/r'.OR.cx2.EQ.'ur' ) THEN
        ur = mix(1)
      ELSEIF ( cx3.EQ.'h/r'.OR.cx2.EQ.'hr' ) THEN
        hr = mix(1)
      ELSEIF ( cx2.EQ.'u1' ) THEN
        Nsk = nmix
        IF ( nmix.GT.NCOL ) THEN
          Nsk = NCOL
          if(makeio.ne.0)WRITE (8,99024) 'u1',Nsk
        ENDIF
        DO i = 1,Nsk
          U1(i) = mix(i)
        ENDDO
      ELSEIF ( cx4.EQ.'mach' ) THEN
        Nsk = nmix
        IF ( nmix.GT.NCOL ) THEN
          Nsk = NCOL
          if(makeio.ne.0)WRITE (8,99024) 'mach1',Nsk
        ENDIF
        DO i = 1,Nsk
          Mach1(i) = mix(i)
        ENDDO
      ELSEIF ( cx3.EQ.'sub' ) THEN
        Nsub = nmix
        IF ( nmix.GT.13 ) THEN
          Nsub = 13
          if(makeio.ne.0)WRITE (8,99024) 'subar',Nsub
        ENDIF
        DO i = 1,Nsub
          Subar(i) = mix(i)
        ENDDO
      ELSEIF ( cx3.EQ.'sup' ) THEN
        Nsup = nmix
        IF ( nmix.GT.13 ) THEN
          Nsup = 13
          if(makeio.ne.0)WRITE (8,99024) 'supar',Nsup
        ENDIF
        DO i = 1,Nsup
          Supar(i) = mix(i)
        ENDDO
      ELSEIF ( cx2.EQ.'ac' ) THEN
        Acat = mix(1)
      ELSEIF ( cx4.EQ.'mdot'.OR.cx2.EQ.'ma' ) THEN
        Ma = mix(1)
      ELSEIF ( cx4.EQ.'case' ) THEN
        Case_bn = cin(in+1)
        lcin(in+1) = 0
      ELSEIF ( Nof.EQ.0.AND.
     &         (cx3.EQ.'phi'.OR.cx3.EQ.'o/f'.OR.cx3.EQ.'f/a'.OR.
     &         cx2.EQ.'%f'.OR.cx1.EQ.'r') ) THEN
        Nof = nmix
        IF ( nmix.GT.MAXMIX ) THEN
          Nof = MAXMIX
          if(makeio.ne.0)WRITE (8,99024) 'o/f',Nof
        ENDIF
        DO k = 1,Nof
          Oxf(k) = mix(k)
        ENDDO
        IF ( cx3.EQ.'phi' ) THEN
          phi = .TRUE.
        ELSEIF ( cx1.EQ.'r' ) THEN
          eqrats = .TRUE.
        ELSEIF ( cx3.EQ.'f/a' ) THEN
          DO k = 1,Nof
            IF ( Oxf(k).GT.0. ) Oxf(k) = 1./Oxf(k)
          ENDDO
        ELSEIF ( cx4.EQ.'%fue' ) THEN
          DO k = 1,Nof
            IF ( Oxf(k).GT.0. ) Oxf(k) = (100.-Oxf(k))/Oxf(k)
          ENDDO
        ENDIF
      ELSE
        if(makeio.ne.0)WRITE (8,99002) cx15
      ENDIF
      IF ( iv.GE.ncin ) GOTO 100
      GOTO 200
 400  RETURN
99001 FORMAT (/,/)
99002 FORMAT ('  WARNING!!  DID NOT RECOGNIZE ',A15,' (INPUT)'/)
99003 FORMAT (/' WARNING!!  LITERAL EXPECTED FOR ',A15,'(INPUT)')
99004 FORMAT (/' REACTANT AMOUNT MISSING (INPUT)')
99005 FORMAT (/' MOLES AND WEIGHT PERCENTS SHOULD NOT BE MIXED (INPUT)')
99006 FORMAT (/' REACTANT TEMPERATURE MISSING (INPUT) ')
99007 FORMAT (/' WARNING!! ',A15,' NOT RECOGNIZED (INPUT)')
99008 FORMAT (/' OPTIONS: TP=',L1,'  HP=',L1,'  SP=',L1,'  TV=',L1,
     &        '  UV=',L1,'  SV=',L1,'  DETN=',L1,'  SHOCK=',L1,
     &        '  REFL=',L1,'  INCD=',L1,/' RKT=',L1,'  FROZ=',L1,
     &        '  EQL=',L1,'  IONS=',L1,'  SIUNIT=',L1,'  DEBUGF=',L1,
     &        '  SHKDBG=',L1,'  DETDBG=',L1,'  TRNSPT=',L1)
99009 FORMAT (/' T,K =',7F11.4)
99010 FORMAT (/1p,' TRACE=',E9.2,'  S/R=',E13.6,'  H/R=',E13.6,'  U/R=',
     &        E13.6)
99011 FORMAT (/' SPECIFIC VOLUME,M**3/KG =',1p,(4E14.7))
99012 FORMAT (/' Pc,BAR =',7F13.6)
99013 FORMAT (/' Pc/P =',9F11.4)
99014 FORMAT (/' SUBSONIC AREA RATIOS =',(5F11.4))
99015 FORMAT (/' SUPERSONIC AREA RATIOS =',(5F11.4))
99016 FORMAT (/' NFZ=',i3,1p,'  Mdot/Ac=',e13.6,'  Ac/At=',e13.6)
99017 FORMAT (/' P,BAR =',7F13.6)
99018 FORMAT (/' ERROR IN REACTANTS DATASET (INPUT)')
99019 FORMAT (/' UNABLE TO PROCESS EQUIVALENCE RATIO =',E11.4,'(INPUT)')
99020 FORMAT (/' TYPE OF PROBLEM NOT SPECIFIED (INPUT)')
99021 FORMAT (/' ASSIGNED VALUES OF TEMPERATURE ARE MISSING IN prob',
     &        ' DATASET (INPUT)')
99022 FORMAT (/' ASSIGNED PRESSURE (OR DENSITY) MISSING IN prob',
     &        ' DATASET (INPUT)')
99023 FORMAT (/' WARNING!!  A KEYWORD IS MISSING (INPUT)')
99024 FORMAT (/' NOTE!! MAXIMUM NUMBER OF ASSIGNED ',A5,' VALUES IS',I3,
     &        ' (INPUT)',/)
99025 FORMAT (/' FATAL ERROR IN DATASET (INPUT)')
      END
      SUBROUTINE MATRIX
C***********************************************************************
C SET UP ITERATION OR DERIVATIVE MATRIX.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      INTEGER i,iq,iq2,iq3,isym,j,k,kk,kmat
      REAL*8 energyl,f,h,ss,sss,term,term1
      SAVE energyl,f,h,i,iq,iq2,iq3,isym,j,k,kk,kmat,ss,sss,term,term1
C
      iq = Nlm + Npr
      Iq1 = iq + 1
      iq2 = Iq1 + 1
      iq3 = iq2 + 1
      kmat = iq3
      IF ( .NOT.Convg.AND.Tp ) kmat = iq2
      Imat = kmat - 1
C CLEAR MATRIX STORAGES TO ZERO
      DO i = 1,Imat
        DO k = 1,kmat
          G(i,k) = 0.0D0
        ENDDO
      ENDDO
      G(iq2,Iq1) = 0.D0
      sss = 0.D0
      Hsum(Npt) = 0.D0
C BEGIN SET-UP OF ITERATION OR DERIVATIVE MATRIX
      DO j = 1,Ng
        Mu(j) = H0(j) - S(j) + Enln(j) + Tm
        IF ( En(j,Npt).NE.0.D0 ) THEN
          h = H0(j)*En(j,Npt)
          f = Mu(j)*En(j,Npt)
          ss = h - f
          term1 = h
          IF ( kmat.EQ.iq2 ) term1 = f
          DO i = 1,Nlm
            IF ( A(i,j).NE.0. ) THEN
              term = A(i,j)*En(j,Npt)
              DO k = i,Nlm
                G(i,k) = G(i,k) + A(k,j)*term
              ENDDO
              G(i,Iq1) = G(i,Iq1) + term
              G(i,iq2) = G(i,iq2) + A(i,j)*term1
              IF ( .NOT.(Convg.OR.Tp) ) THEN
                G(i,iq3) = G(i,iq3) + A(i,j)*f
                IF ( Sp ) G(iq2,i) = G(iq2,i) + A(i,j)*ss
              ENDIF
            ENDIF
          ENDDO
          IF ( kmat.NE.iq2 ) THEN
            IF ( Convg.OR.Hp ) THEN
              G(iq2,iq2) = G(iq2,iq2) + H0(j)*h
              IF ( .NOT.Convg ) THEN
                G(iq2,iq3) = G(iq2,iq3) + H0(j)*f
                G(Iq1,iq3) = G(Iq1,iq3) + f
              ENDIF
            ELSE
              G(iq2,Iq1) = G(iq2,Iq1) + ss
              G(iq2,iq2) = G(iq2,iq2) + H0(j)*ss
              G(iq2,iq3) = G(iq2,iq3) + Mu(j)*ss
              G(Iq1,iq3) = G(Iq1,iq3) + f
            ENDIF
          ENDIF
          G(Iq1,iq2) = G(Iq1,iq2) + term1
        ENDIF
      ENDDO
C CONDENSED SPECIES
      IF ( Npr.NE.0 ) THEN
        DO k = 1,Npr
          j = Jcond(k)
          kk = Nlm + k
          Mu(j) = H0(j) - S(j)
          DO i = 1,Nlm
            G(i,kk) = A(i,j)
            G(i,kmat) = G(i,kmat) - A(i,j)*En(j,Npt)
          ENDDO
          G(kk,iq2) = H0(j)
          G(kk,kmat) = Mu(j)
          Hsum(Npt) = Hsum(Npt) + H0(j)*En(j,Npt)
          IF ( Sp ) THEN
            sss = sss + S(j)*En(j,Npt)
            G(iq2,kk) = S(j)
          ENDIF
        ENDDO
      ENDIF
      sss = sss + G(iq2,Iq1)
      Hsum(Npt) = Hsum(Npt) + G(Iq1,iq2)
      G(Iq1,Iq1) = Sumn - Enn
C REFLECT SYMMETRIC PORTIONS OF THE MATRIX
      isym = Iq1
      IF ( Hp.OR.Convg ) isym = iq2
      DO i = 1,isym
CDIR$ IVDEP
        DO j = i,isym
          G(j,i) = G(i,j)
        ENDDO
      ENDDO
C COMPLETE THE RIGHT HAND SIDE
      IF ( .NOT.Convg ) THEN
        DO i = 1,Nlm
          G(i,kmat) = G(i,kmat) + B0(i) - G(i,Iq1)
        ENDDO
        G(Iq1,kmat) = G(Iq1,kmat) + Enn - Sumn
C COMPLETE ENERGY ROW AND TEMPERATURE COLUMN
        IF ( kmat.NE.iq2 ) THEN
          IF ( Sp ) energyl = S0 + Enn - Sumn - sss
          IF ( Hp ) energyl = Hsub0/Tt - Hsum(Npt)
          G(iq2,iq3) = G(iq2,iq3) + energyl
          G(iq2,iq2) = G(iq2,iq2) + Cpsum
        ENDIF
      ELSE
        IF ( Pderiv ) THEN
C PDERIV = .TRUE.-- SET UP MATRIX TO SOLVE FOR DLVPT
          G(Iq1,iq2) = Enn
          DO i = 1,iq
            G(i,iq2) = G(i,Iq1)
          ENDDO
        ENDIF
        G(iq2,iq2) = G(iq2,iq2) + Cpsum
      ENDIF
      IF ( Vol.AND..NOT.Convg ) THEN
C CONSTANT VOLUME MATRIX
        IF ( kmat.EQ.iq2 ) THEN
          DO i = 1,iq
            G(i,Iq1) = G(i,iq2)
          ENDDO
        ELSE
CDIR$ IVDEP
          DO i = 1,iq
            G(Iq1,i) = G(iq2,i) - G(Iq1,i)
            G(i,Iq1) = G(i,iq2) - G(i,Iq1)
            G(i,iq2) = G(i,iq3)
          ENDDO
          G(Iq1,Iq1) = G(iq2,iq2) - G(Iq1,iq2) - G(iq2,Iq1)
          G(Iq1,iq2) = G(iq2,iq3) - G(Iq1,iq3)
          IF ( Hp ) G(Iq1,iq2) = G(Iq1,iq2) + Enn
        ENDIF
        kmat = Imat
        Imat = Imat - 1
      ENDIF
      END
      SUBROUTINE NEWOF
C***********************************************************************
C CALCULATE NEW VALUES OF B0 AND HSUB0 FOR NEW OF RATIO
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      INTEGER i,j
      REAL*8 assval,bigb,bratio,dbi,smalb,tem,v1,v2
      REAL*8 DABS,DLOG
      SAVE assval,bigb,bratio,dbi,i,j,smalb,tem,v1,v2
C
      IF ( (.NOT.Short_bn) .and.(makeio.ne.0)) WRITE (8,99001) Oxfl
      Eqrat = 0.
      tem = Oxfl + 1.
      v2 = (Oxfl*Vmin(1)+Vmin(2))/tem
      v1 = (Oxfl*Vpls(1)+Vpls(2))/tem
      IF ( v2.NE.0. ) Eqrat = DABS(v1/v2)
      DO i = 1,Nlm
        B0(i) = (Oxfl*B0p(i,1)+B0p(i,2))/tem
        dbi = DABS(B0(i))
        IF ( i.EQ.1 ) THEN
          bigb = dbi
          smalb = dbi
        ELSEIF ( dbi.NE.0. ) THEN
          IF ( dbi.LT.smalb ) smalb = dbi
          IF ( dbi.GT.bigb ) bigb = dbi
        ENDIF
      ENDDO
      Bcheck = bigb*.000001D0
C CALCUALTE MOLECULAR WEIGHT OF TOTAL REACTANT, WMIX.
      IF ( Am(1).NE.0.0.AND.Am(2).NE.0.0 ) THEN
        Wmix = (Oxfl+1.)*Am(1)*Am(2)/(Am(1)+Oxfl*Am(2))
      ELSE
        Wmix = Am(2)
        IF ( Am(2).EQ.0.0 ) Wmix = Am(1)
      ENDIF
      Npt = 1
C IF ASSIGNED U OR H NOT GIVEN IN PROB DATA, INITIAL HSUB0 = 1.D30
      IF ( Size_bn.EQ.0. ) assval = Hsub0
      IF ( assval.GE.1.D30 ) Hsub0 = (Oxfl*Hpp(1)+Hpp(2))/tem
C NOTE THAT "BRATIO" IS "BRATIO" IN SEC 3.2 IN RP-1311.
      bratio = smalb/bigb
      Size_bn = 18.420681D0
      IF ( bratio.LT.1.D-5 ) Size_bn = DLOG(1000.D0/bratio)
      Jsol = 0
      Jliq = 0
      IF ( .NOT.Short_bn ) THEN
        if(makeio.ne.0)WRITE (8,99002)
        IF ( Vol .and.(makeio.ne.0)) WRITE (8,99003)
        IF ( (.NOT.Vol) .and.(makeio.ne.0)) WRITE (8,99004)
        if(makeio.ne.0)WRITE (8,99005) Hpp(2),Hpp(1),Hsub0
        if(makeio.ne.0)WRITE (8,99006)
      ENDIF
      DO i = 1,Nlm
        j = Jcm(i)
        IF ( (.NOT.Short_bn) .and.(makeio.ne.0)) 
     &   WRITE (8,99007) Prod(j),B0p(i,2),B0p(i,1),  B0(i)
      ENDDO
      RETURN
99001 FORMAT (/' O/F = ',F10.6)
99002 FORMAT (/,23X,'EFFECTIVE FUEL',5X,'EFFECTIVE OXIDANT',8X,
     &        'MIXTURE')
99003 FORMAT (' INTERNAL ENERGY',11X,'u(2)/R',14X,'u(1)/R',14X,'u0/R')
99004 FORMAT (' ENTHALPY',18X,'h(2)/R',14X,'h(1)/R',15X,'h0/R')
99005 FORMAT (' (KG-MOL)(K)/KG',4X,E18.8,2E20.8)
99006 FORMAT (/' KG-FORM.WT./KG',13X,'bi(2)',15X,'bi(1)',15X,'b0i')
99007 FORMAT (1X,A16,3E20.8)
      END
      SUBROUTINE OUT1
C***********************************************************************
C OUT1 WRITES REACTANT AND FUEL-OXIDANT RATIO INFORMATION.
C ENTRY OUT2 WRITES THERMODYNAMIC PROPERTIES.
C ENTRY OUT3 WRITES MOLE FRACTIONS.
C ENTRY OUT4 WRITES TRANSPORT PROPERTIES.
C
C NOTE - ROCKET, SHOCK, AND DETON PROBLEMS HAVE ADDITIONAL OUTPUT.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      CHARACTER*15 fc,fgi,fh,fp,frh,fs,fu
      CHARACTER*4 mamo
      INTEGER i,im,ione,ixfr,ixfz,j,k,kin,m,mcond,mcp,mdvp,mdvt,meq,mfa,
     &        mg,mgam,mh,mie,mm,mmw,mof,mp,mpf,mph,mpn,mrho,ms,mson,mt,
     &        mvis,mxx(22),n,notuse
c///      INTEGER INDEX
      LOGICAL kok
      REAL*8 pfactor,pfuel,phi,rho,tem,tra,vnum
      SAVE fc,fgi,fh,fp,frh,fs,fu,i,im,ione,ixfr,ixfz,j,k,kin,kok,m,
     &  mamo,mcond,mcp,mdvp,mdvt,meq,mfa,mg,mgam,mh,mie,mm,mmw,mof,mp,
     &  mpf,mph,mpn,mrho,ms,mson,mt,mvis,mxx,n,notuse,pfactor,pfuel,phi,
     &  rho,tem,tra,vnum
C
      EQUIVALENCE (mxx(1),mp)
      EQUIVALENCE (mxx(2),mt)
      EQUIVALENCE (mxx(3),mrho)
      EQUIVALENCE (mxx(4),mh)
      EQUIVALENCE (mxx(5),mie)
      EQUIVALENCE (mxx(6),mg)
      EQUIVALENCE (mxx(7),ms)
      EQUIVALENCE (mxx(8),mm)
      EQUIVALENCE (mxx(9),mcp)
      EQUIVALENCE (mxx(10),mgam)
      EQUIVALENCE (mxx(11),mson)
      EQUIVALENCE (mxx(12),mcond)
      EQUIVALENCE (mxx(13),mvis)
      EQUIVALENCE (mxx(14),mpn)
      EQUIVALENCE (mxx(15),mpf)
      EQUIVALENCE (mxx(16),mof)
      EQUIVALENCE (mxx(17),mph)
      EQUIVALENCE (mxx(18),meq)
      EQUIVALENCE (mxx(19),mfa)
      EQUIVALENCE (mxx(20),mmw)
      EQUIVALENCE (mxx(21),mdvt)
      EQUIVALENCE (mxx(22),mdvp)
      if(makeio.ne.0)WRITE (8,99001) Case_bn
      IF ( Moles ) THEN
        if(makeio.ne.0)WRITE (8,99002) '   MOLES   '
        IF ( (.NOT.Siunit) .and.(makeio.ne.0)) WRITE (8,99003)
        IF ( Siunit .and.(makeio.ne.0)) WRITE (8,99004)
      ELSE
        if(makeio.ne.0)WRITE (8,99002) 'WT FRACTION'
        IF ( (.NOT.Siunit) .and.(makeio.ne.0)) WRITE (8,99005)
        IF ( Siunit .and.(makeio.ne.0)) WRITE (8,99006)
      ENDIF
      DO n = 1,Nreac
        if(makeio.ne.0)WRITE (8,99007) 
     &        Fox(n),Rname(n),Pecwt(n),Enth(n)*R,Rtemp(n)
      ENDDO
      phi = 0.
      tem = (Vpls(1)+Vmin(1))*Oxfl
      IF ( ABS(tem).GE.1.D-3 ) phi = -(Vmin(2)+Vpls(2))/tem
      IF ( Fox(1).EQ.'NAME' ) THEN
        pfuel = 0.
      ELSE
        pfuel = 100.D0/(1.D0+Oxfl)
      ENDIF
      IF ( Rh(1).NE.0..OR.Rh(2).NE.0. ) THEN
        IF ( Rh(1).EQ.0..OR.Rh(2).EQ.0. ) THEN
          rho = MAX(Rh(1),Rh(2))
        ELSE
          rho = (Oxfl+1.)*Rh(1)*Rh(2)/(Rh(1)+Oxfl*Rh(2))
        ENDIF
        IF ( Siunit ) THEN
          rho = rho*1000.D0
          if(makeio.ne.0)WRITE (8,99021) rho
        ELSE
          if(makeio.ne.0)WRITE (8,99022) rho
        ENDIF
      ENDIF
      if(makeio.ne.0)WRITE (8,99008) Oxfl,pfuel,Eqrat,phi
      RETURN
C***********************************************************************
      ENTRY OUT2
      ione = 0
      IF ( Rkt.AND..NOT.Page1 ) THEN
        ione = 2
        IF ( Iopt.NE.0 ) ione = 3
      ENDIF
C SET MXX ARRAY FOR PLOTTING PARAMETERS
      DO i = 1,22
        mxx(i) = 0
      ENDDO
      DO i = 1,Nplt
        IF ( INDEX(Pltvar(i)(2:),'1').EQ.0 ) THEN
          ixfz = INDEX(Pltvar(i)(2:),'fz')
          ixfr = INDEX(Pltvar(i)(2:),'fr')
          IF ( ixfz.NE.0.OR.ixfr.NE.0 ) THEN
            IF ( Eql ) GOTO 100
          ELSEIF ( .NOT.Eql ) THEN
            GOTO 100
          ENDIF
          IF ( INDEX(Pltvar(i)(1:),'dlnt').NE.0 ) THEN
            mdvt = i
          ELSEIF ( INDEX(Pltvar(i)(1:),'dlnp').NE.0 ) THEN
            mdvp = i
          ELSEIF ( Pltvar(i)(:4).EQ.'pran' ) THEN
            mpn = i
          ELSEIF ( Pltvar(i)(:4).EQ.'cond' ) THEN
            mcond = i
          ELSEIF ( Pltvar(i)(:3).EQ.'phi' ) THEN
            mph = i
          ELSEIF ( Pltvar(i)(:1).EQ.'p' ) THEN
            mp = i
          ELSEIF ( Pltvar(i)(:1).EQ.'t' ) THEN
            mt = i
          ELSEIF ( Pltvar(i)(:3).EQ.'rho' ) THEN
            mrho = i
          ELSEIF ( Pltvar(i)(:1).EQ.'h' ) THEN
            mh = i
          ELSEIF ( Pltvar(i)(:1).EQ.'u' ) THEN
            mie = i
          ELSEIF ( Pltvar(i)(:3).EQ.'gam' ) THEN
            mgam = i
          ELSEIF ( Pltvar(i)(:3).EQ.'son' ) THEN
            mson = i
          ELSEIF ( Pltvar(i)(:1).EQ.'g' ) THEN
            mg = i
          ELSEIF ( Pltvar(i)(:1).EQ.'s' ) THEN
            ms = i
          ELSEIF ( Pltvar(i)(:1).EQ.'m'.AND.Pltvar(i)(:2).NE.'ma' ) THEN
            IF ( .NOT.Gonly.AND.Pltvar(i)(:2).EQ.'mw' ) THEN
              mmw = i
            ELSE
              mm = i
            ENDIF
          ELSEIF ( Pltvar(i)(:2).EQ.'cp' ) THEN
            mcp = i
          ELSEIF ( Pltvar(i)(:3).EQ.'vis' ) THEN
            mvis = i
          ELSEIF ( Pltvar(i)(:3).EQ.'o/f' ) THEN
            mof = i
          ELSEIF ( Pltvar(i)(:2).EQ.'%f' ) THEN
            mpf = i
          ELSEIF ( Pltvar(i)(:3).EQ.'f/a' ) THEN
            mfa = i
          ELSEIF ( Pltvar(i)(:4).EQ.'r,ce' ) THEN
            meq = i
          ENDIF
        ENDIF
 100  ENDDO
      DO i = Iplt + 1,Iplt + Npt
        IF ( mof.GT.0 ) Pltout(i,mof) = Oxfl
        IF ( mpf.GT.0 ) Pltout(i,mpf) = pfuel
        IF ( mph.GT.0 ) Pltout(i,mph) = phi
        IF ( mfa.GT.0 ) Pltout(i,mfa) = 1.D0/Oxfl
        IF ( meq.GT.0 ) Pltout(i,meq) = Eqrat
      ENDDO
      IF ( Siunit ) THEN
        pfactor = 1.D0
        fp = 'P, BAR'
        vnum = 1.D05
        frh = 'RHO, KG/CU M'
        fh = 'H, KJ/KG'
        fu = 'U, KJ/KG'
        fgi = 'G, KJ/KG'
        fs = 'S, KJ/(KG)(K)'
        fc = 'Cp, KJ/(KG)(K)'
      ELSE
        pfactor = 1.D0/1.01325D0
        fp = 'P, ATM'
        vnum = 100.D0
        frh = 'RHO, G/CC'
        fh = 'H, CAL/G'
        fu = 'U, CAL/G'
        fgi = 'G, CAL/G'
        fs = 'S, CAL/(G)(K)'
        fc = 'Cp, CAL/(G)(K)'
      ENDIF
      Fmt(4) = Fmt(6)
C PRESSURE
      CALL VARFMT(Ppp)
      DO i = 1,Npt
        X(i) = Ppp(i)*pfactor
        IF ( Nplt.NE.0.AND.i.GT.ione ) THEN
          IF ( mp.GT.0 ) Pltout(i+Iplt-ione,mp) = X(i)
          IF ( mt.GT.0 ) Pltout(i+Iplt-ione,mt) = Ttt(i)
        ENDIF
      ENDDO
      if(makeio.ne.0)WRITE (8,Fmt) fp,(X(j),j=1,Npt)
C TEMPERATURE
      Fmt(4) = '13'
      Fmt(5) = ' '
      Fmt(7) = '2,'
      if(makeio.ne.0)
     $     WRITE (8,Fmt) 'T, K            ',(Ttt(j),j=1,Npt)
C DENSITY
      DO i = 1,Npt
        IF ( Vlm(i).NE.0. ) X(i) = vnum/Vlm(i)
        IF ( Nplt.NE.0.AND.i.GT.ione.AND.mrho.GT.0 )
     &       Pltout(i+Iplt-ione,mrho) = X(i)
      ENDDO
      CALL EFMT(Fmt(4),frh,X)
C ENTHALPY
      DO i = 1,Npt
        X(i) = Hsum(i)*R
        IF ( Nplt.NE.0.AND.i.GT.ione.AND.mh.GT.0 )
     &       Pltout(i+Iplt-ione,mh) = X(i)
      ENDDO
      Fmt(4) = Fmt(6)
      CALL VARFMT(X)
      if(makeio.ne.0)WRITE (8,Fmt) fh,(X(j),j=1,Npt)
C INTERNAL ENERGY
      DO i = 1,Npt
        X(i) = (Hsum(i)-Ppp(i)*Vlm(i)/Rr)*R
        IF ( Nplt.NE.0.AND.i.GT.ione.AND.mie.GT.0 )
     &       Pltout(i+Iplt-ione,mie) = X(i)
      ENDDO
      CALL VARFMT(X)
      if(makeio.ne.0)WRITE (8,Fmt) fu,(X(j),j=1,Npt)
C GIBBS ENERGY
      DO i = 1,Npt
        X(i) = (Hsum(i)-Ttt(i)*Ssum(i))*R
        IF ( Nplt.NE.0.AND.i.GT.ione ) THEN
          IF ( mg.GT.0 ) Pltout(i+Iplt-ione,mg) = X(i)
          IF ( mm.GT.0 ) Pltout(i+Iplt-ione,mm) = Wm(i)
          IF ( mmw.GT.0 ) Pltout(i+Iplt-ione,mmw) = 1.D0/Totn(i)
          IF ( ms.GT.0 ) Pltout(i+Iplt-ione,ms) = Ssum(i)*R
          IF ( mcp.GT.0 ) Pltout(i+Iplt-ione,mcp) = Cpr(i)*R
          IF ( mgam.GT.0 ) Pltout(i+Iplt-ione,mgam) = Gammas(i)
          IF ( mdvt.GT.0 ) Pltout(i+Iplt-ione,mdvt) = Dlvtp(i)
          IF ( mdvp.GT.0 ) Pltout(i+Iplt-ione,mdvp) = Dlvpt(i)
        ENDIF
      ENDDO
      CALL VARFMT(X)
      if(makeio.ne.0)WRITE (8,Fmt) fgi,(X(j),j=1,Npt)
C ENTROPY
      Fmt(4) = '13'
      Fmt(5) = ' '
      Fmt(7) = '4,'
      if(makeio.ne.0)WRITE (8,Fmt) fs,(Ssum(j)*R,j=1,Npt)
      if(makeio.ne.0)WRITE (8,99009)
C MOLECULAR WEIGHT
      Fmt(7) = '3,'
      if(makeio.ne.0)WRITE (8,Fmt) 'M, (1/n)        ',(Wm(j),j=1,Npt)
      IF ( (.NOT.Gonly) .and.(makeio.ne.0)) 
     $    WRITE (8,Fmt) 'MW, MOL WT      ',
     &    (1.D0/Totn(j),j=1,Npt)
C (DLV/DLP)T
      Fmt(7) = '5,'
      IF ( Eql .and.(makeio.ne.0)) WRITE (8,Fmt) 
     &       '(dLV/dLP)t      ',(Dlvpt(j),j=1,Npt)
C (DLV/DLT)P
      Fmt(7) = '4,'
      IF ( Eql .and.(makeio.ne.0)) 
     &    WRITE (8,Fmt) '(dLV/dLT)p      ',(Dlvtp(j),j=1,Npt)
C HEAT CAPACITY
      if(makeio.ne.0)WRITE (8,Fmt) fc,(Cpr(j)*R,j=1,Npt)
C GAMMA(S)
      Fmt(7) = '4,'
      if(makeio.ne.0)
     $ WRITE (8,Fmt) 'GAMMAs          ',(Gammas(j),j=1,Npt)
C SONIC VELOCITY
      Fmt(7) = '1,'
      DO i = 1,Npt
        Sonvel(i) = (Rr*Gammas(i)*Ttt(i)/Wm(i))**.5
        IF ( Nplt.NE.0.AND.i.GT.ione.AND.mson.GT.0 )
     &       Pltout(i+Iplt-ione,mson) = Sonvel(i)
      ENDDO
      if(makeio.ne.0)
     $ WRITE (8,Fmt) 'SON VEL,M/SEC   ',(Sonvel(j),j=1,Npt)
      RETURN
C***********************************************************************
      ENTRY OUT3
      tra = 5.D-6
      IF ( Trace.NE.0. ) tra = Trace
      IF ( Eql ) THEN
C MOLE FRACTIONS - EQUILIBRIUM
        IF ( Massf ) THEN
          mamo = 'MASS'
        ELSE
          mamo = 'MOLE'
        ENDIF
        if(makeio.ne.0)WRITE (8,99010) mamo
        notuse = 0
        DO k = 1,Ngc
          kok = .TRUE.
          IF ( k.GT.Ng.AND.k.LT.Ngc.AND.Prod(k).EQ.Prod(k+1) ) THEN
            kok = .FALSE.
            im = 0
            GOTO 120
          ENDIF
          DO m = 1,Nplt
            im = 0
            IF ( Pltvar(m).EQ.Prod(k).OR.'*'//Pltvar(m).EQ.Prod(k) )
     &           THEN
              im = m
              GOTO 120
            ENDIF
          ENDDO
 120      kin = 0
          DO i = 1,Npt
            IF ( Massf ) THEN
              tem = Mw(k)
            ELSE
              tem = 1.D0/Totn(i)
            ENDIF
            IF ( k.LE.Ng ) THEN
              X(i) = En(k,i)*tem
            ELSE
              IF ( Prod(k).NE.Prod(k-1) ) X(i) = 0.D0
              IF ( En(k,i).GT.0.D0 ) X(i) = En(k,i)*tem
            ENDIF
            IF ( Nplt.NE.0.AND.i.GT.ione.AND.im.GT.0 )
     &           Pltout(i+Iplt-ione,im) = X(i)
            IF ( kok.AND.X(i).GE.tra ) kin = 1
          ENDDO
          IF ( kin.EQ.1 ) THEN
            IF ( Trace.EQ.0. ) THEN
              if(makeio.ne.0)WRITE (8,99011) Prod(k),(X(i),i=1,Npt)
            ELSE
              CALL EFMT(Fmt(4),Prod(k),X)
            ENDIF
            IF ( Prod(k).EQ.Omit(notuse) ) notuse = notuse - 1
          ELSEIF ( Prod(k).NE.Prod(k-1) ) THEN
            notuse = notuse + 1
            Omit(notuse) = Prod(k)
          ENDIF
        ENDDO
      ENDIF
      if(makeio.ne.0)WRITE (8,99012) Tg(4)
      IF ( .NOT.Short_bn ) THEN
c...  this mamo logic is duplicated because mamo gets nulled somewhere C.Taylor 3/16/2020      
        IF ( Massf ) THEN
          mamo = 'MASS'
        ELSE
          mamo = 'MOLE'
        ENDIF
      
        if(makeio.ne.0)WRITE (8,99013) mamo,tra
        if(makeio.ne.0)WRITE (8,99014) (Omit(i),i=1,notuse)
      ENDIF
      IF ( (.NOT.Moles) .and.(makeio.ne.0)) WRITE (8,99015)
      GOTO 200
C***********************************************************************
      ENTRY OUT4
      if(makeio.ne.0)WRITE (8,99009)
      if(makeio.ne.0)WRITE (8,99016)
      IF ( Siunit ) THEN
        if(makeio.ne.0)WRITE (8,99018)
      ELSE
        if(makeio.ne.0)WRITE (8,99017)
      ENDIF
C VISCOSITY
      Fmt(4) = Fmt(6)
      IF ( Nplt.GT.0 ) THEN
        DO i = 1,Npt
          IF ( i.GT.ione ) THEN
            IF ( mvis.GT.0 ) Pltout(i+Iplt-ione,mvis) = Vis(i)
            IF ( Eql ) THEN
              IF ( mcond.GT.0 ) Pltout(i+Iplt-ione,mcond) = Coneql(i)
              IF ( mpn.GT.0 ) Pltout(i+Iplt-ione,mpn) = Preql(i)
            ELSE
              IF ( mcond.GT.0 ) Pltout(i+Iplt-ione,mcond) = Confro(i)
              IF ( mpn.GT.0 ) Pltout(i+Iplt-ione,mpn) = Prfro(i)
            ENDIF
          ENDIF
        ENDDO
      ENDIF
      CALL VARFMT(Vis)
      if(makeio.ne.0)WRITE (8,Fmt) 'VISC,MILLIPOISE',(Vis(j),j=1,Npt)
      Fmt(4) = '13'
      Fmt(5) = ' '
      Fmt(7) = '4,'
      IF ( Eql ) THEN
        if(makeio.ne.0)WRITE (8,99019)
C SPECIFIC HEAT
        if(makeio.ne.0)WRITE (8,Fmt) fc,(Cpeql(j),j=1,Npt)
C CONDUCTIVITY
        if(makeio.ne.0)
     $   WRITE (8,Fmt) 'CONDUCTIVITY    ',(Coneql(j),j=1,Npt)
C PRANDTL NUMBER
        if(makeio.ne.0)
     $   WRITE (8,Fmt) 'PRANDTL NUMBER  ',(Preql(j),j=1,Npt)
      ENDIF
      if(makeio.ne.0)WRITE (8,99020)
C SPECIFIC HEAT
      if(makeio.ne.0)WRITE (8,Fmt) fc,(Cpfro(j),j=1,Npt)
C CONDUCTIVITY
      if(makeio.ne.0)
     $  WRITE (8,Fmt) 'CONDUCTIVITY    ',(Confro(j),j=1,Npt)
C PRANDTL NUMBER
      if(makeio.ne.0)
     $ WRITE (8,Fmt) 'PRANDTL NUMBER  ',(Prfro(j),j=1,Npt)
 200  RETURN
99001 FORMAT (' CASE = ',a15)
99002 FORMAT (/13X,'REACTANT',20x,a11,'      ENERGY',6x,'TEMP')
99003 FORMAT (57X,' CAL/MOL ',6x,'K')
99004 FORMAT (57X,'KJ/KG-MOL',6x,'K')
99005 FORMAT (42X,'(SEE NOTE)      CAL/MOL       K  ')
99006 FORMAT (42X,'(SEE NOTE)     KJ/KG-MOL      K  ')
99007 FORMAT (1x,a8,4x,a15,11x,f12.7,f14.3,f11.3)
99008 FORMAT (/' O/F=',F11.5,2X,'%FUEL=',F10.6,2X,'R,EQ.RATIO=',F9.6,2X,
     &        'PHI,EQ.RATIO=',F9.6)
99009 FORMAT ()
99010 FORMAT (/1x,A4,' FRACTIONS'/)
99011 FORMAT (1x,A15,F9.5,12F9.5)
99012 FORMAT (/'  * THERMODYNAMIC PROPERTIES FITTED TO',F7.0,'K')
99013 FORMAT (/'    PRODUCTS WHICH WERE CONSIDERED BUT WHOSE ',A4,
     &        ' FRACTIONS',/'    WERE LESS THAN',1PE13.6,
     &        ' FOR ALL ASSIGNED CONDITIONS'/)
99014 FORMAT (5(1x,A15))
99015 FORMAT (/' NOTE. WEIGHT FRACTION OF FUEL IN TOTAL FUELS AND OF',
     &        ' OXIDANT IN TOTAL OXIDANTS')
99016 FORMAT (' TRANSPORT PROPERTIES (GASES ONLY)')
99017 FORMAT ('   CONDUCTIVITY IN UNITS OF MILLICALORIES/(CM)(K)(SEC)'/)
99018 FORMAT ('   CONDUCTIVITY IN UNITS OF MILLIWATTS/(CM)(K)'/)
99019 FORMAT (/'  WITH EQUILIBRIUM REACTIONS'/)
99020 FORMAT (/'  WITH FROZEN REACTIONS'/)
99021 FORMAT (/' REACTANT DENSITY=',F8.2,' KG/CU M')
99022 FORMAT (/' REACTANT DENSITY=',F8.4,' G/CC')
      END
      SUBROUTINE REACT
C***********************************************************************
C READ AND PROCESS REACTANT RECORDS.  CALLED FROM SUBROUTINE INPUT.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      CHARACTER*6 date
      CHARACTER*2 el(5)
      CHARACTER*15 sub
      INTEGER i,icf,ifaz,ifrmla,itot,j,jj,k,kk,kr,l,n,nall,nint,nj,
     &        ntgas,ntot
      LOGICAL fuel,rcoefs,wdone(2),hok
      REAL*8 bb(5),dat(35),dift,eform,pcwt,rcf(9,3),rm,t1,t2
      REAL*8 DABS,DLOG,t1save,t2save
      SAVE bb,dat,date,dift,eform,el,fuel,i,icf,ifaz,ifrmla,itot,j,jj,k,
     &  kk,kr,l,n,nall,nint,nj,ntgas,ntot,pcwt,rcf,rcoefs,rm,sub,t1,t2,
     &  wdone
     
      if( read_d .eq. 0 ) return
C
      DO k = 1,2
        wdone(k) = .FALSE.
        Wp(k) = 0.
        Hpp(k) = 0.
        Vpls(k) = 0.
        Vmin(k) = 0.
        Am(k) = 0.
        Rh(k) = 0.
        DO j = 1,MAXEL
          Elmt(j) = ' '
          B0p(j,k) = 0.
        ENDDO
      ENDDO
      DO i = 1,MAXEL
        dat(i) = 0.
      ENDDO
C IF OXIDANT, KR = 1
C IF FUEL, KR = 2
      DO n = 1,Nreac
        hok = .false.
        t1save = 20000.d0
        t2save = 0.d0
        rcoefs = .TRUE.
        IF ( Energy(n).EQ.'lib'.OR.Rnum(n,1).EQ.0. ) THEN
          Tt = Rtemp(n)
          REWIND IOTHM
          READ (IOTHM) Tg,ntgas,ntot,nall
          DO itot = 1,nall
            IF ( itot.LE.ntot ) THEN
              icf = 3
              IF ( itot.GT.ntgas ) icf = 1
              READ (IOTHM) sub,nint,date,(el(j),bb(j),j=1,5),ifaz,t1,t2,
     &                     rm,((rcf(i,j),i=1,9),j=1,icf)
            ELSE
              READ (IOTHM) sub,nint,date,(el(j),bb(j),j=1,5),ifaz,t1,t2,
     &                     rm,eform
              IF ( nint.GT.0 ) READ (IOTHM) ((rcf(i,j),i=1,9),j=1,nint)
            ENDIF
            IF ( sub.EQ.Rname(n).OR.sub.EQ.'*'//Rname(n) ) THEN
              IF ( nint.EQ.0 ) THEN
                rcoefs = .FALSE.
                hok = .true.
                Enth(n) = eform*1000.D0/Rr
                IF ( Tt.EQ.0 ) THEN
                  Tt = t1
                  Rtemp(n) = t1
                ELSE
                  dift = DABS(Tt-t1)
                  IF ( dift.GT.01d0 ) THEN
                    IF ( dift.GT.10.d0 ) THEN
                      if(makeio.ne.0)WRITE (8,99001) Rname(n),t1,Tt
                      Nlm = 0
                      hok = .false.
                      GOTO 200
                    ELSE
                      if(makeio.ne.0)WRITE (8,99002) Rname(n),t1,Tt
                      Tt = t1
                      Rtemp(n) = t1
                    ENDIF
                  ENDIF
                ENDIF
              ELSE
                if (ifaz.LE.0 ) then
                  t1save = min(t1save,.8d0*tg(1))
                  t2save = max(t2save,1.2d0*t2)
                else  
                  t1save = min(t1save,t1-.001d0)
                  t2save = max(t2save,t2+.001d0)
                endif
                if ( t1save .lt.Tt .and. t2save.gt.Tt ) hok = .true.
              ENDIF
              DO j = 1,5
                IF ( bb(j).EQ.0. ) GOTO 5
                Nfla(n) = j
                Ratom(n,j) = el(j)
                Rnum(n,j) = bb(j)
              ENDDO
 5            IF ( Tt.EQ.0. ) THEN
                IF ( .NOT.Hp ) GOTO 50
                if(makeio.ne.0)WRITE (8,99004) n
                Nlm = 0
                GOTO 200
              ENDIF
              IF ( rcoefs.and.hok ) THEN
                Tln = DLOG(Tt)
                l = 1
                IF ( ifaz.LE.0 ) THEN
                  IF ( Tt.GT.Tg(2) ) l = 2
                  IF ( Tt.GT.Tg(3) ) l = 3
                ENDIF
                Enth(n) = (((((rcf(7,l)/5.D0)*Tt+rcf(6,l)/4.D0)*Tt+rcf(5
     &                    ,l)/3.D0)*Tt+rcf(4,l)/2.D0)*Tt+rcf(3,l))
     &                    *Tt - rcf(1,l)/Tt + rcf(2,l)*Tln + rcf(8,l)
                IF ( Vol.AND.ifaz.LE.0 ) Enth(n) = Enth(n) - Tt
              ENDIF
              if (hok) GOTO 50
            ENDIF
 20       ENDDO
          if (.not.hok) then
            if(makeio.ne.0)WRITE (8,99010) Tt,Rname(n),t1save,t2save
            Energy(n) = ' '
            Nlm = 0
            goto 200
          endif
        ENDIF
 50     ifrmla = Nfla(n)
        IF ( Fox(n)(:1).EQ.'f' ) THEN
          fuel = .TRUE.
          kr = 2
          Fox(n) = 'FUEL'
        ELSEIF ( Fox(n)(:4).EQ.'name' ) THEN
          fuel = .TRUE.
          kr = 2
          Fox(n) = 'NAME'
        ELSE
          kr = 1
          Fox(n) = 'OXIDANT'
        ENDIF
        DO j = 1,MAXEL
          dat(j) = 0.
        ENDDO
C STORE ATOMIC SYMBOLS IN ELMT ARRAY.
C CALCULATE MOLECULAR WEIGHT.
C TEMPORARILY STORE ATOMIC VALENCE IN X.
        rm = 0.D0
        DO jj = 1,ifrmla
          DO j = 1,MAXEL
            nj = j
            IF ( Elmt(j).EQ.' ' ) GOTO 60
            IF ( Ratom(n,jj).EQ.Elmt(j) ) GOTO 80
          ENDDO
 60       Nlm = nj
          Elmt(j) = Ratom(n,jj)
 80       DO kk = 1,101
            IF ( Symbol(kk).EQ.Ratom(n,jj) ) THEN
              rm = rm + Rnum(n,jj)*Atmwt(kk)
              Atwt(j) = Atmwt(kk)
              X(j) = Valnce(kk)
              dat(j) = dat(j) + Rnum(n,jj)
              GOTO 100
            ENDIF
          ENDDO
          if(makeio.ne.0)WRITE (8,99005) Ratom(n,jj)
          Nlm = 0
          GOTO 200
 100    ENDDO
        IF ( Pecwt(n).LT.0. ) THEN
          Pecwt(n) = 0.
          IF ( .NOT.Moles.AND..NOT.wdone(kr) ) THEN
            wdone(kr) = .TRUE.
            Pecwt(n) = 100.
            if(makeio.ne.0)WRITE (8,99006) n
          ELSE
            if(makeio.ne.0)WRITE (8,99007) n
            Nlm = 0
            GOTO 200
          ENDIF
        ENDIF
C ADD CONTRIBUTIONS TO WP(K), HPP(K), AM(K), AND B0P(I,K)
        IF ( Pecwt(n).GT.0. ) wdone(kr) = .TRUE.
        pcwt = Pecwt(n)
        IF ( Moles ) pcwt = pcwt*rm
        Wp(kr) = Wp(kr) + pcwt
        IF ( rm.LE.0.D0 ) THEN
          Nlm = 0
          GOTO 200
        ELSE
          Hpp(kr) = Hpp(kr) + Enth(n)*pcwt/rm
          Am(kr) = Am(kr) + pcwt/rm
          IF ( Dens(n).NE.0. ) THEN
            Rh(kr) = Rh(kr) + pcwt/Dens(n)
          ELSE
            Rh(1) = 0.
            Rh(2) = 0.
          ENDIF
          DO j = 1,Nlm
            B0p(j,kr) = dat(j)*pcwt/rm + B0p(j,kr)
          ENDDO
          Rmw(n) = rm
        ENDIF
      ENDDO
      IF ( .NOT.fuel ) THEN
C 100 PERCENT OXIDANT, SWITCH INDICES
        DO n = 1,Nreac
          Fox(n) = ' '
        ENDDO
        Wp(2) = Wp(1)
        Wp(1) = 0.
        Hpp(2) = Hpp(1)
        Am(2) = Am(1)
        Am(1) = 0.
        DO j = 1,Nlm
          B0p(j,2) = B0p(j,1)
        ENDDO
      ENDIF
      IF ( Nlm.NE.0 ) THEN
C NORMALIZE HPP(KKR),AM(KR),B0P(I,KR), AND PECWT(N).
C CALCULATE V+(KR), AND V-(KR)
        DO kr = 1,2
          IF ( Wp(kr).NE.0. ) THEN
            Hpp(kr) = Hpp(kr)/Wp(kr)
            Am(kr) = Wp(kr)/Am(kr)
            IF ( Rh(kr).NE.0. ) Rh(kr) = Wp(kr)/Rh(kr)
            DO j = 1,Nlm
              B0p(j,kr) = B0p(j,kr)/Wp(kr)
              IF ( X(j).LT.0. ) Vmin(kr) = Vmin(kr) + B0p(j,kr)*X(j)
              IF ( X(j).GT.0. ) Vpls(kr) = Vpls(kr) + B0p(j,kr)*X(j)
            ENDDO
            IF ( .NOT.Moles ) THEN
              DO n = 1,Nreac
                IF ( Fox(n)(:1).NE.'O'.OR.kr.NE.2 ) THEN
                  IF ( Fox(n)(:1).EQ.'O'.OR.kr.NE.1 ) Pecwt(n)
     &                 = Pecwt(n)/Wp(kr)
                ENDIF
              ENDDO
            ENDIF
          ENDIF
        ENDDO
        IF ( .NOT.Short_bn ) THEN
          IF ( Moles ) THEN
            if(makeio.ne.0)WRITE (8,99008) ' MOLES '
          ELSE
            if(makeio.ne.0)WRITE (8,99008) 'WT.FRAC'
          ENDIF
          DO n = 1,Nreac
            if(makeio.ne.0)WRITE (8,99009)
     &                      Fox(n),Rname(n),Pecwt(n),Enth(n),Rtemp(n),
     &                      Dens(n),(Ratom(n,i),Rnum(n,i),i=1,Nfla(n))
          ENDDO
        ENDIF
      ENDIF
 200  RETURN
99001 FORMAT (/' REACTANT ',A15,'HAS BEEN DEFINED FOR THE TEMPERATURE', 
     &  F8.2,'K ONLY.'/' YOUR TEMPERATURE ASSIGNMENT',F8.2,
     &  ' IS MORE THAN 10 K FROM THIS VALUE. (REACT)')
99002 FORMAT (/' NOTE! REACTANT ',A15,'HAS BEEN DEFINED FOR ',
     &  'TEMPERATURE',F8.2,'K ONLY.'/' YOUR TEMPERATURE ASSIGNMENT',
     &  F8.2,' IS NOT = BUT <10 K FROM THIS VALUE. (REACT)')
99003 FORMAT (/' NOTE: ',A15,' IS EITHER NOT IN thermo.lib OR THE',
     &        ' TEMPERATURE ',/,
     &        ' IS OUT OF RANGE FOR THIS SPECIES (REACT)')
99004 FORMAT (/' TEMPERATURE MISSING FOR REACTANT NO.',I2,'(REACT)')
99005 FORMAT (/1x,a2,' NOT FOUND IN BLOCKDATA (REACT)')
99006 FORMAT (/' WARNING!!  AMOUNT MISSING FOR REACTANT',I3,'.',
     &        /' PROGRAM SETS WEIGHT PERCENT = 100. (REACT)')
99007 FORMAT (/' AMOUNT MISSING FOR REACTANT NO.',I2,'(REACT)')
99008 FORMAT (/4x,'REACTANT',10x,A7,3X,'(ENERGY/R),K',3X,
     &        'TEMP,K  DENSITY'/,8x,'EXPLODED FORMULA')
99009 FORMAT (1x,a1,': ',a15,f10.6,e15.6,f9.2,f8.4,/8x,5(2x,a2,f8.5))
99010 FORMAT (/' YOUR ASSIGNED TEMPERATURE',F8.2,'K FOR ',A15,/,
     & 'IS OUTSIDE ITS TEMPERATURE RANGE',F8.2,' TO',F9.2,'K (REACT)')
      END
      SUBROUTINE RKTOUT
C***********************************************************************
C SPECIAL OUTPUT FOR ROCKET PROBLEMS.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      CHARACTER*4 exit(11)
      CHARACTER*15 fi,fiv,fr,z(4)
      INTEGER i,i23,i46,i57,i68,i79,ione,ixfr,ixfz,j,k,line,ln,mae,mcf,
     &        misp,mivac,mmach,mppf,mppj,mxx(8),nex
c///      INTEGER INDEX
      REAL*8 agv,aw,gc,tem,tra,ww
      SAVE agv,aw,fi,fiv,fr,gc,i,i23,i46,i57,i68,i79,ione,ixfr,ixfz,j,k,
     &  line,ln,mae,mcf,misp,mivac,mmach,mppf,mppj,mxx,nex,tem,tra,
     &  ww,z
C
      EQUIVALENCE (mxx(1),mppf)
      EQUIVALENCE (mxx(2),mppj)
      EQUIVALENCE (mxx(3),mmach)
      EQUIVALENCE (mxx(4),mae)
      EQUIVALENCE (mxx(5),mcf)
      EQUIVALENCE (mxx(6),mivac)
      EQUIVALENCE (mxx(7),misp)
      DATA exit/11*'EXIT'/
      IF ( .NOT.Eql ) THEN
        if(makeio.ne.0)WRITE (8,99004)
        IF ( (Nfz.GT.1) .and.(makeio.ne.0)) WRITE (8,99005) Nfz
      ELSE
        if(makeio.ne.0)WRITE (8,99001)
        IF ( (Iopt.NE.0) .and.(makeio.ne.0)) WRITE (8,99002)
        IF ( (Iopt.EQ.0) .and.(makeio.ne.0)) WRITE (8,99003)
      ENDIF
      IF ( (Ttt(1).EQ.T(It)) .and.(makeio.ne.0)) WRITE (8,99006)
      tem = Ppp(1)*14.696006D0/1.01325D0
      if(makeio.ne.0)WRITE (8,99009) 'Pinj',tem
      i23 = 2
      IF ( Iopt.GT.0 ) THEN
        IF ( (Iopt.EQ.1) .and.(makeio.ne.0)) 
     $     WRITE (8,99007) Subar(1),App(2)
        IF ( (Iopt.EQ.2) .and.(makeio.ne.0)) WRITE (8,99008) Ma,App(2)
        i23 = 3
      ENDIF
      CALL OUT1
      Fmt(4) = Fmt(6)
      nex = Npt - 2
      IF ( Page1 ) THEN
        ione = 0
        i46 = 4
        i57 = 5
        i68 = 6
        i79 = 7
      ELSE
        ione = i23
      ENDIF
C PRESSURE RATIOS
      IF ( Iopt.EQ.0 ) THEN
        if(makeio.ne.0)WRITE (8,99011) (exit(i),i=1,nex)
        CALL VARFMT(App)
        if(makeio.ne.0)WRITE (8,Fmt) 'Pinf/P         ',(App(j),j=1,Npt)
      ELSE
        nex = nex - 1
        if(makeio.ne.0)WRITE (8,99010) (exit(i),i=1,nex)
        X(1) = 1.D0
        DO i = 2,Npt
          X(i) = Ppp(1)/Ppp(i)
        ENDDO
        CALL VARFMT(X)
        if(makeio.ne.0)WRITE (8,Fmt) 'Pinj/P         ',(X(i),i=1,Npt)
      ENDIF
      CALL OUT2
      DO i = 1,8
        mxx(i) = 0
      ENDDO
      DO i = 1,Nplt
        ixfz = INDEX(Pltvar(i)(2:),'fz')
        ixfr = INDEX(Pltvar(i)(2:),'fr')
        IF ( ixfz.NE.0.OR.ixfr.NE.0 ) THEN
          IF ( Eql ) GOTO 100
        ELSEIF ( .NOT.Eql ) THEN
          GOTO 100
        ENDIF
        IF ( Pltvar(i)(:4).EQ.'pi/p'.OR.Pltvar(i)(:3).EQ.'pip' ) THEN
          IF ( Iopt.EQ.0 ) mppf = i
          IF ( Iopt.NE.0 ) mppj = i
        ELSEIF ( Pltvar(i)(:4).EQ.'mach' ) THEN
          mmach = i
        ELSEIF ( Pltvar(i)(:2).EQ.'ae' ) THEN
          mae = i
        ELSEIF ( Pltvar(i)(:2).EQ.'cf' ) THEN
          mcf = i
        ELSEIF ( Pltvar(i)(:4).EQ.'ivac' ) THEN
          mivac = i
        ELSEIF ( Pltvar(i)(:3).EQ.'isp' ) THEN
          misp = i
        ENDIF
 100  ENDDO
      IF ( Siunit ) THEN
        agv = 1.
        gc = 1.
        fr = 'CSTAR, M/SEC'
        fiv = 'Ivac, M/SEC'
        fi = 'Isp, M/SEC'
      ELSE
        gc = 32.174
        agv = 9.80665
        fr = 'CSTAR, FT/SEC'
        fiv = 'Ivac,LB-SEC/LB'
        fi = 'Isp, LB-SEC/LB'
      ENDIF
      DO k = 2,Npt
        Spim(k) = (2.*Rr*(Hsum(1)-Hsum(k)))**.5/agv
C AW IS THE LEFT SIDE OF EQ.(6.12) IN RP-1311,PT I.
        aw = Rr*Ttt(k)/(Ppp(k)*Wm(k)*Spim(k)*agv**2)
        IF ( k.EQ.i23 ) THEN
          IF ( Iopt.EQ.0 ) Cstr = gc*Ppp(1)*aw
          IF ( Iopt.NE.0 ) Cstr = gc*Ppp(1)/App(2)*aw
        ENDIF
        vaci(k) = Spim(k) + Ppp(k)*aw
        Vmoc(k) = 0.
        IF ( Sonvel(k).NE.0. ) Vmoc(k) = Spim(k)*agv/Sonvel(k)
      ENDDO
C MACH NUMBER
      Vmoc(1) = 0.
      IF ( Gammas(i23).EQ.0. ) Vmoc(i23) = 0.
      Fmt(7) = '3,'
      if(makeio.ne.0)WRITE (8,Fmt) 'MACH NUMBER    ',(Vmoc(j),j=1,Npt)
      IF ( Trnspt ) CALL OUT4
      if(makeio.ne.0)WRITE (8,99013)
C AREA RATIO
      Fmt(4) = '9x,'
      Fmt(i46) = '9x,'
      CALL VARFMT(Aeat)
      Fmt(5) = ' '
      Fmt(i57) = ' '
      if(makeio.ne.0)WRITE (8,Fmt) 'Ae/At          ',(Aeat(j),j=2,Npt)
C C*
      Fmt(i57) = '13'
      Fmt(i68) = Fmt(i68+2)
      Fmt(i79) = '1,'
      if(makeio.ne.0)WRITE (8,Fmt) fr,(Cstr,j=2,Npt)
C CF - THRUST COEFICIENT
      Fmt(i79) = '4,'
      DO i = 2,Npt
        X(i) = gc*Spim(i)/Cstr
      ENDDO
      if(makeio.ne.0)WRITE (8,Fmt) 'CF             ',(X(j),j=2,Npt)
C VACUUM IMPULSE
      Fmt(i57) = '13'
      Fmt(i79) = '1,'
      if(makeio.ne.0)WRITE (8,Fmt) fiv,(vaci(j),j=2,Npt)
C SPECIFIC IMPULSE
      if(makeio.ne.0)WRITE (8,Fmt) fi,(Spim(j),j=2,Npt)
      IF ( Nplt.GT.0 ) THEN
        Spim(1) = 0
        Aeat(1) = 0
        Vmoc(1) = 0
        vaci(1) = 0
        X(1) = 0
        Spim(1) = 0
        DO i = ione + 1,Npt
          IF ( mppj.GT.0 ) Pltout(i+Iplt-ione,mppj) = Ppp(1)/Ppp(i)
          IF ( mppf.GT.0 ) Pltout(i+Iplt-ione,mppf) = App(i)
          IF ( mmach.GT.0 ) Pltout(i+Iplt-ione,mmach) = Vmoc(i)
          IF ( mae.GT.0 ) Pltout(i+Iplt-ione,mae) = Aeat(i)
          IF ( mcf.GT.0 ) Pltout(i+Iplt-ione,mcf) = X(i)
          IF ( mivac.GT.0 ) Pltout(i+Iplt-ione,mivac) = vaci(i)
          IF ( misp.GT.0 ) Pltout(i+Iplt-ione,misp) = Spim(i)
        ENDDO
      ENDIF
      if(makeio.ne.0)WRITE (8,99012)
      Fmt(4) = ' '
      Fmt(5) = '13'
      Fmt(7) = '5,'
      IF ( Iopt.NE.0 ) THEN
        Fmt(i46) = Fmt(8)
        Fmt(i57) = Fmt(9)
      ENDIF
      IF ( .NOT.Eql ) THEN
        IF ( Massf ) THEN
          if(makeio.ne.0)WRITE (8,99014) 'MASS'
        ELSE
          if(makeio.ne.0)WRITE (8,99014) 'MOLE'
          ww = 1.D0/Totn(Nfz)
        ENDIF
C MOLE (OR MASS) FRACTIONS - FROZEN
        tra = 5.E-6
        IF ( Trace.NE.0. ) tra = Trace
        line = 0
        DO k = 1,Ngc
          IF ( Massf ) ww = Mw(k)
          X(line+1) = En(k,Nfz)*ww
          IF ( X(line+1).GE.tra ) THEN
            line = line + 1
            z(line) = Prod(k)
          ENDIF
          IF ( line.EQ.3.OR.k.EQ.Ngc ) THEN
            IF ( line.EQ.0 ) GOTO 200
            if(makeio.ne.0)WRITE (8,99015) (z(ln),X(ln),ln=1,line)
            line = 0
          ENDIF
        ENDDO
      ENDIF
 200  CALL OUT3
      RETURN
99001 FORMAT (/////13x,' THEORETICAL ROCKET PERFORMANCE ASSUMING',
     &        ' EQUILIBRIUM')
99002 FORMAT (/11x,' COMPOSITION DURING EXPANSION FROM FINITE AREA',
     &        ' COMBUSTOR')
99003 FORMAT (/10x,' COMPOSITION DURING EXPANSION FROM INFINITE AREA',
     &        ' COMBUSTOR')
99004 FORMAT (/////10x,' THEORETICAL ROCKET PERFORMANCE ASSUMING FROZEN'
     &        ,' COMPOSITION')
99005 FORMAT (33X,'AFTER POINT',I2)
99006 FORMAT (25X,'AT AN ASSIGNED TEMPERATURE  ')
99007 FORMAT (' Ac/At =',F8.4,6x,'Pinj/Pinf =',F10.6)
99008 FORMAT (' MDOT/Ac =',F10.3,' (KG/S)/M**2',6x,'Pinj/Pinf =',F10.6)
99009 FORMAT (/1x,A4,' =',F8.1,' PSIA')
99010 FORMAT (/,17X,'INJECTOR  COMB END  THROAT',10(5X,A4))
99011 FORMAT (/17X,'CHAMBER   THROAT',11(5X,A4))
99012 FORMAT ()
99013 FORMAT (/' PERFORMANCE PARAMETERS'/)
99014 FORMAT (1x,A4,' FRACTIONS'/)
99015 FORMAT (1X,3(A15,F8.5,3X))
      END
      SUBROUTINE ROCKET
C***********************************************************************
C EXECUTIVE ROUTINE FOR ROCKET PROBLEMS.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      INTEGER i,i01,i12,iof,iplt1,iplte,ipp,isub,isup1,isupsv,itnum,
     &        itrot,nar,nipp,niter,nn,npr1,nptth
      LOGICAL done,seql,thi
      REAL*8 a1l,acatsv,aeatl,appl,aratio,asq,b1,c1,check,cprf,dd,dh,
     &       dlnp,dlnpe,dlt,dp,eln,mat,msq,p1,pa,pcpa,pcplt,pinf,pinj,
     &       pinjas,pjrat,ppa,pr,pracat,prat,pratsv,pvg,test,tmelt,usq
      REAL*8 DABS,DLOG,DMAX1
      SAVE acatsv,aeatl,appl,aratio,asq,check,cprf,dd,dh,dlnp,dlnpe,dlt,
     &  done,dp,eln,i,i01,i12,iof,iplt1,iplte,ipp,isub,isup1,isupsv,
     &  itnum,itrot,mat,msq,nar,nipp,niter,nn,npr1,nptth,p1,pcpa,pcplt,
     &  pinf,pinj,pinjas,pjrat,ppa,pr,pracat,prat,pratsv,pvg,seql,test,
     &  thi,tmelt,usq
C
      DATA a1l/ - 1.26505/,b1/1.0257/,c1/ - 1.2318/,pa/1.E05/
      iplte = Iplt
      isup1 = 1
      App(1) = 1.
      Iopt = 0
      Npp = Npp + 2
      nn = Npp
      i01 = 0
      i12 = 1
      nipp = 1
      nptth = 2
      IF ( Fac ) THEN
        Eql = .TRUE.
        Npp = Npp + 1
        IF ( Acat.NE.0. ) THEN
          Iopt = 1
        ELSEIF ( Ma.NE.0. ) THEN
          Iopt = 2
        ELSE
          if(makeio.ne.0)WRITE (8,99001)
          Tt = 0.
          GOTO 1400
        ENDIF
        i01 = 1
        i12 = 2
        nipp = 2
        nptth = 3
        DO i = Nsub,1, - 1
          Subar(i+1) = Subar(i)
        ENDDO
        Nsub = Nsub + 1
        IF ( Iopt.NE.1 ) THEN
          IF ( Acat.EQ.0. ) Acat = 2.
        ENDIF
        Subar(1) = Acat
      ELSEIF ( .NOT.Eql.AND.Nfz.GT.1.AND.Nsub.GT.0 ) THEN
        Nsub = 0
        if(makeio.ne.0)WRITE (8,99023)
      ENDIF
      nn = nn + Nsub + Nsup
      IF ( Nfz.GT.2.AND.nn.GT.NCOL-2 ) THEN
        if(makeio.ne.0)WRITE (8,99002) NCOL - 2
        Nfz = 1
        Froz = .FALSE.
      ENDIF
      seql = Eql
      iof = 0
      Tt = Tcest
      Pp = P(1)
      App(i12) = 1.
C LOOP FOR EACH O/F
 100  It = 1
      iof = iof + 1
      Oxfl = Oxf(iof)
      IF ( T(1).NE.0. ) THEN
        Tp = .TRUE.
      ELSE
        Hp = .TRUE.
      ENDIF
      Sp = .FALSE.
      CALL NEWOF
      IF ( T(1).NE.0. ) Tt = T(1)
C LOOP FOR CHAMBER PRESSURES
 200  DO Ip = 1,Np
        itnum = 0
        Area = .FALSE.
        IF ( T(1).EQ.0. ) Hp = .TRUE.
        IF ( T(1).NE.0. ) Tp = .TRUE.
        Sp = .FALSE.
        Eql = .TRUE.
        isub = 1
        Isup = 1
        Pp = P(Ip)
        pinf = Pp
        ipp = 1
        itrot = 3
        isupsv = 1
        niter = 1
        Page1 = .TRUE.
        iplt1 = iplte
        Iplt = iplte
        done = .FALSE.
C LOOP FOR OUTPUT COLUMNS
 250    nar = Npt
        IF ( Eql ) THEN
          CALL EQLBRM
          IF ( Npt.EQ.Nfz ) cprf = Cpsum
        ELSE
          CALL FROZEN
        ENDIF
C TT = 0 IF NO CONVERGENCE
        IF ( Tt.NE.0. ) THEN
C TEST FOR FINITE AREA COMBUSTOR
          IF ( .NOT.Fac ) GOTO 400
          pinjas = P(Ip)*pa
          pinj = pinjas
          IF ( Npt.LE.2 ) THEN
            IF ( Npt.EQ.1.AND.Trnspt ) CALL TRANP
            IF ( Npt.EQ.2 ) pinf = Ppp(2)
          ENDIF
          IF ( Npt.NE.1 ) GOTO 400
C INITIAL ESTIMATE FOR PC (AND ACAT IF NOT ASSIGNED)
          DO i = 1,4
            prat = (b1+c1*Acat)/(1.+a1l*Acat)
            ppa = pinj*prat
            IF ( Iopt.EQ.1 ) GOTO 260
            Acat = ppa/(Ma*2350.)
            IF ( Acat.GE.1. ) THEN
              pratsv = prat
              IF ( Debugf ) THEN
                IF ( (i.LE.1) .and.makeio.ne.0) WRITE (8,99004)
                if(makeio.ne.0)WRITE (8,99005) i,ppa,Acat
              ENDIF
            ELSE
              if(makeio.ne.0)WRITE (8,99003) Ma
              Tt = 0.
              GOTO 1400
            ENDIF
          ENDDO
          Subar(1) = Acat
 260      Pp = ppa/pa
          App(1) = Pp/Ppp(1)
          GOTO 1100
        ELSE
          IF ( Npt.LT.1 ) GOTO 1400
          IF ( .NOT.Area ) GOTO 600
          Npt = nar - 1
          Isup = Nsup + 2
          Isv = 0
          itnum = 0
          GOTO 950
        ENDIF
 300    Hp = .TRUE.
        Sp = .FALSE.
        niter = niter + 1
        Isv = 0
        Npt = 2
        ipp = 2
        CALL SETEN
        GOTO 250
 350    done = .TRUE.
        App(1) = Ppp(2)/Ppp(1)
        Area = .FALSE.
        IF ( Nsub.GT.1 ) isub = 2
        Isv = 4
        Npt = 2
        ipp = MIN(4,Npp)
        CALL SETEN
        Cpr(2) = Cpr(4)
        Dlvpt(2) = Dlvpt(4)
        Dlvtp(2) = Dlvtp(4)
        Gammas(2) = Gammas(4)
        Hsum(2) = Hsum(4)
        Ppp(2) = Ppp(4)
        App(2) = Ppp(1)/pinf
        Ssum(2) = Ssum(4)
        Totn(2) = Totn(4)
        Ttt(2) = Ttt(4)
        Vlm(2) = Vlm(4)
        Wm(2) = Wm(4)
        IF ( (.NOT.Short_bn) .and.makeio.ne.0) WRITE (8,99009)
        GOTO 600
C INITIALIZE FOR THROAT
 400    IF ( ipp.GT.nipp ) THEN
          usq = 2.*(Hsum(1)-Hsum(Npt))*Rr
          IF ( ipp.GT.nptth ) GOTO 600
C THROAT
          IF ( .NOT.thi ) THEN
            Vv = Vlm(nptth)
            pvg = Pp*Vv*Gammas(nptth)
            IF ( pvg.EQ.0. ) THEN
              if(makeio.ne.0)WRITE (8,99010)
              GOTO 550
            ELSE
              msq = usq/pvg
              IF ( (Debug(1).OR.Debug(2)) .and.(makeio.ne.0)) 
     &                      WRITE (8,99011) usq,pvg
              dh = DABS(msq-1.D0)
              IF ( dh.LE.0.4D-4 ) GOTO 550
              IF ( itrot.GT.0 ) THEN
                p1 = Pp
                IF ( Jsol.NE.0 ) THEN
                  tmelt = Tt
                  Pp = Pp*(1.D0+msq*Gammas(nptth))/(Gammas(nptth)+1.D0)
                ELSEIF ( tmelt.EQ.0. ) THEN
                  Pp = Pp*(1.D0+msq*Gammas(nptth))/(Gammas(nptth)+1.D0)
                ELSE
                  if(makeio.ne.0)WRITE (8,99012)
                  dlt = DLOG(tmelt/Tt)
                  dd = dlt*Cpr(nptth)/(Enn*Dlvtp(nptth))
                  Pp = Pp*EXP(dd)
                  App(nptth) = P(Ip)/Pp
                  IF ( Fac ) App(nptth) = pinf/Pp
                  IF ( Eql.AND.(.NOT.Short_bn) .and.(makeio.ne.0))
     &                          WRITE(8,99013) App(nptth)
                  thi = .TRUE.
                  GOTO 250
                ENDIF
                GOTO 500
              ELSEIF ( itrot.LT.0 ) THEN
                IF ( itrot.LT.-19 ) THEN
                  if(makeio.ne.0)WRITE (8,99010)
                  GOTO 550
                ELSE
                  IF ( Npr.NE.npr1 ) GOTO 550
                  Pp = Pp - dp
                  GOTO 500
                ENDIF
              ELSEIF ( Npr.EQ.npr1 ) THEN
                if(makeio.ne.0)WRITE (8,99010)
                GOTO 550
              ELSE
                dp = DABS(Pp-p1)/20.
                Pp = DMAX1(Pp,p1)
                if(makeio.ne.0)WRITE (8,99012)
                Pp = Pp - dp
                GOTO 500
              ENDIF
            ENDIF
          ELSE
            Gammas(nptth) = 0.
            GOTO 550
          ENDIF
        ELSE
          IF ( .NOT.Fac.AND.Trnspt ) CALL TRANP
          IF ( Npt.EQ.Nfz ) Eql = seql
          Tp = .FALSE.
          Hp = .FALSE.
          Sp = .TRUE.
          S0 = Ssum(i12)
        ENDIF
 450    tmelt = 0.
        itrot = 3
        thi = .FALSE.
        App(nptth) = ((Gammas(i12)+1.)/2.)
     &               **(Gammas(i12)/(Gammas(i12)-1.))
        IF ( Eql.AND.(.NOT.Short_bn) .and.(makeio.ne.0))
     &                    WRITE(8,99013)App(nptth)
        Pp = pinf/App(nptth)
        Isv = -i12
        GOTO 1200
 500    npr1 = Npr
        App(nptth) = P(Ip)/Pp
        IF ( Fac ) App(nptth) = pinf/Pp
        IF ( Eql.AND.(.NOT.Short_bn) .and.(makeio.ne.0))
     &                    WRITE(8,99013)App(nptth)
        itrot = itrot - 1
        GOTO 250
 550    Awt = Enn*Tt/(Pp*usq**.5)
        pcplt = DLOG(App(nptth))
 600    Isv = 0
        Aeat(Npt) = Enn*Ttt(Npt)/(Pp*usq**.5*Awt)
        IF ( Tt.EQ.0. ) GOTO 1150
        IF ( Area ) GOTO 750
        IF ( Trnspt.AND.(.NOT.Fac.OR.done.OR.Npt.GT.2) ) CALL TRANP
        IF ( Npt.EQ.Nfz ) Eql = seql
        IF ( Fac ) THEN
          IF ( Npt.EQ.nptth ) THEN
            Area = .TRUE.
            GOTO 750
          ELSEIF ( Npt.EQ.2.AND.done ) THEN
            Npt = 3
            IF ( ipp.LE.Npp ) ipp = ipp - 1
          ENDIF
        ENDIF
 650    IF ( ipp.LT.Npp ) GOTO 1100
 700    IF ( Nsub.EQ.i01.AND.Nsup.EQ.0 ) GOTO 1150
        Area = .TRUE.
C PCP ESTIMATES FOR AREA RATIOS
 750    IF ( itnum.EQ.0 ) THEN
          dlnp = 1.
          itnum = 1
          aratio = Subar(isub)
          IF ( (.NOT.Fac.OR.done).AND.Nsub.LE.i01 ) aratio = Supar(Isup)
          IF ( .NOT.Eql.AND.Nfz.GE.3 ) THEN
            IF ( aratio.LE.Aeat(Nfz) ) THEN
              if(makeio.ne.0)WRITE (8,99014) Nfz
              GOTO 1050
            ENDIF
          ENDIF
          eln = DLOG(aratio)
          IF ( Fac ) THEN
            IF ( .NOT.done ) GOTO 800
          ENDIF
          IF ( Nsub.LE.i01 ) THEN
            IF ( Nfz.EQ.ipp ) isupsv = Isup
            IF ( Supar(Isup).LT.2. ) THEN
              appl = SQRT(eln*(1.535+3.294*eln)) + pcplt
              GOTO 1100
            ELSE
              IF ( Isup.GT.isup1.AND.Supar(Isup-1).GE.2. ) GOTO 850
              appl = Gammas(nptth) + eln*1.4
              GOTO 1100
            ENDIF
          ENDIF
C TEST FOR CONVERGENCE ON AREA RATIO.
        ELSEIF ( Gammas(Npt).GT.0. ) THEN
          check = .00004
          IF ( (Debug(Npt)) .and.(makeio.ne.0)) 
     &              WRITE (8,99016) itnum,aratio,Aeat(Npt),
     &                             App(Npt),dlnp
          IF ( DABS(Aeat(Npt)-aratio)/aratio.LE.check ) GOTO 900
          IF ( ABS(dlnp).LT..00004 ) GOTO 900
          aeatl = DLOG(Aeat(Npt))
          itnum = itnum + 1
          IF ( itnum.GT.10 ) THEN
            if(makeio.ne.0)WRITE (8,99017) aratio
            GOTO 900
          ELSE
C IMPROVED PCP ESTIMATES.
            asq = Gammas(Npt)*Enn*Rr*Tt
            dlnpe = Gammas(Npt)*usq/(usq-asq)
            GOTO 850
          ENDIF
        ELSE
          if(makeio.ne.0)WRITE (8,99015)
          Npt = Npt - 1
          IF ( Nsub.LE.0 ) isup1 = 100
          IF ( Nsub.LT.0. ) Nsup = Isup - 1
          IF ( Nsub.GT.0 ) Nsub = isub - 1
          GOTO 1000
        ENDIF
 800    appl = pcplt/(Subar(isub)+(10.587*eln**2+9.454)*eln)
        IF ( aratio.LT.1.09 ) appl = .9*appl
        IF ( aratio.GT.10. ) appl = appl/aratio
        IF ( isub.GT.1.OR.Npt.EQ.NCOL ) GOTO 1100
        GOTO 1200
 850    dlnp = dlnpe*eln - dlnpe*aeatl
        appl = appl + dlnp
        IF ( itnum.EQ.1 ) GOTO 1100
        IF ( appl.LT.0. ) appl = .000001
        App(Npt) = EXP(appl)
        Pp = pinf/App(Npt)
        GOTO 250
C CONVERGENCE HAS BEEN REACHED FOR ASSIGNED AREA RATIO
 900    Aeat(Npt) = aratio
        IF ( Fac ) THEN
          IF ( .NOT.done ) THEN
            IF ( Iopt.EQ.1 ) THEN
C OPTION 1 FOR FINITE AREA COMBUSTOR. INPUT IS ASSIGNED INJECTOR
C PRESSURE AND CONTRACTION RATIO. IMPROVED ESTIMATE FOR PC
              Area = .FALSE.
              itnum = 0
              ppa = Ppp(Npt)*pa
              pinj = ppa + 1.D05*usq/Vlm(Npt)
              test = (pinj-pinjas)/pinjas
              pcpa = pinf*pa
              IF ( Debugf ) THEN
                if(makeio.ne.0)WRITE (8,99006)
                if(makeio.ne.0)WRITE (8,99007) niter,test,pinjas,
     &             pinj,pcpa,ppa,acatsv, Acat
              ENDIF
              IF ( ABS(test).LT.0.00002 ) GOTO 350
              prat = pinjas/pinj
              Pp = pinf*prat
              GOTO 300
            ELSEIF ( Iopt.EQ.2 ) THEN
C OPTION 2 FOR FINITE AREA COMBUSTOR. INPUT IS ASSIGNED INJECTOR
C PRESSURE AND MASS FLOW PER UNIT AREA. IMPROVED ESTIMATE FOR PC
C AND ACAT
              acatsv = Acat
              pratsv = prat
              Area = .FALSE.
              itnum = 0
              ppa = Ppp(4)*pa
              pinj = ppa + 1.D05*usq/Vlm(4)
              mat = pa/(Awt*Rr)
              Acat = mat/Ma
              prat = (b1+c1*Acat)/(1.+a1l*Acat)
              test = (pinj-pinjas)/pinjas
              pcpa = pinf*pa
              IF ( Debugf ) THEN
                if(makeio.ne.0)WRITE (8,99006)
                if(makeio.ne.0)WRITE (8,99007) niter,test,pinjas,
     &              pinj,pcpa,ppa,acatsv, Acat
              ENDIF
              IF ( ABS(test).LT.0.00002 ) GOTO 350
              pjrat = pinj/pinjas
              Pp = pinf
              DO i = 1,2
                pracat = pratsv/prat
                pr = pjrat*pracat
                Pp = Pp/pr
                pcpa = Pp*pa
                Acat = Acat/pr
                Subar(1) = Acat
                pratsv = prat
                pjrat = 1.
                prat = (b1+c1*Acat)/(1.+a1l*Acat)
                IF ( Debugf .and.(makeio.ne.0)) WRITE (8,99008) 
     &                           pcpa,Acat,pjrat,pracat
              ENDDO
              GOTO 300
            ENDIF
          ENDIF
        ENDIF
 950    IF ( Trnspt ) CALL TRANP
        IF ( Npt.EQ.Nfz ) Eql = seql
 1000   itnum = 0
        IF ( Nsub.GT.i01 ) THEN
          isub = isub + 1
          IF ( isub.LE.Nsub ) GOTO 750
          isub = 1
          Nsub = -Nsub
          IF ( Isup.LE.Nsup ) GOTO 750
          Area = .FALSE.
          GOTO 1150
        ENDIF
 1050   Isup = Isup + 1
        itnum = 0
        IF ( Isup.LE.Nsup ) GOTO 750
        Isup = isupsv
        Area = .FALSE.
        GOTO 1150
C TEST FOR OUTPUT -- SCHEDULES COMPLETE OR NPT=NCOL
 1100   Isv = Npt
        IF ( Npt.NE.NCOL ) GOTO 1200
 1150   IF ( .NOT.Eql ) THEN
          IF ( Nfz.LE.1 ) THEN
            Cpr(Nfz) = cprf
            Gammas(Nfz) = cprf/(cprf-1./Wm(Nfz))
          ENDIF
        ENDIF
        CALL RKTOUT
        Iplt = Iplt + Npt
        IF ( .NOT.Page1 ) THEN
          Iplt = Iplt - 2
          IF ( Iopt.NE.0 ) Iplt = Iplt - 1
          Iplt = MIN(Iplt,500)
        ELSE
          Page1 = .FALSE.
        ENDIF
        iplte = MAX(iplte,Iplt)
        dlnp = 1.
        IF ( Tt.EQ.0. ) Area = .FALSE.
        IF ( (.NOT.Eql).AND.(Tt.EQ.0.) .and.(makeio.ne.0))
     $      WRITE (8,99018)
        IF ( Isv.EQ.0 ) THEN
C PCP, SUBAR, AND SUPAR SCHEDULES COMPLETED
          IF ( Nsub.LT.0 ) Nsub = -Nsub
          IF ( .NOT.Froz.OR..NOT.Eql ) GOTO 1300
C SET UP FOR FROZEN.
          IF ( Eql ) Iplt = iplt1
          Eql = .FALSE.
          Page1 = .TRUE.
          CALL SETEN
          Tt = Ttt(Nfz)
          ipp = Nfz
          IF ( Nfz.EQ.Npt ) GOTO 1150
          Npt = Nfz
          Enn = 1./Wm(Nfz)
          IF ( Nfz.EQ.1 ) GOTO 450
          IF ( Nsub.GT.0 ) THEN
            Nsub = -Nsub
            if(makeio.ne.0)WRITE (8,99023)
          ENDIF
          IF ( App(Nfz).LT.App(nptth) ) THEN
            if(makeio.ne.0)WRITE (8,99024)
          ELSE
            IF ( Nfz.LT.Npp ) GOTO 1200
            GOTO 700
          ENDIF
          GOTO 1300
        ELSE
          IF ( Eql .and.(makeio.ne.0)) WRITE (8,99019)
          Npt = nptth
        ENDIF
C SET INDICES AND ESTIMATES FOR NEXT POINT.
 1200   Npt = Npt + 1
        IF ( Eql.OR.(Isv.EQ.-i12.AND..NOT.seql) ) THEN
C THE FOLLOWING STATEMENT WAS ADDED TO TAKE CARE OF A SITUATION
C WHERE EQLBRM WENT SINGULAR WHEN STARTING FROM ESTIMATES WHERE
C BOTH SOLID AND LIQUID WERE INCLUDED.  JULY 27, 1990.
          IF ( Jliq.NE.0.AND.Isv.GT.0 ) Isv = 0
          CALL SETEN
        ENDIF
 1250   ipp = ipp + 1
        IF ( Npt.GT.nptth ) THEN
          IF ( Area ) THEN
            App(Npt) = EXP(appl)
          ELSE
            App(Npt) = Pcp(ipp-nptth)
            IF ( Fac ) App(Npt) = App(Npt)*pinf/Ppp(1)
            IF ( .NOT.Eql.AND.App(Npt).LT.App(Nfz) ) THEN
              if(makeio.ne.0)WRITE (8,99020) Nfz
              GOTO 1250
            ENDIF
          ENDIF
          Pp = pinf/App(Npt)
          IF ( Fac ) THEN
            IF ( Area ) THEN
              IF ( isub.LE.Nsub.AND.isub.GT.i01.AND.aratio.GE.Aeat(2) )
     &             THEN
                if(makeio.ne.0)WRITE (8,99021) aratio,Aeat(2)
                Npt = Npt - 1
                GOTO 1000
              ENDIF
            ELSEIF ( Npt.GT.nptth.AND.Pcp(ipp-3).LT.Ppp(1)/Ppp(2) ) THEN
              if(makeio.ne.0)WRITE (8,99022) Pcp(ipp-3),Ppp(1)/Ppp(2)
              Npt = Npt - 1
              GOTO 650
            ENDIF
          ENDIF
        ENDIF
        GOTO 250
 1300   Npt = 1
C CHECK FOR COMPLETED SCHEDULES -
C 1) CHAMBER PRESSURES(IP = NP)
C 2) CHAMBER TEMPERATURES(IT = NT)
C 3) O/F VALUES(IOF = NOF)
        IF ( Ip.EQ.Np.AND.It.EQ.Nt.AND.iof.EQ.Nof ) GOTO 1400
        if(makeio.ne.0)WRITE (8,99019)
        CALL SETEN
        Tt = Ttt(i12)
      ENDDO
      IF ( It.LT.Nt ) THEN
        It = It + 1
        Tt = T(It)
        GOTO 200
      ELSEIF ( iof.LT.Nof ) THEN
        GOTO 100
      ENDIF
 1400 Iplt = MAX(Iplt,iplte)
      RETURN
99001 FORMAT (/' FATAL ERROR!! EITHER mdot OR ac/at MISSING ',
     &        'FOR fac PROBLEM (ROCKET)')
99002 FORMAT (/' WARNING!!  nfz NOT ALLOWED TO BE > 2 IF THE TOTAL',/,
     &        ' NUMBER OF POINTS IS >',i3,' (ROCKET)')
99003 FORMAT (/' INPUT VALUE OF mdot/a =',F12.3,' IS TOO LARGE.'/
     &        ' GIVES CONTRACTION RATIO ESTIMATE LESS THAN 1 (ROCKET)')
99004 FORMAT (/'  ITERATION',9X,'PC',7X,'CONTRACTION RATIO')
99005 FORMAT (5X,I2,7X,F12.2,3X,F12.6)
99006 FORMAT (' ITER',3X,'TEST',3X,'ASSIGNED PINJ',1x,'CALC PINJ',5X,
     &        'PC',7X,'P AT ACAT',3X,'PREV ACAT',2X,'ACAT')
99007 FORMAT (I3,F10.6,1x,4F12.2,2F9.5)
99008 FORMAT (' NEW PC = ',F10.2,2X,'NEW ACAT = ',F9.6,2X,'PJRAT =',
     &        F10.7,' PRACAT =',F10.7)
99009 FORMAT (' END OF CHAMBER ITERATIONS')
99010 FORMAT (/' WARNING!!  DIFFICULTY IN LOCATING THROAT (ROCKET)')
99011 FORMAT (/' USQ=',E15.8,5X,'PVG=',E15.8)
99012 FORMAT (/' WARNING!!  DISCONTINUITY AT THE THROAT (ROCKET)')
99013 FORMAT (' Pinf/Pt =',F9.6)
99014 FORMAT (/,' WARNING!! FOR FROZEN PERFORMANCE, POINTS WERE OMITTED'
     &        ,' WHERE THE ASSIGNED',/,' SUPERSONIC AREA RATIOS WERE ',
     &        'LESS THAN THE VALUE AT POINT nfz =',I3,' (ROCKET)')
99015 FORMAT (/' WARNING!!  AREA RATIO CALCULATION CANNOT BE DONE ',
     &        'BECAUSE GAMMAs',/,' CALCULATION IMPOSSIBLE. (ROCKET)')
99016 FORMAT (/' ITER=',I2,2X,'ASSIGNED AE/AT=',F14.7,3X,'AE/AT=',F14.7,
     &        /,2X,'PC/P=',F14.7,2X,'DELTA LN PCP=',F14.7)
99017 FORMAT (/' WARNING!!  DID NOT CONVERGE FOR AREA RATIO =',F10.5,
     &        ' (ROCKET)')
99018 FORMAT (/' WARNING!!  CALCULATIONS WERE STOPPED BECAUSE NEXT ',
     &        'POINT IS MORE',/,' THAN 50 K BELOW THE TEMPERATURE',
     &        ' RANGE OF A CONDENSED SPECIES (ROCKET)')
99019 FORMAT (////)
99020 FORMAT (/,' WARNING!! FOR FROZEN PERFORMANCE, POINTS WERE OMITTED'
     &        ,' WHERE THE ASSIGNED',/,
     &        ' PRESSURE RATIOS WERE LESS THAN ',
     &        'THE VALUE AT POINT nfz =',I3,' (ROCKET)')
99021 FORMAT (/' WARNING!!  ASSIGNED subae/at =',f10.5,' IS NOT ',
     &        'PERMITTED TO BE GREATER'/' THAN ac/at =',f9.5,
     &        '.  POINT OMITTED (ROCKET)')
99022 FORMAT (/' WARNING!!  ASSIGNED pip =',F10.5,
     &        ' IS NOT PERMITTED'/' TO BE LESS THAN  Pinj/Pc =',f9.5,
     &        '. POINT OMITTED',' (ROCKET)')
99023 FORMAT (/' WARNING!!  FOR FROZEN PERFORMANCE, SUBSONIC AREA ',/,
     &       ' RATIOS WERE OMITTED SINCE nfz IS GREATER THAN 1 (ROCKET)'
     &       )
99024 FORMAT (/' WARNING!!  FREEZING IS NOT ALLOWED AT A SUBSONIC ',
     &        'PRESSURE RATIO FOR nfz GREATER'/' THAN 1. FROZEN ',
     &        'PERFORMANCE CALCULATIONS WERE OMITTED (ROCKET)')
      END
      SUBROUTINE SEARCH
C***********************************************************************
C SEARCH THERMO.LIB FOR THERMO DATA FOR SPECIES TO BE CONSIDERED.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      CHARACTER*16 bin(2,40),pure(6),spece(2)
      CHARACTER*6 date(MAXNGC)
      CHARACTER*2 el(5)
      CHARACTER*15 sub
      INTEGER i,i5,ifaz,ii,ir,itot,j,jj(2),jk,k,lineb,nall,ne,nint,
     &        npure,nrec,ntgas,ntot
      REAL*8 b(5),t1,t2,thermo(9,3),trdata(36)
      SAVE b,bin,date,el,i,i5,ifaz,ii,ir,itot,j,jj,jk,k,lineb,nall,ne,
     &  nint,npure,nrec,ntgas,ntot,pure,spece,sub,t1,t2,thermo,trdata
C
      if( read_d .eq. 0 ) return

      Nc = 0
      ne = 0
      DO i = 1,Nlm
        Jx(i) = 0
      ENDDO
      DO j = 1,MAXNGC
        S(j) = 0.
        H0(j) = 0.
        Deln(j) = 0.
        DO i = 1,Nlm
          A(i,j) = 0.
        ENDDO
      ENDDO
C READ TEMPERATURE RANGES FOR COEFFICIENTS OF GASEOUS SPECIES.
C SOME DEFINITIONS:
C   NTGAS = NUMBER OF GASEOUS SPECIES IN THERMO.LIB.
C   NTOT =  NTGAS PLUS NUMBER OF TEMPERATURE INTERVALS FOR CONDENSED.
C   NALL =  NTOT PLUS THE NUMBER OF REACTANT SPECIES IN THERMO.LIB.
C   NG =    NUMBER OF GASES WITH STORED COEFFICIENTS.
C   NC =    NUMBER OF CONDENSED INTERVALS WITH STORED COEFFICIENTS.
C   NGC =    NG + NC
C   THDATE = DATE READ FROM THERMO.INP FILE
      REWIND IOTHM
      READ (IOTHM) Tg,ntgas,ntot,nall,Thdate
      Ngc = 1
      Nc = 1
C BEGIN LOOP FOR READING SPECIES DATA FROM THERMO.LIB.
      DO itot = 1,ntot
        IF ( itot.GT.ntgas ) THEN
          READ (IOTHM) sub,nint,date(Ngc),(el(j),b(j),j=1,5),Ifz(Nc),
     &                 Temp(1,Nc),Temp(2,Nc),Mw(Ngc),(Cft(Nc,k),k=1,9)
        ELSE
          READ (IOTHM) sub,nint,date(Ngc),(el(j),b(j),j=1,5),ifaz,t1,t2,
     &                 Mw(Ngc),thermo
        ENDIF
        IF ( Nonly.NE.0 ) THEN
          i = 1
 20       IF ( Prod(i).NE.sub.AND.'*'//Prod(i).NE.sub ) THEN
            i = i + 1
            IF ( i.LE.Nonly ) GOTO 20
            GOTO 200
          ELSE
            IF ( sub.EQ.Prod(Ngc-1) ) THEN
              Nonly = Nonly + 1
              DO k = Nonly,i + 1, - 1
                Prod(k) = Prod(k-1)
              ENDDO
            ELSE
              Prod(i) = Prod(Ngc)
            ENDIF
            Prod(Ngc) = sub
          ENDIF
        ELSEIF ( Nomit.NE.0 ) THEN
          DO i = 1,Nomit
            IF ( Omit(i).EQ.sub.OR.'*'//Omit(i).EQ.sub ) GOTO 200
          ENDDO
        ENDIF
        DO k = 1,5
          IF ( b(k).EQ.0. ) GOTO 100
          DO i = 1,Nlm
            IF ( Elmt(i).EQ.el(k) ) THEN
              A(i,Ngc) = b(k)
              GOTO 50
            ENDIF
          ENDDO
          DO j = 1,Nlm
            A(j,Ngc) = 0.
          ENDDO
          GOTO 200
 50     ENDDO
 100    Prod(Ngc) = sub
        IF ( itot.GT.ntgas ) THEN
          Nc = Nc + 1
          IF ( Nc.GT.MAXNC ) GOTO 400
        ELSE
          Ng = Ngc
          IF ( Ng.GT.MAXNG ) GOTO 400
          DO i = 1,3
            DO j = 1,9
              Coef(Ng,j,i) = thermo(j,i)
            ENDDO
          ENDDO
C IF SPECIES IS AN ATOMIC GAS, STORE INDEX IN JX
          IF ( b(2).EQ.0..AND.b(1).EQ.1. ) THEN
            DO i = 1,Nlm
              IF ( Elmt(i).EQ.el(1) ) THEN
                ne = ne + 1
                Jx(i) = Ngc
                Jcm(i) = Ngc
                GOTO 150
              ENDIF
            ENDDO
          ENDIF
        ENDIF
 150    Ngc = Ngc + 1
        IF ( Ngc.GT.MAXNGC ) GOTO 400
 200  ENDDO
C FINISHED READING THERMO DATA FROM I/O UNIT IOTHM.
      Ifz(Nc) = 0
      Nc = Nc - 1
      Ngc = Ngc - 1
      Ngp1 = Ng + 1
      IF ( Ngc.LT.Nonly ) THEN
        DO k = Ngc + 1,Nonly
          if(makeio.ne.0)WRITE (8,99001) Prod(k)
        ENDDO
      ENDIF
C FIND MISSING ELEMENTS (IF ANY) FOR COMPONENTS
      Nspx = Ngc
      IF ( ne.LT.Nlm ) THEN
        DO i = 1,Nlm
          IF ( Nspx.GT.MAXNGC ) GOTO 400
          IF ( Jx(i).EQ.0 ) THEN
            Nspx = Nspx + 1
            DO k = 1,Nlm
              A(k,Nspx) = 0.
            ENDDO
            A(i,Nspx) = 1.
            Prod(Nspx) = Elmt(i)
            DO k = 1,101
              IF ( Elmt(i).EQ.Symbol(k) ) THEN
                Mw(Nspx) = Atmwt(k)
                Atwt(i) = Atmwt(k)
                Cp(Nspx) = 2.5D0
                GOTO 210
              ENDIF
            ENDDO
 210        Jx(i) = Nspx
            Jcm(i) = Nspx
          ENDIF
        ENDDO
      ENDIF
C ARE ALL ELEMENTS IN PRODUCT SPECIES?
      DO i = 1,Nlm
        DO j = 1,Ngc
          IF ( A(i,j).NE.0. ) GOTO 300
          ii = i
        ENDDO
        if(makeio.ne.0)WRITE (8,99002) Elmt(ii)
        Ngc = 0
        GOTO 600
 300  ENDDO
C WRITE POSSIBLE PRODUCT LIST
      IF ( .NOT.Short_bn ) THEN
        if(makeio.ne.0)WRITE (8,99003) Thdate
        DO i = 1,Ngc,3
          i5 = i + 2
          IF ( Ngc.LT.i5 ) i5 = Ngc
          if(makeio.ne.0)WRITE (8,99004) (date(j),Prod(j),j=i,i5)
        ENDDO
      ENDIF
      GOTO 600
 400  if(makeio.ne.0)WRITE (8,99005)
      Ngc = 0
      GOTO 600
C SEARCH FOR TRANSPORT PROPERTIES FOR THIS CHEMICAL SYSTEM
      ENTRY READTR
      if( read_d .eq. 0 ) return
      REWIND IOTRN
      REWIND IOSCH
      Ntape = 0
      npure = 0
      lineb = 1
      IF ( (.NOT.Short_bn) .and.(makeio.ne.0)) WRITE (8,99006)
      READ (IOTRN) nrec
      DO ir = 1,nrec
        READ (IOTRN) spece,trdata
        k = 1
 450    DO j = 1,Ng
          IF ( spece(k).EQ.Prod(j).OR.'*'//spece(k).EQ.Prod(j) ) THEN
            jj(k) = j
            IF ( k.EQ.2 ) THEN
C STORE NAMES FOR BINARIES IN BIN ARRAY.
              DO k = 1,2
                bin(k,lineb) = spece(k)
              ENDDO
              lineb = lineb + 1
              GOTO 500
            ELSE
              jj(2) = j
              IF ( spece(2).EQ.' ' ) THEN
C WRITE NAMES FOR PURE SPECIES.
                npure = npure + 1
                pure(npure) = spece(1)
                GOTO 500
              ELSE
                k = 2
                GOTO 450
              ENDIF
            ENDIF
          ENDIF
        ENDDO
        GOTO 550
 500    if(makeio.ne.0)WRITE (IOSCH) jj,trdata
        Ntape = Ntape + 1
 550    IF ( npure.NE.0.AND.(npure.GE.6.OR.ir.GE.nrec) ) THEN
          IF ( (.NOT.Short_bn) .and.(makeio.ne.0)) 
     &            WRITE (8,99007) (pure(jk),jk=1,npure)
          npure = 0
        ENDIF
      ENDDO
      lineb = lineb - 1
      IF ( .NOT.Short_bn ) THEN
        if(makeio.ne.0)WRITE (8,99008)
        DO j = 1,lineb
          if(makeio.ne.0)WRITE (8,99009) (bin(i,j),i=1,2)
        ENDDO
      ENDIF
      if(makeio.ne.0)WRITE (8,99010)
 600  RETURN
99001 FORMAT (/' WARNING!!  ',A15,' NOT A PRODUCT IN thermo.lib FILE ',
     &        '(SEARCH)')
99002 FORMAT (/' PRODUCT SPECIES CONTAINING THE ELEMENT',A3,' MISSING',
     &        //,13x,'FATAL ERROR (SEARCH)')
99003 FORMAT (/2x,'SPECIES BEING CONSIDERED IN THIS SYSTEM',
     &        /' (CONDENSED PHASE MAY HAVE NAME LISTED SEVERAL TIMES)',
     &        /'  LAST thermo.inp UPDATE: ',A10,/)
99004 FORMAT (3(2X,A6,2X,A15))
99005 FORMAT (/' INSUFFICIENT STORAGE FOR PRODUCTS-SEE RP-1311,',
     &        /'   PART 2, PAGE 39. (SEARCH)')
99006 FORMAT (/' SPECIES WITH TRANSPORT PROPERTIES'//8X,'PURE SPECIES'/)
99007 FORMAT (4(2x,A16))
99008 FORMAT (/'     BINARY INTERACTIONS'/)
99009 FORMAT (5X,2A16)
99010 FORMAT ()
      END
      SUBROUTINE SETEN
C***********************************************************************
C USE COMPOSITIONS FROM PREVIOUS POINT AS INITIAL ESTIMATES FOR
C CURRENT POINT NPT.  IF -
C  ISV>0  USE COMPOSITIONS FROM POINT ISV.
C  ISV<0  SAVE COMPOSITIONS FROM POINT -ISV FOR POSSIBLE LATER USE.
C         ALSO USE COMPOSITIONS FROM POINT -ISV FOR NPT.
C  ISV=0  USE COMPOSITIONS SAVED WHEN ISV<0.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      INTEGER j,lsav
      REAL*8 tsave
      REAL*8 DEXP
      SAVE j,lsav,tsave
C
      IF ( Isv.LT.0 ) THEN
C FIRST T--SAVE COMPOSITIONS FOR FUTURE POINTS WITH THIS T
        Isv = -Isv
        tsave = Ttt(Isv)
        Ensave = Enn
        Enlsav = Ennl
        lsav = Lsave
        DO j = 1,Ng
          Sln(j) = Enln(j)
        ENDDO
        DO j = 1,Ng
          En(j,Npt) = En(j,Isv)
        ENDDO
        Npr = 0
        DO j = Ngp1,Ngc
          Sln(j) = En(j,Isv)
          En(j,Npt) = Sln(j)
          IF ( Jliq.EQ.j ) THEN
            En(Jsol,Npt) = En(Jsol,Isv) + En(Jliq,Isv)
            En(Jliq,Npt) = 0.
            Jsol = 0
            Jliq = 0
            tsave = tsave - 5.
            Tt = tsave
            Sln(j) = 0.
          ELSEIF ( En(j,Npt).GT.0. ) THEN
            Npr = Npr + 1
            Jcond(Npr) = j
          ENDIF
        ENDDO
      ELSEIF ( Isv.EQ.0 ) THEN
C NEXT POINT FIRST T IN SCHEDULE, USE PREVIOUS COMPOSITIONS FOR THIS T
        Jsol = 0
        Jliq = 0
        Enn = Ensave
        Ennl = Enlsav
        Lsave = lsav
        Npr = 0
        DO j = Ngp1,Ngc
          En(j,Npt) = Sln(j)
          IF ( En(j,Npt).GT.0.D0 ) THEN
            Npr = Npr + 1
            Jcond(Npr) = j
          ENDIF
        ENDDO
        DO j = 1,Ng
          En(j,Npt) = 0.
          Enln(j) = Sln(j)
          IF ( Sln(j).NE.0. ) THEN
            IF ( (Enln(j)-Ennl+18.5).GT.0. ) En(j,Npt) = DEXP(Enln(j))
          ENDIF
        ENDDO
        IF ( .NOT.Tp ) Tt = tsave
        Sumn = Enn
      ELSEIF ( Isv.GT.0 ) THEN
C USE COMPOSITIONS FROM PREVIOUS POINT
        DO j = 1,Ngc
          En(j,Npt) = En(j,Isv)
        ENDDO
      ENDIF
      END
      SUBROUTINE SHCK
C***********************************************************************
C PRIMARY ROUTINE FOR SHOCK PROBLEMS.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      CHARACTER*1 cr12,cr52
      INTEGER i,iof,it1,it2,itr,j,n
      LOGICAL refl,seql,srefl
      REAL*8 ax,axx,b2,cormax,gg,hs,m2m1(NCOL),mis(13),mu12rt,p1,p21,
     &       p21l,p2p1(NCOL),pmn,rho12,rho52,rrho(NCOL),sg(78),t1,t21,
     &       t21l,t2t1(NCOL),ttmax,u1u2(NCOL),uis(13),utwo(NCOL),uu,wmx,
     &       ww
      REAL*8 DABS,DEXP,DLOG,DMIN1
      SAVE ax,axx,b2,cormax,cr12,cr52,gg,hs,i,iof,it1,it2,itr,j,m2m1,
     &  mis,mu12rt,n,p1,p21,p21l,p2p1,pmn,refl,rho12,rho52,rrho,seql,sg,
     &  srefl,t1,t21,t21l,t2t1,ttmax,u1u2,uis,utwo,uu,wmx,ww
C
      IF ( Trace.EQ.0. ) Trace = 5.E-9
      Tp = .TRUE.
      Cpmix = 0.
      srefl = .FALSE.
      IF ( .NOT.Short_bn ) THEN
        if(makeio.ne.0)WRITE (8,99001)
        if(makeio.ne.0)WRITE (8,99002) Incdeq,Refleq,Incdfz,Reflfz
      ENDIF
      IF ( Refleq.OR.Reflfz ) srefl = .TRUE.
      seql = Incdeq
      IF ( T(1).EQ.0. ) T(1) = Rtemp(1)
      DO i = 1,Nsk
        uis(i) = U1(i)
        mis(i) = Mach1(i)
        IF ( Mach1(i).EQ.0.0.AND.U1(i).EQ.0.0 ) GOTO 100
      ENDDO
 100  IF ( Nsk.GT.NCOL ) THEN
        if(makeio.ne.0)WRITE (8,99003) NCOL
        Nsk = NCOL
      ENDIF
      IF ( .NOT.Short_bn ) THEN
        if(makeio.ne.0)WRITE (8,99004) (U1(i),i=1,Nsk)
        if(makeio.ne.0)WRITE (8,99005) (Mach1(i),i=1,Nsk)
      ENDIF
      iof = 0
 200  iof = iof + 1
      Oxfl = Oxf(iof)
      CALL NEWOF
      Incdeq = seql
 300  refl = .FALSE.
      it2 = 2
      it1 = 1
      Pp = P(1)
      Tt = T(1)
      IF ( .NOT.Incdeq ) THEN
C FROZEN
        DO n = 1,Nsk
          Dlvtp(n) = 1.
          Dlvpt(n) = -1.
        ENDDO
      ENDIF
      DO Npt = 1,Nsk
        Ppp(Npt) = P(Npt)
        Ttt(Npt) = T(Npt)
        IF ( Npt.GT.1 ) THEN
          IF ( Ppp(Npt).EQ.0. ) Ppp(Npt) = Ppp(Npt-1)
          IF ( Ttt(Npt).EQ.0. ) Ttt(Npt) = Ttt(Npt-1)
          Ssum(Npt) = Ssum(Npt-1)
          Hsum(Npt) = Hsum(Npt-1)
          IF ( Ttt(Npt).EQ.Tt.AND.Ppp(Npt).EQ.Pp ) GOTO 350
        ENDIF
        Pp = Ppp(Npt)
        Tt = Ttt(Npt)
        IF ( Tt.GE.Tg(1)*.8D0 ) THEN
          CALL HCALC
          Hsum(Npt) = Hsub0
        ELSE
          if(makeio.ne.0)WRITE (8,99016) Tt,Npt
          GOTO 1000
        ENDIF
 350    IF ( Cpmix.NE.0. ) Gamma1 = Cpmix/(Cpmix-1./Wmix)
        A1 = (Rr*Gamma1*Tt/Wmix)**.5
        IF ( U1(Npt).EQ.0. ) U1(Npt) = A1*Mach1(Npt)
        IF ( Mach1(Npt).EQ.0. ) Mach1(Npt) = U1(Npt)/A1
        Wm(Npt) = Wmix
        Cpr(Npt) = Cpmix
        Gammas(Npt) = Gamma1
        Vlm(Npt) = Rr*Tt/(Wmix*Pp)
      ENDDO
      Npt = Nsk
C OUTPUT--1ST CONDITION
      if(makeio.ne.0)WRITE (8,99006)
      IF ( .NOT.Incdeq ) THEN
        if(makeio.ne.0)WRITE (8,99008)
      ELSE
        if(makeio.ne.0)WRITE (8,99007)
      ENDIF
      Eql = .FALSE.
      CALL OUT1
      if(makeio.ne.0)WRITE (8,99009)
      Fmt(4) = '13'
      Fmt(5) = ' '
      Fmt(7) = '4,'
      if(makeio.ne.0)WRITE (8,Fmt) 'MACH NUMBER1   ',(Mach1(j),j=1,Npt)
      Fmt(7) = '2,'
      if(makeio.ne.0)WRITE (8,Fmt) 'U1, M/SEC      ',(U1(j),j=1,Npt)
      CALL OUT2
C BEGIN CALCULATIONS FOR 2ND CONDITION
      IF ( Incdeq ) Eql = .TRUE.
      Npt = 1
 400  Gamma1 = Gammas(Npt)
      uu = U1(Npt)
      wmx = Wm(Npt)
      p1 = Ppp(Npt)
      t1 = Ttt(Npt)
      hs = Hsum(Npt)
      IF ( refl ) uu = u1u2(Npt)
      mu12rt = wmx*uu**2/(Rr*t1)
      IF ( refl ) THEN
C REFLECTED--SUBSCRIPTS 2=1, 5=2, P52=P21
        t21 = 2.
        b2 = (-1.-mu12rt-t21)/2.
        p21 = -b2 + SQRT(b2**2-t21)
      ELSE
        p21 = (2.*Gamma1*Mach1(Npt)**2-Gamma1+1.)/(Gamma1+1.)
C THE FOLLOWING IMPROVED FORMULATION FOR THE INITIAL ESTIMATE FOR THE
C 2ND CONDITION WAS MADE AND TESTED BY S. GORDON 7/10/89.
        IF ( .NOT.Eql ) THEN
          t21 = p21*(2./Mach1(Npt)**2+Gamma1-1.)/(Gamma1+1.)
        ELSE
          Pp = p21*p1
          Tp = .FALSE.
          Hp = .TRUE.
          Hsub0 = hs + uu**2/(2.*Rr)
          CALL EQLBRM
          t21 = Ttt(Npt)/t1
          Hp = .FALSE.
          Tp = .TRUE.
        ENDIF
      ENDIF
      p21l = DLOG(p21)
      ttmax = 1.05*Tg(4)/t1
      t21 = DMIN1(t21,ttmax)
      t21l = DLOG(t21)
      itr = 1
 500  IF ( Shkdbg .and.(makeio.ne.0)) WRITE (8,99010) 
     &               itr,it2,it1,p21,it2,it1,t21,rho52
      Tt = t21*t1
      Pp = p21*p1
      IF ( .NOT.Eql ) THEN
C FROZEN
        Tln = DLOG(Tt)
        IF ( .NOT.Incdeq ) THEN
          CALL HCALC
          IF ( Tt.EQ.0. ) GOTO 600
          Hsum(Npt) = Hsub0
          Cpr(Npt) = Cpmix
        ELSE
          CALL CPHS
          Cpr(Npt) = Cpsum
          Hsum(Npt) = 0.
          DO j = 1,Ng
            Hsum(Npt) = Hsum(Npt) + H0(j)*En(j,Npt)
          ENDDO
          Hsum(Npt) = Hsum(Npt)*Tt
        ENDIF
      ELSE
        CALL EQLBRM
        IF ( Tt.EQ.0. ) GOTO 800
      ENDIF
      rho12 = wmx*t21/(Wm(Npt)*p21)
      gg = rho12*mu12rt
      rho52 = 1./rho12
      IF ( refl ) gg = -mu12rt*rho52/(rho52-1.)**2
      G(1,1) = -gg*Dlvpt(Npt) - p21
      G(1,2) = -gg*Dlvtp(Npt)
      G(1,3) = p21 - 1. + gg - mu12rt
      IF ( refl ) G(1,3) = p21 - 1. + gg*(rho52-1.)
      gg = gg*t1/wmx
      IF ( .NOT.refl ) gg = gg*rho12
      G(2,1) = -gg*Dlvpt(Npt) + Tt*(Dlvtp(Npt)-1.)/Wm(Npt)
      G(2,2) = -gg*Dlvtp(Npt) - Tt*Cpr(Npt)
      gg = 1. - rho12**2
      IF ( refl ) gg = (rho52+1.)/(rho52-1.)
      G(2,3) = Hsum(Npt) - hs - uu**2*gg/(2.*Rr)
      X(3) = G(1,1)*G(2,2) - G(1,2)*G(2,1)
      X(1) = (G(1,3)*G(2,2)-G(2,3)*G(1,2))/X(3)
      X(2) = (G(1,1)*G(2,3)-G(2,1)*G(1,3))/X(3)
      IF ( Shkdbg ) THEN
        if(makeio.ne.0)WRITE (8,99011) G(1,1),G(1,2),G(1,3)
        if(makeio.ne.0)WRITE (8,99011) G(2,1),G(2,2),G(2,3)
        if(makeio.ne.0)WRITE (8,99012) X(1),X(2)
        if(makeio.ne.0)WRITE (8,99013) Hsum(Npt),hs,uu,uu*rho12
      ENDIF
      ax = DABS(X(1))
      axx = DABS(X(2))
      IF ( axx.GT.ax ) ax = axx
      IF ( ax.GE..00005 ) THEN
        cormax = .40546511
        IF ( itr.GT.4 ) cormax = .22314355
        IF ( itr.GT.12 ) cormax = .09531018
        IF ( itr.GT.20 ) cormax = .04879016
        ax = ax/cormax
        IF ( ax.GT.1. ) THEN
          X(1) = X(1)/ax
          X(2) = X(2)/ax
        ENDIF
        p21l = p21l + X(1)
        t21l = t21l + X(2)
        p21 = DEXP(p21l)
        t21 = DEXP(t21l)
        IF ( Shkdbg .and.(makeio.ne.0))WRITE (8,99014) cormax,X(1),X(2)
        IF ( itr.NE.1.OR.t21.LT.ttmax ) THEN
          itr = itr + 1
          IF ( itr.LT.61 ) GOTO 500
          if(makeio.ne.0)WRITE (8,99015) U1(Npt)
        ELSE
          Tt = 0.
          Npt = Npt - 1
          GOTO 700
        ENDIF
      ENDIF
C CONVERGED OR TOOK 60 ITERATIONS WITHOUT CONVERGING.
C STORE RESULTS.
 600  rrho(Npt) = rho52
      m2m1(Npt) = Wm(Npt)/wmx
      p2p1(Npt) = p21
      t2t1(Npt) = t21
      utwo(Npt) = uu*rho12
      u1u2(Npt) = uu - utwo(Npt)
      IF ( Tt.GE.Tg(1)*.8D0.AND.Tt.LE.Tg(4)*1.1D0 ) THEN
        IF ( refl ) THEN
        ENDIF
        IF ( .NOT.Eql ) THEN
C FROZEN
          Ppp(Npt) = Pp
          Ttt(Npt) = Tt
          Gammas(Npt) = Cpr(Npt)/(Cpr(Npt)-1./wmx)
          Vlm(Npt) = Rr*Tt/(wmx*Pp)
          IF ( Incdeq ) THEN
            Ssum(Npt) = 0.
            DO j = 1,Ngc
              pmn = Pp*wmx*En(j,Npt)
              IF ( En(j,Npt).GT.0. ) Ssum(Npt) = Ssum(Npt) + En(j,Npt)
     &             *(S(j)-DLOG(pmn))
            ENDDO
          ENDIF
        ENDIF
        GOTO 900
      ENDIF
 700  if(makeio.ne.0)WRITE (8,99016) Tt,Npt
      Tt = 0.
 800  IF ( Npt.LT.1 ) GOTO 1000
      Nsk = Npt
 900  IF ( Trnspt ) CALL TRANP
      Isv = 0
      IF ( Npt.LT.Nsk ) Isv = Npt
      IF ( Npt.EQ.1 ) Isv = -1
      Npt = Npt + 1
      IF ( Eql ) CALL SETEN
      IF ( Npt.LE.Nsk ) GOTO 400
      Npt = Nsk
      IF ( refl ) THEN
        IF ( (.NOT.Eql) .and.(makeio.ne.0)) WRITE (8,99020)
        IF ( Eql .and.(makeio.ne.0)) WRITE (8,99021)
        cr12 = '2'
        cr52 = '5'
      ELSE
        IF ( (.NOT.Eql) .and.(makeio.ne.0)) WRITE (8,99018)
        IF ( Eql .and.(makeio.ne.0)) WRITE (8,99019)
        cr12 = '1'
        cr52 = '2'
      ENDIF
      Fmt(7) = '2,'
      if(makeio.ne.0)WRITE (8,Fmt) 
     &    'U'//cr52//', M/SEC      ',(utwo(j),j=1,Npt)
      CALL OUT2
      IF ( Trnspt ) CALL OUT4
      if(makeio.ne.0)WRITE (8,99017)
      Fmt(7) = '3,'
      if(makeio.ne.0)
     $   WRITE (8,Fmt) 'P'//cr52//'/P'//cr12//'           ',
     &              (p2p1(j),j=1,Npt)
      if(makeio.ne.0)
     $   WRITE (8,Fmt) 'T'//cr52//'/T'//cr12//'           ',
     &              (t2t1(j),j=1,Npt)
      Fmt(7) = '4,'
      if(makeio.ne.0)
     $   WRITE (8,Fmt) 'M'//cr52//'/M'//cr12//'           ',
     &              (m2m1(j),j=1,Npt)
      if(makeio.ne.0)
     $   WRITE (8,Fmt) 'RHO'//cr52//'/RHO'//cr12//'       ',
     &              (rrho(j),j=1,Npt)
      Fmt(7) = '2,'
      IF ( (.NOT.refl) .and.(makeio.ne.0)) 
     $   WRITE (8,Fmt) 'V2, M/SEC      ',
     &                                            (u1u2(j),j=1,Npt)
      IF ( refl .and.(makeio.ne.0)) WRITE (8,Fmt) 'U5+V2,M/SEC    ',
     &                                            (u1u2(j),j=1,Npt)
      IF ( .NOT.Eql ) THEN
C WRITE FROZEN MOLE (OR MASS) FRACTIONS
        Fmt(7) = '5,'
        IF ( .NOT.Incdeq ) THEN
          IF ( Massf ) THEN
            if(makeio.ne.0)WRITE (8,99022) 'MASS'
          ELSE
            if(makeio.ne.0)WRITE (8,99022) 'MOLE'
            ww = wmx
          ENDIF
          DO n = 1,Nreac
            j = Jray(n)
            IF ( Massf ) ww = Mw(j)
            if(makeio.ne.0)WRITE (8,99023) Prod(j),(En(j,i)*ww,i=1,Npt)
          ENDDO
        ELSE
          Eql = .TRUE.
          CALL OUT3
          Eql = .FALSE.
        ENDIF
      ELSE
        CALL OUT3
      ENDIF
      Iplt = MIN(Iplt+Npt,500)
      IF ( srefl ) THEN
        IF ( .NOT.refl ) THEN
          refl = .TRUE.
          it2 = 5
          it1 = 2
          Eql = .TRUE.
          IF ( Reflfz ) THEN
            Eql = .FALSE.
            IF ( Refleq ) THEN
              j = 0
              DO i = 1,Npt
                j = j + 1
                sg(j) = u1u2(i)
                j = j + 1
                sg(j) = Wm(i)
                j = j + 1
                sg(j) = Ppp(i)
                j = j + 1
                sg(j) = Ttt(i)
                j = j + 1
                sg(j) = Hsum(i)
                j = j + 1
                sg(j) = Gammas(i)
              ENDDO
            ENDIF
          ENDIF
          Npt = 1
          GOTO 400
        ELSEIF ( .NOT.Eql.AND.Refleq ) THEN
          j = 1
          DO i = 1,Npt
            u1u2(i) = sg(j)
            Wm(i) = sg(j+1)
            Ppp(i) = sg(j+2)
            Ttt(i) = sg(j+3)
            Hsum(i) = sg(j+4)
            Gammas(i) = sg(j+5)
            j = j + 6
          ENDDO
          Eql = .TRUE.
          Npt = 1
          GOTO 400
        ENDIF
      ENDIF
      IF ( Incdeq.AND.Incdfz ) THEN
        Incdeq = .FALSE.
        Eql = .FALSE.
        GOTO 300
      ELSEIF ( iof.GE.Nof ) THEN
        Tp = .FALSE.
        DO n = 1,Nreac
          Rtemp(n) = T(1)
        ENDDO
      ELSE
        DO i = 1,Nsk
          U1(i) = uis(i)
          Mach1(i) = mis(i)
        ENDDO
        GOTO 200
      ENDIF
 1000 RETURN
99001 FORMAT (/'   *** INPUT FOR SHOCK PROBLEMS ***')
99002 FORMAT (/' INCDEQ =',L2,'   REFLEQ =',L2,'   INCDFZ =',L2,
     &        '    REFLFZ =',L2)
99003 FORMAT (/' WARNING!!  ONLY ',I2,' u1 OR mach1 VALUES ALLOWED ',
     &        '(SHCK)')
99004 FORMAT (/1p,' U1 =   ',5E13.6,/(8X,5E13.6))
99005 FORMAT (/1p,' MACH1 =',5E13.6,/(8X,5E13.6))
99006 FORMAT (////25X,'SHOCK WAVE PARAMETERS ASSUMING')
99007 FORMAT (/,16X,' EQUILIBRIUM COMPOSITION FOR INCIDENT SHOCKED',
     &        ' CONDITIONS'//)
99008 FORMAT (/,17X,' FROZEN COMPOSITION FOR INCIDENT SHOCKED',
     &        ' CONDITI1ONS'//)
99009 FORMAT (/' INITIAL GAS (1)')
99010 FORMAT (/' ITR NO.=',I3,3X,'P',I1,'/P',I1,' =',F9.4,3X,'T',I1,
     &        '/T',I1,' =',F9.4,'   RHO2/RHO1 =',F9.6)
99011 FORMAT (/' G(I,J)  ',3E15.8)
99012 FORMAT (/' X       ',2E15.8)
99013 FORMAT (/' HSUM HS UU U2 ',4E15.8)
99014 FORMAT (/' MAX.COR.=',e13.6,' X(1)=',e13.6,' X(2)=',e13.6)
99015 FORMAT (/6x,' WARNING!!  NO CONVERGENCE FOR u1=',F8.1,
     &        /'  ANSWERS NOT RELIABLE, SOLUTION MAY NOT EXIST (SHCK)')
99016 FORMAT (/' TEMPERATURE=',E12.4,' IS OUT OF EXTENDED RANGE ',
     &        'FOR POINT',I5,' (SHCK)')
99017 FORMAT ()
99018 FORMAT (/' SHOCKED GAS (2)--INCIDENT--FROZEN')
99019 FORMAT (/' SHOCKED GAS (2)--INCIDENT--EQUILIBRIUM')
99020 FORMAT (/' SHOCKED GAS (5)--REFLECTED--FROZEN')
99021 FORMAT (/' SHOCKED GAS (5)--REFLECTED--EQUILIBRIUM')
99022 FORMAT (/1x,A4,' FRACTIONS'/)
99023 FORMAT (' ',A16,F8.5,12F9.5)
      END
      SUBROUTINE THERMP
C***********************************************************************
C ASSIGNED THERMODYNAMIC STATES.  HP,SP,TP,UV,SV, AND TV PROBLEMS.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      INTEGER iof
      LOGICAL uv,tv,sv
      SAVE iof
C
      EQUIVALENCE (Hp,Uv)
      EQUIVALENCE (Tp,Tv)
      EQUIVALENCE (Sp,Sv)
      Eql = .TRUE.
      DO iof = 1,Nof
        Oxfl = Oxf(iof)
        CALL NEWOF
C SET ASSIGNED P OR VOLUME
        DO Ip = 1,Np
          Pp = P(Ip)
C SET ASSIGNED T
          DO It = 1,Nt
            Vv = V(Ip)
            Tt = T(It)
            CALL EQLBRM
            IF ( Npt.EQ.0 ) GOTO 200
            IF ( Trnspt.AND.Tt.NE.0. ) CALL TRANP
            Isv = 0
            IF ( Ip.NE.Np.OR.It.NE.Nt.AND.Tt.NE.0. ) THEN
              Isv = Npt
              IF ( Npt.NE.NCOL ) GOTO 10
            ENDIF
            IF ( (.NOT.Hp) .and.(makeio.ne.0)) WRITE (8,99001)
            IF ( Hp .and.(makeio.ne.0)) WRITE (8,99002)
            IF ( .NOT.Vol ) THEN
              IF ( Hp .and.(makeio.ne.0)) WRITE (8,99006)
              IF ( Tp .and.(makeio.ne.0)) WRITE (8,99007)
              IF ( Sp .and.(makeio.ne.0)) WRITE (8,99008)
            ELSE
              IF ( Uv .and.(makeio.ne.0)) WRITE (8,99003)
              IF ( Tv .and.(makeio.ne.0)) WRITE (8,99004)
              IF ( Sv .and.(makeio.ne.0)) WRITE (8,99005)
            ENDIF
            CALL OUT1
            if(makeio.ne.0)WRITE (8,99009)
            CALL OUT2
            IF ( Trnspt ) CALL OUT4
            CALL OUT3
            Iplt = MIN(Iplt+Npt,500)
            IF ( Isv.EQ.0.AND.iof.EQ.Nof ) GOTO 200
            if(makeio.ne.0)WRITE (8,99010)
            Npt = 0
 10         Npt = Npt + 1
            IF ( .NOT.Tp.AND.Tt.NE.0. ) T(1) = Tt
            IF ( Nt.EQ.1.AND.Np.EQ.1 ) GOTO 100
            IF ( Ip.EQ.1.AND.It.EQ.1 ) Isv = -Isv
            IF ( Nt.NE.1 ) THEN
              IF ( It.EQ.Nt.OR.Tt.EQ.0. ) Isv = 0
            ENDIF
            CALL SETEN
          ENDDO
        ENDDO
 100  ENDDO
 200  RETURN
99001 FORMAT (////15X,'THERMODYNAMIC EQUILIBRIUM PROPERTIES AT ASSIGNED'
     &        )
99002 FORMAT (////9X,
     &     'THERMODYNAMIC EQUILIBRIUM COMBUSTION PROPERTIES AT ASSIGNED'
     &     )
99003 FORMAT (/36X,' VOLUME'/)
99004 FORMAT (/28X,'TEMPERATURE AND VOLUME'/)
99005 FORMAT (/30X,'ENTROPY AND VOLUME'/)
99006 FORMAT (/34X,' PRESSURES'/)
99007 FORMAT (/27X,'TEMPERATURE AND PRESSURE'/)
99008 FORMAT (/29X,'ENTROPY AND PRESSURE'/)
99009 FORMAT (/' THERMODYNAMIC PROPERTIES'/)
99010 FORMAT (////)
      END
      SUBROUTINE TRANIN
C***********************************************************************
C BRINGS IN AND SORTS OUT INPUT FOR TRANSPORT CALCULATIONS
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      INTEGER i,ii,inds(MAXTR),ir,j,jtape(2),k,k1,k2,kt,kvc,l,loop,m,nms
      LOGICAL change,elc1,elc2,ion1,ion2,setx
      REAL*8 coeff,debye,ekt,enel,enmin,ionic,lamda,omega,prop,qc,ratio,
     &       stcf(MAXTR,MAXTR),stcoef(MAXTR),te,testen,testot,total,
     &       trc(6,3,2),wmols(MAXTR),wmred,xsel,xss(MAXTR)
      REAL*8 DABS,DEXP,DLOG,DSQRT
      SAVE change,coeff,debye,ekt,elc1,elc2,enel,enmin,i,ii,inds,ion1,
     &  ion2,ionic,ir,j,jtape,k,k1,k2,kt,kvc,l,lamda,loop,m,nms,omega,
     &  prop,qc,ratio,setx,stcf,stcoef,te,testen,testot,total,trc,wmols,
     &  wmred,xsel,xss
C
      IF ( .NOT.Eql ) THEN
        IF ( .NOT.Shock ) THEN
          IF ( .NOT.setx ) THEN
            setx = .TRUE.
            Nm = nms
            DO i = 1,Nm
              Xs(i) = xss(i)
              Wmol(i) = wmols(i)
              Ind(i) = inds(i)
            ENDDO
          ENDIF
          GOTO 300
        ELSEIF ( .NOT.Incdeq ) THEN
          IF ( Npt.LE.1 ) THEN
            Nm = Nreac
            DO i = 1,Nm
              j = Jray(i)
              Ind(i) = j
              Wmol(i) = Mw(j)
              Xs(i) = En(j,1)*Wm(1)
            ENDDO
          ENDIF
          GOTO 300
        ENDIF
      ENDIF
C PICK OUT IMPORTANT SPECIES
      Nm = 0
      total = 0.D0
      enmin = 1.0D-11/Wm(Npt)
      testot = 0.999999999D0/Wm(Npt)
      DO i = 1,Lsave
        j = Jcm(i)
        IF ( En(j,Npt).LE.0.D0.AND.j.LE.Ngc ) THEN
          IF ( (Enln(j)-Ennl+25.328436D0).GT.0.D0 ) En(j,Npt)
     &         = DEXP(Enln(j))
        ENDIF
        Nm = Nm + 1
        Ind(Nm) = j
        total = total + En(j,Npt)
        IF ( Mw(j).LT.1.0D0 ) enel = En(j,Npt)
        En(j,Npt) = -En(j,Npt)
      ENDDO
      testen = 1.D0/(Ng*Wm(Npt))
      loop = 0
 100  IF ( total.LE.testot.AND.loop.LE.Ng ) THEN
        loop = loop + 1
        testen = testen/10.
        DO j = 1,Ng
          IF ( En(j,Npt).GE.testen ) THEN
            IF ( Nm.GE.MAXTR ) THEN
              if(makeio.ne.0)WRITE (8,99001) Nm,Npt
              GOTO 200
            ELSE
              total = total + En(j,Npt)
              Nm = Nm + 1
              Ind(Nm) = j
              En(j,Npt) = -En(j,Npt)
            ENDIF
          ENDIF
        ENDDO
        IF ( testen.GT.enmin ) GOTO 100
      ENDIF
C CALCULATE MOLE FRACTIONS FROM THE EN(J,NPT)
 200  DO j = 1,Ng
        En(j,Npt) = DABS(En(j,Npt))
      ENDDO
      DO i = 1,Nm
        j = Ind(i)
        Wmol(i) = Mw(j)
        Xs(i) = En(j,Npt)/total
      ENDDO
      IF ( Npt.EQ.Nfz ) THEN
        nms = Nm
        DO i = 1,Nm
          xss(i) = Xs(i)
          wmols(i) = Wmol(i)
          inds(i) = Ind(i)
        ENDDO
        setx = .FALSE.
      ENDIF
C REWRITE REACTIONS TO ELIMINATE TRACE ELEMENTS
      Nr = Nm - Lsave
      IF ( Nr.NE.0 ) THEN
        DO k = 1,MAXTR
          DO m = 1,MAXTR
            Stc(k,m) = 0.0D0
          ENDDO
        ENDDO
        k = 1
        DO i = Lsave + 1,Nm
          Stc(k,i) = -1.0D0
          j = Ind(i)
          DO m = 1,Lsave
            Stc(k,m) = A(m,j)
          ENDDO
          k = k + 1
        ENDDO
        DO i = 1,Nm
          IF ( Xs(i).LT.1.0D-10 ) THEN
            m = 1
            change = .FALSE.
            DO j = 1,Nr
              coeff = Stc(j,i)
              IF ( ABS(coeff).GT.1.0D-05 ) THEN
                IF ( .NOT.change ) THEN
                  change = .TRUE.
                  DO k = 1,Nm
                    stcoef(k) = Stc(j,k)/coeff
                  ENDDO
                  GOTO 210
                ELSE
                  DO k = 1,Nm
                    Stc(j,k) = (Stc(j,k)/coeff) - stcoef(k)
                  ENDDO
                ENDIF
              ENDIF
              DO k = 1,Nm
                stcf(m,k) = Stc(j,k)
              ENDDO
              m = m + 1
 210        ENDDO
            DO ii = 1,Nm
              DO j = 1,Nr
                Stc(j,ii) = stcf(j,ii)
              ENDDO
            ENDDO
            Nr = m - 1
          ENDIF
        ENDDO
      ENDIF
C FIND TRANSPORT DATA FOR IMPORTANT INTERACTIONS
 300  DO i = 1,Nm
        Con(i) = 0.0
        DO j = 1,Nm
          Eta(i,j) = 0.0
        ENDDO
      ENDDO
      REWIND IOSCH
      DO ir = 1,Ntape
        READ (IOSCH) jtape,trc
        DO k = 1,2
          DO i = 1,Nm
            j = Ind(i)
            IF ( j.EQ.jtape(k) ) THEN
              l = i
              IF ( k.EQ.2 ) THEN
                kvc = 1
 302            kt = 1
                IF ( trc(2,1,kvc).NE.0.E0 ) THEN
                  IF ( trc(2,2,kvc).NE.0.E0 ) THEN
                    IF ( Tt.GT.trc(2,1,kvc) ) kt = 2
                    IF ( trc(2,3,kvc).NE.0. ) THEN
                      IF ( Tt.GT.trc(2,2,kvc) ) kt = 3
                    ENDIF
                  ENDIF
                  prop = EXP(trc(6,kt,kvc)
     &                   +(trc(5,kt,kvc)/Tt+trc(4,kt,kvc))
     &                   /Tt+trc(3,kt,kvc)*Tln)
                  IF ( kvc.EQ.2 ) THEN
                    Con(l) = prop
                    GOTO 400
                  ELSE
                    Eta(l,m) = prop
                    IF ( l.NE.m ) Eta(m,l) = Eta(l,m)
                  ENDIF
                ELSEIF ( kvc.EQ.2 ) THEN
                  GOTO 400
                ENDIF
                kvc = 2
                GOTO 302
              ELSE
                m = i
                GOTO 350
              ENDIF
            ENDIF
          ENDDO
          GOTO 400
 350    ENDDO
 400  ENDDO
C MAKE ESTIMATES FOR MISSING DATA
C
C INCLUDES ION CROSS SECTION ESTIMATES
C ESTIMATES FOR  E-ION, ION-ION, E-NEUTRAL, ION-NEUTRAL
C DEBYE SHIELDING WITH IONIC CUTOFF DISTANCE
      IF ( Ions ) THEN
        te = Tt/1000.D0
        ekt = 4.8032D0**2/(Boltz*te)
        qc = 100.D0*(ekt**2)
        xsel = enel/total
        IF ( xsel.LT.1.0D-12 ) xsel = 1.0D-12
        debye = ((22.5D0/Pi)*(Rr/Avgdr*100.D0)*(te/xsel))/ekt**3
        ionic = ((810.D0/(4.0D0*Pi))*(Rr/Avgdr*100D0)*(te/xsel))
     &          **(2.0/3.0)/ekt**2
        lamda = DSQRT(debye+ionic)
        lamda = MAX(lamda,2.71828183D0)
      ENDIF
      DO i = 1,Nm
        k = Ind(i)
        Cprr(i) = Cp(k)
        IF ( .NOT.(Ions.AND.(DABS(A(Nlm,k)).EQ.1.D0).AND.
     &       (Eta(i,i).EQ.0.D0)) ) THEN
          IF ( Eta(i,i).EQ.0.D0 ) THEN
            omega = DLOG(50.D0*Wmol(i)**4.6/Tt**1.4)
            omega = MAX(omega,1.D0)
            Eta(i,i) = Viscns*DSQRT(Wmol(i)*Tt)/omega
          ENDIF
          IF ( Con(i).EQ.0.D0 ) Con(i) = Eta(i,i)
     &         *Rr*(.00375D0+.00132D0*(Cprr(i)-2.5D0))/Wmol(i)
        ENDIF
      ENDDO
      DO i = 1,Nm
        DO j = i,Nm
          ion1 = .FALSE.
          ion2 = .FALSE.
          elc1 = .FALSE.
          elc2 = .FALSE.
          omega = 0.0
          IF ( Eta(i,j).EQ.0. ) Eta(i,j) = Eta(j,i)
          IF ( Eta(j,i).EQ.0. ) Eta(j,i) = Eta(i,j)
          IF ( Eta(i,j).EQ.0. ) THEN
            IF ( Ions ) THEN
C ESTIMATE FOR IONS
              k1 = Ind(i)
              k2 = Ind(j)
              IF ( ABS(A(Nlm,k1)).EQ.1.0 ) ion1 = .TRUE.
              IF ( ABS(A(Nlm,k2)).EQ.1.0 ) ion2 = .TRUE.
              IF ( Wmol(i).LT.1.0 ) elc1 = .TRUE.
              IF ( Wmol(j).LT.1.0 ) elc2 = .TRUE.
              IF ( ion1.AND.ion2 ) omega = 1.36D0*qc*DLOG(lamda)
              IF ( (ion1.AND.elc2).OR.(ion2.AND.elc1) )
     &             omega = 1.29D0*qc*DLOG(lamda)
              IF ( (ion1.AND..NOT.ion2).OR.(ion2.AND..NOT.ion1) )
     &             omega = EXP(6.776-0.4*Tln)
              IF ( omega.NE.0. ) THEN
                wmred = DSQRT(2.0*Tt*Wmol(i)*Wmol(j)/(Wmol(i)+Wmol(j)))
                Eta(i,j) = Viscns*wmred*Pi/omega
                Eta(j,i) = Eta(i,j)
                IF ( i.EQ.j ) THEN
                  Cprr(i) = Cp(k1)
                  Con(i) = Eta(i,i)
     &                     *Rr*(.00375D0+.00132D0*(Cprr(i)-2.5D0))
     &                     /Wmol(i)
                ENDIF
                GOTO 450
              ENDIF
            ENDIF
C ESTIMATE FOR UNLIKE INTERACTIONS FROM RIGID SPHERE ANALOGY
            ratio = DSQRT(Wmol(j)/Wmol(i))
            Eta(i,j) = 5.656854D0*Eta(i,i)
     &                 *SQRT(Wmol(j)/(Wmol(i)+Wmol(j)))
            Eta(i,j) = Eta(i,j)/(1.D0+DSQRT(ratio*Eta(i,i)/Eta(j,j)))**2
            Eta(j,i) = Eta(i,j)
          ENDIF
 450    ENDDO
      ENDDO
      RETURN
99001 FORMAT (/' WARNING!!  MAXIMUM ALLOWED NO. OF SPECIES',I3,
     &        ' WAS USED IN ',
     &        /' TRANSPORT PROPERTY CALCULATIONS FOR POINT',I3,
     &        '(TRANIN))')
      END
      SUBROUTINE TRANP
C***********************************************************************
C CALCULATES GAS TRANSPORT PROPERTIES
C
C   NUMBER OF GASEOUS SPECIES = NM   (MAXIMUM MAXTR)
C   NUMBER OF CHEMICAL REACTIONS = NR (NM - NLM)
C   ARRAY OF STOICHIOMETRIC COEFFICIENTS = STC
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C LOCAL VARIABLES
      INTEGER i,i1,j,jj,k,m,mm,nlmm,nmm
      REAL*8 cpreac,delh(MAXTR),gmat(MAXMAT,MAXMAT+1),phi(MAXTR,MAXTR),
     &       psi(MAXTR,MAXTR),reacon,rtpd(MAXTR,MAXTR),stx(MAXTR),
     &       stxij(MAXTR,MAXTR),sumc,sumv,wtmol,xskm(MAXTR,MAXTR)
      REAL*8 DABS
      SAVE cpreac,delh,gmat,i,i1,j,jj,k,m,mm,nlmm,nmm,phi,psi,reacon,
     &  rtpd,stx,stxij,sumc,sumv,wtmol,xskm
C
      CALL TRANIN
C CALCULATE VISCOSITY AND FROZEN THERMAL CONDUCTIVITY
      nmm = Nm - 1
      DO i = 1,Nm
        rtpd(i,i) = 0.D0
        phi(i,i) = 1.D0
        psi(i,i) = 1.D0
      ENDDO
      Confro(Npt) = 0.D0
      Vis(Npt) = 0.D0
      DO i = 1,nmm
        i1 = i + 1
CDIR$ IVDEP
        DO j = i1,Nm
          sumc = 2.D0/(Eta(i,j)*(Wmol(i)+Wmol(j)))
          phi(i,j) = sumc*Wmol(j)*Eta(i,i)
          phi(j,i) = sumc*Wmol(i)*Eta(j,j)
          sumc = (Wmol(i)+Wmol(j))**2
          psi(i,j) = phi(i,j)
     &               *(1.D0+2.41D0*(Wmol(i)-Wmol(j))*(Wmol(i)-.142D0*
     &               Wmol(j))/sumc)
          psi(j,i) = phi(j,i)
     &               *(1.D0+2.41D0*(Wmol(j)-Wmol(i))*(Wmol(j)-.142D0*
     &               Wmol(i))/sumc)
        ENDDO
      ENDDO
      DO i = 1,Nm
        sumc = 0.D0
        sumv = 0.D0
        DO j = 1,Nm
          sumc = sumc + psi(i,j)*Xs(j)
          sumv = sumv + phi(i,j)*Xs(j)
        ENDDO
        Vis(Npt) = Vis(Npt) + Eta(i,i)*Xs(i)/sumv
        Confro(Npt) = Confro(Npt) + Con(i)*Xs(i)/sumc
      ENDDO
      IF ( Eql.AND.Nr.GT.0 ) THEN
C CALCULATE REACTION HEAT CAPACITY AND THERMAL CONDUCTIVITY
        m = Nr + 1
        DO i = 1,Nr
          delh(i) = 0.0D0
          DO k = 1,Lsave
            j = Jcm(k)
            delh(i) = Stc(i,k)*H0(j) + delh(i)
          ENDDO
          nlmm = Lsave + 1
          DO k = nlmm,Nm
            j = Ind(k)
            delh(i) = Stc(i,k)*H0(j) + delh(i)
          ENDDO
          G(i,m) = delh(i)
        ENDDO
        DO i = 1,MAXTR
          DO j = 1,MAXTR
            IF ( DABS(Stc(i,j)).LT.1.0D-6 ) Stc(i,j) = 0.0D0
          ENDDO
        ENDDO
        jj = Nm - 1
        DO k = 1,jj
          mm = k + 1
          DO m = mm,Nm
            rtpd(k,m) = Wmol(k)*Wmol(m)/(1.1*Eta(k,m)*(Wmol(k)+Wmol(m)))
            xskm(k,m) = Xs(k)*Xs(m)
            xskm(m,k) = xskm(k,m)
            rtpd(m,k) = rtpd(k,m)
          ENDDO
        ENDDO
        DO i = 1,Nr
          DO j = i,Nr
            G(i,j) = 0.0D0
            gmat(i,j) = 0.0D0
          ENDDO
        ENDDO
        DO k = 1,jj
          mm = k + 1
          DO m = mm,Nm
            IF ( Xs(k).GE.1.0D-10.AND.Xs(m).GE.1.0D-10 ) THEN
              DO j = 1,Nr
                IF ( (Stc(j,k).EQ.0.D0).AND.(Stc(j,m).EQ.0.D0) ) stx(j)
     &               = 0.D0
                IF ( (Stc(j,k).NE.0.D0).OR.(Stc(j,m).NE.0.D0) ) stx(j)
     &               = Xs(m)*Stc(j,k) - Xs(k)*Stc(j,m)
              ENDDO
              DO i = 1,Nr
                DO j = i,Nr
                  stxij(i,j) = stx(i)*stx(j)/xskm(k,m)
                  G(i,j) = G(i,j) + stxij(i,j)
                  gmat(i,j) = gmat(i,j) + stxij(i,j)*rtpd(k,m)
                ENDDO
              ENDDO
            ENDIF
          ENDDO
        ENDDO
        m = 1 + Nr
        DO i = 1,Nr
CDIR$ IVDEP
          DO j = i,Nr
            G(j,i) = G(i,j)
          ENDDO
          G(i,m) = delh(i)
        ENDDO
        Imat = Nr
        CALL GAUSS
        cpreac = 0.D0
        DO i = 1,Nr
          G(i,m) = delh(i)
          cpreac = cpreac + R*delh(i)*X(i)
CDIR$ IVDEP
          DO j = i,Nr
            G(i,j) = gmat(i,j)
            G(j,i) = G(i,j)
          ENDDO
        ENDDO
        CALL GAUSS
        reacon = 0.D0
        DO i = 1,Nr
          reacon = reacon + R*delh(i)*X(i)
        ENDDO
        reacon = .6D0*reacon
      ELSE
        cpreac = 0.D0
        reacon = 0.D0
      ENDIF
C CALCULATE OTHER ANSWERS
      Cpfro(Npt) = 0.D0
      wtmol = 0.D0
      DO i = 1,Nm
        Cpfro(Npt) = Cpfro(Npt) + Xs(i)*Cprr(i)
        wtmol = wtmol + Xs(i)*Wmol(i)
      ENDDO
      Cpfro(Npt) = Cpfro(Npt)*R/wtmol
      Confro(Npt) = Confro(Npt)/1000.D0
      IF ( .NOT.Siunit ) Confro(Npt) = Confro(Npt)/4.184D0
      Vis(Npt) = Vis(Npt)/1000.D0
      Prfro(Npt) = Vis(Npt)*Cpfro(Npt)/Confro(Npt)
      IF ( Eql ) THEN
        cpreac = cpreac/wtmol
        reacon = reacon/1000.D0
        Cpeql(Npt) = cpreac + Cpfro(Npt)
        Coneql(Npt) = Confro(Npt) + reacon
        Preql(Npt) = Vis(Npt)*Cpeql(Npt)/Coneql(Npt)
      ENDIF
      END
      SUBROUTINE UTHERM(Readok)
C***********************************************************************
C READ THERMO DATA FROM I/O UNIT 5 IN RECORD FORMAT AND WRITE
C UNFORMATTED ON I/O UNIT IOTHM.  DATA ARE REORDERED GASES FIRST.
C
C USES SCRATCH I/O UNIT IOSCH.
C
C UTHERM IS CALLED FROM SUBROUTINE INPUT.
C
C NOTE:  THIS ROUTINE MAY BE CALLED DIRECTLY AND USED BY ITSELF TO
C PROCESS THE THERMO DATA.
C
C GASEOUS SPECIES:
C THE STANDARD TEMPERATURE RANGES TGL ARE GIVEN ON THE FIRST
C RECORD, FOLLOWED BY THE DATE OF THE LAST DATA CHANGE THDATE.
C
C WHEN COEFFICIENTS ARE NOT GIVEN FOR THE THIRD TEMPERATURE
C INTERVAL, A STRAIGHT LINE FOR CP/R IS USED.  FOR HIGH TEMPS,
C THE EXTRAPOLATION GOES BETWEEN THE LAST POINT GIVEN AND THE
C FOLLOWING VALUES AA AT TINF=1.D06 K:
C      MONATOMICS  2.5
C      DIATOMICS   4.5
C      POLYATOMICS 3*N-1.75  (AVERAGE 1.5 AND 2)
C
C THE FOLLOWING EXTRAPOLATION IS NOT CURRENTLY PROGRAMED (12/9/98):
C   FOR LOW TEMPS, THE EXTRAPOLATION GOES BETWEEN THE FIRST VALUE
C   DOWN TO THE FOLLOWING VALUES AA AT 0 K:
C      MONATOMICS  2.5
C      DIATOMICS   3.5
C      POLYATOMICS 3.75 (AVERAGE 3.5 AND 4.0)
C
C IF DATA ARE AVAILABLE FOR THE THIRD T INTERVAL, IFAZ (SEE
C DEFINITION) IS SET TO -1 AND THE NAME IS ALTERED TO START WITH *.
C
C CONDENSED SPECIES:
C NO EXTRAPOLATIONS ARE DONE.  TEMP INTERVALS VARY.
C
C SOME DEFINITIONS:
C TGL(I)  - TEMPERATURE INTERVALS FOR GASES (I.E. 200,1000,6000,20000).
C FILL(I) - IF TRUE, DATA MISSING FOR INTERVAL.  CURRENTLY ONLY 3RD
C           INTERVAL CHECKED.
C NGL     - NUMBER OF GASEOUS PRODUCTS.
C NS      - NGL + NUMBER OF CONDENSED PRODUCT PHASES.
C NALL    - NS + NUMBER OF REACTANT SPECIES.
C IFAZ    - PHASE INDICATOR. GASES ARE 0, CONDENSED PHASES ARE NUMBERED
C           STARTING WITH 1 FOR THE LOWEST T RANGE, 2 FOR THE NEXT
C           CONTIGUOUS PHASE, ETC.
C NTL     - NUMBER OF T INTERVALS FOR A SPECIES SET.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C DUMMY ARGUMENTS
      LOGICAL Readok
C LOCAL VARIABLES
      CHARACTER*15 name
      CHARACTER*16 namee
      CHARACTER*65 notes
      CHARACTER*2 sym(5)
      CHARACTER*6 date
      INTEGER i,ifaz,ifzm1,inew,int_bn,j,k,kk,l,nall,ncoef,ngl,ns,ntl
c///      INTEGER INDEX
      LOGICAL fill(3)
      REAL*8 aa,atms,cpfix,dlt,expn(8),fno(5),hform,hh,mwt,templ(9),tex,
     &       tgl(4),thermo(9,3),tinf,tl(2),ttl,tx
      REAL*8 DBLE,DLOG
      
      if( read_d .eq. 0 ) return
      
C
      ngl = 0
      ns = 0
      nall = 0
      ifzm1 = 0
      inew = 0
      tinf = 1.D06
      REWIND IOSCH
      READ (7,99001) tgl,Thdate
 100  DO i = 1,3
        fill(i) = .TRUE.
        DO j = 1,9
          thermo(j,i) = 0.
        ENDDO
      ENDDO
      hform = 0.
      tl(1) = 0.
      tl(2) = 0.
      READ (7,99002,END=300,ERR=400) name,notes
      IF ( name(:3).EQ.'END'.OR.name(:3).EQ.'end' ) THEN
        IF ( INDEX(name,'ROD').EQ.0.AND.INDEX(name,'rod').EQ.0 )
     &       GOTO 300
        ns = nall
        GOTO 100
      ENDIF
      READ (7,99003,ERR=400) ntl,date,(sym(j),fno(j),j=1,5),ifaz,mwt,
     &                       hform
      if(makeio.ne.0)WRITE (8,99004) name,date,hform,notes
C IF NTL=0, REACTANT WITHOUT COEFFICIENTS
      IF ( ntl.EQ.0 ) THEN
        IF ( ns.EQ.0 ) GOTO 300
        nall = nall + 1
        READ (7,99005,ERR=400) tl,ncoef,expn,hh
        thermo(1,1) = hform
        WRITE (IOSCH) name,ntl,date,(sym(j),fno(j),j=1,5),ifaz,tl,mwt,
     &                thermo
        GOTO 100
      ELSEIF ( name.EQ.'Air' ) THEN
        sym(1) = 'N'
        fno(1) = 1.56168D0
        sym(2) = 'O'
        fno(2) = .419590D0
        sym(3) = 'AR'
        fno(3) = .009365D0
        sym(4) = 'C'
        fno(4) = .000319D0
      ELSEIF ( name.EQ.'e-' ) THEN
        mwt = 5.48579903D-04
      ENDIF
      DO i = 1,ntl
        READ (7,99005,ERR=400) tl,ncoef,expn,hh
        READ (7,99006,ERR=400) templ
        IF ( ifaz.EQ.0.AND.i.GT.3 ) GOTO 400
        IF ( ifaz.LE.0 ) THEN
          IF ( tl(2).GT.tgl(4)-.01D0 ) THEN
            ifaz = -1
            namee = '*'//name
            name = namee(:15)
          ENDIF
          IF ( tl(1).GE.tgl(i+1) ) GOTO 200
          int_bn = i
          fill(i) = .FALSE.
        ELSE
          int_bn = 1
          IF ( i.GT.1 ) THEN
            DO k = 1,7
              thermo(k,1) = 0.D0
            ENDDO
          ENDIF
        ENDIF
        DO l = 1,ncoef
          DO k = 1,7
            IF ( expn(l).EQ.DBLE(k-3) ) THEN
              thermo(k,int_bn) = templ(l)
              GOTO 150
            ENDIF
          ENDDO
 150    ENDDO
        thermo(8,int_bn) = templ(8)
        thermo(9,int_bn) = templ(9)
        IF ( ifaz.GT.0 ) THEN
          nall = nall + 1
          IF ( ifaz.GT.ifzm1 ) THEN
            inew = inew + 1
          ELSE
            inew = i
          ENDIF
          WRITE (IOSCH) name,ntl,date,(sym(j),fno(j),j=1,5),inew,tl,mwt,
     &                  thermo
        ENDIF
 200  ENDDO
      ifzm1 = ifaz
      IF ( ifaz.LE.0 ) THEN
        inew = 0
        nall = nall + 1
        IF ( ifaz.LE.0.AND.ns.EQ.0 ) THEN
          ngl = ngl + 1
          IF ( fill(3) ) THEN
            atms = 0.
            DO i = 1,5
              IF ( sym(i).EQ.' '.OR.sym(i).EQ.'E' ) GOTO 210
              atms = atms + fno(i)
            ENDDO
C FOR GASES WITH NO COEFFICIENTS FOR TGL(3)-TGL(4) INTERVAL,
C CALCULATE ESTIMATED COEFFICIENTS. (STRAIGHT LINE FOR CP/R)
 210        aa = 2.5D0
            IF ( atms.GT.1.9 ) aa = 4.5D0
            IF ( atms.GT.2.1 ) aa = 3.*atms - 1.75D0
            ttl = tl(2)
            tx = ttl - tinf
            cpfix = 0
            templ(8) = 0.
            templ(9) = 0.
            dlt = DLOG(ttl)
            DO k = 7,1, - 1
              kk = k - 3
              IF ( kk.EQ.0 ) THEN
                cpfix = cpfix + thermo(k,2)
                templ(8) = templ(8) + thermo(k,2)
                templ(9) = templ(9) + thermo(k,2)*dlt
              ELSE
                tex = ttl**kk
                cpfix = cpfix + thermo(k,2)*tex
                templ(9) = templ(9) + thermo(k,2)*tex/kk
                IF ( kk.EQ.-1 ) THEN
                  templ(8) = templ(8) + thermo(k,2)*dlt/ttl
                ELSE
                  templ(8) = templ(8) + thermo(k,2)*tex/(kk+1)
                ENDIF
              ENDIF
            ENDDO
            templ(2) = (cpfix-aa)/tx
            thermo(4,3) = templ(2)
            templ(1) = cpfix - ttl*templ(2)
            thermo(3,3) = templ(1)
            thermo(8,3) = thermo(8,2)
     &                    + ttl*(templ(8)-templ(1)-.5*templ(2)*ttl)
            thermo(9,3) = -templ(1)*dlt + thermo(9,2) + templ(9)
     &                    - templ(2)*ttl
          ENDIF
        ENDIF
C WRITE COEFFICIENTS ON SCRATCH I/O UNIT IOSCH
        WRITE (IOSCH) name,ntl,date,(sym(j),fno(j),j=1,5),ifaz,tl,mwt,
     &                thermo
      ENDIF
      GOTO 100
C END OF DATA. COPY CONDENSED & REACTANT DATA FROM IOSCH & ADD TO IOTHM.
 300  REWIND IOSCH
      IF ( ns.EQ.0 ) ns = nall
      WRITE (IOTHM) tgl,ngl,ns,nall,Thdate
C WRITE GASEOUS PRODUCTS ON IOTHM
      IF ( ngl.NE.0 ) THEN
        DO i = 1,ns
          READ (IOSCH) name,ntl,date,(sym(j),fno(j),j=1,5),ifaz,tl,mwt,
     &                 thermo
          IF ( ifaz.LE.0 ) WRITE (IOTHM) name,ntl,date,
     &                            (sym(j),fno(j),j=1,5),ifaz,tl,mwt,
     &                            thermo
        ENDDO
      ENDIF
      IF ( ngl.NE.nall ) THEN
C WRITE CONDENSED PRODUCTS AND REACTANTS ON IOTHM
        REWIND IOSCH
        DO i = 1,nall
          READ (IOSCH) name,ntl,date,(sym(j),fno(j),j=1,5),ifaz,tl,mwt,
     &                 thermo
          IF ( i.GT.ns ) THEN
            WRITE (IOTHM) name,ntl,date,(sym(j),fno(j),j=1,5),ifaz,tl,
     &                    mwt,thermo(1,1)
            IF ( ntl.GT.0 ) WRITE (IOTHM) thermo
          ELSEIF ( ifaz.GT.0 ) THEN
            WRITE (IOTHM) name,ntl,date,(sym(j),fno(j),j=1,5),ifaz,tl,
     &                    mwt,(thermo(k,1),k=1,9)
          ENDIF
        ENDDO
      ENDIF
      RETURN
 400  if(makeio.ne.0)WRITE (8,99007) name
      Readok = .FALSE.
      RETURN
99001 FORMAT (4F10.3,a10)
99002 FORMAT (a15,a65)
99003 FORMAT (i2,1x,a6,1x,5(a2,f6.2),i2,f13.5,f15.3)
99004 FORMAT (' ',a15,2x,a6,e15.6,2x,a65)
99005 FORMAT (2F11.3,i1,8F5.1,2x,f15.3)
99006 FORMAT (5D16.8/2D16.8,16x,2D16.8)
99007 FORMAT (/' ERROR IN PROCESSING thermo.inp AT OR NEAR ',A15,
     &        ' (UTHERM)')
      END
      SUBROUTINE UTRAN(Readok)
C***********************************************************************
C READ TRANSPORT PROPERTIES FORM I/O UNIT 5 IN RECORD FORMAT AND WRITE
C UNFORMATTED ON I/O UNIT IOTRN.  USES SCRATCH I/O UNIT IOSCH.
C
C UMCOEF IS CALLED FROM THE MAIN PROGRAM AFTER A RECORD WITH 'TRAN'
C IN COLUMNS 1-4 HAS BEEN READ.
C
C NOTE:  THIS ROUTINE MAY BE CALLED DIRECTLY  AND USED BY ITSELF TO
C PROCESS THE TRANSPORT PROPERTY DATA.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C DUMMY ARGUMENTS
      LOGICAL Readok
C LOCAL VARIABLES
      CHARACTER*16 tname(2)
      CHARACTER*1 vorc
      INTEGER i,ic,in,iv,j,k,ncc,nn,ns,nv
      REAL*8 cc,tc(36),tcin(6),trcoef(6,3,2),vvl
C
      EQUIVALENCE (tc(1),trcoef(1,1,1))
      ns = 0
      REWIND IOSCH
 100  DO i = 1,36
        tc(i) = 0.
      ENDDO
      READ (7,99001) tname,vvl,nv,cc,ncc
      IF ( tname(1).EQ.'end'.OR.tname(1).EQ.'LAST' ) THEN
        WRITE (IOTRN) ns
        REWIND IOSCH
        DO i = 1,ns
          READ (IOSCH,ERR=200) tname,trcoef
          WRITE (IOTRN) tname,trcoef
        ENDDO
        GOTO 300
      ELSE
        ic = 0
        iv = 0
        nn = nv + ncc
        IF ( nv.LE.3.AND.ncc.LE.3 ) THEN
          DO in = 1,nn
            READ (7,99002) vorc,tcin
            IF ( vorc.EQ.'C' ) THEN
              k = 2
              ic = ic + 1
              j = ic
            ELSE
              k = 1
              iv = iv + 1
              j = iv
            ENDIF
            IF ( j.GT.3 ) GOTO 200
            DO i = 1,6
              trcoef(i,j,k) = tcin(i)
            ENDDO
          ENDDO
          ns = ns + 1
          WRITE (IOSCH) tname,trcoef
          GOTO 100
        ENDIF
      ENDIF
 200  if(makeio.ne.0)WRITE (8,99003) tname
      Readok = .FALSE.
 300  RETURN
99001 FORMAT (2A16,2X,A1,I1,A1,I1)
99002 FORMAT (1X,A1,2F9.2,4E15.8)
99003 FORMAT (/' ERROR IN PROCESSING trans.inp AT OR NEAR (UTRAN)',/1X,
     &        2A16)
      END
      SUBROUTINE VARFMT(Vx)
C***********************************************************************
C SET DECIMAL PLACES ACCORDING TO NUMBER SIZE FOR F-FORMAT IN
C VARIABLE FORMAT FMT.
C***********************************************************************
      IMPLICIT NONE
      INCLUDE 'py_cea.inc'
C DUMMY ARGUMENTS
      REAL*8 Vx(NCOL)
C LOCAL VARIABLES
      INTEGER i,k
      REAL*8 vi
      REAL*8 DABS
      SAVE i,k,vi
C
      DO i = 1,Npt
        vi = DABS(Vx(i))
        k = 2*i + 3
        Fmt(k) = '5,'
        IF ( vi.GE.1. ) Fmt(k) = '4,'
        IF ( vi.GE.10. ) Fmt(k) = '3,'
        IF ( vi.GE.100. ) Fmt(k) = '2,'
        IF ( vi.GE.10000. ) Fmt(k) = '1,'
        IF ( vi.GE.1000000. ) Fmt(k) = '0,'
      ENDDO
      Fmt(29)(2:) = ' '
      END

      PROGRAM b1b2b3
C 
C												February 12, 2004
C  1. Find atomic symbols for reactant species.
C  2. Find species ID lists for B1, B2, and B3.
C
C  Input consists of one record for each reactant species ID 
C    plus a ENDR record followed by one record of atomic
C      symbols. - 12/18/2001 Using atomTemp a72
C    The reactant species ID's must start in column 2.
C    The symbols must be:
C       1) All capital letters
C       2) Start in column 2
C       3) In one line (record)
C       4) Left-adjusted in field-widths of 3 characters 
C          eg.  " C  H  V  MG "  (quotes not part of input)
C  When trying to find reactant species ID's, the first record is
C    blank and is followed by the atomic symbol list.
C  When trying to find omit and only lists, any species ID's from
C    the reactants are listed followed by a blank.  Then if there
C    are any atoms from user defined reactants, those atomic symbols
C    are listed in the final record. The final record will be blank
C    if there are no user defined reactants.
C  Output lists appear in files B1, B2, and B3 for gases, condensed
C    and reactant-only species respectively.
C    
      PARAMETER (IOTHM=14,iob1=10,iob2=11,iob3=12)
C
      DOUBLE PRECISION b(5),t1,t2,mw,cft(9,3),Tg(4)
C
      CHARACTER el(5)*2,date*6,sub*15,Thdate*10,sub0*15,atoms(24)*3
      CHARACTER Rids(24)*15, atomTemp*72
C
      OPEN (5,FILE='input.txt',STATUS='old',FORM='formatted')
      OPEN (IOTHM,FILE='thermo.lib',STATUS='old',FORM='unformatted')
      OPEN (iob1,FILE='B1.txt',STATUS='unknown',FORM='formatted')
      OPEN (iob2,FILE='B2.txt',STATUS='unknown',FORM='formatted')
      OPEN (iob3,FILE='B3.txt',STATUS='unknown',FORM='formatted')
C
      WRITE (iob1,20) ' '
      WRITE (iob2,20) ' '
      WRITE (iob3,20) ' '
      REWIND iob1
      REWIND iob2
      REWIND iob3
      do 12 i=1,24
      Atoms(i)=' '
      Rids(i) = ' '
12    continue
      Natom = 0
      Nrid = 0
C
C  Read reactant names (Rids)--blank if none.
C


	DO 25 i=1,24
      READ (5,15) Rids(i)
15    FORMAT (1X, a )
	print *, Rids(i)
        IF (Rids(i)(1:4).EQ.'ENDR') THEN
          READ (5,20) atomTemp
20        FORMAT (1X, a72 )
          print *, atomTemp
		GOTO 30
	  ENDIF
        Nrid = Nrid + 1
	
25    CONTINUE

30	CONTINUE
      n= 1

      DO 40 K=1,24

        Atoms(K) = atomTemp(n:n+2)
	  Natom = Natom + 1
	  if ( Atoms(K) .eq. '   ' ) GOTO 60
        n=n+3
      
40	CONTINUE  
C
C  Read atomic symbols (Atoms)--3 blank Char '   ' if none.
C


60	continue
      
C
C  SEARCH thermo.lib SPECIES NAMES (sub)
C
C   SOME DEFINITIONS:
C     ntgas = NUMBER OF GASEOUS SPECIES IN thermo.lib.
C     ntot =  NTGAS PLUS NUMBER OF TEMPERATURE INTERVALS FOR CONDENSED.
C     nall =  NTOT PLUS THE NUMBER OF REACTANT SPECIES IN THERMO.LIB.
C     Ng =    NUMBER OF GASES WITH STORED COEFFICIENTS.
C     Nc =    NUMBER OF CONDENSED INTERVALS WITH STORED COEFFICIENTS.
C     Ngc =    Ng + Nc
C     Thdate = DATE OF LAST thermo.lib UPDATE.
C
100   IF (Nrid .EQ. 0)  goto 210
C
C  Find atomic symbols for reactant species in thermo.lib
C
110   REWIND IOTHM
      READ (IOTHM) Tg,ntgas,ntot,nall,Thdate
      sub0 = ' '
C   BEGIN LOOP FOR READING SPECIES DATA FROM THERMO.LIB.
      Iid = 0
      DO 200 itot = 1,nall
      IF (itot.le.ntot) THEN
        icf=3
        io = iob1
        if ( itot.GT.ntgas ) then
          icf=1
          io = iob2
        endif
          READ (IOTHM) sub,nint,date,(el(j),b(j),j=1,5),Ifaz,t1,t2,
     &                 mw,((cft(i,j),i=1,9),j=1,icf)
      ELSE
        io = iob3
        READ (IOTHM) sub,nint,date,(el(j),b(j),j=1,5),ifaz,t1,t2,mw,eform
        IF (nint.GT.0) READ (IOTHM) ((cft(i,j),i=1,9),j=1,nint)
      ENDIF
C
      IF ( sub.EQ.sub0 ) go to 200
      sub0 = sub
      IF (sub(1:1).EQ.'*') sub = sub(2:)
      DO 114 i=1,Nrid
        if ( Rids(i).EQ.sub) goto 116
114   CONTINUE
      goto 200
116   Iid = Iid + 1
      print *, sub
          DO 140 k = 1,5
            if ( b(k).EQ.0. ) GOTO 140
            IF ( Natom.EQ.0 ) THEN
              NAtom = Natom +1
              Atoms(Natom) = el(k)
              goto 140
            ELSE
              Nd = Natom
              DO 120 i = 1,Nd
                if ( Atoms(i).EQ.el(k) ) GOTO 140
                Natom = Natom + 1
                Atoms(Natom) = el(k)
                goto 140
120           CONTINUE
            ENDIF
140       CONTINUE
          IF ( Iid.GE.Nrid ) goto 210
200   CONTINUE
C
C  Find species ID's for B1, B2, and B3 for atomic symbols (Atoms).
C
210   REWIND IOTHM
      READ (IOTHM) Tg,ntgas,ntot,nall,Thdate
      sub0 = ' '
C   BEGIN LOOP FOR READING SPECIES DATA FROM THERMO.LIB.
      DO 400 itot = 1,nall
      IF (itot.le.ntot) THEN
        icf=3
        io = iob1
        if ( itot.GT.ntgas ) then
          icf=1
          io = iob2
        endif
          READ (IOTHM) sub,nint,date,(el(j),b(j),j=1,5),Ifaz,t1,t2,
     &                 mw,((cft(i,j),i=1,9),j=1,icf)
      ELSE
        io = iob3
        READ (IOTHM) sub,nint,date,(el(j),b(j),j=1,5),ifaz,t1,t2,mw,eform
        IF (nint.GT.0) READ (IOTHM) ((cft(i,j),i=1,9),j=1,nint)
      ENDIF
C
      IF ( sub.EQ.sub0 ) go to 400
      sub0 = sub
      IF (sub(1:1).EQ.'*') sub = sub(2:)
          DO 300 k = 1,5
            DO 260 i = 1,Natom
            if ( b(k).EQ.0. ) GOTO 350
            if ( Atoms(i).EQ.el(k) ) GOTO 300
260         CONTINUE
            GOTO 400
300       CONTINUE
C
350   WRITE (io,355) sub
355   FORMAT ( a15 )
400   CONTINUE
C
500   CLOSE (IOTHM)
      CLOSE ( 5)
      CLOSE (iob1)
      CLOSE (iob2)
      CLOSE (iob3)
      STOP
      END

#!/bin/sh
#
#      clean upstream source to achieve DFSG compliance
#      Copyright 2020 by Bdale Garbee.  GPL v3 or any later version.
#

# remove pre-compiled Windows binaries
find . -name \*.pyd -exec rm {} \;

# remove jquery-related javascript droppings
find . -name \*.js -exec rm {} \;

# remove pre-run coverage analysis output to avoid copyright assertion confusion
rm -rf rocketcea/cover

# remove spurious csv file that somehow ends up in the delivered python dir
rm rocketcea/separated_Noz.csv rocketcea/tests/separated_Noz.csv

# remove spurious "backup" file
rm rocketcea/cea_obj.py.bak

rem 1st do 32 bit 
call run_setup_build_win32.bat 35
python .\rocketcea\examples\quick_chk.py > build_results.txt

call run_setup_build_win32.bat 36
python .\rocketcea\examples\quick_chk.py >> build_results.txt

call run_setup_build_win32.bat 37
python .\rocketcea\examples\quick_chk.py >> build_results.txt

call run_setup_build_win32.bat 27
python .\rocketcea\examples\quick_chk.py >> build_results.txt

rem then do 64 bit 
call run_setup_build_win64.bat 35
python .\rocketcea\examples\quick_chk.py >> build_results.txt

call run_setup_build_win64.bat 36
python .\rocketcea\examples\quick_chk.py >> build_results.txt

call run_setup_build_win64.bat 37
python .\rocketcea\examples\quick_chk.py >> build_results.txt

call run_setup_build_win64.bat 27
python .\rocketcea\examples\quick_chk.py >> build_results.txt

rem display final results
type build_results.txt

#!/bin/sh
#
#      clean upstream source to achieve DFSG compliance
#      Copyright 2024 by Bdale Garbee.  GPL v3 or any later version.
#

# remove backup file that interferes with building cleanly
rm -f cea_obj.py.bak backup/cea_obj.py.bak

# remove odd zip file file that doesn't seem to be used
rm -f backup/RocketCEA\ Install.flash.zip.html

# remove pre-run coverage analysis output to avoid copyright assertion confusion
rm -rf cover 

# remove pre-built sphinx doc tree
rm -rf docs/_build/* rocketcea/sphinx_html

# remove generated .csv files that litter delivered python dir
find . -name separated_Noz.csv -exec rm {} \;

# remove pre-built Windows binaries
find . -name \*.exe -exec rm {} \;

# remove embedded jquery and related javascript droppings
rm -rf rocketcea/sphinx_html/_static/jquery*
find . -name \*.pyd -exec rm {} \;
find . -name \*.js -exec rm {} \;

set PATH=C:\MinGW\mingw32\bin;C:\MinGW\mingw32\lib;%PATH%

SET GCC=C:\MinGW\bin\gcc.exe
SET PYTHON_LIB = D:\Python37\libs

SET LIBRARY_PATH = C:\MinGW\lib
SET G95_LIBRARY_PATH = C:\MinGW\lib
SET MSYS = C:\MinGW\msys\1.0\bin
set C_INCLUDE_PATH=C:\mingw\include

set PYTHONPATH = D:\Python37
set C_INCLUDE_PATH = C:\MinGW\include

rem set GFORTRAN_UNBUFFERED_ALL = Y

D:\Python37\python.exe sphinxy.py

rem set python path variable (Default is Python 3.7 32 bit)
IF "%1"=="" ( SET "MYPYTHONPATH=D:\py_versions\Python37_32" ) ELSE ( SET "MYPYTHONPATH=D:\py_versions\Python%1_32" )

rem Make sure that PATH is as simple as possible
set PATH=C:\MinGW\mingw32\bin;C:\MinGW\mingw32\lib;%MYPYTHONPATH%;%MYPYTHONPATH%\Scripts

pip uninstall -y rocketcea

python setup.py build --compiler=mingw32

python setup.py install
python setup.py sdist bdist_wheel

rem Test the compiled module
rem python .\rocketcea\examples\quick_chk.py
python -c "from rocketcea.cea_obj import CEA_Obj; C=CEA_Obj(oxName='LOX', fuelName='LH2'); print(C.get_Isp())"

@echo off
setlocal

rem Change "do_the_upload=FALSE" to "do_the_upload=TRUE" to run the upload
rem AFTER... satisfying upload check list
set "do_the_upload=FALSE"

if "%do_the_upload%" == "TRUE" (
    echo ...............................................................
    echo doing the upload
    echo NOTE: twine on WSL Ubuntu works MUCH better with testpypi
    echo twine upload --config-file "/mnt/c/Users/Charlie Taylor/.pypirc"  --repository testpypi --skip-existing dist/*.*
    echo ...............................................................
    C:\Python310\Scripts\twine.exe upload --config-file "%HOMEPATh%\.pypirc" --repository testpypi --skip-existing dist/*.*
    echo ....................... DONE ..................................
) else (
    echo ...................... CHECK LIST .............................
    echo ...............................................................
    echo Install from local source afer all changes made
    echo pip install .
    echo ...............................................................
    echo RUN pytest
    echo ...............................................................
    echo Make sure that sphinx HTML is built with _BUILD_SPHINX_HTML.BAT
    echo ...............................................................
    echo COMMIT all files in git
    echo ...............................................................
    echo Make sure that "python -m build" has been executed
    echo        AND any "python -m build --wheel"
    echo ...............................................................
    echo Run "twine check" to see if long description will render correctly
    echo twine check dist/*            OR 
    echo twine check dist/*24.tar.gz (where: 24 is current version)
    echo ...............................................................
    echo THEN: set "do_the_upload=TRUE" to run the upload
    echo AFTER UPLOAD: set "do_the_upload=FALSE"
    echo ...............................................................
)

endlocal



rem only upload source to PyPI
rem twine upload --repository testpypi --skip-existing dist/*.gz


rem To install from testpypi
rem  python -m pip install --index-url https://test.pypi.org/simple/ rocketcea

rem set python path variable (Default is Python 3.10 64 bit)
IF "%1"=="" ( SET "MYPYTHONPATH=C:\Python310" ) ELSE ( SET "MYPYTHONPATH=D:\py_versions\Python%1_64" )

rem Make sure that PATH is as simple as possible
set PATH=C:\MinGW\mingw64\bin;C:\MinGW\mingw64\lib;%MYPYTHONPATH%;%MYPYTHONPATH%\Scripts

SET "MYPYTHONPATH=C:\Python310" 
set PATH=C:\MinGW\mingw64\bin;C:\MinGW\mingw64\lib;%MYPYTHONPATH%;%MYPYTHONPATH%\Scripts;C:\Windows\System32

cd .\docs
C:\Python310\Scripts\sphinx-build.exe -b html -d _build/doctrees  . _build/html
cd ..

xcopy /S .\docs\_build\html .\rocketcea\sphinx_html /y
